{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

unit class_assembly_vxlan;

interface

uses base_structures,
     class_parser_vxlan,
     class_assembly_baseclass;


type tVXLANAssembler = class (tFrameAssembler)

                                constructor create;

                                private
                                       priv_VXLANIDPresent   : boolean;
                                       priv_NetworkIndicator : longword;

                                protected
                                         // called from base class from GetAssembly

                                         procedure DetermineAssemblySize; override;
                                         procedure Assemble; override;

                                public
                                      procedure CopyFromParser (Parser : tVXLANParser);
                           end;


implementation

uses toolkit;

(* ------------------------------------------- *)
{ tVXLANAssembler }
(* ------------------------------------------- *)

constructor tVXLANAssembler.create;

begin
     inherited;
end;

(* ------------------------------------------- *)

procedure tVXLANAssembler.DetermineAssemblySize;

begin
     prot_length := sizeOf (tVXLANHdrStruct);
end;

(* ------------------------------------------- *)

procedure tVXLANAssembler.Assemble;

var pData : pVXLANHdrStruct;
    lhelp : longword;

begin
     pData := pVXLANHdrStruct (prot_data);

     if priv_VXLANIDPresent then
        pData^.Flags := 8
     else
         pData^.Flags := 0;

     pData^.Reserved[0] := 0;
     pData^.Reserved[1] := 0;
     pData^.Reserved[2] := 0;

     pData^.NetworkIndicator := swap32 (priv_NetworkIndicator shl 8);
end;

(* ------------------------------------------- *)

procedure tVXLANAssembler.CopyFromParser (Parser: tVXLANParser);

begin
     priv_VXLANIDPresent := Parser.VXLANIDPresent;
     priv_NetworkIndicator := Parser.NetworkIndicator;
end;

(* ------------------------------------------- *)

end.
