{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

unit base_determine_protocols;

interface

uses definition_ip_addresses;


         function getProtocolFromL4Ports (SocketPair : tIPv4SocketPair) : integer; overload;
         function getProtocolFromL4Ports (SocketPair : tIPv6SocketPair) : integer; overload;
         function getProtocolFromL4Ports (Source, Destination : word) : integer; overload;

implementation

uses base_structures,
     class_parser_baseclass;

(* ------------------------------------------- *)

function GetProtocolFromPort (Port : word) : integer;

begin
     case Port of
      53    : result := NEXT_HEADER_DNS;
      67,68 : result := NEXT_HEADER_DHCPv4
     else
         result := 0;
     end
end;

(* ------------------------------------------- *)

function getProtocolFromL4Ports (SocketPair : tIPv4SocketPair) : integer; overload;

begin
     result := getProtocolFromL4Ports (SocketPair.Source.Port, SocketPair.Destination.Port);
end;

(* ------------------------------------------- *)

function getProtocolFromL4Ports (SocketPair : tIPv6SocketPair) : integer; overload;

begin
     result := getProtocolFromL4Ports (SocketPair.Source.Port, SocketPair.Destination.Port);
end;

(* ------------------------------------------- *)

function getProtocolFromL4Ports (Source, Destination : word) : integer;

begin
     result := GetProtocolFromPort (Source);

     if result = 0 then
        result := GetProtocolFromPort (Destination);

     if result = 0 then
        result := NEXT_HEADER_UNKNOWN;
end;

(* ------------------------------------------- *)

end.
