{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

unit databasetools;

interface

uses

{$ifdef VER230}

     // AnyDAC

     uADStanIntf, uADStanOption, uADStanError, uADGUIxIntf,
     uADPhysIntf, uADStanDef, uADStanPool,
     uADStanAsync, uADPhysManager, uADStanParam, uADDatSManager, uADDAptIntf,
     uADDAptManager, uADStanExprFuncs, Vcl.StdCtrls, uADPhysSQLite, Data.DB,
     uADCompDataSet, uADCompClient, uADGUIxFormsWait, uADPhysSQLiteWrapper;

{$else}

     // FireDAC

     FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf,
     FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.dAPT,
     FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Stan.ExprFuncs,
     FireDAC.VCLUI.Wait, FireDAC.Comp.UI, FireDAC.Phys.SQLite, FireDAC.Phys.SQLiteWrapper,
     Data.DB, FireDAC.Comp.Client, FireDAC.Stan.Param;
{$endif}


     {$REGION 'Documentation'}
     ///	<summary>
     ///	  Copies one SQlite Database to another
     ///	</summary>
     ///	<param name="SourceDB">
     ///	  Source database, must be open
     ///	</param>
     ///	<param name="DestinationDB">
     ///	  Source database, must be open
     ///	</param>
     {$ENDREGION}
     procedure SQliteBackup (SourceDB, DestinationDB : TFDConnection);


implementation

(* ------------------------------------------- *)

procedure SQliteBackup (SourceDB, DestinationDB : TFDConnection);

var oBackup: TFDSQLiteBackup;
    oSrc, oDest: TSQLiteDatabase;
    DriverLnk : TFDPhysSQLiteDriverLink;

begin
     oDest := TSQLiteDatabase(DestinationDB.ConnectionIntf.CliObj);
     oSrc := TSQLiteDatabase(SourceDB.ConnectionIntf.CliObj);

     try
        DriverLnk := TFDPhysSQLiteDriverLink.Create(nil);

        oBackup := TFDSQLiteBackup.Create (Nil);
        oBackup.DriverLink := DriverLnk;

        try
           oBackup.DatabaseObj := oSrc;
           oBackup.DestDatabaseObj := oDest;
           oBackup.Backup;
        finally
               oBackup.Free;
               DriverLnk.Free;
        end
     finally
     end;
end;

(* ------------------------------------------- *)

end.
