LINKTYPE_NULL =	0;                             //	No link layer information. A packet saved with this link layer contains a raw L3 packet preceded by a 32-bit host-byte-order AF_ value indicating the specific L3 type.
LINKTYPE_ETHERNET	= 1;                         //	D/I/X and 802.3 Ethernet
LINKTYPE_EXP_ETHERNET	=	2;                     //	Experimental Ethernet (3Mb)
LINKTYPE_AX25 =	3;                             //	Amateur Radio AX.25
LINKTYPE_PRONET =	4;                           //	Proteon ProNET Token Ring
LINKTYPE_CHAOS =	5;                            //	Chaos
LINKTYPE_TOKEN_RING	=	6;                       //	IEEE 802 Networks
LINKTYPE_ARCNET =	7;                           //	ARCNET, with BSD-style header
LINKTYPE_SLIP	=	8;                             //	Serial Line IP
LINKTYPE_PPP =	9;                              //	Point-to-point Protocol
LINKTYPE_FDDI	=	10;                            //	FDDI
LINKTYPE_PPP_HDLC =	50;                        //	PPP in HDLC-like framing
LINKTYPE_PPP_ETHER =	51;                       //	NetBSD PPP-over-Ethernet
LINKTYPE_SYMANTEC_FIREWALL	=	99;               //	Symantec Enterprise Firewall
LINKTYPE_ATM_RFC1483 =	100;                    //	LLC/SNAP-encapsulated ATM
LINKTYPE_RAW =	101;                            //	Raw IP
LINKTYPE_SLIP_BSDOS	=	102;                     //	BSD/OS SLIP BPF header
LINKTYPE_PPP_BSDOS =	103;                      //	BSD/OS PPP BPF header
LINKTYPE_C_HDLC =	104;                         //	Cisco HDLC
LINKTYPE_IEEE802_11 =	105;                     //	IEEE 802.11 (wireless)
LINKTYPE_ATM_CLIP =	106;                       //	Linux Classical IP over ATM
LINKTYPE_FRELAY =	107;                         //	Frame Relay
LINKTYPE_LOOP =	108;                           //	OpenBSD loopback
LINKTYPE_ENC =	109;                            //	OpenBSD IPSEC enc
LINKTYPE_LANE8023 =	110;                       //	ATM LANE + 802.3 (Reserved for future use)
LINKTYPE_HIPPI =	111;                          //	NetBSD HIPPI (Reserved for future use)
LINKTYPE_HDLC =	112;                           //	NetBSD HDLC framing (Reserved for future use)
LINKTYPE_LINUX_SLL =	113;                      //	Linux cooked socket capture
LINKTYPE_LTALK =	114;                          //	Apple LocalTalk hardware
LINKTYPE_ECONET	=	115;                         //	Acorn Econet
LINKTYPE_IPFILTER	=	116;                       //	Reserved for use with OpenBSD ipfilter
LINKTYPE_PFLOG =	117;                          //	OpenBSD DLT_PFLOG
LINKTYPE_CISCO_IOS	=	118;                      //	For Cisco-internal use
LINKTYPE_PRISM_HEADER =	119;                   //	802.11+Prism II monitor mode
LINKTYPE_AIRONET_HEADER =	120;                 //	FreeBSD Aironet driver stuff
LINKTYPE_HHDLC =	121;                          //	Reserved for Siemens HiPath HDLC
LINKTYPE_IP_OVER_FC	=	122;                     //	RFC 2625 IP-over-Fibre Channel
LINKTYPE_SUNATM =	123;                         //	Solaris+SunATM
LINKTYPE_RIO	=	124;                            //	RapidIO - Reserved as per request from Kent Dahlgren <kent@praesum.com> for private use.
LINKTYPE_PCI_EXP =	125;                        //	PCI Express - Reserved as per request from Kent Dahlgren <kent@praesum.com> for private use.
LINKTYPE_AURORA =	126;                         //	Xilinx Aurora link layer - Reserved as per request from Kent Dahlgren <kent@praesum.com> for private use.
LINKTYPE_IEEE802_11_RADIO	=	127;               //	802.11 plus BSD radio header
LINKTYPE_TZSP	=	128;                           //	Tazmen Sniffer Protocol - Reserved for the TZSP encapsulation, as per request from Chris Waters <chris.waters@networkchemistry.com> TZSP is a generic encapsulation for any other link type, which includes a means to include meta-information with the packet, e.g. signal strength and channel for 802.11 packets.
LINKTYPE_ARCNET_LINUX =	129;                   //	Linux-style headers
LINKTYPE_JUNIPER_MLPPP	=	130;                  //	Juniper-private data link type, as per request from Hannes Gredler <hannes@juniper.net>. The corresponding DLT_s are used for passing on chassis-internal metainformation such as QOS profiles, etc..
LINKTYPE_JUNIPER_MLFR =	131;                   //	Juniper-private data link type, as per request from Hannes Gredler <hannes@juniper.net>. The corresponding DLT_s are used for passing on chassis-internal metainformation such as QOS profiles, etc..
LINKTYPE_JUNIPER_ES =	132;                     //	Juniper-private data link type, as per request from Hannes Gredler <hannes@juniper.net>. The corresponding DLT_s are used for passing on chassis-internal metainformation such as QOS profiles, etc..
LINKTYPE_JUNIPER_GGSN	=	133;                   //	Juniper-private data link type, as per request from Hannes Gredler <hannes@juniper.net>. The corresponding DLT_s are used for passing on chassis-internal metainformation such as QOS profiles, etc..
LINKTYPE_JUNIPER_MFR =	134;                    //	Juniper-private data link type, as per request from Hannes Gredler <hannes@juniper.net>. The corresponding DLT_s are used for passing on chassis-internal metainformation such as QOS profiles, etc..
LINKTYPE_JUNIPER_ATM2	=	135;                   //	Juniper-private data link type, as per request from Hannes Gredler <hannes@juniper.net>. The corresponding DLT_s are used for passing on chassis-internal metainformation such as QOS profiles, etc..
LINKTYPE_JUNIPER_SERVICES	=	136;               //	Juniper-private data link type, as per request from Hannes Gredler <hannes@juniper.net>. The corresponding DLT_s are used for passing on chassis-internal metainformation such as QOS profiles, etc..
LINKTYPE_JUNIPER_ATM1	=	137;                   //	Juniper-private data link type, as per request from Hannes Gredler <hannes@juniper.net>. The corresponding DLT_s are used for passing on chassis-internal metainformation such as QOS profiles, etc..
LINKTYPE_APPLE_IP_OVER_IEEE1394	=	138;         //	Apple IP-over-IEEE 1394 cooked header
LINKTYPE_MTP2_WITH_PHDR	=	139;                 //	Signaling System 7 Message Transfer Part Level 2, as specified by ITU-T Recommendation Q.703, preceded by a pseudo-header.
LINKTYPE_MTP2 =	140;                           //	Signaling System 7 Message Transfer Part Level 2, as specified by ITU-T Recommendation Q.703.
LINKTYPE_MTP3 =	141;                           //	Signaling System 7 Message Transfer Part Level 3, as specified by ITU-T Recommendation Q.704, with no MTP2 header preceding the MTP3 packet.
LINKTYPE_SCCP =	142;                           //	Signaling System 7 Signalling Connection Control Part, as specified by ITU-T Recommendation Q.711, ITU-T Recommendation Q.712, ITU-T Recommendation Q.713, and ITU-T Recommendation Q.714, with no MTP3 or MTP2 headers preceding the SCCP packet.
LINKTYPE_DOCSIS =	143;                         //	DOCSIS MAC frames, as described by the DOCSIS 3.0 MAC and Upper Layer Protocols Interface Specification.
LINKTYPE_LINUX_IRDA 	=	144;                    //	Linux-IrDA packets, with a LINKTYPE_LINUX_IRDA header, with the payload for IrDA frames beginning with by the IrLAP header as defined by IrDA Data Specifications, including the IrDA Link Access Protocol specification.
LINKTYPE_IBM_SP	=	145;                         //	Reserved for IBM SP switch and IBM Next Federation switch.
LINKTYPE_IBM_SN	=	146;                         //	Reserved for IBM SP switch and IBM Next Federation switch.
LINKTYPE_USER0 = 147;                          // Reserved for private use;
LINKTYPE_USER1 = 148;                          // Reserved for private use;
LINKTYPE_USER2 = 149;                          // Reserved for private use;
LINKTYPE_USER3 = 150;                          // Reserved for private use;
LINKTYPE_USER4 = 151;                          // Reserved for private use;
LINKTYPE_USER5 = 152;                          // Reserved for private use;
LINKTYPE_USER6 = 153;                          // Reserved for private use;
LINKTYPE_USER7 = 154;                          // Reserved for private use;
LINKTYPE_USER8 = 155;                          // Reserved for private use;
LINKTYPE_USER9 = 156;                          // Reserved for private use;
LINKTYPE_USER10 = 157;                         // Reserved for private use;
LINKTYPE_USER11 = 158;                         // Reserved for private use;
LINKTYPE_USER12 = 159;                         // Reserved for private use;
LINKTYPE_USER13 = 160;                         // Reserved for private use;
LINKTYPE_USER14 = 161;                         // Reserved for private use;
LINKTYPE_USER15 = 162;                         // Reserved for private use;
LINKTYPE_IEEE802_11_AVS =	163;	                // DLT_IEEE802_11_RADIO_AVS	AVS monitor mode information followed by an 802.11 header.
LINKTYPE_BACNET_MS_TP	= 165;                   // DLT_BACNET_MS_TP	BACnet MS/TP frames, as specified by section 9.3 MS/TP Frame Format of ANSI/ASHRAE Standard 135, BACnet - A Data Communication Protocol for Building Automation and Control Networks, including the preamble and, if present, the Data CRC.
LINKTYPE_PPP_PPPD	= 166;                       // DLT_PPP_PPPD	PPP in HDLC-like encapsulation, but with the 0xff address byte replaced by a direction indication - 0x00 for incoming and 0x01 for outgoing.
LINKTYPE_GPRS_LLC	= 169;                       // DLT_GPRS_LLC	General Packet Radio Service Logical Link Control, as defined by 3GPP TS 04.64.
LINKTYPE_LINUX_LAPD	= 177;                     // DLT_LINUX_LAPD	Link Access Procedures on the D Channel (LAPD) frames, as specified by ITU-T Recommendation Q.920 and ITU-T Recommendation Q.921, captured via vISDN, with a LINKTYPE_LINUX_LAPD header, followed by the Q.921 frame, starting with the address field.
LINKTYPE_JUNIPER = 178;                        // Juniper Firewall Pseudoheader
LINKTYPE_BLUETOOTH_HCI_H4	= 187;               // DLT_BLUETOOTH_HCI_H4	Bluetooth HCI UART transport layer; the frame contains an HCI packet indicator byte, as specified by Volume 4, part A of the Core Version 4.0 of the Bluetooth specifications, followed by an HCI packet of the specified packet type, as specified by Volume 2, Part E of the same document.
LINKTYPE_USB_LINUX	= 189;                      // DLT_USB_LINUX	USB packets, beginning with a Linux USB header, as specified by the struct usbmon_packet in the Documentation/usb/usbmon.txt file in the Linux source tree. Only the first 48 bytes of that header are present. All fields in the header are in the host byte order for the pcap file, as specified by the file's magic number, or for the section of the pcap-ng file, as specified by the Section Header Block.
LINKTYPE_PPI	= 192;                            // DLT_PPI	Per-Packet Information information, as specified by the Per-Packet Information Header Specification, followed by a packet with the LINKTYPE_ value specified by the pph_dlt field of that header.
LINKTYPE_IEEE802_15_4	= 195;                   // DLT_IEEE802_15_4	IEEE 802.15.4 wireless Personal Area Network, with each packet having the FCS at the end of the frame.
LINKTYPE_SITA	= 196;                           // DLT_SITA	Various link-layer types, with a pseudo-header, for SITA.
LINKTYPE_ERF	= 197;                            // DLT_ERF	Various link-layer types, with a pseudo-header, for Endace DAG cards; encapsulates Endace ERF records.
LINKTYPE_BLUETOOTH_HCI_H4_WITH_PHDR	= 201;     // DLT_BLUETOOTH_HCI_H4_WITH_PHDR	Bluetooth HCI UART transport layer; the frame contains a 4-byte direction field, in network byte order (big-endian), the low-order bit of which is set if the frame was sent from the host to the controller and clear if the frame was received by the host from the controller, followed by an HCI packet indicator byte, as specified by Volume 4, part A of the Core Version 4.0 of the Bluetooth specifications, followed by an HCI packet of the specified packet type, as specified by Volume 2, Part E of the same document.
LINKTYPE_AX25_KISS	= 202;                      // DLT_AX25_KISS	AX.25 packet, with a 1-byte KISS header containing a type indicator.
LINKTYPE_LAPD	= 203;                           // DLT_LAPD	Link Access Procedures on the D Channel (LAPD) frames, as specified by ITU-T Recommendation Q.920 and ITU-T Recommendation Q.921, starting with the address field, with no pseudo-header.
LINKTYPE_PPP_WITH_DIR	= 204;                   // DLT_PPP_WITH_DIR	PPP, as per RFC 1661 and RFC 1662, preceded with a one-byte pseudo-header with a zero value meaning "received by this host" and a non-zero value meaning "sent by this host".
LINKTYPE_C_HDLC_WITH_DIR	= 205;                // DLT_C_HDLC_WITH_DIR	Cisco PPP with HDLC framing, as per section 4.3.1 of RFC 1547, preceded with a one-byte pseudo-header with a zero value meaning "received by this host" and a non-zero value meaning "sent by this host".
LINKTYPE_FRELAY_WITH_DIR =	206;                // DLT_FRELAY_WITH_DIR	Frame Relay, preceded with a one-byte pseudo-header with a zero value meaning "received by this host" and a non-zero value meaning "sent by this host".
LINKTYPE_IPMB_LINUX	= 209;                     // DLT_IPMB_LINUX	IPMB over an I2C circuit, with a Linux-specific pseudo-header.
LINKTYPE_IEEE802_15_4_NONASK_PHY	= 215;        // DLT_IEEE802_15_4_NONASK_PHY	IEEE 802.15.4 wireless Personal Area Network, with each packet having the FCS at the end of the frame, and with the PHY-level data for non-ASK PHYs (4 octets of 0 as preamble, one octet of SFD, one octet of frame length + reserved bit) preceding the MAC-layer data (starting with the frame control field).
LINKTYPE_USB_LINUX_MMAPPED	= 220;              // DLT_USB_LINUX_MMAPPED	USB packets, beginning with a Linux USB header, as specified by the struct usbmon_packet in the Documentation/usb/usbmon.txt file in the Linux source tree. All 64 bytes of the header are present. All fields in the header are in the host byte order for the pcap file, as specified by the file's magic number, or for the section of the pcap-ng file, as specified by the Section Header Block. For isochronous transfers, the ndesc field specifies the number of isochronous descriptors that follow.
LINKTYPE_FC_2	= 224;                           // DLT_FC_2	Fibre Channel FC-2 frames, beginning with a Frame_Header.
LINKTYPE_FC_2_WITH_FRAME_DELIMS	= 225;         // DLT_FC_2_WITH_FRAME_DELIMS	Fibre Channel FC-2 frames, beginning an encoding of the SOF, followed by a Frame_Header, and ending with an encoding of the SOF.
LINKTYPE_IPNET	= 226;                          // DLT_IPNET	Solaris ipnet pseudo-header, followed by an IPv4 or IPv6 datagram.
LINKTYPE_CAN_SOCKETCAN	= 227;                  // DLT_CAN_SOCKETCAN	CAN (Controller Area Network) frames, with a pseudo-header as supplied by Linux SocketCAN.
LINKTYPE_IPV4	= 228;                           // DLT_IPV4	Raw IPv4; the packet begins with an IPv4 header.
LINKTYPE_IPV6	= 229;                           // DLT_IPV6	Raw IPv6; the packet begins with an IPv6 header.
LINKTYPE_IEEE802_15_4_NOFCS	= 230;             // DLT_IEEE802_15_4_NOFCS	IEEE 802.15.4 wireless Personal Area Network, without the FCS at the end of the frame.
LINKTYPE_DBUS	= 231;                           //	DLT_DBUS	Raw D-Bus messages, starting with the endianness flag, followed by the message type, etc., but without the authentication handshake before the message sequence.
LINKTYPE_DVB_CI	= 235;	                        // DLT_DVB_CI	DVB-CI (DVB Common Interface for communication between a PC Card module and a DVB receiver), with the message format specified by the PCAP format for DVB-CI specification.
LINKTYPE_MUX27010	= 236;                       // DLT_MUX27010	Variant of 3GPP TS 27.010 multiplexing protocol (similar to, but not the same as, 27.010).
LINKTYPE_STANAG_5066_D_PDU	= 237;              // DLT_STANAG_5066_D_PDU	D_PDUs as described by NATO standard STANAG 5066, starting with the synchronization sequence, and including both header and data CRCs. The current version of STANAG 5066 is backwards-compatible with the 1.0.2 version, although newer versions are classified.
LINKTYPE_NFLOG	= 239;                          //	DLT_NFLOG	Linux netlink NETLINK NFLOG socket log messages.
LINKTYPE_NETANALYZER	= 240;                    // DLT_NETANALYZER	Pseudo-header for Hilscher Gesellschaft fr Systemautomation mbH netANALYZER devices, followed by an Ethernet frame, beginning with the MAC header and ending with the FCS.
LINKTYPE_NETANALYZER_TRANSPARENT	= 241;        // DLT_NETANALYZER_TRANSPARENT	Pseudo-header for Hilscher Gesellschaft fr Systemautomation mbH netANALYZER devices, followed by an Ethernet frame, beginning with the preamble, SFD, and MAC header, and ending with the FCS.
LINKTYPE_IPOIB	= 242;                          //	DLT_IPOIB	IP-over-Infiniband, as specified by RFC 4391 section 6.
LINKTYPE_MPEG_2_TS	= 243;                      // DLT_MPEG_2_TS	MPEG-2 Transport Stream transport packets, as specified by ISO 13818-1/ITU-T Recommendation H.222.0 (see table 2-2 of section 2.4.3.2 "Transport Stream packet layer").
LINKTYPE_NG40	= 244;                           //	DLT_NG40	Pseudo-header for ng4T GmbH's UMTS Iub/Iur-over-ATM and Iub/Iur-over-IP format as used by their ng40 protocol tester, followed by frames for the Frame Protocol as specified by 3GPP TS 25.427 for dedicated channels and 3GPP TS 25.435 for common/shared channels in the case of ATM AAL2 or UDP traffic, by SSCOP packets as specified by ITU-T Recommendation Q.2110 for ATM AAL5 traffic, and by NBAP packets for SCTP traffic.
LINKTYPE_NFC_LLCP	= 245;                       // DLT_NFC_LLCP	Pseudo-header for NFC LLCP packet captures, followed by frame data for the LLCP Protocol as specified by NFCForum-TS-LLCP_1.1.
