/* TraceWrangler - Network Capture File Toolkit
   By Jasper Bongertz <jasper@packet-foo.com>
   Copyright 2016 Jasper Bongertz
 
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

CREATE TABLE "TCPConversations" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "IPVersion" INTEGER DEFAULT 4, "SourceIP" VARCHAR, "SourcePort" INTEGER, "DestinationIP" VARCHAR, "DestinationPort" INTEGER, "ClientIP" VARCHAR, "FramesSrcToDst" INTEGER DEFAULT 0, "FramesDstToSrc" INTEGER DEFAULT 0, "BytesSrcToDst" INTEGER DEFAULT 0, "BytesDstToSrc" INTEGER DEFAULT 0, "FirstFrame" BIGINT DEFAULT 0, "LastFrame" BIGINT DEFAULT 0, "FirstFrameOffset" BIGINT DEFAULT 0, "LastFrameOffset" BIGINT DEFAULT 0, "FirstFrameTime" DATETIME, "FirstFrameTimeNano" INTEGER DEFAULT 0, "LastFrameTime" DATETIME, "LastFrameTimeNano" INTEGER DEFAULT 0, "SessionStatus" INTEGER DEFAULT 0, "SynFlagSeen" BOOL DEFAULT 0, "FinFlagSeen" BOOL DEFAULT 0, "RstFlagSeen" BOOL DEFAULT 0, "TCPFlags" INTEGER DEFAULT 0, "InitialRTTns" BIGINT DEFAULT 0, "Quality" INTEGER, "FlagIPv4" BOOL DEFAULT 0, "FlagIPv6" BOOL DEFAULT 0, "FlagICMP" BOOL DEFAULT 0, "Attributes" INTEGER DEFAULT 0, "InterfaceIDs" VARCHAR, "TunnelFlags" INTEGER DEFAULT 0, "MiscInfo" VARCHAR);
CREATE TABLE "UDPConversations" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "IPVersion" INTEGER DEFAULT 4, "SourceIP" VARCHAR, "SourcePort" INTEGER, "DestinationIP" VARCHAR, "DestinationPort" INTEGER, "FramesSrcToDst" INTEGER DEFAULT 0, "FramesDstToSrc" INTEGER DEFAULT 0, "BytesSrcToDst" INTEGER DEFAULT 0, "BytesDstToSrc" INTEGER DEFAULT 0, "FirstFrame" BIGINT DEFAULT 0, "LastFrame" BIGINT DEFAULT 0, "FirstFrameOffset" BIGINT DEFAULT 0, "LastFrameOffset" BIGINT DEFAULT 0, "FirstFrameTime" DATETIME, "FirstFrameTimeNano" INTEGER DEFAULT 0, "LastFrameTime" DATETIME, "LastFrameTimeNano" INTEGER DEFAULT 0, "FlagIPv4" BOOL DEFAULT 0, "FlagIPv6" BOOL DEFAULT 0, "FlagICMP" BOOL DEFAULT 0, "Attributes" INTEGER DEFAULT 0, "InterfaceIDs" VARCHAR, "TunnelFlags" INTEGER DEFAULT 0, "MiscInfo" VARCHAR);
CREATE TABLE "IPv4Conversations" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "SourceIP" VARCHAR, "DestinationIP" VARCHAR, "FramesSrcToDst" INTEGER DEFAULT 0, "FramesDstToSrc" INTEGER DEFAULT 0, "BytesSrcToDst" INTEGER DEFAULT 0, "BytesDstToSrc" INTEGER DEFAULT 0, "FirstFrame" BIGINT DEFAULT 0, "LastFrame" BIGINT DEFAULT 0, "FirstFrameOffset" BIGINT DEFAULT 0, "LastFrameOffset" BIGINT DEFAULT 0, "FirstFrameTime" DATETIME, "FirstFrameTimeNano" INTEGER DEFAULT 0, "LastFrameTime" DATETIME, "LastFrameTimeNano" INTEGER DEFAULT 0, "FlagARP" BOOL DEFAULT 0, "FlagIPv4" BOOL DEFAULT 0, "FlagDNS" BOOL DEFAULT 0, "FlagICMP" BOOL DEFAULT 0, "FlagNRB" BOOL DEFAULT 0, "Attributes" INTEGER DEFAULT 0, "InterfaceIDs" VARCHAR, "MiscInfo" VARCHAR);
CREATE TABLE "IPv4Endpoints" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "IPAddress" VARCHAR, "FramesReceived" INTEGER DEFAULT 0, "FramesSent" INTEGER DEFAULT 0, "BytesReceived" INTEGER DEFAULT 0, "BytesSent" INTEGER DEFAULT 0, "FirstFrame" BIGINT DEFAULT 0, "LastFrame" BIGINT DEFAULT 0, "FirstFrameOffset" BIGINT DEFAULT 0, "LastFrameOffset" BIGINT DEFAULT 0, "FirstFrameTime" DATETIME, "FirstFrameTimeNano" INTEGER DEFAULT 0, "LastFrameTime" DATETIME, "LastFrameTimeNano" INTEGER DEFAULT 0, "TTL" INTEGER DEFAULT 0, "FlagARP" BOOL DEFAULT 0, "FlagIPv4" BOOL DEFAULT 0, "FlagDNS" BOOL DEFAULT 0, "FlagICMP" BOOL DEFAULT 0, "FlagNRB" BOOL DEFAULT 0, "Attributes" INTEGER DEFAULT 0, "InterfaceIDs" VARCHAR, "MiscInfo" VARCHAR);
CREATE TABLE "IPv6Conversations" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "SourceIP" VARCHAR, "DestinationIP" VARCHAR, "FramesSrcToDst" INTEGER DEFAULT 0, "FramesDstToSrc" INTEGER DEFAULT 0, "BytesSrcToDst" INTEGER DEFAULT 0, "BytesDstToSrc" INTEGER DEFAULT 0, "FirstFrame" BIGINT DEFAULT 0, "LastFrame" BIGINT DEFAULT 0, "FirstFrameOffset" BIGINT DEFAULT 0, "LastFrameOffset" BIGINT DEFAULT 0, "FirstFrameTime" DATETIME, "FirstFrameTimeNano" INTEGER DEFAULT 0, "LastFrameTime" DATETIME, "LastFrameTimeNano" INTEGER DEFAULT 0, "FlagIPv6" BOOL DEFAULT 0, "FlagDNS" BOOL DEFAULT 0, "FlagICMP" BOOL DEFAULT 0, "FlagNRB" BOOL DEFAULT 0, "Attributes" INTEGER DEFAULT 0, "InterfaceIDs" VARCHAR, "MiscInfo" VARCHAR);
CREATE TABLE "IPv6Endpoints" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "IPAddress" VARCHAR, "FramesReceived" INTEGER DEFAULT 0, "FramesSent" INTEGER DEFAULT 0, "BytesReceived" INTEGER DEFAULT 0, "BytesSent" INTEGER DEFAULT 0, "FirstFrame" BIGINT DEFAULT 0, "LastFrame" BIGINT DEFAULT 0, "FirstFrameOffset" BIGINT DEFAULT 0, "LastFrameOffset" BIGINT DEFAULT 0, "FirstFrameTime" DATETIME, "FirstFrameTimeNano" INTEGER DEFAULT 0, "LastFrameTime" DATETIME, "LastFrameTimeNano" INTEGER DEFAULT 0, "HopLimit" INTEGER DEFAULT 0, "FlagIPv6" BOOL DEFAULT 0, "FlagDNS" BOOL DEFAULT 0, "FlagICMP" BOOL DEFAULT 0, "FlagNRB" BOOL DEFAULT 0, "Attributes" INTEGER DEFAULT 0, "InterfaceIDs" VARCHAR, "MiscInfo" VARCHAR);
CREATE TABLE "MACConversations" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "SourceMAC" VARCHAR, "DestinationMAC" VARCHAR, "FramesSrcToDst" INTEGER DEFAULT 0, "FramesDstToSrc" INTEGER DEFAULT 0, "BytesSrcToDst" INTEGER DEFAULT 0, "BytesDstToSrc" INTEGER DEFAULT 0, "FirstFrame" BIGINT DEFAULT 0, "LastFrame" BIGINT DEFAULT 0, "FirstFrameOffset" BIGINT DEFAULT 0, "LastFrameOffset" BIGINT DEFAULT 0, "FirstFrameTime" DATETIME, "FirstFrameTimeNano" INTEGER DEFAULT 0, "LastFrameTime" DATETIME, "LastFrameTimeNano" INTEGER DEFAULT 0, "FlagEthernet" BOOL DEFAULT 0, "FlagARP" BOOL DEFAULT 0, "Attributes" INTEGER DEFAULT 0, "InterfaceIDs" VARCHAR, "MiscInfo" VARCHAR);
CREATE TABLE "MACEndpoints" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "MACAddress" VARCHAR, "FramesReceived" INTEGER DEFAULT 0, "FramesSent" INTEGER DEFAULT 0, "BytesReceived" INTEGER DEFAULT 0, "BytesSent" INTEGER DEFAULT 0, "FirstFrame" BIGINT DEFAULT 0, "LastFrame" BIGINT DEFAULT 0, "FirstFrameOffset" BIGINT DEFAULT 0, "LastFrameOffset" BIGINT DEFAULT 0, "FirstFrameTime" DATETIME, "FirstFrameTimeNano" INTEGER DEFAULT 0, "LastFrameTime" DATETIME, "LastFrameTimeNano" INTEGER DEFAULT 0, "FlagEthernet" BOOL DEFAULT 0, "FlagARP" BOOL DEFAULT 0, "Attributes" INTEGER DEFAULT 0, "InterfaceIDs" VARCHAR, "MiscInfo" VARCHAR);
CREATE TABLE "MACtoIPLinks" ("id" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL UNIQUE, "fileid" INTEGER NOT NULL, "MACIndex" INTEGER NOT NULL, "IPIndex" INTEGER NOT NULL, "Anchor" VARCHAR, "Framecount" INTEGER DEFAULT 0);
CREATE TABLE "NameResolution" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "ipversion" INTEGER DEFAULT 4, "fqdn" CHAR, "answertype" INTEGER DEFAULT 0, "answer" CHAR, "ReplyCode" INTEGER DEFAULT 0, "FrameCount" INTEGER DEFAULT 0, "FirstFrame" BIGINT DEFAULT 0, "LastFrame" BIGINT DEFAULT 0, "FirstFrameOffset" BIGINT DEFAULT 0, "LastFrameOffset" BIGINT DEFAULT 0, "FirstFrameTime" DATETIME, "FirstFrameTimeNano" INTEGER DEFAULT 0, "LastFrameTime" DATETIME, "LastFrameTimeNano" INTEGER DEFAULT 0, "QueryTypes" BIGINT DEFAULT 0, "FlagIsAnswer" BOOL default 0, "FlagQueryOnly" BOOL DEFAULT 0, "FlagNRB" BOOL DEFAULT 0, "FlagDNS" BOOL DEFAULT 0, "FlagNBNS" BOOL DEFAULT 0, "FlagDHCP" BOOL DEFAULT 0, "FlagExternalResearch" BOOL DEFAULT 0, "InterfaceIDs" VARCHAR, "MiscInfo" VARCHAR);
CREATE TABLE "blockchainentries" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "blocksequence" INTEGER DEFAULT 0, "blocktypeid" INTEGER DEFAULT 0, "sectionstartoffset" BIGINT DEFAULT 0, "sectionendoffset" BIGINT DEFAULT 0, "firstblockstartoffset" BIGINT DEFAULT 0, "lastblockendoffset" BIGINT DEFAULT 0, "blocklength" INTEGER DEFAULT 0, "count" BIGINT DEFAULT 0, "shb_majorversion" INTEGER DEFAULT 0, "shb_minorversion" INTEGER DEFAULT 0, "shb_byteordermagic" INTEGER DEFAULT 0, "shb_sectionlength" CHAR, "shb_comment" CHAR, "shb_hardware" CHAR, "shb_os" CHAR, "shb_userappl" CHAR, "shb_guid" CHAR, "idb_index" INTEGER DEFAULT 0, "idb_linktype" INTEGER DEFAULT 0, "idb_snaplen" INTEGER DEFAULT 0, "idb_name" CHAR, "idb_description" CHAR, "idb_tsresolution" INTEGER DEFAULT 0, "idb_filter" CHAR, "isb_interfaceid" INTEGER DEFAULT 0, "isb_timestamp" DATETIME, "isb_starttime" DATETIME, "isb_endtime" DATETIME, "isb_received" INTEGER DEFAULT 0, "isb_dropped" INTEGER DEFAULT 0, "nrb_ipv4recordcount" INTEGER DEFAULT 0, "nrb_ipv6recordcount" INTEGER DEFAULT 0);
CREATE TABLE "filelist" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "filename" CHAR NOT NULL , "filepath" CHAR NOT NULL , "filesize" BIGINT, "filedate" DATETIME, "fullfilescanned" BOOL DEFAULT 0, "pcapngstructscanned" BOOL NOT NULL  DEFAULT 0, "conversationsscanned" BOOL NOT NULL  DEFAULT 0, "processingstatus" INTEGER DEFAULT 1, "tasksprocessed" INTEGER DEFAULT 0, "firstframetimestamp" DATETIME, "firstframenanoseconds" INTEGER DEFAULT 0, "lastframetimestamp" DATETIME, "lastframenanoseconds" INTEGER DEFAULT 0, "LayerComplexity" INTEGER DEFAULT 0);
CREATE TABLE "filestatistics" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER, "firstframetime" DATETIME, "firstframetimenanosecs" INTEGER DEFAULT 0, "firstframeoffset" BIGINT DEFAULT 0, "lastframetime" DATETIME, "lastframetimenanosecs" INTEGER DEFAULT 0, "lastframeoffset" BIGINT DEFAULT 0, "minframesize" INTEGER DEFAULT 0, "maxframesize" INTEGER DEFAULT 0, "averageframesize" INTEGER DEFAULT 0, "framecount" INTEGER DEFAULT 0, "totalframebytes" INTEGER DEFAULT 0, "totalwirebytes" INTEGER DEFAULT 0, "isFrameSliced" BOOL DEFAULT 0, "SliceIsConstant" BOOL DEFAULT 1, "slicesize" INTEGER DEFAULT 0, "TimeOrderIsCorrect" BOOL DEFAULT 1, "OutOfTimeFrames" INTEGER DEFAULT 0);
CREATE TABLE "framecomments" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER, "frameid" INTEGER, "comment" VARCHAR);
CREATE TABLE "meta" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "name" CHAR, "value" CHAR);
CREATE TABLE "nrbentries" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER, "ipversion" INTEGER DEFAULT 4, "fqdn" CHAR, "address" CHAR);
CREATE TABLE "pcapngfilestatistics" ("id" INTEGER PRIMARY KEY  AUTOINCREMENT  NOT NULL  UNIQUE , "fileid" INTEGER DEFAULT 0, "sectioncount" INTEGER DEFAULT 0, "filepacketcount" INTEGER DEFAULT 0, "fileinterfacecount" INTEGER DEFAULT 0, "statisticblockcount" INTEGER DEFAULT 0, "statpacketcount" INTEGER DEFAULT 0, "statfilteracceptcount" INTEGER DEFAULT 0, "statosdropcount" INTEGER DEFAULT 0, "statusdeliveredcount" INTEGER DEFAULT 0, "errorcode" INTEGER DEFAULT 0, "errortext" CHAR);
CREATE TABLE "messages" ("id" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL UNIQUE, "fileid" INTEGER NOT NULL, "componentid" INTEGER NOT NULL, "severity" INTEGER DEFAULT 0, "messageid" INTEGER DEFAULT 0, "messagetext" VARCHAR, "parameterlist" VARCHAR, "frameindex" INTEGER DEFAULT 0, "codelocation" VARCHAR);
CREATE TABLE "PortMapping" ("id" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL UNIQUE, "MapType" INTEGER NOT NULL, "SourceIP" VARCHAR, "DestinationIP" VARCHAR, SourcePort INTEGER, DestinationPort INTEGER, "ProtocolIndex" INTEGER NOT NULL);
CREATE TABLE "AddressBook" ("id" INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL UNIQUE, "AddressType" INTEGER NOT NULL, "Address1" VARCHAR NOT NULL, "Address2" VARCHAR NOT NULL, "Address3" VARCHAR NOT NULL, "Name" VARCHAR NOT NULL, "Anchor" VARCHAR);
CREATE INDEX "IntelDBReadFileStatisticsByFileIndex" ON filestatistics (fileid);
CREATE INDEX "IntelDBReadBlockChainEntriesByFileIndex" ON blockchainentries (fileid);
CREATE INDEX "IntelDBReadBlockChainEntriesByFileIndexAndSequence" ON blockchainentries (fileid,blocksequence);
CREATE INDEX "IntelDBReadFrameCommentsByFileIndex" ON framecomments (fileid);
CREATE INDEX "IntelDBReadPCAPNGStatisticsByFileIndex" ON pcapngfilestatistics (fileid);
CREATE INDEX "IntelDBReadNRBEntriesByFileIndex" ON nrbentries (fileid,ipversion);
CREATE INDEX "ConvStoreReadMACEndpoints" ON MACEndpoints (fileid,FirstFrame);
CREATE INDEX "ConvStoreReadMACConversations" ON MACConversations (fileid,FirstFrame);
CREATE INDEX "ConvStoreReadIPv4Endpoints" ON IPv4Endpoints (fileid,FirstFrame);
CREATE INDEX "ConvStoreReadIPv4Conversations" ON IPv4Conversations (fileid,FirstFrame);
CREATE INDEX "ConvStoreReadIPv6Endpoints" ON IPv6Endpoints (fileid,FirstFrame);
CREATE INDEX "ConvStoreReadIPv6Conversations" ON IPv6Conversations (fileid,FirstFrame);
CREATE INDEX "ConvStoreReadTCPConversations" ON TCPConversations (fileid,FirstFrame);
CREATE INDEX "ConvStoreReadUDPConversations" ON UDPConversations (fileid,FirstFrame);
CREATE INDEX "ConvStoreReadNameResolution" ON NameResolution (fileid,FirstFrame);