{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

unit dialog_debuginfo;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls;

type
  TFormDebugDetails = class(TForm)
    PageControl1: TPageControl;
    TabSheetRecordSizes: TTabSheet;
    MemoRecordSizes: TMemo;
    procedure onShow(Sender: TObject);
    procedure onCreate(Sender: TObject);
  private
         procedure ShowRecordSizes;
  public

  end;

var
  FormDebugDetails: TFormDebugDetails;

implementation

{$R *.dfm}

uses definition_conversation_types,
     definition_filter_structures,
     definition_tcp_structures;

(* ------------------------------------------- *)

procedure TFormDebugDetails.onCreate(Sender: TObject);

begin
     // Workaround for scaling problems: look for /noscale command line option

     self.Scaled := FindCmdLineSwitch ('noscale');
end;

(* ------------------------------------------- *)

procedure TFormDebugDetails.onShow(Sender: TObject);

begin
     ShowRecordSizes;
end;

(* ------------------------------------------- *)

procedure TFormDebugDetails.ShowRecordSizes;

begin
     MemoRecordSizes.Lines.Clear;
     MemoRecordSizes.Lines.Add ('Filter Struct: ' + IntToStr (sizeOf (tFrameFilter)) + ' bytes');
     MemoRecordSizes.Lines.Add ('');
     MemoRecordSizes.Lines.Add ('MAC Endpoint:' + IntToStr (sizeOf (tMACEndpoint)) + ' bytes');
     MemoRecordSizes.Lines.Add ('IPv4 Endpoint:' + IntToStr (sizeOf (tIPv4Endpoint)) + ' bytes');
     MemoRecordSizes.Lines.Add ('IPv6 Endpoint:' + IntToStr (sizeOf (tIPv6Endpoint)) + ' bytes');
     MemoRecordSizes.Lines.Add ('MAC Conversation:' + IntToStr (sizeOf (tMACConversation)) + ' bytes');
     MemoRecordSizes.Lines.Add ('IPv4 Conversation:' + IntToStr (sizeOf (tIPv4Conversation)) + ' bytes');
     MemoRecordSizes.Lines.Add ('IPv6 Conversation:' + IntToStr (sizeOf (tIPv6Conversation)) + ' bytes');
//   MemoRecordSizes.Lines.Add ('TCPv4 Conversation:' + IntToStr (sizeOf (tTCPIPv4Conversation)) + ' bytes');
//   MemoRecordSizes.Lines.Add ('TCPv6 Conversation:' + IntToStr (sizeOf (tTCPIPv6Conversation)) + ' bytes');
     MemoRecordSizes.Lines.Add ('TCP Conversation:' + IntToStr (sizeOf (tTCPConversation)) + ' bytes');
//   MemoRecordSizes.Lines.Add ('UDPv4 Conversation:' + IntToStr (sizeOf (tUDPIPv4Conversation)) + ' bytes');
//   MemoRecordSizes.Lines.Add ('UDPv6 Conversation:' + IntToStr (sizeOf (tUDPIPv6Conversation)) + ' bytes');
     MemoRecordSizes.Lines.Add ('UDP Conversation:' + IntToStr (sizeOf (tUDPConversation)) + ' bytes');
     MemoRecordSizes.Lines.Add ('Name Resolution:' + IntToStr (sizeOf (tNameResolutionEntry)) + ' bytes');
     MemoRecordSizes.Lines.Add ('');
     MemoRecordSizes.Lines.Add ('TCPBasicConversationState:' + IntToStr (sizeOf (tTCPBasicConversationState)) + ' bytes');
end;

(* ------------------------------------------- *)

end.
