{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

unit dialog_edit_interface;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls;

type
  TFormEditInterface = class(TForm)
    GroupBoxInterfaceDetails: TGroupBox;
    LabelInterfaceName: TLabel;
    EditInterfaceName: TEdit;
    LabelInterfaceDescription: TLabel;
    EditInterfaceDescription: TEdit;
    ButtonOkay: TButton;
    ButtonCancel: TButton;
    LabelLinkLayerType: TLabel;
    ComboBoxLinkLayerType: TComboBox;
    LabelSnapLength: TLabel;
    EditSnapLength: TEdit;
    UpDownSnapLength: TUpDown;
    LabelTimestampResolution: TLabel;
    ComboBoxTimestampResolution: TComboBox;
    EditCustomTSResolution: TEdit;
    procedure onChangeTimestampResolution(Sender: TObject);
    procedure onCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

        procedure initialize;
  end;

var
  FormEditInterface: TFormEditInterface;

implementation

{$R *.dfm}

(* -------------------------------------- *)

procedure TFormEditInterface.onCreate(Sender: TObject);

begin
     // Workaround for scaling problems: look for /noscale command line option

     self.Scaled := FindCmdLineSwitch ('noscale');
end;

(* -------------------------------------- *)

procedure TFormEditInterface.initialize;

begin
     EditInterfaceName.Text := '';
     EditInterfaceDescription.Text := '';
     ComboBoxLinkLayerType.ItemIndex := 0;
     UpDownSnapLength.Position := 65535;
     ComboBoxTimestampResolution.ItemIndex := 1;
end;

(* -------------------------------------- *)

procedure TFormEditInterface.onChangeTimestampResolution(Sender: TObject);

begin
     case ComboBoxTimestampResolution.ItemIndex of
      0 : begin
               EditCustomTSResolution.Text := '3';
               EditCustomTSResolution.Enabled := false;
               EditCustomTSResolution.Visible := false;
          end;
      1 : begin
               EditCustomTSResolution.Text := '6';
               EditCustomTSResolution.Enabled := false;
               EditCustomTSResolution.Visible := false;
          end;
      2 : begin
               EditCustomTSResolution.Text := '9';
               EditCustomTSResolution.Enabled := false;
               EditCustomTSResolution.Visible := false;
          end;
      3 : begin
               EditCustomTSResolution.Enabled := true;
               EditCustomTSResolution.Visible := true;
          end;
     end;
end;

(* -------------------------------------- *)

end.
