{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit form_about;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Vcl.Imaging.pngimage;

type
  TFormAbout = class(TForm)
    Image1: TImage;
    LabelHeadline: TLabel;
    LabelBuildDate: TLabel;
    LabelCopyright: TLabel;
    Button1: TButton;
    LabelAlphaBuild: TLabel;
    MemoThanks: TMemo;
    procedure onShow(Sender: TObject);
    procedure onCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormAbout: TFormAbout;

implementation

uses DateUtils,
     toolkit;

{$R *.dfm}

{$i 'base\builddate.inc'}
{
const BuildDay = 23;
      BuildMonth = 12;
      BuildYear = 2014;
}
(* ------------------------------------------- *)

procedure TFormAbout.onCreate(Sender: TObject);

begin
     // Workaround for scaling problems: look for /noscale command line option

     self.Scaled := FindCmdLineSwitch ('noscale');
end;

(* ------------------------------------------- *)

procedure TFormAbout.onShow(Sender: TObject);

var exeversion : string;
    builddate  : tDateTime;

begin
     exeversion := getExeVersion (ParamStr(0));
     builddate := encodeDateTime (BuildYear, BuildMonth, BuildDay, 0,0,0,0);

     LabelHeadline.Caption := 'TraceWrangler Version ' + exeversion;

     if (BuildYear = yearOf (now)) and (BuildMonth = monthOf (now)) and (BuildDay = dayOf (now)) then
        LabelBuildDate.Caption := 'Built today'
     else
         LabelBuildDate.Caption := 'Built on ' + DateToStr (builddate);

     LabelCopyright.Caption := '(c) 2013-' + IntToStr (BuildYear) + ' Jasper Bongertz, all rights reserved';
end;

(* ------------------------------------------- *)

end.
