{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

unit class_frameprocessor_reassembler;

interface

uses base_structures,
     class_rawframe,
     class_frameprocessor_baseclass;

type tFrameProcessorReassembler = class (tFrameProcessor)

                                        private
                                               function getRawFrameFromFrameChunk (Frame : tRawFrame; PayLoad : tFrameChunk; FrameLengthModifier : integer) : tRawFrame;

                                        public
                                              /// <summary>
                                              ///   Removes all MPLS shims from the
                                              ///   frame if found, and moves the
                                              ///   tunneled content to the
                                              ///   beginning of the frame.
                                              /// </summary>
                                              /// <param name="Frame">
                                              ///   Frame to be processed
                                              /// </param>
                                              function getProcessedFrame (Frame : tRawFrame) : tRawFrame; override;
                                  end;

implementation

uses SiAuto,
     SysUtils,
     class_parser_baseclass,
     common_parse_helpers,
     base_checksums,
     class_parser_ethernet,
     class_parser_ipv4,
     class_parser_ipv6,
     class_assembly_ethernet,
     class_parsemaster;

(* ------------------------------------------- *)
{ tFrameProcessorReassembler }
(* ------------------------------------------- *)

function tFrameProcessorReassembler.getRawFrameFromFrameChunk (Frame: tRawFrame; PayLoad: tFrameChunk; FrameLengthModifier: integer): tRawFrame;

begin

end;

(* ------------------------------------------- *)

function tFrameProcessorReassembler.getProcessedFrame (Frame: tRawFrame): tRawFrame;

var
//  ParseMaster  : tParseMaster;
    ParseEntry   : tParseEntry;
    NewFrame     : tRawFrame;
    HeaderType   : tHeaderType;
    EthParser    : tEthernetParser;
    EthAssembler : tEthernetAssembler;
    GenParser    : tFrameParser;
    FirstChunk   : tFrameChunk;
    SecondChunk  : tFrameChunk;
    MergeChunk   : tFrameChunk;
    found        : boolean;
    FirstShim    : integer;
    LastShim     : integer;
    FirstOffset  : integer;
    LastOffset   : integer;
    i            : integer;

begin
//   SiMain.EnterMethod ('tFrameProcessorReassembler.getProcessedFrame');

     if not assigned (prot_ParseMaster) then
        prot_ParseMaster := tParseMaster.create(Frame, ppmParseAll);






     result := NewFrame;

//   SiMain.LeaveMethod ('tFrameProcessorReassembler.getProcessedFrame');
end;

(* ------------------------------------------- *)

end.
