{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit main;

interface

uses Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
     Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.Menus,
     Vcl.ComCtrls, VirtualTrees, Vcl.StdCtrls, Vcl.Buttons, Vcl.ImgList, Vcl.Imaging.pngimage,

{$ifndef disableupdatecheck}

     IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, IdAuthentication,
     IdIOHandler, IdIOHandlerSocket, IdIOHandlerStack, IdSSL, IdSSLOpenSSL,

{$endif}

     // Debugging

     SiAuto,

     // Trace and Packet handling classes

     base_structures,
     pcapng_structures,
     definition_simple_nameresolution,
     definition_conversation_types,
     class_diagmessagehandler,
     class_tracefilelist,
     class_tracefilesetloader,
     class_taskprocessor_baseclass,
     class_tasklistmanager,
     class_frameprocessor_multiwriter, FireDAC.Moni.Base,
     FireDAC.Moni.RemoteClient, System.Actions, Vcl.ActnList;

type tListProcessOption = (plRemoveFile, plShowFileDetails, plSetTimeStampToFirstFrame, plSetTimeStampToLastFrame, plExportDescription, plRenameFile);

     TFormMain = class (TForm)

                       MainMenuMain: TMainMenu;
                       StatusBarMain: TStatusBar;
                       MenuFile: TMenuItem;
                       MenuExit: TMenuItem;
                       PanelMainLevel1Top: TPanel;
                       PanelMainLevel1Bottom: TPanel;
                       SplitterMainLevel1: TSplitter;
                       PopupMenuFilelist: TPopupMenu;
                       MenuPopupMainAddFiles: TMenuItem;
                       MenuPopupMainRemoveFiles: TMenuItem;
                       MenuOptions: TMenuItem;
                       MenuPreferences: TMenuItem;
                       MenuHelp: TMenuItem;
                       PanelMainLevel2Tasks: TPanel;
                       PanelMainLevel2TaskDetails: TPanel;
                       SplitterMainLevel2: TSplitter;
                       VSTTaskList: TVirtualStringTree;
                       ButtonAddTask: TButton;
                       ButtonRemoveTask: TButton;
                       PageControlMainDetails: TPageControl;
                       TabSheetPCAPngDetails: TTabSheet;
                       QuickInfo: TTabSheet;
                       PageControlFileList: TPageControl;
                       TabSheetFilelistStart: TTabSheet;
                       TabSheetFilelist: TTabSheet;
                       VSTTraceFilelist: TVirtualStringTree;
                       ButtonAddTracefiles: TBitBtn;
                       PanelIntro: TPanel;
                       VSTFileDetails: TVirtualStringTree;
                       GroupBoxGeneralDetails: TGroupBox;
                       TimerStartup: TTimer;
                       LabelFilename: TLabel;
                       LabelValueFilename: TLabel;
                       LabelScanStatus: TLabel;
                       LabelValueScanStatus: TLabel;
                       ButtonExecuteTasks: TButton;
                       MemoMainStartHint: TMemo;
                       LabelPCAPngStructureNotScannedNote: TLabel;
                       ButtonPCAPngScanNow: TButton;
                       TabSheetLog: TTabSheet;
                       RichEditLog: TRichEdit;
                       ButtonEditTask: TButton;
                       MenuLoadFiles: TMenuItem;
                       MenuAbout: TMenuItem;
                       MenuCheckForUpdate: TMenuItem;
                       PopupMenuTaskList: TPopupMenu;
                       MenuTaskExport: TMenuItem;
                       MenuTaskImport: TMenuItem;
                       MenuPopupMainSetFileTime: TMenuItem;
                       MenuPopupMainSetFileTimeToFirstFrame: TMenuItem;
                       MenuPopupMainSeparator1: TMenuItem;
                       LabelPacketCount: TLabel;
                       LabelValuePacketCount: TLabel;
                       LabelFirstFrame: TLabel;
                       LabelValueFirstFrame: TLabel;
                       LabelLastFrame: TLabel;
                       LabelValueLastFrame: TLabel;
                       LabelTraceDuration: TLabel;
                       LabelValueTraceDuration: TLabel;
                       MenuPopupMainSetFileTimeToLastFrame: TMenuItem;
                       LabelFrameSlided: TLabel;
                       LabelValueFrameSlided: TLabel;
                       LabelStrictTimeOrder: TLabel;
                       LabelValueStrictTimeOrder: TLabel;
                       LabelMinFrameSize: TLabel;
                       LabelValueMinFrameSize: TLabel;
                       LabelMaxFrameSize: TLabel;
                       LabelValueMaxFrameSize: TLabel;
                       LabelAverageFrameSize: TLabel;
                       LabelValueAverageFrameSize: TLabel;
                       LabelDataSize: TLabel;
                       LabelValueDataSize: TLabel;
                       LabelFrameComments: TLabel;
                       LabelValueFrameComments: TLabel;
                       ButtonQuickInfoScanNow: TButton;
                       TabSheetProcessingStatus: TTabSheet;
                       GroupBoxProcessingStatus: TGroupBox;
                       LabelHeaderOverhead: TLabel;
                       LabelValueHeaderOverhead: TLabel;
                       LabelSlicedDataSize: TLabel;
                       LabelValueSlicedDataSize: TLabel;
                       LabelFileComment: TLabel;
                       LabelValueFileComment: TLabel;
                       MenuPopupMainExportFileComments: TMenuItem;
                       MenuPopupMainExportCommentToDescription: TMenuItem;
                       ButtonAddDirectory: TBitBtn;
                       LabelCurrentStatus: TLabel;
                       LabelValueCurrentStatus: TLabel;
                       LabelCurrentFilename: TLabel;
                       LabelValueCurrentFilename: TLabel;
                       ProgressBarTotal: TProgressBar;
                       LabelTotalProgress: TLabel;
                       MenuTaskListSeparator1: TMenuItem;
                       MenuTaskInstantAnonymize: TMenuItem;
                       MenuTaskInstantEdit: TMenuItem;
                       MenuTaskInstantMerge: TMenuItem;
                       MenuTools: TMenuItem;
                       MenuCommunicationDetails: TMenuItem;
                       ButtonAbortScan: TButton;
                       LabelInterfaceCount: TLabel;
                       LabelValueInterfaceCount: TLabel;
                       MenuOpenHelp: TMenuItem;
                       TimerScanNowButtonStatus: TTimer;
                       LabelCurrentScanFpS: TLabel;
                       LabelValueCurrentScanFpS: TLabel;
                       MenuTaskInstantExtract: TMenuItem;
                       PageControlProcessingStatusDetails: TPageControl;
                       TabSheetFileScan: TTabSheet;
                       GroupBoxConversationScanDetails: TGroupBox;
                       LabelEthernetAddresses: TLabel;
                       LabelIPv4Addresses: TLabel;
                       LabelIPv6Addresses: TLabel;
                       LabelValueEthernetEndpoints: TLabel;
                       LabelValueIPv4Addresses: TLabel;
                       LabelValueIPv6Addresses: TLabel;
                       LabelEthernetConversations: TLabel;
                       LabelIPv4Conversations: TLabel;
                       LabelIPv6Conversations: TLabel;
                       LabelTCPConversations: TLabel;
                       LabelUDPConversations: TLabel;
                       LabelValueEthernetConversations: TLabel;
                       LabelValueIPv4Conversations: TLabel;
                       LabelValueIPv6Conversations: TLabel;
                       LabelValueTCPConversations: TLabel;
                       LabelValueUDPConversations: TLabel;
                       TabSheetExtractionDetails: TTabSheet;
                       GroupBoxExtractionDetails: TGroupBox;
                       LabelTaskDetailsActiveWriterCount: TLabel;
                       LabelTaskDetailsMaxWriterCount: TLabel;
                       LabelTaskDetailsFilesCreated: TLabel;
                       LabelTaskDetailsFramesWritten: TLabel;
                       LabelTaskDetailsMetaInfoMatchCount: TLabel;
                       LabelTaskDetailsLastMetaMatch: TLabel;
                       LabelValueTaskDetailsActiveWriterCount: TLabel;
                       LabelValueTaskDetailsMaxWriterCount: TLabel;
                       LabelValueTaskDetailsFilesCreated: TLabel;
                       LabelValueTaskDetailsFramesWritten: TLabel;
                       LabelValueTaskDetailsMetaInfoMatchCount: TLabel;
                       LabelValueTaskDetailsLastMetaMatch: TLabel;
                       LabelTaskDetailsTotalFramesRead: TLabel;
                       LabelValueTaskDetailsTotalFramesRead: TLabel;
                       MenuPopupMainRenameFile: TMenuItem;
                       MenuRenameFiles: TMenuItem;
                       MenuDebug: TMenuItem;
                       MenuDebugShowRecordSizes: TMenuItem;
                       MenuSetWindowLabel: TMenuItem;
                       MenuDebugTest: TMenuItem;
                       ButtonQuickAddAnonymizationTask: TButton;
                       ButtonQuickAddExtractionTask: TButton;
                       ButtonQuickAddMergeTask: TButton;
                       ButtonQuickAddEditTask: TButton;
                       MenuLoadFromDirectory: TMenuItem;
                       MenuPopupMainAddDirectory: TMenuItem;
                       MenuPopupMainScanFiles: TMenuItem;
                       ActionListMain: TActionList;
                       ActionRunTask: TAction;

                       // Events

                       procedure onCreateMain(Sender: TObject);
                       procedure onDestroyMain(Sender: TObject);
                       procedure ButtonAddTracefilesClick(Sender: TObject);
                       procedure MenuPopupMainAddFilesClick(Sender: TObject);
                       procedure MenuPopupMainRemoveFilesClick(Sender: TObject);
                       procedure onVSTFileListKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
                       procedure onVSTFileListGetHint(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex;var LineBreakStyle: TVTTooltipLineBreakStyle; var HintText: string);
                       procedure onVSTFileListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
                       procedure onVSTFileDetailsDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
                       procedure ButtonAddTaskClick(Sender: TObject);
                       procedure MenuPreferencesClick(Sender: TObject);
                       procedure onShowMain(Sender: TObject);
                       procedure onTimerStartup(Sender: TObject);
                       procedure onChangeVSTTaskList(Sender: TBaseVirtualTree; Node: PVirtualNode);
                       procedure onVSTTaskListDblClick(Sender: TObject);
                       procedure ButtonRemoveTaskClick(Sender: TObject);
                       procedure onAfterCellPaintFileList(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; CellRect: TRect);
                       procedure onResizeMain(Sender: TObject);
                       procedure ButtonPCAPngScanNowClick(Sender: TObject);
                       procedure onFreeVSTFileDetailsNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
                       procedure ButtonEditTaskClick(Sender: TObject);
                       procedure MenuLoadFilesClick(Sender: TObject);
                       procedure MenuCheckForUpdateClick(Sender: TObject);
                       procedure MenuAboutClick(Sender: TObject);
                       procedure MenuTaskImportClick(Sender: TObject);
                       procedure MenuTaskExportClick(Sender: TObject);
                       procedure onPopupTaskMenu(Sender: TObject);
                       procedure MenuExportPCAPngStructToFileClick(Sender: TObject);
                       procedure onVSTFileDetailsGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
                       procedure onPopupFilelist(Sender: TObject);
                       procedure MenuPopupMainSetFileTimeToFirstFrameClick(Sender: TObject);
                       procedure MenuPopupMainSetFileTimeToLastFrameClick(Sender: TObject);
                       procedure ButtonQuickInfoScanNowClick(Sender: TObject);
                       procedure MenuPopupMainExportCommentToDescriptionClick(Sender: TObject);
                       procedure ButtonAddDirectoryClick(Sender: TObject);
                       procedure MenuExitClick(Sender: TObject);
                       procedure onVSTTaskListKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
                       procedure onVSTFileListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
                       procedure MenuTaskInstantAnonymizeClick(Sender: TObject);
                       procedure MenuTaskInstantEditClick(Sender: TObject);
                       procedure MenuTaskInstantMergeClick(Sender: TObject);
                       procedure MenuCommunicationDetailsClick(Sender: TObject);
                       procedure ButtonAbortScanClick(Sender: TObject);
                       procedure onVSTFileListAddToSelection(Sender: TBaseVirtualTree; Node: PVirtualNode);
                       procedure MenuOpenHelpClick(Sender: TObject);
                       procedure onVSTTaskListGetHint(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; var LineBreakStyle: TVTTooltipLineBreakStyle; var HintText: string);
                       procedure onVSTFileListRemoveFromSelection(Sender: TBaseVirtualTree; Node: PVirtualNode);
                       procedure onTimerScanNowButtonStatus(Sender: TObject);
                       procedure onVSTFileListClick(Sender: TObject);
                       procedure MenuTaskInstantExtractClick(Sender: TObject);
                       procedure onVSTTaskListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
                       procedure onVSTTaskListPaintText(Sender: TBaseVirtualTree; const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType);
                       procedure MenuPopupMainRenameFileClick(Sender: TObject);
                       procedure onChangeMainMenu(Sender: TObject; Source: TMenuItem; Rebuild: Boolean);
                       procedure onVSTFileListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
                       procedure onHTTPProxyAuthorization(Sender: TObject; Authentication: TIdAuthentication; var Handled: Boolean);
                       procedure MenuDebugShowRecordSizesClick(Sender: TObject);
                       procedure MenuSetWindowLabelClick(Sender: TObject);
                       procedure MenuDebugTestClick(Sender: TObject);
                       procedure ButtonQuickAddAnonymizationTaskClick(Sender: TObject);
                       procedure ButtonQuickAddExtractionTaskClick(Sender: TObject);
                       procedure ButtonQuickAddEditTaskClick(Sender: TObject);
                       procedure ButtonQuickAddMergeTaskClick(Sender: TObject);
                       procedure MenuLoadFromDirectoryClick(Sender: TObject);
                       procedure MenuPopupMainAddDirectoryClick(Sender: TObject);
                       procedure MenuPopupMainScanFilesClick(Sender: TObject);
                       procedure ActionRunTaskExecute(Sender: TObject);

                       private
                              // Variables and objects

                              TempPath                : string;
                              ProgramDataPath         : string;
                              DefaultsPath            : string;
                              FactoryPath             : string;
                              TaskDataPath            : string;
                              PreferencesFile         : string;

                              TraceSetLoader          : tTraceFileSetLoader;
                              TaskListManager         : tTaskListManager;

                              priv_CurrentDetailNode  : PVirtualNode;

                              priv_filescanok         : boolean;
                              priv_totalscanfileindex : integer;     // Used for TotalProgressBar
                              priv_abortscanrequested : boolean;
                              priv_scanningMultiples  : boolean;
                              priv_warnminfilesize    : boolean;
                              priv_warnmaxfilesize    : boolean;
                              priv_renameparams       : tRenameParams;

                              priv_AutoRunTasks       : boolean;
                              priv_ExitAfterAutoRun   : boolean;
                              priv_IsSpecialBuild     : boolean;
{$ifndef disableupdatecheck}
                              priv_HTTPClient         : TIdHTTP;
{$endif}
                              priv_TotalConvCounters  : tConversationCountTable;

                              priv_fileprogressbar    : TProgressBar;

                              procedure UpdateWindowCaption;

                              // Windows API stuff

                              procedure WMDROPFILES (var msg : TWMDropFiles) ; message WM_DROPFILES;

                              // Events of sub-objects

                              procedure OnAddDuplicate (Sender : tObject; const Filename : string; var discardFile : boolean);
                              procedure OnAddUnknownFileType (Sender : tObject; const Filename : string);
                              procedure OnExtractFileSection (const Filename : string; const SectionIndex : integer);

                              // FileEntries

                              procedure onStartScanOfFile (Sender : tObject;  const Status : tProcessingStatus);
                              procedure onFileAdvancePercentScanned (Sender : tObject; const PercentageScanned, FramesPerSecond : integer; var AbortScan : boolean);
                              procedure onEndScanOfFile (Sender : tObject;  const Status : tProcessingStatus);
//                            procedure onScanAdvancePercentProcessed (Sender : tObject; const PercentageScanned : integer);

                              procedure onFileStatusChange (Sender : tObject;  const Status : tProcessingStatus);

                              // Tasks

                              procedure onTaskAdvancePercentProcessed (Sender : tObject; FileEntry : tTracefileEntry; const PercentageParsed : integer);
                              procedure onEditingAdvancePercentProcessed (const FileID : integer; FileEntry : tTracefileEntry; const PercentageParsed : integer);

                              procedure onPreparserErrorParsingFrame (const FileID : integer; FileEntry : tTracefileEntry; const FrameIndex : uint64);
                              procedure onPreparseFrame (const FileID : integer; FileEntry : tTracefileEntry; const FrameIndex : integer);
                              procedure onCompleteScanOfFile (const FileID : integer; FileEntry : tTracefileEntry; const ErrorCount : integer; const CacheHitRatioSummary : string);

                              procedure onTaskStartProcessingOfFile (FileEntry : tTracefileEntry);
                              procedure onTaskSkippingFile (FileEntry : tTracefileEntry);
                              procedure onTaskAnonymizeQueryPCAPngHeaderDetails (FileEntry : tTracefileEntry; OptionQueryList : tNGSHBParsedOptionValues);
                              procedure onTaskAnonymizeEditNameResolution (FileEntry : tTracefileEntry; IPv4List : tSimpleIPv4NameResolutionList; IPv6List : tSimpleIPv6NameResolutionList);
                              procedure onTaskErrorParsingFrame (const FileEntry : tTracefileEntry; const FrameIndex : uint64; const ErrorLocation : tATErrorLocation; var AbortTask : boolean);

                              procedure OnMultiWriterChange (Sender: tObject; const Statistics: tMultiWriteStatistics);

                              procedure onParserHasDiagnostics (Sender : tObject; FileEntry : tTraceFileEntry; Messagelist : tDiagnosticMsgList);

//                            procedure onTaskExtractNextFile (Sender : tObject; FileEntry : tTraceFileEntry);   for later

                              // Helper functions & procedures

                              procedure PrepareProgramPaths;
                              procedure PrepareTabsheetHeaders;
                              /// <summary>
                              ///   Activtates the AddTask button if at least
                              ///   one file is in the file list
                              /// </summary>
                              procedure UpdateTaskOptions;
                              /// <summary>
                              ///   Sorts the filelist in the TraceSetLoader
                              ///   object, then refreshs the display and makes
                              ///   the file list visible. After than, the task
                              ///   options are enabled.
                              /// </summary>
                              procedure UpdateFileList;
                              procedure UpdateFileListStatus;
                              procedure FinalizeAddingFiles;
                              procedure PrepareTotalAutoScanDetails;
                              procedure PrepareManualScanDetails;
                              procedure PerformPendingAutoScans;
                              procedure PerformManualScans;
                              procedure AddTaskToDisplay (NewTask : tTaskEntry);
                              procedure DeleteSelectedFilesFromList;
                              procedure DeleteSelectedTasksFromList;
                              procedure LoadPreferencesFile;
                              procedure CheckDefaultTaskSettings;
                              procedure AssignPreferences;
                              procedure AddTaskFileToList (Filename : string);
                              procedure AddFileToFilelist (Filename : string);
                              procedure AddFilesByWildCard (Filename : string);
                              procedure ProcessCmdLineParameters;
                              procedure AutoRunTasks;
                              procedure CreateExistingTasknameList (var List : tStringlist);
                              function GetValidTaskName (CurrentName : string; ExistingNames : tStringList) : string;
                              procedure UpdateExecuteButtonStatus;

                              // Worker functions and procedures

                              procedure FinalizeProcessStatus (FileEntry : tTracefileEntry; const ErrorCount : integer);
//                            procedure FinalizeScanStatus (FileEntry : tTracefileEntry);
                              function addAnonymizationTask (const TaskName : string) : boolean;
                              function addExtractionTask (const TaskName : string) : boolean;
                              function addEditTask (const TaskName : string) : boolean;
                              function addMergeTask (const TaskName : string) : boolean;
                              function addPCAPngSeparationTask (const TaskName : string) : boolean;
                              function AddFileDetailNode (const Parent : pVirtualNode; const Name, Value : string; const Expanded : boolean = false) : pVirtualNode;
                              procedure AddGeneralFileDetailsToTree (VSTNode : pVirtualNode; FileEntry : tTracefileEntry);
                              procedure AddFileBlockChainDetailsToTree (VSTNode : pVirtualNode; ChainRootNode : pBlockChainEntry);
                              procedure ShowFileDetails (FileEntry : tTracefileEntry);
                              procedure ClearFileDetails;

                              procedure ProcessFileListItems (const ProcessingOption : tListProcessOption);
                              procedure RefreshTraceFileList;
                              {$REGION 'Documentation'}
                              /// <summary>
                              ///   Updates the status bar when files were
                              ///   added or removed. Also updates the tasklist,
                              ///    because repainting some entries may be
                              ///   required when the conversation store status
                              ///   changes
                              /// </summary>
                              {$ENDREGION}
                              procedure UpdateStatusbarAndTasklist;
                              procedure AddFilesFromDirectory (Path : string);
                              procedure AddFilesFromFilelist (ListFilename : string);

                              procedure PrepareProgressbarForNode (const Node : pVirtualNode);

                              // Task execution

                              procedure ExecuteAnonymizationTask (const CurrentTask : tTaskEntry);
                              procedure ExecuteExtractionTask (const CurrentTask : tTaskEntry);
                              procedure ExecuteEditTask (const CurrentTask : tTaskEntry);
                              procedure ExecuteMergeTask (const CurrentTask : tTaskEntry);
                              procedure ExecuteSeparationTask (const CurrentTask : tTaskEntry);

                              procedure ExecuteTask (const CurrentTask : tTaskEntry);
{$ifndef disableupdatecheck}
                              function getVersionFromWeb (Params : string) : tVersionStruct;
{$endif}
                       public

                 end;

var FormMain: TFormMain;

implementation

{$R *.dfm}

uses
    Shlobj,
    Math,
    ShellAPI,
    DateUtils,
    Registry,
    toolkit,
    definition_ip_addresses,
    definition_anonymization_struct,
    commander_tools,
    proxy_tools,
    class_dirparser,
    class_formstorage,
    class_taskprocessor_sanitize,
    class_taskprocessor_extract,
    class_taskprocessor_edit,
    class_taskprocessor_merge,
    class_taskprocessor_separate,
    class_replacement_manager,
    class_inteldb_manager,
    class_conversationstorage,
{$ifdef debug}
    definition_filter_structures,
{$endif}
    dialog_selecttask,
    dialog_conversation_summary,
    form_task_anonymize,
    form_task_edit,
    form_task_separate,
    form_task_merge,
    form_preferences,
    form_updatenotification,
    form_about,
    datamodule_main,
    form_task_extract,
    dialog_rename_files,
    dialog_debuginfo,
    dialog_windowlabel;

type pVSTFileListEntry = ^tVSTFileListEntry;
     tVSTFileListEntry = record
                               index            : integer;
                               entry            : tTracefileEntry;
                               processingstatus : tProcessingStatus;
                               PCAPngStructRead : boolean;
//                             progressbar      : TProgressBar;
                         end;

     pVSTFileDetailEntry = ^tVSTFileDetailEntry;
     tVSTFileDetailEntry = record
                                 name     : string;
                                 value    : string;
                           end;

     pVSTTaskEntry = ^tVSTTaskEntry;
     tVSTTaskEntry = record
                           index    : integer;
                           entry    : tTaskEntry;
                     end;

const PageQuickInfo    = 0;
      PagePCAPngStruct = 1;
      PageLog					     = 2;
      PageScanStatus   = 3;

      PageScanDetails       = 0;
      PageExtractionDetails = 1;

      colStatus = 7;

(* ------------------------------------------ *)

function BrowseDialog (const Title: string; const Flag: integer): string;

var lpItemID    : PItemIDList;
    BrowseInfo  : TBrowseInfo;
    DisplayName : array[0..MAX_PATH] of char;
    TempPath    : array[0..MAX_PATH] of char;

begin
     Result:='';
     FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);

     with BrowseInfo do
          begin
               hwndOwner := Application.Handle;
               pszDisplayName := @DisplayName;
               lpszTitle := PChar(Title);
               ulFlags := Flag;
          end;

  lpItemID := SHBrowseForFolder(BrowseInfo);

  if lpItemId <> nil then
     begin
          SHGetPathFromIDList(lpItemID, TempPath);
          Result := TempPath;
          GlobalFreePtr(lpItemID);
     end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onCreateMain (Sender: TObject);

var BitMode : string;

begin
     // Workaround for scaling problems: look for /noscale command line option

     self.Scaled := not FindCmdLineSwitch ('noscale');

     if self.scaled then
        SiMain.LogDebug ('Forms are scaled')
     else
         SiMain.LogDebug ('Forms are NOT scaled');

{$ifdef WIN64}
     BitMode := 'x64';
{$else}
     BitMode := 'x32';
{$endif}

{$ifdef debug}
     if Si.enabled then
        begin
             SiMain.LogMessage ('SmartInspect logging enabled for project TraceWrangler ' + bitmode + ' running in debug mode');
             SiMain.LogMessage ('Path to binary is "' + paramStr(0) + '"');
        end;
{$else}
     if Si.enabled then
        begin
             SiMain.LogMessage ('SmartInspect logging enabled for project TraceWrangler ' + bitmode + ' running in debug mode');
             SiMain.LogMessage ('Path to binary is "' + paramStr(0) + '"');
        end;
{$endif}

     priv_fileprogressbar := TProgressBar.Create (VSTTracefilelist);
     priv_fileprogressbar.Parent := VSTTracefilelist;

     priv_IsSpecialBuild := false;
     priv_warnmaxfilesize := true;
     priv_warnminfilesize := true;

     // Declare that we do accept dropped files

     DragAcceptFiles (Handle, True);

     // Create objects and other structures

     TraceSetLoader := tTracefileSetLoader.create;

     TraceSetLoader.onAddDuplicateFile := OnAddDuplicate;
     TraceSetLoader.onAddUnknownFileType := OnAddUnknownFileType;

     TraceSetLoader.OnStartScanOfFile := onStartScanOfFile;
     TraceSetLoader.OnEndScanOfFile := onEndScanOfFile;
     TraceSetLoader.OnAdvancePercentageScanned := onFileAdvancePercentScanned;
     TraceSetLoader.OnFileStatusChange := onFileStatusChange;
     TraceSetLoader.OnDiagnosticsMessages := onParserHasDiagnostics;

     // Remove tab headers and switch to correct pages

     PrepareTabsheetHeaders;

     // Prepare VSTs

     VSTTracefilelist.NodeDataSize := sizeOf (tVSTFileListEntry);
     VSTFileDetails.NodeDataSize := sizeOf (tVSTFileDetailEntry);
     VSTTaskList.NodeDataSize := sizeOf (tVSTTaskEntry);

     priv_CurrentDetailNode := nil;

     // Do not allow scanning of files for last frame time stamp by default

     priv_filescanok := false;

     priv_scanningMultiples := false;

     // Prepare Paths we need

     PrepareProgramPaths;

     if System.SysUtils.Win32MajorVersion >= 6 then
        begin
             ButtonQuickAddAnonymizationTask.Style := bsCommandLink;
             ButtonQuickAddExtractionTask.Style := bsCommandLink;
             ButtonQuickAddEditTask.Style := bsCommandLink;
             ButtonQuickAddMergeTask.Style := bsCommandLink;
        end
     else
         begin
              ButtonQuickAddAnonymizationTask.Style := bsPushButton;
              ButtonQuickAddExtractionTask.Style := bsPushButton;
              ButtonQuickAddEditTask.Style := bsPushButton;
              ButtonQuickAddMergeTask.Style := bsPushButton;
         end;

//{$ifdef debug}
//
//     if FileExists ('D:\Traces\traceintel.db') then
//        DeleteFile ('D:\Traces\traceintel.db');
//
//{$endif}

{$ifdef debug}
{
     ButtonTest.Enabled := true;
     ButtonTest.Visible := true;
}
{$endif}

{$ifdef disableupdatecheck}

     MenuCheckForUpdate.Visible := false;

{$endif}

     priv_AutoRunTasks := false;
     priv_ExitAfterAutoRun := false;
end;

(* ------------------------------------------- *)

procedure TFormMain.onTaskAdvancePercentProcessed (Sender : tObject; FileEntry : tTracefileEntry; const PercentageParsed: integer);

var NodeData    : pVSTFileListEntry;
    extractTask : tTaskProcessorExtract;
    multistats  : tMultiWriteStatistics;
    iHelp       : integer;
    dHelp       : double;

begin
     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

//   NodeData^.progressbar.Position := PercentageParsed;
     priv_fileprogressbar.Position := PercentageParsed;
     VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);

     // Display specific task details

     if Sender.ClassType = tTaskProcessorExtract then
        begin
             extractTask := (Sender as tTaskProcessorExtract);

             LabelValueCurrentStatus.Caption := 'Extracting conversations';
             LabelValueCurrentFilename.Caption := FileEntry.FullName;

             // To avoid printing 0 values (due to whatever reason this seems to happen in the middle of a task sometimes), only update
             // FPS if greater than zero. Cheated, yes. I'm too lazy right now to find out why zeroes happen.

             if extractTask.FramesPerSecond > 0 then
                LabelValueCurrentScanFpS.Caption := IntToStr (extractTask.FramesPerSecond);

             dHelp := 100 * extractTask.TotalFrameReadCount / extractTask.TotalFramesToScan;
             iHelp := trunc (dHelp);

             ProgressBarTotal.Position := iHelp;

             if extractTask.ExtractionMode = xmFilePerConversation then
                begin
                     multistats := extractTask.MultiWriteStatistics;

                     LabelValueTaskDetailsActiveWriterCount.Caption := IntToStr (multistats.ActiveWriterCount);
                     LabelValueTaskDetailsMaxWriterCount.Caption := IntToStr (multistats.MaxWriterCount);
                     LabelValueTaskDetailsFilesCreated.Caption := IntToStr (multistats.FilesCreated);
                     LabelValueTaskDetailsTotalFramesRead.Caption := PointText (extractTask.TotalFrameReadCount) + ' / ' + PointText (extractTask.TotalFramesToScan);
                     LabelValueTaskDetailsFramesWritten.Caption := PointText (multistats.FramesWritten);
//                   LabelValueTaskDetailsMetaInfoMatchCount.Caption := IntToStr (multistats.MetaInfoMatchCount) + ' / ' + IntToStr (multistats.MetaInfoSetSize);
//                   LabelValueTaskDetailsLastMetaMatch.Caption := multistats.MetaInfoLastMatch.RuleDetails.Comment;
                end;
        end;

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.onEditingAdvancePercentProcessed (const FileID: integer; FileEntry: tTracefileEntry; const PercentageParsed: integer);

var NodeData : pVSTFileListEntry;

begin
     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

//   NodeData^.progressbar.Position := PercentageParsed;
     priv_fileprogressbar.Position := PercentageParsed;
     VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.OnMultiWriterChange (Sender: tObject; const Statistics: tMultiWriteStatistics);

begin
     // TODO: Update Task process pane
end;

(* ------------------------------------------- *)

procedure TFormMain.onParserHasDiagnostics (Sender: tObject; FileEntry : tTraceFileEntry; Messagelist: tDiagnosticMsgList);

var msg   : tDiagnosticMsg;
    count : integer;
    i     : integer;

begin
     count := length (MessageList);

     for i := 1 to count do
         begin
              msg := MessageList[i-1];

//            RichEditLog.Lines.Add (msg.messagehandle + ' at frame #' + msg.frameindex.ToString);
              RichEditLog.Lines.Add ('Frame #' + msg.frameindex.ToString + ': ' + msg.DisplayText);
         end;
end;

(* ------------------------------------------- *)

procedure TFormMain.UpdateWindowCaption;

var BitMode : string;

begin
{$ifdef WIN64}
     BitMode := 'x64';
{$else}
     BitMode := 'x32';
{$endif}

{$ifdef debug}
     if Si.enabled then
        begin
             FormMain.Caption := 'TraceWrangler ' + BitMode + ' - Debug Mode (SmartInspect active)';
        end
     else
         FormMain.Caption := 'TraceWrangler ' + BitMode + ' - Debug Mode';
{$else}
     if Si.enabled then
        begin
             FormMain.Caption := 'TraceWrangler ' + BitMode + ' - Beta Version (SmartInspect active)';
        end
     else
         FormMain.Caption := 'TraceWrangler ' + BitMode + ' - Beta Version';
{$endif}

     FormMain.Caption := FormMain.Caption + ' Version ' + getExeVersion (ParamStr(0));

     if trim (TWWindowLabel) <> '' then
        FormMain.Caption := FormMain.Caption + ' [' + TWWindowLabel + ']';

     if priv_IsSpecialBuild then
        FormMain.Caption := FormMain.Caption + ' [SpecialBuild]';

     if not FormMain.Scaled then
        FormMain.Caption := FormMain.Caption + ' [NoScale]';
end;

(* ------------------------------------------- *)

procedure TFormMain.onShowMain (Sender: TObject);

begin
     // Reset visual elements that may look different in design mode for practical reasons

     VSTFileDetails.Align := alClient;
     ButtonPCAPngScanNow.Left := (TabSheetPCAPngDetails.Width div 2) - (ButtonPCAPngScanNow.Width div 2);

     UpdateWindowCaption;

     // Display debug mode if it is on

{$ifdef debug}
     MenuDebug.Enabled := True;
     MenuDebug.Visible := True;
{$endif}

end;

(* ------------------------------------------- *)

procedure TFormMain.onResizeMain(Sender: TObject);

begin
     ButtonPCAPngScanNow.Left := (TabSheetPCAPngDetails.Width div 2) - (ButtonPCAPngScanNow.Width div 2);
end;

(* ------------------------------------------- *)

procedure TFormMain.AssignPreferences;

var inteldbparams : tIntelDBParameters;

begin
     // Assign Loader Preferences

     TraceSetLoader.AutoScanThreshold := StrToInt (FormPreferences.EditFileScanThreshold.Text) * 1024 * 1024;

     // TraceIntel database settings

     inteldbparams.initialize;
     inteldbparams.DoNotUseIntelDB := not FormPreferences.CheckBoxUseIntelDB.Checked;
     inteldbparams.HideIntelDBFile := FormPreferences.CheckBoxMarkIntelDBFileInvisible.Checked;

     if FormPreferences.RadioButtonUsePerDirectoryDatabase.Checked then
        begin
             inteldbparams.UseLocalDBFiles := true;
             inteldbparams.GlobalDBPath := '';
        end
     else
         begin
              inteldbparams.UseLocalDBFiles := false;
              inteldbparams.GlobalDBPath := IncludeTrailingPathDelimiter (FormPreferences.EditGlobalIntelDBPath.Text);

              if not DirectoryExists (inteldbparams.GlobalDBPath) then
                 ForceDirectories (inteldbparams.GlobalDBPath);
         end;

     TraceSetLoader.IntelDBParams := inteldbparams;

     if DirectoryExists (FormPreferences.EditPathTaskFiles.Text) then
        TaskDataPath := IncludeTrailingBackSlash (FormPreferences.EditPathTaskFiles.Text);

     // Set Mainform panel slider mode

     if not FormPreferences.getAdvancedBoolSetting ('ToggleAdvMainResizeLowerPanel') then
        begin
             PanelMainLevel1Bottom.Align := alBottom;
             PanelMainLevel1Top.Align := alClient;
        end;

     LocalTraceIntelFilename := FormPreferences.EditTraceIntelDBFilename.Text;
end;

(* ------------------------------------------- *)

procedure TFormMain.AddTaskFileToList (Filename: string);

var boOkay   : boolean;
    TaskName : string;
    NewTask  : tTaskEntry;
    help     : string;
    StorMan  : tFormStorageManager;

begin
     boOkay := false;

     // Check if the task file exists, or if it can be found in the tasks directory

     if FileExists (Filename) then
        boOkay := true
     else
         begin
              Filename := TaskDataPath + Filename;

              boOkay := FileExists (Filename);
         end;

     // If found, add it

     if boOkay then
        begin
             TaskName := ExtractFileName (Filename);
             TaskName := ChangeFileExt (TaskName, '');

             Storman :=  tFormStorageManager.create (self);
             Storman.DatabaseFile := Filename;

             help := Storman.retrieveValueFroMDB ('FormName');

             if help = FormTaskAnonymize.Name then
                NewTask := tTaskEntry.create (TaskName, ttAnonymize)
             else
             if help = FormTaskExtract.Name then
                NewTask := tTaskEntry.create (TaskName, ttExtract)
             else
             if help = FormTaskEdit.Name then
                NewTask := tTaskEntry.create (TaskName, ttEdit)
             else
             if help = FormTaskMerge.Name then
                NewTask := tTaskEntry.create (TaskName, ttMerge)
             else
             if help = FormTaskSeparation.Name then
                NewTask := tTaskEntry.create (TaskName, ttSeparate)
             else
                 BoOkay := false;

             if boOkay then
                begin
                     NewTask.ParameterFile := Filename;

                     TaskListManager.addTask (NewTask);

                     AddTaskToDisplay (NewTask);

                     UpdateExecuteButtonStatus;
                     UpdateTaskOptions;
                end
             else
                 MessageDlg('Error: could not parse task file specified in command line parameter, ignoring.', mtError, [mbOK], 0);
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.FinalizeAddingFiles;

begin
     Application.ProcessMessages;

     if TraceSetLoader.FileCount > 0 then
        begin
             StatusBarMain.Panels[0].Text := 'Status: accessing IntelDB';
             Application.ProcessMessages;

             UpdateFileList;
             PerformPendingAutoScans;

             StatusBarMain.Panels[0].Text := 'Status: aggregating flows';
             Application.ProcessMessages;

             TraceSetLoader.UpdateConversationStore;

             MenuCommunicationDetails.Enabled := TraceSetLoader.ConversationStore.HasRecords;

             StatusBarMain.Panels[0].Text := 'Status: idle';

             MenuCommunicationDetails.Enabled := TraceSetLoader.ConversationStore.HasRecords;
        end
     else
         PageControlFileList.ActivePageIndex := 0;

     StatusBarMain.Panels[2].Text := '';
     UpdateExecuteButtonStatus;
     UpdateStatusbarAndTasklist;
     UpdateTaskOptions;

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.ProcessCmdLineParameters;

var Filename : string;
    ext      : string;
    boOkay   : boolean;
    help     : string;
    i        : integer;

begin
     // Add files if passed by command line

     for i := 1 to ParamCount do
         begin
              Filename := ParamStr(i);

              if pos ('/', Filename) <> 1 then
                 begin
                      ext := ExtractFileExt (Filename);

                      // Exclude SmartInspect debug files if specified

                      if ext <> '.sil' then
                         begin
                              if ext = '.task' then
                                 AddTaskFileToList (Filename)
                              else
                                  if FileExists (Filename) then
                                     begin
                                          Filename := DetermineFilenameFromParam (Filename);
                                          AddFileToFilelist (FileName);
                                     end
                                  else
                                      if DirectoryExists (filename) then
                                         begin
                                              boOkay := true;

                                              if FormPreferences.CheckBoxWarnWhenAddingDirectories.Checked and not FormPreferences.CheckBoxSkipWarningForCommandLine.Checked then
                                                 boOkay := (MessageDlg('Do you want to add all files in "' + filename + '"?', mtConfirmation, [mbYes, mbNo], 0) = mrYes);

                                              if boOkay then
                                                 AddFilesFromDirectory (Filename);
                                         end
                                      else
                                          if pos ('*', Filename) > 0 then
                                             AddFilesByWildCard (Filename);
                         end;
                 end
              else
                  begin
                       // options, starting with a slash

                       FindCmdLineSwitch ('filelist', help);
                       help := DetermineFilenameFromParam (help);

                       if help <> '' then
                          AddFilesFromFilelist (help);

                       priv_AutoRunTasks := FindCmdLineSwitch ('autorun');
                       priv_ExitAfterAutoRun := FindCmdLineSwitch ('exit');
                  end;
         end;

     FinalizeAddingFiles;

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.AutoRunTasks;

begin
     if (TraceSetLoader.FileCount > 0) and (TaskListManager.count > 0) then
//      ButtonExecuteTasksClick (nil);
        ActionRunTask.Execute;
end;

(* ------------------------------------------- *)

procedure TFormMain.onTimerStartup (Sender: TObject);

var Filename : string;

{$ifdef debug}
    MyReg    : tRegistry;
    FileSet  : tStringlist;
    TaskFile : string;
    i        : Integer;
{$endif}

begin
{$ifdef debug}

     if Screen.DesktopWidth > 1920 then
        begin
             FormMain.Left := 1921;
             FormMain.Top := 0;

             Application.ProcessMessages;
        end;

{$endif}

     TimerStartup.Enabled := false;

     // Load Preferences

     LoadPreferencesFile;
     AssignPreferences;

     // Create TaskManager

     TaskListManager := tTaskListManager.create (TaskDataPath);

     // Check default task settings

     CheckDefaultTaskSettings;

     // Check for updates if configured

     if FormPreferences.CheckBoxAutomaticCheckForUpdate.Checked then
        MenuCheckForUpdateClick (nil);

     if ParamCount > 0 then
        ProcessCmdLineParameters;

{$ifdef debug}

     // Load last loaded files and tasks if no parameters are specified

     if ParamCount = 0 then
        begin
             MyReg := tRegistry.Create;
             MyReg.RootKey := HKEY_CURRENT_USER;

             FileSet := tStringlist.Create;

             try
                if MyReg.OpenKey ('SOFTWARE\PacketFoo\TraceWrangler', false) then
                   begin
                        if MyReg.ValueExists ('LastFileSet') then
                           FileSet.Text := MyReg.ReadString ('LastFileSet');

                        if MyReg.ValueExists ('LastTask') then
                           TaskFile := MyReg.ReadString ('LastTask')
                        else
                            TaskFile := '';

                        for i := 1 to FileSet.Count do
                            AddFileToFilelist (FileSet[i-1]);

                        if fileExists (TaskFile) then
                           AddTaskFileToList (TaskFile);

                        FinalizeAddingFiles;

                        Application.ProcessMessages;
                   end;
             finally
                    MyReg.Free;
                    FileSet.Free;
             end;
        end;

{$endif}

     if priv_AutoRunTasks then
        begin
             AutoRunTasks;

             if priv_ExitAfterAutoRun then
                application.Terminate;
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onDestroyMain(Sender: TObject);

{$ifdef debug}
var myReg   : tRegistry;
    FileSet : tStringlist;
    task    : tTaskEntry;

begin
     if ParamCount = 0 then
        begin
             MyReg := tRegistry.Create;
             MyReg.RootKey := HKEY_CURRENT_USER;

             FileSet := TraceSetLoader.FileList.GetFileNameList;
             task := TaskListManager.getTask(1);

             try
                if MyReg.OpenKey ('SOFTWARE\PacketFoo\TraceWrangler', true) then
                   begin
                        MyReg.WriteString ('LastFileSet', FileSet.Text);

                        if assigned (task) then
                           MyReg.WriteString ('LastTask', task.ParameterFile);
                   end;
             finally
                    MyReg.Free;
                    FileSet.Free;
             end;
        end;
{$else}
begin
{$endif}
     TaskListManager.free;
     TraceSetLoader.free;
end;

(* ------------------------------------------- *)

procedure TFormMain.LoadPreferencesFile;

begin
     SiMain.LogVerbose('Loading Preferences from "' + PreferencesFile + '"');

     if FileExists (PreferencesFile) then
        FormPreferences.LoadPreferences (PreferencesFile)
     else
         if (MessageDlg('This build of TraceWrangler is an beta build. Use at your own risk.', mtInformation, [mbOK, mbCancel], 0) = mrOk) then
            begin
                 // create default files <- i think this is outdated :-)

                 FormPreferences.SavePreferences (PreferencesFile);
            end
         else
             Application.Terminate;
end;

(* ------------------------------------------- *)

procedure TFormMain.PrepareProgramPaths;

var help : string;
    i    : integer;

begin
     SiMain.EnterMethod('TFormMain.PrepareProgramPaths');

     TempPath := IncludeTrailingPathDelimiter (GetPathOfTempFiles + 'TraceWrangler');
     ProgramDataPath := IncludeTrailingPathDelimiter (GetPathOfRoamingAppData + 'TraceWrangler');
     TaskDataPath := IncludeTrailingPathDelimiter (ProgramDataPath + 'TaskData');
     DefaultsPath := IncludeTrailingPathDelimiter (ProgramDataPath + 'Default');
     FactoryPath := IncludeTrailingPathDelimiter (DefaultsPath + 'Factory');

     // TODO: figure out how to support true portable installations, and arbitrary preference files
{
     for i := 1 to ParamCount do
         begin
              help := ParamStr(i);

              if pos ('/p then

         end;
}
     PreferencesFile := ProgramDataPath + 'preferences.db';

     if Si.Enabled then
        begin
             SiMain.LogDebug('Setting temporary path: "' + TempPath + '"');
             SiMain.LogDebug('Setting ProgramData path: "' + ProgramDataPath + '"');
             SiMain.LogDebug('Setting TaskData path: "' + TaskDataPath + '"');
             SiMain.LogDebug('Setting Defaults path: "' + DefaultsPath + '"');
             SiMain.LogDebug('Setting Factory path: "' + FactoryPath + '"');
             SiMain.LogDebug('Setting Preferences file: "' + PreferencesFile + '"');
        end;

     try
        ForceDirectories (TempPath);

        if not DirectoryExists (TempPath) then
           begin
                MessageDlg ('Warning: could not create temporary directory "' + TempPath + '". Some tasks may fail until the problem is solved', mtWarning, [mbOK], 0);
                SiMain.LogError ('Warning: could not create temporary directory "' + TempPath + '". Some tasks may fail until the problem is solved');
           end
        else
            if not IsDirectoryWriteable (TempPath) then
               begin
                    MessageDlg ('Warning: temporary directory "' + TempPath + '" is not writable. Some tasks may fail until the problem is solved', mtWarning, [mbOK], 0);
                    SiMain.LogError ('Warning: temporary directory "' + TempPath + '" is not writable. Some tasks may fail until the problem is solved');
               end
            else
                SiMain.LogVerbose ('Temp directory "' + TempPath + '" seems to be writable.');

        ForceDirectories (TaskDataPath);           // Includes ProgramDataPath

        if not DirectoryExists (TaskDataPath) then
           begin
                MessageDlg ('Warning: could not create task directory "' + TaskDataPath + '". Some tasks may fail until the problem is solved', mtWarning, [mbOK], 0);
                SiMain.LogError ('Warning: could not create task directory "' + TaskDataPath + '". Some tasks may fail until the problem is solved');
           end
        else
            if not IsDirectoryWriteable (TaskDataPath) then
               begin
                    MessageDlg ('Warning: task directory "' + TaskDataPath + '" is not writable. Some tasks may fail until the problem is solved', mtWarning, [mbOK], 0);
                    SiMain.LogError ('Warning: task directory "' + TaskDataPath + '" is not writable. Some tasks may fail until the problem is solved');
               end
            else
                SiMain.LogVerbose ('Task directory "' + TaskDataPath + '" seems to be writable.');

        ForceDirectories (DefaultsPath);

        if not DirectoryExists (DefaultsPath) then
           begin
                MessageDlg ('Warning: could not create task defaults directory "' + DefaultsPath + '"', mtWarning, [mbOK], 0);
                SiMain.LogError ('Warning: could not create task defaults directory "' + DefaultsPath + '"');
           end
        else
            if not IsDirectoryWriteable (DefaultsPath) then
               begin
                    MessageDlg ('Warning: task defaults directory "' + DefaultsPath + '" is not writable', mtWarning, [mbOK], 0);
                    SiMain.LogError ('Warning: task defaults directory "' + DefaultsPath + '" is not writable');
               end
            else
                SiMain.LogVerbose ('Task defaults directory "' + DefaultsPath + '" seems to be writable.');

        ForceDirectories (FactoryPath);

        if not DirectoryExists (FactoryPath) then
           begin
                MessageDlg ('Warning: could not create task factory default directory "' + FactoryPath + '"', mtWarning, [mbOK], 0);
                SiMain.LogError ('Warning: could not create task factory default directory "' + FactoryPath + '".');
           end
        else
            if not IsDirectoryWriteable (FactoryPath) then
               begin
                    MessageDlg ('Warning: task factory defaultdirectory "' + FactoryPath + '" is not writable', mtWarning, [mbOK], 0);
                    SiMain.LogError ('Warning: task factory defaultdirectory "' + FactoryPath + '" is not writable');
               end
            else
                SiMain.LogVerbose ('Task factory defaults directory "' + FactoryPath + '" seems to be writable.');

     except
           MessageDlg('Error: could not create working directories, aborting!', mtError, [mbOK], 0);
           SiMain.LogError ('Error: could not create working directories, aborting');

           Application.Terminate;
     end;

     SiMain.LeaveMethod('TFormMain.PrepareProgramPaths');
end;

(* ------------------------------------------- *)

procedure TFormMain.CheckDefaultTaskSettings;

var FrmGen : integer;
    DBGen  : integer;

begin
     // Create factory default files

     FormTaskAnonymize.SaveSettings (DefaultsPath + 'Factory\anonymize.task');
     FormTaskExtract.SaveSettings (DefaultsPath + 'Factory\extract.task');
     FormTaskEdit.SaveSettings (DefaultsPath + 'Factory\edit.task');
     FormTaskMerge.SaveSettings (DefaultsPath + 'Factory\merge.task');

     // Create "replacable" default files if not there yet

     // Anonymization Task

     if not FileExists (DefaultsPath + 'anonymize.task') then
        FormTaskAnonymize.SaveSettings (DefaultsPath + 'anonymize.task');

{    if not FileExists (DefaultsPath + 'Factory\anonymize.task') then

     else
         begin
              // Verify the form generation index (meaning, check if the form has newer elements)

              FrmGen := StrToInt (FormTaskAnonymize.EditFormGenerationIndex.Text);
              DBGen := GetFormStorageGenerationIndex (DefaultsPath + 'anonymize.task');

              // DBGen is -1 if the file was not accessable, and 0 if no generation index was found

              if (DBGen > -1) and (FrmGen > DBGen) then
                 begin
                      // The file is outdated

                      if (MessageDlg('Your default anonymization profile is outdated and will be replaced with a newer version.', mtInformation, [mbOK, mbCancel], 0) = mrOk) then
                         begin
                              DeleteFile (DefaultsPath + 'anonymize.task');
                              FormTaskAnonymize.SaveSettings (DefaultsPath + 'anonymize.task');
                         end;
                 end;
         end;
}
     FormTaskAnonymize.PathToDefaultSettings := DefaultsPath;    // needed for saving settings as default

     if not FileExists (DefaultsPath + 'extract.task') then
        FormTaskExtract.SaveSettings (DefaultsPath + 'extract.task');

     if not FileExists (DefaultsPath + 'edit.task') then
        FormTaskEdit.SaveSettings (DefaultsPath + 'edit.task');

     if not FileExists (DefaultsPath + 'merge.task') then
        FormTaskMerge.SaveSettings (DefaultsPath + 'merge.task');
end;

(* ------------------------------------------- *)

procedure TFormMain.PrepareTabsheetHeaders;

var i : integer;

begin
     // Filelist tabs

     for i := 1 to PageControlFileList.PageCount do
         PageControlFileList.Pages[i-1].TabVisible := false;

     PageControlFileList.ActivePageIndex := 0;

     // Task Details tabs

//{$ifndef debug}
//   for i := 1 to PageControlTaskDetails.PageCount do
//       PageControlTaskDetails.Pages[i-1].TabVisible := false;
//{$endif}

     TabSheetPCAPngDetails.TabVisible := false;
     TabSheetProcessingStatus.TabVisible := false;

     // Process Detail tabs

     for i := 1 to PageControlProcessingStatusDetails.PageCount do
         PageControlProcessingStatusDetails.Pages[i-1].TabVisible := false;

     PageControlProcessingStatusDetails.ActivePageIndex := PageScanDetails;

     // Main Control

     PageControlMainDetails.ActivePageIndex := PageQuickInfo;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var nodedata  : pVSTFileListEntry;
    fileentry : tTracefileEntry;

begin
     nodedata := VSTTracefilelist.GetNodeData(Node);

     fileentry := nodedata^.entry as tTracefileEntry;

     case column of
      0 : celltext := IntToStr (nodedata^.index);
      1 : celltext := fileentry.Filename;
      2 : celltext := intToCool (fileentry.FileSize);
      3 : celltext := CaptureFileTypeAsText (fileentry.TracefileType);
      4 : begin
               if fileentry.FirstFrameTimestamp.datetime <> 0 then
                  celltext := DateTimeToStr (fileentry.FirstFrameTimestamp.datetime)
               else
                   if fileentry.FrameCount = 0 then
                      celltext := 'not available'
                   else
                       celltext := 'unknown';
          end;
      5 : celltext := fileentry.CaptureDuration;
      6 : begin
               if fileentry.PacketStatisticsRead then
                  celltext := pointtext (fileentry.FrameCount)
               else
                   celltext := 'not scanned';
          end;
      7 : celltext := getStatusDescription (nodedata^.processingstatus);
     end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onAfterCellPaintFileList(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; CellRect: TRect);

var nodedata  : pVSTFileListEntry;

begin
     if Column = 7 then
        begin
             nodedata := VSTTraceFileList.GetNodeData(Node);

             if (nodedata^.processingstatus in [psScanningBasics, psScanningPCAPngStruct, psScanningConversations, psTaskProcessing]) then
                begin
                     CellRect := VSTTraceFileList.GetDisplayRect (Node, Column, false);
{
                     nodedata^.progressbar.Left := CellRect.Left + 2;
                     nodedata^.progressbar.Top := CellRect.Top + 2;
                     nodedata^.progressbar.Width := CellRect.Right-CellRect.Left - 4;
                     nodedata^.progressbar.Height := CellRect.Bottom-CellRect.Top - 4;
}
                     priv_fileprogressbar.Left := CellRect.Left + 2;
                     priv_fileprogressbar.Top := CellRect.Top + 2;
                     priv_fileprogressbar.Width := CellRect.Right-CellRect.Left - 4;
                     priv_fileprogressbar.Height := CellRect.Bottom-CellRect.Top - 4;
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileDetailsGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var nodedata  : pVSTFileDetailEntry;

begin
     nodedata := VSTFileDetails.GetNodeData(Node);

     case column of
      0 : celltext := nodedata^.name;
      1 : celltext := nodedata^.value;
     end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileDetailsDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);

var nodedata  : pVSTFileDetailEntry;
    celltext  : string;

begin
     nodedata := VSTFileDetails.GetNodeData(Node);

     case column of
      0 : celltext := nodedata^.name;
      1 : celltext := nodedata^.value;
     end;

     TargetCanvas.TextOut(CellRect.Left, CellRect.Top, celltext);

     DefaultDraw := false;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTTaskListDblClick(Sender: TObject);

begin
     ButtonEditTaskClick (Sender);
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTTaskListGetHint(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; var LineBreakStyle: TVTTooltipLineBreakStyle; var HintText: string);

var nodedata  : pVSTTaskEntry;
    celltext  : string;

begin
     nodedata := VSTFileDetails.GetNodeData(Node);

     HintText := nodedata.entry.ParameterFile;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTTaskListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var nodedata  : pVSTTaskEntry;

begin
     nodedata := VSTFileDetails.GetNodeData(Node);

     case column of
      0 : celltext := nodedata^.entry.TaskName;
     end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTTaskListPaintText (Sender: TBaseVirtualTree; const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType);

var nodedata  : pVSTTaskEntry;

begin
     nodedata := VSTFileDetails.GetNodeData(Node);

     case nodedata^.entry.TaskType of
      ttExtract : begin
                       if TraceSetLoader.ConversationStore.HasRecords then
                          TargetCanvas.Font.Color := clWindowText
                       else
                           TargetCanvas.Font.Color := clRed;
                  end;
     end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onFreeVSTFileDetailsNode(Sender: TBaseVirtualTree; Node: PVirtualNode);

var nodedata  : pVSTFileDetailEntry;

begin
     nodedata := VSTFileDetails.GetNodeData(Node);

     nodedata^.name := '';
     nodedata^.value := '';
end;

(* ------------------------------------------- *)

procedure TFormMain.onHTTPProxyAuthorization (Sender: TObject; Authentication: TIdAuthentication; var Handled: Boolean);

begin
     Handled := True;
end;

(* ------------------------------------------- *)

procedure TFormMain.onChangeVSTTaskList (Sender: TBaseVirtualTree; Node: PVirtualNode);

var doEnable : boolean;

begin
     doEnable := (VSTTaskList.SelectedCount > 0);

     ButtonRemoveTask.Enabled := doEnable;
     ButtonEditTask.Enabled := doEnable;
end;

(* ------------------------------------------- *)

// Creates a new node and adds the details

function TFormMain.AddFileDetailNode (const Parent : pVirtualNode; const Name, Value : string; const Expanded : boolean = false) : pVirtualNode;

var NewNode : PVirtualNode;
    Data    : pVSTFileDetailEntry;

begin
     NewNode := VSTFileDetails.AddChild(Parent);
     Data := VSTFileDetails.GetNodeData(NewNode);

     Data^.name := Name;
     Data^.value := Value;

     if Expanded then
        NewNode.States := NewNode.States + [vsExpanded];

     result := NewNode;
end;

(* ------------------------------------------- *)

// Writes the general file info to the detail tree

procedure TFormMain.AddGeneralFileDetailsToTree (VSTNode : pVirtualNode; FileEntry : tTracefileEntry);

var SectionTreeNode : PVirtualNode;

begin
     SectionTreeNode := AddFileDetailNode (VSTNode, 'General', '');

     AddFileDetailNode (SectionTreeNode, 'Path', FileEntry.FilePath);
     AddFileDetailNode (SectionTreeNode, 'Name', FileEntry.FileName);
     AddFileDetailNode (SectionTreeNode, 'Size', PointText (FileEntry.FileSize) + ' Bytes');
     AddFileDetailNode (SectionTreeNode, 'Section Count', IntToStr (FileEntry.PCAPngStatistics.SectionCount));
     AddFileDetailNode (SectionTreeNode, 'Total Frame Count', PointText (FileEntry.FrameCount));

     if yearof (FileEntry.FirstFrameTimestamp.datetime) > 1970 then
        AddFileDetailNode (SectionTreeNode, 'First Frame Time', DateTimeToStr (FileEntry.FirstFrameTimestamp.datetime) + '.' + IntToStr (FileEntry.FirstFrameTimestamp.nanoseconds))
     else
         AddFileDetailNode (SectionTreeNode, 'First Frame Time', 'n/a');

     AddFileDetailNode (SectionTreeNode, 'InterfaceCount', IntToStr (FileEntry.Channelcount));

     VSTFileDetails.FullExpand(SectionTreeNode);
end;

(* ------------------------------------------- *)

// Writes the pcap-ng FileBlockChain to the tree

procedure TFormMain.AddFileBlockChainDetailsToTree (VSTNode : pVirtualNode; ChainRootNode : pBlockChainEntry);

var BaseTreeNode     : PVirtualNode;
    SectionTreeNode  : PVirtualNode;
    BlockTreeNode    : PVirtualNode;
    DetailTreeNode   : PVirtualNode;
    CurrentChainNode : pBlockChainEntry;
    SectionCount     : integer;
    sComment         : string;
    i                : integer;

begin
     BaseTreeNode := AddFileDetailNode (VSTNode, 'Block Chain Structure', '', true);

     SectionCount := 0;

     CurrentChainNode := ChainRootNode;

     while CurrentChainNode <> nil do
           begin
                case CurrentChainNode^.BlockTypeID of
                 BLOCKTYPE_SECTION_HEADER       :  begin
                                                        Inc (SectionCount);

                                                        SectionTreeNode := AddFileDetailNode (BaseTreeNode, 'Section #' + IntToStr (SectionCount), '');

                                                        AddFileDetailNode (SectionTreeNode, 'Section Start Offset', '0x' + IntToHex (CurrentChainNode^.SectionStartOffset, 0));
                                                        AddFileDetailNode (SectionTreeNode, 'Section End Offset', '0x' + IntToHex (CurrentChainNode^.SectionEndOffset, 0));
                                                        AddFileDetailNode (SectionTreeNode, 'Section Total Length', IntToStr (CurrentChainNode^.SectionEndOffset - CurrentChainNode^.SectionStartOffset + 1) + ' Bytes (calculated)');

                                                        BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Block', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                                                        AddFileDetailNode (BlockTreeNode, 'Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Block Total Length',  IntToStr (CurrentChainNode^.BlockLength)  + ' Bytes');

                                                        case CurrentChainNode^.SHBByteOrderMagic of
                                                         $1A2B3C4D : sComment := '(Little Endian)';
                                                         $4D3C2B1A : sComment := '(Big Endian)';
                                                        else
                                                            sComment := '(invalid)';
                                                        end;

                                                        AddFileDetailNode (BlockTreeNode, 'Byte Order Magic', '0x' + IntToHex (CurrentChainNode^.SHBByteOrderMagic, 8) + ' ' + sComment);
                                                        AddFileDetailNode (BlockTreeNode, 'Section Header Version', IntToStr (CurrentChainNode^.SHBMajorVersion) + '.' + IntToStr (CurrentChainNode^.SHBMinorVersion));

                                                        if CurrentChainNode^.SHBSectionLength = $FFFFFFFFFFFFFFFF then
                                                           sComment := '(not specified)'
                                                        else
                                                            sComment := '';

                                                        AddFileDetailNode (BlockTreeNode, 'Total Section Length', '0x' + IntToHex (CurrentChainNode^.SHBSectionLength,0) + ' ' + sComment);

                                                        if CurrentChainNode^.SHBComment <> '' then
                                                           AddFileDetailNode (BlockTreeNode, 'Comments', CurrentChainNode^.SHBComment);

                                                        if CurrentChainNode^.SHBHardware <> '' then
                                                           AddFileDetailNode (BlockTreeNode, 'Hardware', CurrentChainNode^.SHBHardware);

                                                        if CurrentChainNode^.SHBOS <> '' then
                                                           AddFileDetailNode (BlockTreeNode, 'Operating System', CurrentChainNode^.SHBOS);

                                                        if CurrentChainNode^.SHBUserAppl <> '' then
                                                           AddFileDetailNode (BlockTreeNode, 'User Application', CurrentChainNode^.SHBUserAppl);

                                                   end;
                 BLOCKTYPE_INTERFACE_DESCRIPTION : begin
                                                        BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Block', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                                                        AddFileDetailNode (BlockTreeNode, 'Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Block Total Length', IntToStr (CurrentChainNode^.BlockLength) + ' Bytes');

                                                        AddFileDetailNode (BlockTreeNode, 'Interface Index', IntToStr (CurrentChainNode^.IDBIndex));
                                                        AddFileDetailNode (BlockTreeNode, 'Link Type', IntToStr (CurrentChainNode^.IDBLinkType) + ' (' + getLinkTypeName (CurrentChainNode^.IDBLinkType) + ')');
                                                        AddFileDetailNode (BlockTreeNode, 'Snap Length', IntToStr (CurrentChainNode^.IDBSnapLen) + ' Bytes');
                                                        AddFileDetailNode (BlockTreeNode, 'FCS Length', IntToStr (CurrentChainNode^.IDBFCSLen) + ' Bytes');

                                                        if CurrentChainNode^.IDBName <> '' then
                                                           AddFileDetailNode (BlockTreeNode, 'Name', CurrentChainNode^.IDBName);

                                                        if CurrentChainNode^.IDBDescription <> '' then
                                                           AddFileDetailNode (BlockTreeNode, 'Description', CurrentChainNode^.IDBDescription);

                                                        if CurrentChainNode^.IDBIPv4AddressList.count > 0 then
                                                           begin
                                                                if CurrentChainNode^.IDBIPv4AddressList.count = 1 then
                                                                   AddFileDetailNode (BlockTreeNode, 'IPv4 Address', CurrentChainNode^.IDBIPv4AddressList.list[0].ValueAsString + ', Mask ' + CurrentChainNode^.IDBIPv4AddressList.list[0].MaskAsString)
                                                                else
                                                                    begin
                                                                         DetailTreeNode := AddFileDetailNode (BlockTreeNode, 'IPv4 Address List', IntToStr (CurrentChainNode^.IDBIPv4AddressList.count));

                                                                         for i := 1 to CurrentChainNode^.IDBIPv4AddressList.count do
                                                                             AddFileDetailNode (DetailTreeNode, CurrentChainNode^.IDBIPv4AddressList.list[i-1].ValueAsString, CurrentChainNode^.IDBIPv4AddressList.list[i-1].MaskAsString);
                                                                    end;
                                                           end;

                                                        if CurrentChainNode^.IDBIPv6AddressList.count > 0 then
                                                           begin
                                                                if CurrentChainNode^.IDBIPv6AddressList.count = 1 then
                                                                   AddFileDetailNode (BlockTreeNode, 'IPv6 Address', CurrentChainNode^.IDBIPv6AddressList.list[0].ValueAsString)
                                                                else
                                                                    begin
                                                                         DetailTreeNode := AddFileDetailNode (BlockTreeNode, 'IPv6 Address List', IntToStr (CurrentChainNode^.IDBIPv6AddressList.count));

                                                                         for i := 1 to CurrentChainNode^.IDBIPv6AddressList.count do
                                                                             AddFileDetailNode (DetailTreeNode, CurrentChainNode^.IDBIPv6AddressList.list[i-1].ValueAsString, '');
                                                                    end;
                                                           end;

                                                        if CurrentChainNode^.IDBMACAddress <> VALUE_ZERO_MAC then
                                                           AddFileDetailNode (BlockTreeNode, 'MAC Address', CurrentChainNode^.IDBMACAddress.asString);

                                                        case CurrentChainNode^.IDBTSResolution of
                                                         0 : sComment := '(Seconds)';
                                                         3 : sComment := '(Milliseconds)';
                                                         6 : sComment := '(Microseconds)';
                                                         9 : sComment := '(Nanoseconds)';
                                                        end;

                                                        AddFileDetailNode (BlockTreeNode, 'Timestamp Resolution', IntToStr (CurrentChainNode^.IDBTSResolution) + ' ' + sComment);

                                                        if CurrentChainNode^.IDBFilter.FilterType <> cftUnknown then
                                                           begin
                                                                if CurrentChainNode^.IDBFilter.FilterString <> '' then
                                                                   AddFileDetailNode (BlockTreeNode, 'Capture Filter', '"' + CurrentChainNode^.IDBFilter.FilterString + '" (' + (CurrentChainNode^.IDBFilter.FilterTypeName) + ')')
                                                                else
                                                                    AddFileDetailNode (BlockTreeNode, 'Capture Filter', 'none');
                                                           end;


                                                   end;

                 BLOCKTYPE_NAME_RESOLUTION       : begin
                                                        BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Block', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                                                        AddFileDetailNode (BlockTreeNode, 'Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Block Total Length', IntToStr (CurrentChainNode^.BlockLength) + ' Bytes');

                                                        DetailTreeNode := AddFileDetailNode (BlockTreeNode, 'IPv4 Address Record Sets', IntToStr (CurrentChainNode^.NRBIPv4RecordCount));

                                                        for i := 1 to CurrentChainNode^.NRBIPv4RecordCount do
                                                            AddFileDetailNode (DetailTreeNode, CurrentChainNode^.NRBIPv4AddressList.IPv4NameList[i-1].FQDN, CurrentChainNode^.NRBIPv4AddressList.IPv4NameList[i-1].IPv4Address.ValueAsString);

                                                        DetailTreeNode := AddFileDetailNode (BlockTreeNode, 'IPv6 Address Record Sets', IntToStr (CurrentChainNode^.NRBIPv6RecordCount));

                                                        for i := 1 to CurrentChainNode^.NRBIPv6RecordCount do
                                                            AddFileDetailNode (DetailTreeNode, CurrentChainNode^.NRBIPv6AddressList.IPv6NameList[i-1].FQDN, CurrentChainNode^.NRBIPv6AddressList.IPv6NameList[i-1].IPv6Address.ValueAsString);
                                                   end;
                 BLOCKTYPE_PACKET,
                 BLOCKTYPE_SIMPLE_PACKET,
                 BLOCKTYPE_ENHANCED_PACKET       : begin
                                                        BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Blocks', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                                                        AddFileDetailNode (BlockTreeNode, 'First Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Last Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));

                                                        AddFileDetailNode (BlockTreeNode, 'Block Count', IntToStr (CurrentChainNode^.Count));
                                                   end;

                 BLOCKTYPE_INTERFACE_STATISTICS  : begin
                                                        BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Block', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                                                        AddFileDetailNode (BlockTreeNode, 'Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Block Total Length', IntToStr (CurrentChainNode^.BlockLength) + ' Bytes');

                                                        AddFileDetailNode (BlockTreeNode, 'Interface Index', IntToStr (CurrentChainNode^.ISBInterfaceID));
                                                        AddFileDetailNode (BlockTreeNode, 'Timestamp', DateTimeToStr (CurrentChainNode^.ISBTimestamp) + ' (UTC)');
                                                        AddFileDetailNode (BlockTreeNode, 'StartTime', DateTimeToStr (CurrentChainNode^.ISBStartTime) + ' (UTC)');
                                                        AddFileDetailNode (BlockTreeNode, 'EndTime', DateTimeToStr (CurrentChainNode^.ISBEndTime) + ' (UTC)');
                                                        AddFileDetailNode (BlockTreeNode, 'Received Frames', IntToStr (CurrentChainNode^.ISBReceived));
                                                        AddFileDetailNode (BlockTreeNode, 'Dropped Frames', IntToStr (CurrentChainNode^.ISBDropped));
                                                   end;
                 BLOCKTYPE_IRIG_TIMESTAMP,
                 BLOCKTYPE_ARINC_429_IN_AFDX     : begin
                                                        BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Blocks', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                                                        AddFileDetailNode (BlockTreeNode, 'First Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Last Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));

                                                        AddFileDetailNode (BlockTreeNode, 'Block Total Length', IntToStr (CurrentChainNode^.BlockLength) + ' Bytes');
                                                   end;
                 BLOCKTYPE_HONE_PROCESS_EVENT,
                 BLOCKTYPE_HONE_CONNECTION_EVENT : begin
                                                        BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Block', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                                                        AddFileDetailNode (BlockTreeNode, 'First Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Last Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));

                                                        AddFileDetailNode (BlockTreeNode, 'Block Total Length', IntToStr (CurrentChainNode^.BlockLength) + ' Bytes');
                                                   end;
                 BLOCKTYPE_SYSDIG_MACHINE_INFO,
                 BLOCKTYPE_SYSDIG_PROCESS_LIST,
                 BLOCKTYPE_SYSDIG_INTERFACE_LIST,
                 BLOCKTYPE_SYSDIG_USER_LIST      : begin
                                                        BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Block', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                                                        AddFileDetailNode (BlockTreeNode, 'First Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Last Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));

                                                        AddFileDetailNode (BlockTreeNode, 'Block Total Length', IntToStr (CurrentChainNode^.BlockLength) + ' Bytes');
                                                   end;
                 BLOCKTYPE_SYSDIG_FD_LIST,
                 BLOCKTYPE_SYSDIG_EVENT          : begin
                                                        BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Blocks', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                                                        AddFileDetailNode (BlockTreeNode, 'First Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                                                        AddFileDetailNode (BlockTreeNode, 'Last Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));

                                                        AddFileDetailNode (BlockTreeNode, 'Block Count', IntToStr (CurrentChainNode^.Count));
                                                   end;

                else
                    begin
                         BlockTreeNode := AddFileDetailNode (SectionTreeNode, CurrentChainNode^.BlockTypeName + ' Block', '(Block Type 0x' + IntToHex (CurrentChainNode^.BlockTypeID, 8) + ')');

                         AddFileDetailNode (BlockTreeNode, 'Block Start Offset', '0x' + IntToHex (CurrentChainNode^.FirstBlockStartOffset, 0));
                         AddFileDetailNode (BlockTreeNode, 'Block End Offset', '0x' + IntToHex (CurrentChainNode^.LastBlockEndOffset, 0));
                         AddFileDetailNode (BlockTreeNode, 'Block Total Length', IntToStr (CurrentChainNode^.BlockLength) + ' Bytes');
                    end;
                end;

                CurrentChainNode := CurrentChainNode.NextBlockType;
           end;
end;

(* ------------------------------------------- *)

procedure TFormMain.ClearFileDetails;

begin
     // Clear file details

     LabelValueFilename.Caption := 'n/a';
     LabelValueScanStatus.Caption := 'n/a';
     TabSheetPCAPngDetails.TabVisible := false;

     LabelValuePacketCount.Caption := 'n/a';

     LabelValueFirstFrame.Caption := 'n/a';
     LabelValueLastFrame.Caption := 'n/a';
     LabelValueTraceDuration.Caption := 'n/a';

     LabelValueMinFrameSize.Caption := 'n/a';
     LabelValueMaxFrameSize.Caption := 'n/a';
     LabelValueAverageFrameSize.Caption := 'n/a';

     LabelValueDataSize.Caption := 'n/a';
     LabelValueHeaderOverhead.Caption := 'n/a';
     LabelValueFrameSlided.Caption := 'n/a';
     LabelValueStrictTimeOrder.Caption := 'n/a';

     LabelValueFrameComments.Caption := 'n/a';

     LabelValueFileComment.Caption := 'n/a';
     LabelValueInterfaceCount.Caption := 'n/a';
end;

(* ------------------------------------------- *)

procedure TFormMain.ShowFileDetails (FileEntry : tTracefileEntry);

var sSectionHint : string;
    CurrentTab   : integer;
    help         : string;

begin
     // Show generic stuff first

     LabelValueFilename.Caption := FileEntry.FullName;

     if (FileEntry.FirstFrameTimestamp.datetime = 0) and (FileEntry.FrameCount = 0) then
        LabelValueFirstFrame.Caption := 'unknown'
     else
         LabelValueFirstFrame.Caption := FileEntry.FirstFrameTimestamp.asDateTimeString;

     if FileEntry.PacketStatisticsRead then
        begin
             LabelValuePacketCount.Caption := pointtext (FileEntry.GeneralStatistics.FrameCount);

             ButtonQuickInfoScanNow.Visible := false;
             ButtonQuickInfoScanNow.Enabled := false;

             if Fileentry.FrameCount = 0 then
                begin
                     LabelValueLastFrame.Caption := 'n/a';
                     LabelValueTraceDuration.Caption := 'n/a';

                     LabelValueMinFrameSize.Caption := '0 bytes';
                     LabelValueMaxFrameSize.Caption := '0 bytes';
                     LabelValueAverageFrameSize.Caption := '0 bytes';
                end
             else
                 begin
                      LabelValueLastFrame.Caption := FileEntry.LastFrameTimestamp.asDateTimeString;
                      LabelValueTraceDuration.Caption := FileEntry.CaptureDuration + ' h';

                      LabelValueMinFrameSize.Caption := Pointtext (FileEntry.GeneralStatistics.MinFrameSize) + ' bytes';
                      LabelValueMaxFrameSize.Caption := Pointtext (FileEntry.GeneralStatistics.MaxFrameSize) + ' bytes';
                      LabelValueAverageFrameSize.Caption := Pointtext (FileEntry.GeneralStatistics.AverageFrameSize) + ' bytes';
                 end;

             LabelValueDataSize.Caption := Pointtext (FileEntry.GeneralStatistics.TotalWireBytes) + ' bytes';
             LabelValueHeaderOverhead.Caption := Pointtext (FileEntry.FileSize - FileEntry.GeneralStatistics.TotalFrameBytes) + ' bytes';

             if FileEntry.GeneralStatistics.IsSliced then
                begin
                     if FileEntry.GeneralStatistics.SliceSizeConstant then
                        LabelValueFrameSlided.Caption := 'yes (at ' + IntToStr (fileentry.GeneralStatistics.SliceSize) + ' bytes)'
                     else
                         LabelValueFrameSlided.Caption := 'yes (dynamic)';

//                   LabelSlicedDataSize.Visible := true;
//                   LabelValueSlicedDataSize.Visible := true;

                     LabelValueSlicedDataSize.Caption := Pointtext (FileEntry.GeneralStatistics.TotalFrameBytes) + ' bytes';
                end
             else
                 begin
                      LabelValueFrameSlided.Caption := 'no';
                      LabelValueSlicedDataSize.Caption := 'n/a';
                 end;

             if FileEntry.GeneralStatistics.TimeOrderCorrect then
                LabelValueStrictTimeOrder.Caption := 'correct'
             else
                 LabelValueStrictTimeOrder.Caption := 'out of order';

             // Display Comments for file/packet, if any

             if length (FileEntry.PacketCommentList) > 0 then
                LabelValueFrameComments.Caption := pointtext (length (FileEntry.PacketCommentList))
             else
                 LabelValueFrameComments.Caption := '0';

             if FileEntry.FileComment <> '' then
                begin
                     help := UTF8ToANSI (FileEntry.FileComment);

                     LabelValueFileComment.Caption := help;
                end
             else
                 LabelValueFileComment.Caption := 'n/a';

             // Interface count

             LabelValueInterfaceCount.Caption := IntToStr (FileEntry.CaptureInterfaces.Count);
        end
     else
         begin
              ButtonQuickInfoScanNow.Visible := true;
              ButtonQuickInfoScanNow.Enabled := true;

              LabelValueLastFrame.Caption := 'unknown';
              LabelValueTraceDuration.Caption := 'unknown';

              LabelValueMinFrameSize.Caption := 'unknown';
              LabelValueMaxFrameSize.Caption := 'unknown';
              LabelValueAverageFrameSize.Caption := 'unknown';

              LabelValueDataSize.Caption := 'unknown';
              LabelValueHeaderOverhead.Caption := 'unknown';
              LabelValueFrameSlided.Caption := 'unknown';
              LabelValueStrictTimeOrder.Caption := 'unknown';

              LabelValueFrameComments.Caption := 'unknown';

              LabelValueFileComment.Caption := 'unknown';
              LabelValueInterfaceCount.Caption := 'unknown';
          end;

     // Scan status

     if FileEntry.ProcessingStatus = psNewFile then
        begin
             LabelValueScanStatus.Caption := 'not scanned (file size exceeds scan threshold)';

             if FileEntry.PCAPngStructRead then
                begin
                     if Fileentry.PacketStatisticsRead then
                        begin
                             if fileentry.FrameCount > 0 then
                                LabelValueScanStatus.Caption := 'all packets scanned for general statistics and PCAPng structure'
                             else
                                 LabelValueScanStatus.Caption := 'no packets available for scanning';
                        end;

                     if FileEntry.PCAPngStatistics.SectionCount = 1 then
                        sSectionHint := '1 Section found'
                     else
                         sSectionHint := IntToStr (FileEntry.PCAPngStatistics.SectionCount) + ' Sections found';
                end;

             if FileEntry.ConversationsScanned then
                LabelValueScanStatus.Caption := 'Fully Scanned';
        end
     else
         begin
              if Fileentry.PacketStatisticsRead then
                 begin
                      if fileentry.FrameCount > 0 then
                         LabelValueScanStatus.Caption := 'all packets scanned for general statistics and PCAPng structure'
                      else
                          LabelValueScanStatus.Caption := 'no packets available for scanning';
                 end;
         end;

     // We only do details for PCAPng at the moment

     if FileEntry.TracefileType = cfPCAPng then
        begin
             CurrentTab := PageControlMainDetails.ActivePageIndex;
             TabSheetPCAPngDetails.TabVisible := true;

             if CurrentTab = PageScanStatus then
                PageControlMainDetails.ActivePageIndex := PageQuickInfo
             else
                 PageControlMainDetails.ActivePageIndex := CurrentTab;

             // The file might not yet have been scanned because it was too large

             if FileEntry.PCAPngStructRead then
                begin
                     VSTFileDetails.Visible := true;

                     VSTFileDetails.Clear;
                     VSTFileDetails.BeginUpdate;

                     AddGeneralFileDetailsToTree (nil, FileEntry);
                     AddFileBlockChainDetailsToTree (nil, FileEntry.BlockChainRoot);

                     VSTFileDetails.EndUpdate;
                end
             else
                 VSTFileDetails.Visible := false;
        end
     else
         begin
              TabSheetPCAPngDetails.TabVisible := false;
              PageControlMainDetails.ActivePageIndex := PageQuickInfo;
         end;

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

// This routine processes all selected nodes one after another and does whatever the
// ProcessingOption is set to

procedure TFormMain.ProcessFileListItems (const ProcessingOption : tListProcessOption);

var node      : pVirtualNode;
    nodedata  : pVSTFileListEntry;
    fileentry : tTracefileEntry;
    boOkay    : boolean;
    rcode     : integer;
    sMsg      : string;
    dummy     : tFrameTimeStamp;
    boIgnore  : boolean;

begin
     node := VSTTracefilelist.GetFirstSelected (false);
     boIgnore := False;

     while node <> nil do
           begin
                nodedata := VSTTracefilelist.GetNodeData(node);
                fileentry := nodedata.entry;

                case ProcessingOption of
                 plRemoveFile               : begin
                                                   // If the current node is shown in detail, clear those
                                                   // but remember that we removed the node, so set current
                                                   // node to nil

                                                   if node = priv_CurrentDetailNode then
                                                      begin
                                                           priv_CurrentDetailNode := nil;

                                                           ClearFileDetails;
                                                      end;

//                                                 nodedata^.progressbar.Free;

                                                   TraceSetLoader.RemoveFile (fileentry.FullName);
                                              end;
                 plSetTimeStampToFirstFrame : begin
                                                   // Reads the first frame time and sets the file timestamp to that date/time

                                                   rcode := fileentry.SetFiletimeToFirstFrameTime;

                                                   if not boIgnore and (rcode <> 0) then
                                                      begin
                                                           case rcode of
                                                            5                   : sMsg := 'Warning: could not update file timestamp for "' + fileentry.FullName + '". Check if the file is write protected.';
                                                            32                  : sMsg := 'Warning: could not update file timestamp for "' + fileentry.FullName + '". Maybe the file is in use by another process.';
                                                           NoFrameTimeAvailable : sMsg := 'Warning: could not update file timestamp for "' + fileentry.FullName + '" - no frame found';
                                                           else
                                                               sMsg := 'Warning: could not update file timestamp for "' + fileentry.FullName + '". Maybe the file is in use by another process or write protected.';
                                                           end;

                                                           if MessageDlg (sMsg, mtWarning, [mbOK,mbIgnore], 0) = mrIgnore then
                                                              boIgnore := True;
                                                      end;
                                              end;
                 plSetTimeStampToLastFrame  : begin
                                                   // TODO: the next block needs to be checked before looping through the entries to avoid messaging each and every single one

                                                   if fileentry.LastFrameTimestamp.datetime = 0 then
                                                      begin
                                                           if priv_filescanok or (MessageBox (0, 'Some files have not yet been scanned and so the timestamp of the last frame is unknown. Scanning might take a while. Do you want to scan those files?',
                                                              'Confirmation required', MB_ICONASTERISK or MB_YESNO) = idYes) then
                                                              begin
                                                                   priv_filescanok := true;

                                                                   // Trigger scan - we do not really need the result here, but this way the lastframetimestamp is set

                                                                   dummy := fileentry.LastFrameTimestamp;
                                                              end
                                                           else
                                                               boOkay := false;
                                                      end
                                                   else
                                                       boOkay := true;

                                                   if boOkay then
                                                      rcode := fileentry.SetFiletimeToLastFrameTime;

                                                   if not boIgnore and (rcode <> 0) then
                                                      begin
                                                           case rcode of
                                                            5                   : sMsg := 'Warning: could not update file timestamp for "' + fileentry.FullName + '". Check if the file is write protected.';
                                                            32                  : sMsg := 'Warning: could not update file timestamp for "' + fileentry.FullName + '". Maybe the file is in use by another process.';
                                                           NoFrameTimeAvailable : sMsg := 'Warning: could not update file timestamp for "' + fileentry.FullName + '" - no frame found';
                                                           else
                                                               sMsg := 'Warning: could not update file timestamp for "' + fileentry.FullName + '". Maybe the file is in use by another process or write protected.';
                                                           end;

                                                           if MessageDlg (sMsg, mtWarning, [mbOK,mbIgnore], 0) = mrIgnore then
                                                              boIgnore := True;
                                                      end;
                                              end;
                 plExportDescription        : begin
                                                   if fileentry.FileComment <> '' then
                                                      setTotalCommanderDescription (fileentry.FilePath + fileentry.FileName, fileentry.FileComment);
                                              end;
                 plRenameFile               : begin
                                                   fileentry.rename (priv_renameparams);
                                                   VSTTraceFilelist.RepaintNode (node);

                                                   // Adjust the counter

                                                   priv_renameparams.Counter.increment;
                                              end;
                end;

                node := VSTTracefilelist.GetNextSelected(node);
           end;

     if ProcessingOption = plRemoveFile then
        begin
             TraceSetLoader.UpdateConversationStore;
             MenuCommunicationDetails.Enabled := TraceSetLoader.ConversationStore.HasRecords;
        end;

     StatusBarMain.Panels[2].Text := '';
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileListAddToSelection (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     TimerScanNowButtonStatus.Enabled := true;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     MenuRenameFiles.Enabled := (VSTTracefilelist.SelectedCount > 0);
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileListClick (Sender: TObject);

var node      : pVirtualNode;
    nodedata  : pVSTFileListEntry;
    fileentry : tTracefileEntry;

begin
     node := VSTTraceFileList.GetFirstSelected;

     if (node <> nil) then
        begin
             if (node <> priv_CurrentDetailNode) then
                begin
                     nodedata := VSTTracefilelist.GetNodeData(node);
                     fileentry := nodedata.entry;

                     ShowFileDetails (fileentry);
                     priv_CurrentDetailNode := node;
                end;
        end
     else
         begin
              priv_currentdetailnode := nil;
         end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileListRemoveFromSelection (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     TimerScanNowButtonStatus.Enabled := true;
end;

(* ------------------------------------------- *)

procedure TFormMain.onTimerScanNowButtonStatus(Sender: TObject);

begin
     TimerScanNowButtonStatus.Enabled := false;

     // Check if we need to enable the manual scan button when files are selected

     ButtonQuickInfoScanNow.enabled := TraceSetLoader.TotalStatsIncomplete and (VSTTraceFileList.SelectedCount > 0);
     ButtonQuickInfoScanNow.Visible := ButtonQuickInfoScanNow.Enabled;

     if VSTTraceFileList.SelectedCount = 0 then
        ClearFileDetails;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

var nodedata  : pVSTFileListEntry;
    fileentry : tTracefileEntry;

begin
//   ProcessFileListItems (plShowFileDetails);

     if node <> priv_CurrentDetailNode then
        begin
             nodedata := VSTTracefilelist.GetNodeData(node);
             fileentry := nodedata.entry;

             ShowFileDetails (fileentry);
             priv_CurrentDetailNode := node;
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileListGetHint(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; var LineBreakStyle: TVTTooltipLineBreakStyle; var HintText: string);

var nodedata  : pVSTFileListEntry;
    fileentry : tTracefileEntry;
    celltext  : string;

begin
     nodedata := VSTTracefilelist.GetNodeData(Node);
     fileentry := nodedata^.entry as tTracefileEntry;

     HintText := fileentry.getHintText;
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTFileListKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);

begin
     if Key = 46 then
        DeleteSelectedFilesFromList;
//     else
//         showmessage ('Key: #' + IntToStr (Key));
end;

(* ------------------------------------------- *)

procedure TFormMain.onVSTTaskListKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);

begin
     if Key = 46 then
        DeleteSelectedTasksFromList;
end;

(* ------------------------------------------- *)

procedure TFormMain.UpdateStatusbarAndTasklist;

begin
     // Update Statusbar

     StatusBarMain.Panels[1].Text := 'Files: ' + IntToStr (TraceSetLoader.FileCount);

     if not TraceSetLoader.TotalStatsIncomplete then
        begin
             StatusBarMain.Panels[3].Text := 'Total Frames: ' + PointText (TraceSetLoader.TotalFrameCount) + '    Total Bytes: ' + PointText (TraceSetLoader.TotalFrameBytes);
             ButtonQuickInfoScanNow.Visible := false;
             ButtonQuickInfoScanNow.Enabled := false;
        end
     else
         begin
             StatusBarMain.Panels[3].Text := 'Total Frames: n/a    Total Bytes: n/a';
             ButtonQuickInfoScanNow.Visible := false;
             ButtonQuickInfoScanNow.Enabled := false;
         end;

     // Update TaskList

     VSTTaskList.Repaint;
end;

(* ------------------------------------------- *)

procedure TFormMain.RefreshTraceFileList;

var fileentry : tTraceFileEntry;
    nodedata  : pVSTFileListEntry;
    newnode   : pVirtualNode;
    i         : integer;

begin
     VSTTraceFileList.Clear;
     VSTTracefilelist.BeginUpdate;

     for i := 1 to TraceSetLoader.FileCount do
         begin
              fileentry := TraceSetLoader.getFile(i);

              newnode := VSTTracefilelist.AddChild(VSTTracefileList.RootNode);
              nodedata := VSTTracefilelist.GetNodeData(newnode);

              nodedata^.index := i;
              nodedata^.entry := fileentry;
              nodedata^.processingstatus := fileentry.ProcessingStatus;
{
              nodedata^.progressbar := TProgressBar.Create(VSTTracefilelist);
              nodedata^.progressbar.Parent := VSTTracefilelist;
              nodedata^.progressbar.Position := 0;
              nodedata^.progressbar.Max := 100;
              nodedata^.progressbar.Visible := false;
}
              // Store node references in fileentry to find it if we need to update it on processing tasks

              fileentry.AssociatedTreeNode := newnode;
         end;

     VSTTracefilelist.EndUpdate;

     priv_fileprogressbar.Visible := false;

     UpdateStatusbarAndTasklist;
end;

(* ------------------------------------------- *)

procedure TFormMain.UpdateTaskOptions;

begin
     // Activate controls if necessary

     ButtonAddTask.Enabled := (VSTTracefilelist.RootNodeCount > 0);

     ButtonQuickAddAnonymizationTask.Visible := (VSTTaskList.RootNodeCount = 0);
     ButtonQuickAddAnonymizationTask.Enabled := ButtonAddTask.Enabled;
     ButtonQuickAddExtractionTask.Visible := ButtonQuickAddAnonymizationTask.Visible;

     if (TraceSetLoader <> nil) and (TraceSetLoader.ConversationStore <> nil) then
        ButtonQuickAddExtractionTask.Enabled := TraceSetLoader.ConversationStore.HasRecords;

     ButtonQuickAddEditTask.Visible := ButtonQuickAddAnonymizationTask.Visible;
     ButtonQuickAddEditTask.Enabled := ButtonAddTask.Enabled;
     ButtonQuickAddMergeTask.Visible := ButtonQuickAddAnonymizationTask.Visible;
     ButtonQuickAddMergeTask.Enabled := ButtonAddTask.Enabled;
end;

(* ------------------------------------------- *)

// Helper routine that finalizes modifications to the file list

procedure TFormMain.UpdateExecuteButtonStatus;

var task   : tTaskEntry;
    boOkay : boolean;
    count  : integer;
    i      : integer;

begin
     boOkay := (VSTTracefilelist.RootNodeCount > 0) and (TaskListManager.count > 0);

     if boOkay and (TaskListManager <> nil) then
        begin
             count := TaskListManager.count;

             for i := 1 to count do
                 begin
                      task := TaskListManager.getTask(i);

                      // Extract tasks need the conversations to be scanned
                      // TODO: hasRecords may not be good enough - we need to know all files were scanned

                      if (task.TaskType = ttExtract) then
                         begin
                              // Check if we have a loader and a conversation store

                              if (TraceSetLoader <> nil) and (TraceSetLoader.ConversationStore <> nil) then
                                 begin
                                      if not TraceSetLoader.ConversationStore.HasRecords then
                                         boOkay := false;
                                 end;
                         end;
                 end;
        end;

     ButtonExecuteTasks.Enabled := boOkay;
end;

(* ------------------------------------------- *)

procedure TFormMain.UpdateFileList;

begin
     TraceSetLoader.SortFilelist (stFirstFrameTime);

     // Add them to the tree list

     RefreshTraceFileList;

     // Toggle pagecontrol to show file list

     PageControlFileList.ActivePageIndex := 1;

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.UpdateFileListStatus;

var FileEntry : tTracefileEntry;
    NodeData  : pVSTFileListEntry;
    i         : integer;

begin
     for i := 1 to TraceSetLoader.FileCount do
         begin
              FileEntry := TraceSetLoader.getFile (i);
              NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

              // Set the status to pending or no task assigned depending on the task list
              // for files that haven't been processed yet

              case FileEntry.ProcessingStatus of
               psNoTaskAssigned : begin
                                       if TaskListManager.count > 0 then
                                          FileEntry.ProcessingStatus := psTaskPending;
                                  end;
               psTaskPending    : begin
                                       if TaskListManager.count > 0 then
                                          FileEntry.ProcessingStatus := psNoTaskAssigned;
                                  end;
              end;

              if Nodedata <> nil then
                 NodeData^.processingstatus := FileEntry.ProcessingStatus;
         end;
{
     if not TraceSetLoader.TotalStatsIncomplete then
        begin
             StatusBarMain.Panels[3].Text := 'Total Frames: ' + PointText (TraceSetLoader.TotalFrameCount) + '    Total Bytes: ' + PointText (TraceSetLoader.TotalFrameBytes);
             ButtonQuickInfoScanNow.Visible := false;
             ButtonQuickInfoScanNow.Enabled := false;
        end
     else
         begin
             StatusBarMain.Panels[3].Text := 'Total Frames: n/a    Total Bytes: n/a';
             ButtonQuickInfoScanNow.Visible := false;
             ButtonQuickInfoScanNow.Enabled := false;
         end;
}
end;

(* ------------------------------------------- *)

procedure TFormMain.PrepareTotalAutoScanDetails;

var FileEntry : tTracefileEntry;
    NodeData  : pVSTFileListEntry;
    count     : integer;
    i         : integer;

begin
     // Prepare Counters

     priv_TotalConvCounters.initialize;

     // Prepare Total Progressbar scope

     count := 0;

     for i := 1 to TraceSetLoader.FileCount do
         begin
              FileEntry := TraceSetLoader.getFile (i);

              if not Fileentry.PacketStatisticsRead then
                 inc (count);
         end;

     ProgressBarTotal.Max := count * 100;

     priv_totalscanfileindex := 0;
end;

(* ------------------------------------------- *)

procedure TFormMain.PrepareManualScanDetails;

var FileEntry : tTracefileEntry;
    Node      : pVirtualNode;
    NodeData  : pVSTFileListEntry;
    count     : integer;
    i         : integer;

begin
     // Prepare Counters

     priv_TotalConvCounters.initialize;

     // Prepare Total Progressbar scope

     count := 0;

     node := VSTTraceFileList.GetFirstSelected(false);

     while node <> nil do
           begin
                NodeData := VSTTracefileList.GetNodeData(node);
                FileEntry := NodeData^.entry;

                if not Fileentry.PacketStatisticsRead then
                   inc (count);

                node := VSTTraceFileList.GetNextSelected(node);
           end;

     ProgressBarTotal.Max := count * 100;

     priv_totalscanfileindex := 0;
end;

(* ------------------------------------------- *)

procedure TFormMain.PerformPendingAutoScans;

var FileEntry    : tTracefileEntry;
    Node         : pVirtualNode;
    NodeData     : pVSTFileListEntry;
    DBParams     : tIntelDBParameters;
    SkippedCount : integer;
    i            : integer;

begin
     DBParams.initialize;

     // Enable persistent mode to allow reusing the same DB for multiple files in the same directory

     DBParams.UsePersistentIntelDB := true;

     priv_scanningMultiples := true;
     ButtonAbortScan.Enabled := true;
     priv_abortscanrequested := false;

     PrepareTotalAutoScanDetails;

     // Do the scan

     i := 0;
     SkippedCount := 0;

     while (i < TraceSetLoader.FileCount) and not priv_abortscanrequested do
           begin
                inc (i);

                FileEntry := TraceSetLoader.getFile (i);

                VSTTraceFilelist.ScrollIntoView (FileEntry.AssociatedTreeNode, true);

                if not Fileentry.PacketStatisticsRead then
                   begin
                        inc (priv_totalscanfileindex);

                        // Read the file with persistent DB settings (DB is opened by the first file that needs it)

                        FileEntry.IntelDBParameters := DBParams;
                        FileEntry.EssentialPacketSaveMode := FormPreferences.CheckBoxSaveEssentialsToFile.Checked;
                        FileEntry.ReadFileDetails (True);

                        // Retrieve settings as they may have changed

                        DBParams := FileEntry.IntelDBParameters;

                        // Make sure the file itself has no DB links left, otherwise it may try to access an invalid DB at some later time

                        FileEntry.IntelDBParameters.initialize;

                        if not FileEntry.ConversationsScanned then
                           inc (SkippedCount);

                        VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);
                        Application.ProcessMessages;
                   end;
           end;

     // Close IntelDB

     if DBParams.IntelDB <> nil then
        begin
             DBParams.IntelDB.Disconnect;
             DBParams.IntelDB.free;
             DBParams.IntelDB := nil;
        end;

     priv_scanningMultiples := false;

     if priv_abortscanrequested then
        begin
             Node := FileEntry.AssociatedTreeNode;
             NodeData := VSTTraceFileList.GetNodeData (Node);

             NodeData^.processingstatus := FileEntry.ProcessingStatus;
{
             NodeData^.progressbar.Max := 100;
             NodeData^.progressbar.Position := 0;
             NodeData^.progressbar.Visible := false;
}
             priv_fileprogressbar.Visible := false;

             VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);
        end
     else
         begin
              if (SkippedCount > 0) and not (FormPreferences.CheckBoxDoNotWarnAboutScanThreshold.Enabled and FormPreferences.CheckBoxDoNotWarnAboutScanThreshold.Checked) then
                 MessageDlg ('Some files were not scanned since their file sizes exceed the auto scan threshold', mtInformation, [mbOK], 0);
         end;

     PageControlMainDetails.ActivePageIndex := PageQuickInfo;

     ButtonAbortScan.Enabled := false;
end;

(* ------------------------------------------- *)

procedure TFormMain.PerformManualScans;

var FileEntry : tTracefileEntry;
    Node      : pVirtualNode;
    NodeData  : pVSTFileListEntry;

begin
     PrepareManualScanDetails;

     priv_scanningMultiples := true;
     ButtonAbortScan.Enabled := true;
     priv_abortscanrequested := false;

     node := VSTTraceFileList.GetFirstSelected(false);

     while (node <> nil) and not priv_abortscanrequested do
           begin
                NodeData := VSTTracefileList.GetNodeData(node);
                FileEntry := NodeData^.entry;

                if not Fileentry.PacketStatisticsRead then
                   begin
                        inc (priv_totalscanfileindex);

                        StatusbarMain.Panels[0].Text := 'Scanning File';
                        StatusbarMain.Panels[1].Text := fileentry.FileName;
                        Application.ProcessMessages;

                        // Do the scan

                        FileEntry.EssentialPacketSaveMode := FormPreferences.CheckBoxSaveEssentialsToFile.Checked;

                        FileEntry.ForceReadFileDetails;

                        VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);
                   end;

                if not priv_abortscanrequested then
                   node := VSTTraceFileList.GetNextSelected(node);
             end;

     priv_scanningMultiples := false;

     if priv_abortscanrequested then
        begin
             NodeData := VSTTraceFileList.GetNodeData (Node);

             NodeData^.processingstatus := FileEntry.ProcessingStatus;
{
             NodeData^.progressbar.Max := 100;
             NodeData^.progressbar.Position := 0;
             NodeData^.progressbar.Visible := false;
}
             priv_fileprogressbar.Visible := false;

//           VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);
             VSTTracefilelist.RepaintNode (node);
        end;

     PageControlMainDetails.ActivePageIndex := PageQuickInfo;

     ButtonAbortScan.Enabled := false;

     node := VSTTraceFileList.FocusedNode;

     if node = nil then
        node := VSTTraceFileList.GetFirstSelected;

     if node <> nil then
        ShowFileDetails (fileentry);
end;

(* ------------------------------------------- *)

// Routine that updates the TreeList showing all tasks

procedure TFormMain.AddTaskToDisplay (NewTask : tTaskEntry);

var Node : PVirtualNode;
    Data : pVSTTaskEntry;

begin
     Node := VSTTaskList.AddChild(VSTTaskList.RootNode);
     Data := VSTTaskList.GetNodeData(Node);

     Data^.index := VSTTaskList.RootNodeCount;
     Data^.entry := NewTask;

     VSTTaskList.Repaint;
end;

(* ------------------------------------------- *)

procedure TFormMain.OnAddDuplicate (Sender: tObject; const Filename: string; var discardFile: boolean);

begin
     discardFile := true;
end;

(* ------------------------------------------- *)

procedure TFormMain.OnAddUnknownFileType (Sender: tObject; const Filename: string);

begin
     if FormPreferences.getAdvancedBoolSetting ('ToggleAdvWarnOnDiscardingUnknownFileTypes') then
        MessageDlg('Cannot add file "' + Filename + '": unknown file type', mtWarning, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormMain.OnExtractFileSection (const Filename: string; const SectionIndex: integer);

var NodeData : pVSTFileListEntry;

begin
     NodeData := VSTTracefilelist.GetNodeData(priv_CurrentDetailNode);

//   NodeData^.progressbar.Position := SectionIndex;
     priv_fileprogressbar.Position := SectionIndex;
     VSTTracefilelist.RepaintNode (priv_CurrentDetailNode);
end;

(* ------------------------------------------- *)

procedure TFormMain.AddFilesFromDirectory (Path: string);

var DirParser : tDirParser;
    filename  : string;
    i         : integer;

begin
     DirParser := tDirParser.create;

     DirParser.BaseDirectory := Path;
     DirParser.FileMask := '*.*';
     DirParser.IncludeSubDirs := FormPreferences.CheckBoxIncludeSubdirectories.Checked;

     DirParser.execute;

     if DirParser.FileCount > 0 then
        begin
             PageControlFileList.ActivePageIndex := 1;
             Application.ProcessMessages;

             if FormPreferences.CheckBoxWarnAlsoIfAddingFromDirectory.Enabled and (not FormPreferences.CheckBoxWarnAlsoIfAddingFromDirectory.Checked) then
                TraceSetLoader.onAddUnknownFileType := nil;

             for i := 1 to DirParser.FileCount do
                 begin
                      filename := DirParser.getFileName (i);

                      if lowercase (extractfilename (filename)) <> LocalTraceIntelFilename then
                          AddFileToFilelist (filename);
                 end;

             TraceSetLoader.onAddUnknownFileType := OnAddUnknownFileType;
        end;

     DirParser.free;

     UpdateStatusbarAndTasklist;
end;

(* ------------------------------------------- *)

procedure TFormMain.AddFilesFromFilelist (Listfilename: string);

var Filelist : tStringlist;
    Filename : string;
    path     : string;
    i        : integer;

begin
     path := extractfilepath (ListFilename);

     if Fileexists (ListFilename) then
        begin
             Filelist := tStringlist.Create;

             try
                filelist.LoadFromFile (ListFilename);

                PageControlFileList.ActivePageIndex := 1;
                Application.ProcessMessages;

                if FormPreferences.CheckBoxWarnAlsoIfAddingFromDirectory.Enabled and (not FormPreferences.CheckBoxWarnAlsoIfAddingFromDirectory.Checked) then
                   TraceSetLoader.onAddUnknownFileType := nil;

                for i := 1 to Filelist.Count do
                    begin
                         filename := DetermineFilenameFromParam (Filelist[i-1]);

                         if filename = '' then
                            begin
                                 // Try adding path of filelist

                                 if fileexists (path + Filelist[i-1]) then
                                    filename := path + Filelist[i-1];
                            end;

                         if (filename <> '') and (lowercase (extractfilename (filename)) <> LocalTraceIntelFilename) then
                            AddFileToFilelist (filename);
                    end;

                TraceSetLoader.onAddUnknownFileType := OnAddUnknownFileType;

             finally
                    Filelist.Free;
             end;
        end;

     UpdateStatusbarAndTasklist;
end;

(* ------------------------------------------- *)

procedure TFormMain.AddFileToFilelist (Filename: string);

var fileentry : tTracefileEntry;
    newnode   : pVirtualNode;
    nodedata  : pVSTFileListEntry;
    filesize  : int64;

begin
     if fileExists (Filename) then
        begin
             filesize := GetFileSize (Filename);

             if filesize < 24 then
                begin
                     if priv_warnminfilesize then
                        MessageDlg ('Error: file "' + Filename + '" is too small, ignoring (and all others with the same problem).', mtError, [mbOK], 0);

                     priv_warnminfilesize := false;
                end
             else
                 if filesize > integer.MaxValue then
                    begin
                         if priv_warnmaxfilesize then
                            MessageDlg ('Error: file "' + Filename + '" is too big (max ' + pointtext (integer.MaxValue) + ' bytes), ignoring (and all others with the same problem).', mtError, [mbOK], 0);

                         priv_warnmaxfilesize := false;
                    end
                 else
                     if lowercase (extractfilename (filename)) <> LocalTraceIntelFilename then
                        begin
                             // Add the new file to the set of files, which creates a new fileentry object to work with

                             fileentry := TraceSetLoader.AddFile (FileName);

                             // If this file was really a trace file we get the entry back, otherwise its nil

                             if fileentry <> nil then
                                begin
                                     newnode := VSTTracefilelist.AddChild(VSTTracefileList.RootNode);
                                     nodedata := VSTTracefilelist.GetNodeData(newnode);

                                     nodedata^.index := TraceSetLoader.FileList.Count;
                                     nodedata^.entry := fileentry;
                                     nodedata^.processingstatus := fileentry.ProcessingStatus;
{
                                     nodedata^.progressbar := TProgressBar.Create (VSTTracefilelist);
                                     nodedata^.progressbar.Visible := false;
                                     nodedata^.progressbar.Parent := VSTTracefilelist;
                                     nodedata^.progressbar.Position := 0;
                                     nodedata^.progressbar.Max := 100;
}
                                     priv_fileprogressbar.Visible := false;

                                     // Paint the new entry

                                     VSTTracefileList.ScrollIntoView (newnode, false);

                                     // Store node references in fileentry to find it if we need to update it on processing tasks

                                     fileentry.AssociatedTreeNode := newnode;
                                end;

                             Application.ProcessMessages;
                        end;
        end
     else
         RichEditLog.Lines.Add ('Cannot find file "' + Filename + '", ignoring');
end;

(* ------------------------------------------- *)

procedure TFormMain.AddFilesByWildCard (Filename: string);

var DirParser : tDirParser;
    Path      : string;
    i         : integer;

begin
     Path := ExtractFilePath (Filename);

     if DirectoryExists (Path) then
        begin
             DirParser := tDirParser.create;

             DirParser.BaseDirectory := Path;
             DirParser.FileMask := ExtractFilename (Filename);
             DirParser.IncludeSubDirs := FormPreferences.CheckBoxIncludeSubdirectories.Checked;

             DirParser.execute;

             // Disable Warnings by unhooking event

             if DirParser.FileCount > 0 then
                begin
                     PageControlFileList.ActivePageIndex := 1;
                     Application.ProcessMessages;

                     if FormPreferences.CheckBoxWarnAlsoIfAddingFromDirectory.Enabled and (not FormPreferences.CheckBoxWarnAlsoIfAddingFromDirectory.Checked) then
                        TraceSetLoader.onAddUnknownFileType := nil;

                     for i := 1 to DirParser.FileCount do
                         begin
                              filename := DirParser.getFileName (i);

                              if lowercase (extractfilename (filename)) <> LocalTraceIntelFilename then
                                 AddFileToFilelist (filename);
                         end;

                     // Reestablish event hook

                     TraceSetLoader.onAddUnknownFileType := OnAddUnknownFileType;
                end;

             DirParser.free;
        end;

     UpdateStatusbarAndTasklist;
end;

(* ------------------------------------------- *)

// Routine that handles the accepting of dropped files from Windows Explorer

procedure TFormMain.WMDROPFILES (var msg: TWMDropFiles);

const MAXFILENAME = 255;

var i          : integer;
    FileCount  : integer;
    OSFileName : array [0..MAXFILENAME] of char;
    Filename   : string;
    boOkay     : boolean;

begin
     TraceSetLoader.IgnoredFilesWhenAdding := 0;

     // how many files dropped?

     fileCount := DragQueryFile(msg.Drop, $FFFFFFFF, OSFileName, MAXFILENAME) ;

     if filecount > 0 then
        begin
             PageControlFileList.ActivePageIndex := 1;
             Application.ProcessMessages;
        end;

     // query for file names

     for i := 0 to fileCount - 1 do
         begin
              DragQueryFile(msg.Drop, i, OSFileName, MAXFILENAME) ;
              Filename := string (OSFileName);

              StatusBarMain.Panels[2].Text := ExtractFileName (Filename);

              if FileExists (Filename) and (lowercase (ExtractFileName (filename)) <> LocalTraceIntelFilename) then
                 begin
                      if not (ExtractFileExt (Filename) = '.task') then
                         AddFileToFilelist (Filename)
                      else
                          AddTaskFileToList (Filename);
                 end
              else
                  if DirectoryExists (filename) then
                     begin
                          boOkay := true;

                          if FormPreferences.CheckBoxWarnWhenAddingDirectories.Checked then
                             boOkay := (MessageDlg('Do you want to add all files in "' + filename + '"?', mtConfirmation, [mbYes, mbNo], 0) = mrYes);

                          if boOkay then
                             AddFilesFromDirectory (Filename);
                     end;
         end;

     // Release memory

     DragFinish(msg.Drop) ;

     // Update display

     FinalizeAddingFiles;

     StatusBarMain.Panels[2].Text := '';
{
     if (VSTTraceFilelist.RootNodeCount = 0) then
        begin
             PageControlFileList.ActivePageIndex := 0;
             UpdateStatusbarAndTasklist;
             UpdateExecuteButtonStatus;
             Application.ProcessMessages;
        end
     else
         begin
              StatusBarMain.Panels[0].Text := 'Status: accessing IntelDB';
              Application.ProcessMessages;

              UpdateFileList;
              PerformPendingAutoScans;
              TraceSetLoader.UpdateConversationStore;

              MenuCommunicationDetails.Enabled := TraceSetLoader.ConversationStore.HasRecords;

              UpdateExecuteButtonStatus;

              UpdateFileListStatus;

              StatusBarMain.Panels[0].Text := 'Status: idle';
              Application.ProcessMessages;
         end;

     UpdateStatusbarAndTasklist;
}
end;

(* ------------------------------------------- *)

procedure TFormMain.PrepareProgressbarForNode (const Node : pVirtualNode);

var CellRect: TRect;

begin
     CellRect := VSTTraceFileList.GetDisplayRect (Node, ColStatus, false);

     priv_fileprogressbar.Left := CellRect.Left + 2;
     priv_fileprogressbar.Top := CellRect.Top + 2;
     priv_fileprogressbar.Width := CellRect.Right-CellRect.Left - 4;
     priv_fileprogressbar.Height := CellRect.Bottom-CellRect.Top - 4;

     priv_fileprogressbar.Max := 100;
     priv_fileprogressbar.Position := 0;
     priv_fileprogressbar.Visible := true;
end;

(* ------------------------------------------- *)

// This routine adds files via the open dialog

procedure TFormMain.ButtonAddTracefilesClick (Sender: TObject);

var filename : string;
    i        : integer;

begin
     if DataModuleMain.OpenDialogFilelist.Execute then
        begin
             TraceSetLoader.IgnoredFilesWhenAdding := 0;

             // Add files, then sort them

             for i := 1 to DataModuleMain.OpenDialogFilelist.Files.Count do
                 begin
                      filename := DataModuleMain.OpenDialogFilelist.Files[i-1];

                      StatusBarMain.Panels[2].Text := ExtractFileName (filename);

                      if lowercase (extractfilename (filename)) <> LocalTraceIntelFilename then
                         AddFileToFilelist (DataModuleMain.OpenDialogFilelist.Files[i-1]);
                 end;

             FinalizeAddingFiles;
{
             StatusBarMain.Panels[2].Text := '';

             StatusBarMain.Panels[0].Text := 'Status: accessing IntelDB';
             Application.ProcessMessages;

             UpdateFileListStatus;
             UpdateFileList;
             PerformPendingAutoScans;
             TraceSetLoader.UpdateConversationStore;

             StatusBarMain.Panels[0].Text := 'Status: idle';
             Application.ProcessMessages;

             MenuCommunicationDetails.Enabled := TraceSetLoader.ConversationStore.HasRecords;

             if TraceSetLoader.IgnoredFilesWhenAdding > 0 then
                MessageDlg('Skipped ' + IntToStr (TraceSetLoader.IgnoredFilesWhenAdding) + ' files - could not determine trace file format', mtWarning, [mbOK], 0);

             UpdateExecuteButtonStatus;
}
        end;

//   UpdateStatusbarAndTasklist;
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonAbortScanClick(Sender: TObject);

begin
     priv_abortscanrequested := true;
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonAddDirectoryClick (Sender: TObject);

var sPath : string;

begin
     sPath := BrowseDialog ('Select Path', BIF_RETURNONLYFSDIRS);

     if directoryExists (sPath) then
        begin
             AddFilesFromDirectory (sPath);

             FinalizeAddingFiles;
{
             StatusBarMain.Panels[2].Text := '';

             StatusBarMain.Panels[0].Text := 'Status: accessing IntelDB';
             Application.ProcessMessages;

             UpdateFileListStatus;
             UpdateFileList;
             PerformPendingAutoScans;
             TraceSetLoader.UpdateConversationStore;

             StatusBarMain.Panels[0].Text := 'Status: idle';
             Application.ProcessMessages;

             MenuCommunicationDetails.Enabled := TraceSetLoader.ConversationStore.HasRecords;

             if TraceSetLoader.IgnoredFilesWhenAdding > 0 then
                MessageDlg('Skipped ' + IntToStr (TraceSetLoader.IgnoredFilesWhenAdding) + ' files - could not determine trace file format', mtWarning, [mbOK], 0);

             UpdateExecuteButtonStatus;
}
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.DeleteSelectedFilesFromList;

begin
     ProcessFileListItems (plRemoveFile);

     UpdateFileList;
     UpdateTaskOptions;
end;

(* ------------------------------------------- *)

procedure TFormMain.DeleteSelectedTasksFromList;

begin
     // Lazy me...

     ButtonRemoveTask.Click;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuPopupMainSetFileTimeToFirstFrameClick (Sender: TObject);

begin
     ProcessFileListItems (plSetTimeStampToFirstFrame);

     MessageDlg('Task complete.', mtInformation, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuPopupMainSetFileTimeToLastFrameClick (Sender: TObject);

begin
     // make sure that not all files are automatically scanned

     priv_filescanok := false;

     // Process files

     ProcessFileListItems (plSetTimeStampToLastFrame);

     priv_filescanok := false;

     MessageDlg('Task complete.', mtInformation, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuCommunicationDetailsClick(Sender: TObject);

var ConversationStore : tConversationStorage;

begin
     FormConversationSummary.TracefileList := TraceSetLoader.FileList;

     // hand over the conversation store object in two steps for debugging purposes

     ConversationStore := TraceSetLoader.ConversationStore;
     FormConversationSummary.ConversationStore := ConversationStore;

     FormConversationSummary.SetMode (cmmMainForm);
     FormConversationSummary.TempPath := TempPath;

     FormConversationSummary.ShowModal;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuAboutClick(Sender: TObject);

begin
     FormAbout.showModal;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuCheckForUpdateClick (Sender: TObject);

var versionrec : tVersionStruct;
    exeversion : string;
    params     : string;

begin
{$ifndef disableupdatecheck}

     if Sender = nil then
        Params := 'startup=1'
     else
         Params := 'startup=0';

     versionrec := getVersionFromWeb (params);
     exeversion := GetExeVersion (paramStr(0));

     // a little paranoid anti-webpage-hijacking-and-distributing-weird-strings check, could do a regex later

     if (versionrec.status = vsOkay) and ((length (versionrec.version) > 16) or (pos ('build', versionrec.version) = 0)) then
        versionrec.status := vsFormatError;

     case versionrec.status of
      vsConnectionFail          : begin
                                       if (Sender <> nil) or (FormPreferences.CheckBoxDoNotWarnIfNoConnection.Enabled and FormPreferences.CheckBoxDoNotWarnIfNoConnection.Checked) then
                                          MessageDlg ('Update check failed, maybe there is no direct connection to the internet or outgoing https on port 443 is blocked.', mtError, [mbOK], 0);
                                  end;
      vsFormatError             : MessageDlg ('Update check failed, version record has a bad format', mtError, [mbOK], 0);
      vsProxyAutoConfigError    : begin
                                       if (Sender <> nil) or (FormPreferences.CheckBoxDoNotWarnIfNoConnection.Enabled and FormPreferences.CheckBoxDoNotWarnIfNoConnection.Checked) then
                                          MessageDlg ('Update check failed, caused by an error in the proxy auto config script.', mtError, [mbOK], 0);
                                  end;
      vsProxyScriptDownloadFail : begin
                                       if (Sender <> nil) or (FormPreferences.CheckBoxDoNotWarnIfNoConnection.Enabled and FormPreferences.CheckBoxDoNotWarnIfNoConnection.Checked) then
                                          MessageDlg ('Update check failed, caused by download failure of the proxy auto config script.', mtError, [mbOK], 0);
                                  end;
      vsWPADDetectionFail       : begin
                                       if (Sender <> nil) or (FormPreferences.CheckBoxDoNotWarnIfNoConnection.Enabled and FormPreferences.CheckBoxDoNotWarnIfNoConnection.Checked) then
                                          MessageDlg ('Update check failed, caused by proxy WPAD detection failure.', mtError, [mbOK], 0);
                                  end;
      vsOkay                    : begin
                                       if versionrec.version > exeversion then
                                          begin
                                               FormUpdateNotification.LabelValueNewVersion.Caption := versionrec.version + ' (' + DateToStr (versionrec.builddate) + ')';
                                               FormUpdateNotification.LabelValueCurrentVersion.Caption := exeversion;
                                               FormUpdateNotification.MemoChangeLog.Text := versionrec.changelog;

                                               FormUpdateNotification.showmodal;

                                               if FormUpdateNotification.ModalResult = mrOK then
                                                  ShellExecute(0, 'OPEN', PChar(TracebusterDownloadURL), '', '', SW_SHOWNORMAL);
                                          end
                                       else
                                           begin
                                                // If it is an automatic check we don't report that it is the latest version

                                                if Sender <> nil then
                                                   begin
                                                        if exeversion > versionrec.version then
                                                           MessageDlg('You''re running a special version that is newer than the latest official release.', mtInformation, [mbOK], 0)
                                                        else
                                                            MessageDlg('You''re running the latest version.', mtInformation, [mbOK], 0);
                                                   end;
                                           end;
                                  end;
      vsProxyFail               : begin
                                       if (Sender <> nil) or (FormPreferences.CheckBoxDoNotWarnIfNoConnection.Enabled and FormPreferences.CheckBoxDoNotWarnIfNoConnection.Checked) then
                                          MessageDlg ('Proxy Connection failed, probably due to an authentication failure', mtError, [mbOK], 0);
                                  end;
     end;
{$endif}
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuLoadFilesClick(Sender: TObject);

begin
     ButtonAddTracefiles.Click;        // Lazy me...
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuLoadFromDirectoryClick(Sender: TObject);

begin
     ButtonAddDirectoryClick (Sender)
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuOpenHelpClick(Sender: TObject);

var helpfile : string;

begin
     helpfile := extractFilePath (ParamStr(0)) + 'tracewrangler.chm';

     if fileexists (helpfile) then
        ShellExecute (Handle, 'open', pChar (helpfile), '', nil,SW_SHOWNORMAL);
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuPopupMainAddFilesClick(Sender: TObject);

begin
     ButtonAddTracefiles.Click;        // Lazy me...
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuPopupMainAddDirectoryClick(Sender: TObject);

begin
     ButtonAddDirectoryClick (Sender);
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuPopupMainRemoveFilesClick(Sender: TObject);

begin
     DeleteSelectedFilesFromList;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuPopupMainScanFilesClick(Sender: TObject);

begin
     ButtonQuickInfoScanNow.Click;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuPopupMainRenameFileClick (Sender: TObject);

begin
     FormRenameFiles.TraceFileList := TraceSetLoader.FileList;
     FormRenameFiles.showModal;

     if FormRenameFiles.ModalResult = mrOK then
        begin
             priv_renameparams := FormRenameFiles.getParams;

             ProcessFileListItems (plRenameFile);
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuPopupMainExportCommentToDescriptionClick (Sender: TObject);

begin
     ProcessFileListItems (plExportDescription);
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuPreferencesClick(Sender: TObject);

begin
     FormPreferences.EditPathTaskFiles.Text := TaskDataPath;

     if FormPreferences.EditGlobalIntelDBPath.Text = '' then
        FormPreferences.EditGlobalIntelDBPath.Text := ProgramDataPath + 'IntelDB\';

     FormPreferences.ShowModal;

     if FormPreferences.ModalResult = mrOK then
        begin
             // Save new settings

             FormPreferences.SavePreferences (PreferencesFile);

             AssignPreferences;
        end
     else
         LoadPreferencesFile;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuSetWindowLabelClick(Sender: TObject);

begin
     FormWindowLabel.ShowModal;

     if FormWindowLabel.ModalResult = mrOK then
        begin
             TWWindowLabel := FormWindowLabel.EditWindowLabel.Text;

             UpdateWindowCaption;
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuDebugShowRecordSizesClick(Sender: TObject);

begin
     FormDebugDetails.ShowModal;
end;

(* ------------------------------------------- *)

procedure TFormMain.onChangeMainMenu(Sender: TObject; Source: TMenuItem; Rebuild: Boolean);

begin
     MenuRenameFiles.Enabled := (VSTTracefilelist.SelectedCount > 0);
end;

(* ------------------------------------------- *)

procedure TFormMain.onPopupFilelist(Sender: TObject);

var fileentry : tTracefileEntry;
    node      : pVirtualNode;
    data      : pVSTFileListEntry;

begin
     MenuPopupMainRemoveFiles.Enabled := (VSTTracefilelist.SelectedCount > 0);
     MenuPopupMainSetFileTime.Enabled := MenuPopupMainRemoveFiles.Enabled;
     MenuPopupMainRenameFile.Enabled := MenuPopupMainRemoveFiles.Enabled;

     MenuPopupMainSetFileTimeToFirstFrame.Enabled := MenuPopupMainSetFileTime.Enabled;
     MenuPopupMainSetFileTimeToLastFrame.Enabled := MenuPopupMainSetFileTime.Enabled;

     MenuPopupMainExportFileComments.Enabled := MenuPopupMainRemoveFiles.Enabled;
     MenuPopupMainExportCommentToDescription.Enabled := MenuPopupMainExportFileComments.Enabled;

     // the next block of code is just for fun :-)

     if (VSTTracefilelist.SelectedCount = 1) then
        begin
             MenuPopupMainRemoveFiles.Caption := '&Remove File';
             MenuPopupMainScanFiles.Caption := '&Scan File';
        end
     else
         begin
              MenuPopupMainRemoveFiles.Caption := '&Remove Files';
              MenuPopupMainScanFiles.Caption := '&Scan Files';
         end;

     MenuPopupMainScanFiles.Enabled := false;
     node := VSTTraceFileList.GetFirstSelected;

     while assigned (node) and not MenuPopupMainScanFiles.Enabled do
           begin
                data := VSTTraceFileList.GetNodeData (node);
                fileentry := data^.entry;

                if not fileentry.ConversationsScanned then
                   MenuPopupMainScanFiles.Enabled := true;

                node := VSTTraceFileList.GetNextSelected (node);
           end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onPopupTaskMenu(Sender: TObject);

var name : string;

begin
     MenuTaskExport.Enabled := (VSTTaskList.SelectedCount > 0);
end;

(* ------------------------------------------- *)

procedure TFormMain.CreateExistingTasknameList (var List: tStringlist);

var Node          : PVirtualNode;
    Data          : pVSTTaskEntry;

begin
     List.Clear;

     Node := VSTTaskList.GetFirst;

     while Node <> nil do
           begin
                Data := VSTTaskList.GetNodeData (node);
                List.Add (Data^.entry.TaskName);

                Node := VSTTaskList.GetNext (node);
           end;
end;

(* ------------------------------------------- *)

function TFormMain.GetValidTaskName (CurrentName: string; ExistingNames: tStringList): string;

var value : string;
    i     : integer;

begin
     Value := CurrentName;

     if ExistingNames.IndexOf (lowercase (value)) > -1 then
        begin
             i := 1;

             repeat
                   value := leftstring (value, ' (');
                   value := value + ' (' + IntToStr (i) + ')';

                   inc (i);

             until (ExistingNames.IndexOf (lowercase (value)) = -1);
        end;

     result := Value;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuTaskExportClick (Sender: TObject);

var Node : PVirtualNode;
    Data : pVSTTaskEntry;
    Okay : boolean;

begin
     Node := VSTTaskList.GetFirstSelected;

     while (Node <> nil) do
           begin
                if DataModuleMain.SaveDialogExportTask.Execute then
                   begin
                        Data := VSTTaskList.GetNodeData (Node);

                        Okay := true;

                        if FileExists (DataModuleMain.SaveDialogExportTask.FileName) then
                           Okay := (MessageDlg('Warning: file exists, do you want to replace it?', mtWarning, [mbYes, mbNo], 0) = mrYes);

                        if Okay then
                           try
                              CopyFile (pWideChar (Data^.entry.ParameterFile), pWideChar (DataModuleMain.SaveDialogExportTask.FileName), false);
                           except
                                 MessageDlg('Error: could not export file, maybe the destination is write protected?', mtError, [mbOK], 0);
                           end;

                        Node := VSTTaskList.GetNextSelected(Node);
                   end
                else
                    Exit;
           end;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuTaskImportClick (Sender: TObject);

var filename : string;

begin
     if DataModuleMain.OpenDialogImportTask.Execute then
        begin
             filename := TaskDataPath + ExtractFileName (DataModuleMain.OpenDialogImportTask.FileName);

             CopyFile (pWideChar (DataModuleMain.OpenDialogImportTask.FileName), pWideChar (Filename), false);

             if FileExists (filename) then
                begin
                     AddTaskFileToList (Filename);
                     UpdateTaskOptions;
                end
             else
                 MessageDlg('Error: could not import file', mtError, [mbOK], 0);
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuExitClick(Sender: TObject);

begin
     FormMain.Close;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuExportPCAPngStructToFileClick(Sender: TObject);

begin
     VSTFileDetails.SaveToCSVFile ('D:\Test.csv', true);
end;

(* ------------------------------------------- *)

function TFormMain.addAnonymizationTask (const TaskName : string) : boolean;

var NewTask   : tTaskEntry;
    ParamFile : string;

begin
     // TODO: Set PreParsedDataAvailable accordingly if we have preparse results in inteldb

     // Load default settings

     FormTaskAnonymize.LoadSettings (DefaultsPath + 'anonymize.task');
     FormTaskAnonymize.FileList := TraceSetLoader.FileList;
     FormTaskAnonymize.ConversationStore := TraceSetLoader.ConversationStore;

     FormTaskAnonymize.ShowModal;

{$ifdef debug}

     FormTaskAnonymize.getAnonymizationParameters.SaveToConfigFile ('d:\anontask.tcf', false);

{$endif}

     if FormTaskAnonymize.ModalResult = mrOK then
        begin
             result := true;
             ParamFile := TaskDataPath + TaskName + '.task';

             FormTaskAnonymize.SaveSettings (ParamFile);

             NewTask := tTaskEntry.create (TaskName, ttAnonymize);
             NewTask.ParameterFile := ParamFile;

             TaskListManager.addTask (NewTask);

             AddTaskToDisplay (NewTask);
        end
     else
         result := false;
end;

(* ------------------------------------------- *)

function TFormMain.addExtractionTask(const TaskName: string): boolean;

var NewTask   : tTaskEntry;
    ParamFile : string;

begin
     FormTaskExtract.LoadSettings (DefaultsPath + 'extract.task');

     // Transfer trace file list and conversation store

     FormTaskExtract.ConversationStore := TraceSetLoader.ConversationStore;
     FormTaskExtract.FileList := TraceSetLoader.FileList;

     FormTaskExtract.ShowModal;

     if FormTaskExtract.ModalResult = mrOK then
        begin
             result := true;
             ParamFile := TaskDataPath + TaskName + '.task';

             FormTaskExtract.SaveSettings (ParamFile);

             NewTask := tTaskEntry.create (TaskName, ttExtract);
             NewTask.ParameterFile := ParamFile;

             TaskListManager.addTask (NewTask);

             AddTaskToDisplay (NewTask);
        end;
end;

(* ------------------------------------------- *)

function TFormMain.addEditTask(const TaskName: string): boolean;

var NewTask   : tTaskEntry;
    ParamFile : string;

begin
     FormTaskEdit.LoadSettings (DefaultsPath + 'edit.task');

     FormTaskEdit.ShowModal;

     if FormTaskEdit.ModalResult = mrOK then
        begin
             result := true;
             ParamFile := TaskDataPath + TaskName + '.task';

             FormTaskEdit.SaveSettings (ParamFile);

             NewTask := tTaskEntry.create (TaskName, ttEdit);
             NewTask.ParameterFile := ParamFile;

             TaskListManager.addTask (NewTask);

             AddTaskToDisplay (NewTask);
        end;
end;

(* ------------------------------------------- *)

function TFormMain.addMergeTask(const TaskName: string): boolean;

var NewTask   : tTaskEntry;
    ParamFile : string;

begin
     FormTaskMerge.LoadSettings (DefaultsPath + 'merge.task');

     // Transfer trace file list and conversation store

     FormTaskMerge.PrepareMapper (TraceSetLoader.FileList);
     FormTaskMerge.ConversationStore := TraceSetLoader.ConversationStore;

     FormTaskMerge.ShowModal;

     if FormTaskMerge.ModalResult = mrOK then
        begin
             result := true;
             ParamFile := TaskDataPath + TaskName + '.task';

             FormTaskMerge.SaveSettings (ParamFile);

             NewTask := tTaskEntry.create (TaskName, ttMerge);
             NewTask.ParameterFile := ParamFile;

             TaskListManager.addTask (NewTask);

             AddTaskToDisplay (NewTask);
        end;

     FormTaskMerge.DiscardMapper;
end;

(* ------------------------------------------- *)

function TFormMain.addPCAPngSeparationTask (const TaskName : string) : boolean;

var NewTask   : tTaskEntry;
    ParamFile : string;

begin
     // Sanity check first

     if TraceSetLoader.PCAPngFileCount = 0 then
        begin
             MessageDlg('No PCAPng File found in file list. You cannot add this type of task, sorry!', mtWarning, [mbOK], 0);
             Exit;
        end;

     if TraceSetLoader.MaxPCAPngSectionCount < 2 then
        begin
             MessageDlg('No PCAPng File with more than one section found. You cannot add this type of task, sorry!', mtWarning, [mbOK], 0);
             Exit;
        end;

     FormTaskSeparation.ShowModal;

     if FormTaskSeparation.ModalResult = mrOK then
        begin
             result := true;
             ParamFile := TaskDataPath + TaskName + '.task';

             FormTaskSeparation.SaveSettings (ParamFile);

             NewTask := tTaskEntry.create (TaskName, ttSeparate);
             NewTask.ParameterFile := ParamFile;

             TaskListManager.addTask (NewTask);

             AddTaskToDisplay (NewTask);
        end
     else
         result := false;
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonAddTaskClick(Sender: TObject);

var TaskWasAdded : boolean;
    TaskName     : string;
    Node         : PVirtualNode;
    Data         : pVSTTaskEntry;

begin
     FormSelectTask.ClearTaskNames;

     Node := VSTTaskList.GetFirst;

     while Node <> nil do
           begin
                Data := VSTTaskList.GetNodeData (node);
                FormSelectTask.AddTaskName (Data^.entry.TaskName);

                Node := VSTTaskList.GetNext (node);
           end;

     FormSelectTask.ShowModal;

     if FormSelectTask.ModalResult = mrOK then
        begin
             TaskName := FormSelectTask.EditTaskname.Text;

             case FormSelectTask.ComboBoxSelectTask.ItemIndex of
              1 : TaskWasAdded := addAnonymizationTask (TaskName);
              2 : TaskWasAdded := addExtractionTask (TaskName);
              3 : TaskWasAdded := addEditTask (Taskname);
              4 : TaskWasAdded := addMergeTask (Taskname);
              5 : TaskWasAdded := addPCAPngSeparationTask (Taskname);
             end;

             // If the task was added successfully we clear the profile selector for the next task unless a setting prevents it

             if TaskWasAdded then
                begin
                     if FormPreferences.getAdvancedBoolSetting ('ToggleAdvAlwaysClearProfileSelector') then
                        begin
                             FormSelectTask.ComboBoxSelectTask.ItemIndex := 0;
                             FormSelectTask.EditTaskname.Text := '';
                        end;

//                   ButtonExecuteTasks.Enabled := true;
                     UpdateExecuteButtonStatus;

                     UpdateFileListStatus;
                     UpdateFileList;
                     UpdateTaskOptions;
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonEditTaskClick(Sender: TObject);

var Node  : PVirtualNode;
    Data  : pVSTTaskEntry;
    Entry : tTaskEntry;

begin
     if VSTTaskList.SelectedCount > 0 then
        begin
             Node := VSTTaskList.GetFirstSelected;
             Data := VSTTaskList.GetNodeData (Node);

             Entry := Data^.entry;

             case Entry.TaskType of
              ttAnonymize : begin
                                 FormTaskAnonymize.LoadSettings (Entry.ParameterFile);
                                 FormTaskAnonymize.ConversationStore := TraceSetLoader.ConversationStore;
                                 FormTaskAnonymize.FileList := TraceSetLoader.FileList;

                                 FormTaskAnonymize.ShowModal;

{$ifdef debug}

                                 FormTaskAnonymize.getAnonymizationParameters.SaveToConfigFile ('d:\anontask.tcf', false);

{$endif}

                                 if FormTaskAnonymize.ModalResult = mrOK then
                                    FormTaskAnonymize.SaveSettings (Entry.ParameterFile);
                            end;
              ttExtract   : begin
                                 FormTaskExtract.ConversationStore := TraceSetLoader.ConversationStore;
                                 FormTaskExtract.LoadSettings (Entry.ParameterFile);
                                 FormTaskExtract.FileList := TraceSetLoader.FileList;

                                 FormTaskExtract.ShowModal;

                                 if FormTaskExtract.ModalResult = mrOK then
                                    FormTaskExtract.SaveSettings (Entry.ParameterFile);
                            end;
              ttEdit      : begin
                                 FormTaskEdit.LoadSettings (Entry.ParameterFile);

                                 FormTaskEdit.ShowModal;

                                 if FormTaskEdit.ModalResult = mrOK then
                                    FormTaskEdit.SaveSettings (Entry.ParameterFile);
                            end;
              ttMerge     : begin
                                 FormTaskMerge.PrepareMapper (TraceSetLoader.FileList);
                                 FormTaskMerge.LoadSettings (Entry.ParameterFile);
                                 FormTaskMerge.ConversationStore := TraceSetLoader.ConversationStore;

                                 FormTaskMerge.ShowModal;

                                 if FormTaskMerge.ModalResult = mrOK then
                                    FormTaskMerge.SaveSettings (Entry.ParameterFile);

                                 FormTaskMerge.DiscardMapper;
                            end;
              ttSeparate  : begin
                                 FormTaskSeparation.LoadSettings (Entry.ParameterFile);

                                 FormTaskSeparation.ShowModal;

                                 if FormTaskSeparation.ModalResult = mrOK then
                                    FormTaskSeparation.SaveSettings (Entry.ParameterFile);
                            end;
             end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonRemoveTaskClick(Sender: TObject);

var doRemove : boolean;
    Node     : PVirtualNode;
    OldNode  : PVirtualNode;
    Data     : pVSTTaskEntry;

begin
     if not FormPreferences.getAdvancedBoolSetting ('ToggleAdvDoNotAskWhenRemovingTasks') then
        doRemove := (MessageBox(0, 'Do you really want to remove this task?', 'Remove Task', MB_ICONQUESTION or MB_YESNO) = ID_YES)
     else
         doRemove := true;

     if doRemove then
        begin
             Node := VSTTaskList.GetFirstSelected;

             while Node <> nil do
                   begin
                        Data := VSTTaskList.GetNodeData(Node);

                        // Delete the task, including the parameter file in the tasks directory

                        TaskListManager.removeTask (Data^.entry.TaskIndex);

                        OldNode := Node;
                        Node := VSTTaskList.GetNextSelected(Node);
                        VSTTaskList.DeleteNode(OldNode);
                   end;
{
                   if (VSTTracefilelist.RootNodeCount > 0) and (VSTTaskList.RootNodeCount > 0) then
                      ButtonExecuteTasks.Enabled := true;
}
                   UpdateExecuteButtonStatus;
        end;

     UpdateFileListStatus;
     UpdateTaskOptions;
end;

(* ------------------------------------------- *)

procedure TFormMain.ActionRunTaskExecute(Sender: TObject);

var Node     : PVirtualNode;
    Data     : pVSTTaskEntry;

begin
     Node := VSTTaskList.GetFirst;

     while Node <> nil do
           begin
                Data := VSTTaskList.GetNodeData(node);

                StatusBarMain.Panels[0].Text := 'Status: Processing tasks';
                Application.ProcessMessages;

                ExecuteTask (Data^.entry);
                Node := VSTTaskList.GetNext(Node);

                StatusBarMain.Panels[0].Text := 'Status: Idle';
                Application.ProcessMessages;
           end;

     priv_fileprogressbar.Position := 100;
     priv_fileprogressbar.Visible := false;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuTaskInstantAnonymizeClick(Sender: TObject);

var TaskWasAdded  : boolean;
    ExistingNames : tStringList;
    TaskName      : string;

begin
     Taskname := 'Anonymize Files';

     ExistingNames := tStringlist.Create;
     CreateExistingTasknameList (ExistingNames);

     TaskName := GetValidTaskName (TaskName, ExistingNames);
     TaskWasAdded := addAnonymizationTask (Taskname);

     // If the task was added successfully we clear the profile selector for the next task unless a setting prevents it

     if TaskWasAdded then
        begin
//           ButtonExecuteTasks.Enabled := true;
             UpdateExecuteButtonStatus;

             UpdateFileListStatus;
             UpdateFileList;
             UpdateTaskOptions;
        end;

     ExistingNames.Free;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuTaskInstantExtractClick(Sender: TObject);

var TaskWasAdded  : boolean;
    ExistingNames : tStringList;
    TaskName      : string;

begin
     Taskname := 'Extract Files';

     ExistingNames := tStringlist.Create;
     CreateExistingTasknameList (ExistingNames);

     TaskName := GetValidTaskName (TaskName, ExistingNames);
     TaskWasAdded := addExtractionTask (Taskname);

     // If the task was added successfully we clear the profile selector for the next task unless a setting prevents it

     if TaskWasAdded then
        begin
//           ButtonExecuteTasks.Enabled := true;
             UpdateExecuteButtonStatus;

             UpdateFileListStatus;
             UpdateFileList;
             UpdateTaskOptions;
        end;

     ExistingNames.Free;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuTaskInstantEditClick(Sender: TObject);

var TaskWasAdded  : boolean;
    ExistingNames : tStringList;
    TaskName      : string;

begin
     Taskname := 'Edit Files';

     ExistingNames := tStringlist.Create;
     CreateExistingTasknameList (ExistingNames);

     TaskName := GetValidTaskName (TaskName, ExistingNames);
     TaskWasAdded := addEditTask (Taskname);

     // If the task was added successfully we clear the profile selector for the next task unless a setting prevents it

     if TaskWasAdded then
        begin
//           ButtonExecuteTasks.Enabled := true;
             UpdateExecuteButtonStatus;

             UpdateFileListStatus;
             UpdateFileList;
             UpdateTaskOptions;
        end;

     ExistingNames.Free;
end;

(* ------------------------------------------- *)

procedure TFormMain.MenuTaskInstantMergeClick(Sender: TObject);

var TaskWasAdded  : boolean;
    ExistingNames : tStringList;
    TaskName      : string;

begin
     Taskname := 'Merge Files';

     ExistingNames := tStringlist.Create;
     CreateExistingTasknameList (ExistingNames);

     TaskName := GetValidTaskName (TaskName, ExistingNames);
     TaskWasAdded := addMergeTask (Taskname);

     // If the task was added successfully we clear the profile selector for the next task unless a setting prevents it

     if TaskWasAdded then
        begin
//           ButtonExecuteTasks.Enabled := true;
             UpdateExecuteButtonStatus;

             UpdateFileListStatus;
             UpdateFileList;
             UpdateTaskOptions;
        end;

     ExistingNames.Free;
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonQuickAddAnonymizationTaskClick (Sender: TObject);

begin
     MenuTaskInstantAnonymizeClick (Sender);
end;


procedure TFormMain.ButtonQuickAddExtractionTaskClick (Sender: TObject);

begin
     MenuTaskInstantExtractClick (Sender);
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonQuickAddEditTaskClick(Sender: TObject);

begin
     MenuTaskInstantEditClick (Sender);
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonQuickAddMergeTaskClick(Sender: TObject);

begin
     MenuTaskInstantMergeClick (Sender);
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonQuickInfoScanNowClick (Sender: TObject);

begin
     PerformManualScans;
     TraceSetLoader.UpdateConversationStore;

     MenuCommunicationDetails.Enabled := TraceSetLoader.ConversationStore.HasRecords;

     UpdateStatusbarAndTasklist;

     // Repaint task list in case there was a red flagged extraction task

     VSTTaskList.Repaint;

     UpdateTaskOptions;
     UpdateExecuteButtonStatus;
end;

(* ------------------------------------------- *)

procedure TFormMain.ButtonPCAPngScanNowClick(Sender: TObject);

var node      : pVirtualNode;
    nodedata  : pVSTFileListEntry;
    fileentry : tTracefileEntry;

begin
     node := VSTTracefilelist.FocusedNode;

     if (node <> nil) then
           begin
                nodedata := VSTTracefilelist.GetNodeData(node);
                fileentry := nodedata.entry;

                // Assign feedback function

                fileentry.OnAdvancePercentageScanned := onFileAdvancePercentScanned;

                // Do the Scan - its the same routine as QuickInfoScan
                // because if the user is willing to wait he can wait for both

                FileEntry.ForceReadPCAPngDetails;

                ShowFileDetails (fileentry);

                VSTTracefilelist.RepaintNode(node);
           end;
end;

(* ------------------------------------------- *)

procedure TFormMain.ExecuteAnonymizationTask (const CurrentTask: tTaskEntry);

var fileentry              : tTracefileEntry;
    NodeData               : pVSTFileListEntry;
    ReplacementDBFile      : string;
    LocationType           : tLocationType;
    Outputdir              : string;
    OutputParams           : tOutputlocation;
    AnonParams             : tAnonymizeParameters;
    ReplacementMgr         : tReplacementManager;
    taskprocessor          : tTaskProcessorAnonymize;
    ErrorCode              : tTaskErrorCode;
    i                      : integer;
    UseMemoryDB            : boolean;

begin
     FormTaskAnonymize.LoadSettings (CurrentTask.ParameterFile);
     AnonParams := FormTaskAnonymize.getAnonymizationParameters;
     AnonParams.OverwriteExistingTarget := FormPreferences.getAdvancedBoolSetting ('ToggleAdvOverwriteExistingFile');

     // Create default file name

     ReplacementDBFile := changeFileExt (CurrentTask.ParameterFile, '.rdb');
     ReplacementMgr := tReplacementManager.create (ReplacementDBFile, AnonParams);

     // Process files

     for i := 1 to TraceSetLoader.FileCount do
         begin
              AnonParams.TracefileListIndex := i;

              fileentry := TraceSetLoader.getFile(i);
              priv_CurrentDetailNode := fileentry.AssociatedTreeNode;

              NodeData := VSTTracefilelist.GetNodeData (priv_CurrentDetailNode);

              // Update node status

              NodeData^.processingstatus := psTaskProcessing;
//            NodeData^.progressbar.Position := 0;
              priv_fileprogressbar.Position := 0;
              VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);

              // Prepare task

              if FormTaskAnonymize.RadioButtonFileOutputSameDirectory.Checked then
                 begin
                      LocationType := ltSameDirectory;
                      Outputdir := fileentry.FilePath;
                 end;

              if FormTaskAnonymize.RadioButtonFileOutputToSubdirectory.Checked then
                 begin
                      LocationType := ltSubdirectory;
                      Outputdir := FormTaskSeparation.LabeledEditOutputToSubdirectory.Text;
                 end;

              if FormTaskAnonymize.RadioButtonFileOutputToAbsoluteDirectory.Checked then
                 begin
                      LocationType := ltAbsoluteDirectory;
                      Outputdir := FormTaskAnonymize.LabeledEditOutputToDirectory.Text;
                 end;

              OutputParams.initialize (LocationType, fileentry.FullName, Outputdir, FormTaskAnonymize.EditOutputFilename.Text);

              if FormTaskAnonymize.CheckBoxSetFileDateTo.Checked then
                 begin
                      case FormTaskAnonymize.ComboBoxSetFileTimestampScope.ItemIndex of
                       0 : begin
                                outputparams.TimestampMode := tsmOriginalFile;
                                outputparams.OriginalFileTime := fileentry.FileDate;
                           end;
                       1 : outputparams.TimestampMode := tsmFirstFrame;
                       2 : outputparams.TimestampMode := tsmLastFrame;
                      end;
                 end
              else
                  outputparams.TimestampMode := tsmNone;

              // Create Task Processor and assign events etc

              taskprocessor := tTaskProcessorAnonymize.create (FileEntry, outputparams, ReplacementMgr, AnonParams);

              taskprocessor.OnAdvancePercentageProcessed := onTaskAdvancePercentProcessed;
              taskprocessor.onStartProcessingFile := onTaskStartProcessingOfFile;
              taskprocessor.onErrorProcessingFrame := onTaskErrorParsingFrame;

              // Run the task

              ErrorCode := taskprocessor.execute;

              // TODO: handle anonymization error code

              FinalizeProcessStatus (fileentry, taskprocessor.ErrorCount);

              taskprocessor.free;

              // Update list status

              case ErrorCode of
               ecSuccess : NodeData^.processingstatus := psTaskComplete;
               ecFailure : NodeData^.processingstatus := psTaskFailed;
              end;

//            NodeData^.progressbar.Position := NodeData^.progressbar.Max;
              priv_fileprogressbar.Position := priv_fileprogressbar.Max;
              VSTTracefilelist.RepaintNode (priv_CurrentDetailNode);
         end;

     // CleanUp

     priv_CurrentDetailNode := nil;        // necessary because we touched the detail node as part of the task running and it may lead to inconsistencies with the display
     ReplacementMgr.free;
end;

(* ------------------------------------------- *)

procedure TFormMain.ExecuteExtractionTask (const CurrentTask: tTaskEntry);

var taskprocessor : tTaskProcessorExtract;
    TaskParams    : tExtractionParameters;
    ErrorCode     : tTaskErrorCode;

begin
     FormTaskExtract.ConversationStore := TraceSetLoader.ConversationStore;
     FormTaskExtract.FileList := TraceSetLoader.FileList;

     FormTaskExtract.LoadSettings (CurrentTask.ParameterFile);
     TaskParams := FormTaskExtract.getParameters;
     TaskParams.TraceFileList := TraceSetLoader.FileList;

     // Prepare task

     taskprocessor := tTaskProcessorExtract.create (TraceSetLoader.ConversationStore, TaskParams);

     taskprocessor.OnAdvancePercentageProcessed := onTaskAdvancePercentProcessed;
     taskprocessor.onStartProcessingFile := onTaskStartProcessingOfFile;
     taskprocessor.onErrorProcessingFrame := onTaskErrorParsingFrame;
     taskprocessor.onFinishProcessingFile := FinalizeProcessStatus;
     taskprocessor.onSkippingFile := onTaskSkippingFile;

     // Show task details pane

     ProgressBarTotal.Max := 100;         // it's going to be percent based

     TabSheetProcessingStatus.TabVisible := True;
     PageControlProcessingStatusDetails.ActivePageIndex := PageExtractionDetails;
     PageControlMainDetails.ActivePageIndex := PageScanStatus;

     Application.ProcessMessages;

     // Run the task

     ErrorCode := taskprocessor.execute;

     // Finalize

     ProgressBarTotal.Position := 100;
     FinalizeProcessStatus (taskprocessor.InputFile, taskprocessor.ErrorCount);

     // TODO: handle the extraction error code

     taskprocessor.free;

     TabSheetProcessingStatus.TabVisible := false;
     PageControlMainDetails.ActivePageIndex := PageQuickInfo;
     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.ExecuteEditTask (const CurrentTask: tTaskEntry);

var fileentry              : tTracefileEntry;
    NodeData               : pVSTFileListEntry;
    taskprocessor          : tTaskProcessorEdit;
    TaskParams             : tEditParameters;
    ErrorCode              : tTaskErrorCode;
    LocationType           : tLocationType;
    Outputdir              : string;
    OutputParams           : tOutputlocation;
    i                      : integer;

begin
     FormTaskEdit.LoadSettings (CurrentTask.ParameterFile);
     TaskParams := FormTaskEdit.getParameters;

     // Process files

     for i := 1 to TraceSetLoader.FileCount do
         begin
              TaskParams.TracefileListIndex := i;

              fileentry := TraceSetLoader.getFile(i);
              priv_CurrentDetailNode := fileentry.AssociatedTreeNode;

              NodeData := VSTTracefilelist.GetNodeData (priv_CurrentDetailNode);

              // Update node status

              NodeData^.processingstatus := psTaskProcessing;
//            NodeData^.progressbar.Position := 0;
              priv_fileprogressbar.Position := 0;
              VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);

              // Prepare task

              if FormTaskEdit.RadioButtonFileOutputSameDirectory.Checked then
                 begin
                      LocationType := ltSameDirectory;
                      Outputdir := fileentry.FilePath;
                 end;

              if FormTaskEdit.RadioButtonFileOutputToSubdirectory.Checked then
                 begin
                      LocationType := ltSubdirectory;
                      Outputdir := FormTaskSeparation.LabeledEditOutputToSubdirectory.Text;
                 end;

              if FormTaskEdit.RadioButtonFileOutputToAbsoluteDirectory.Checked then
                 begin
                      LocationType := ltAbsoluteDirectory;
                      Outputdir := FormTaskEdit.LabeledEditOutputToAbsoluteDirectory.Text;
                 end;

              if FormTaskEdit.CheckBoxSetFileDateTo.Checked then
                 begin
                      case FormTaskEdit.ComboBoxSetFileTimestampScope.ItemIndex of
                       0 : outputparams.TimestampMode := tsmOriginalFile;
                       1 : outputparams.TimestampMode := tsmFirstFrame;
                       2 : begin
                                outputparams.TimestampMode := tsmLastFrame;
                                outputparams.OriginalFileTime := fileentry.FileDate;
                           end;
                      end;
                 end
              else
                  outputparams.TimestampMode := tsmNone;

              OutputParams.initialize (LocationType, fileentry.FullName, Outputdir, FormTaskEdit.EditOutputFilename.Text);

              taskprocessor := tTaskProcessorEdit.create (FileEntry, outputparams, TaskParams);
              taskprocessor.OnAdvancePercentageProcessed := onTaskAdvancePercentProcessed;
              taskprocessor.onStartProcessingFile := onTaskStartProcessingOfFile;
              taskprocessor.onErrorProcessingFrame := onTaskErrorParsingFrame;

              // Run the task

              ErrorCode := taskprocessor.execute;

              // TODO: handle the edit task error code

              FinalizeProcessStatus (fileentry, taskprocessor.ErrorCount);

              taskprocessor.free;

              // TODO: apply timestamp settings to new file

              // Update list status

              NodeData^.processingstatus := psTaskComplete;

//            NodeData^.progressbar.Position := NodeData^.progressbar.Max;
              priv_fileprogressbar.Position := priv_fileprogressbar.Max;
              VSTTracefilelist.RepaintNode (priv_CurrentDetailNode);
         end;
end;

(* ------------------------------------------- *)

procedure TFormMain.ExecuteMergeTask (const CurrentTask: tTaskEntry);

var taskprocessor : tTaskProcessorMerge;
    TaskParams    : tMergeParameters;
    ErrorCode     : tTaskErrorCode;

begin
     FormTaskMerge.PrepareMapper (TraceSetLoader.FileList);
     FormTaskMerge.LoadSettings (CurrentTask.ParameterFile);
     TaskParams := FormTaskMerge.getParameters;

     // Prepare task

     taskprocessor := tTaskProcessorMerge.create (TaskParams);
{
     taskprocessor.OnAdvancePercentageProcessed := onTaskAdvancePercentProcessed;
     taskprocessor.onStartProcessingFile := onTaskStartProcessingOfFile;
     taskprocessor.onErrorProcessingFrame := onTaskErrorParsingFrame;
}
     // Run the task

     ErrorCode := taskprocessor.execute;

     taskprocessor.free;
end;

(* ------------------------------------------- *)

procedure TFormMain.ExecuteSeparationTask(const CurrentTask: tTaskEntry);

var fileentry     : tTracefileEntry;
    NodeData      : pVSTFileListEntry;
    TaskParams    : tSeparationParameters;
    LocationType  : tLocationType;
    Outputdir     : string;
    OutputParams  : tOutputlocation;
    taskprocessor : tTaskProcessorSeparate;
    ErrorCode     : tTaskErrorCode;
    i             : integer;

begin
     FormTaskSeparation.LoadSettings (CurrentTask.ParameterFile);

     // Process files

     for i := 1 to TraceSetLoader.FileCount do
         begin
              fileentry := TraceSetLoader.getFile(i);
              priv_CurrentDetailNode := fileentry.AssociatedTreeNode;

              NodeData := VSTTracefilelist.GetNodeData (priv_CurrentDetailNode);

              // Update node status

              NodeData^.processingstatus := psTaskProcessing;
//            NodeData^.progressbar.Position := 0;
              priv_fileprogressbar.Position := 0;
              VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);

              // Prepare task

              TaskParams.OverwriteFileByDefault := false;      // TODO: get from task settings

//            NodeData^.progressbar.Max := NodeData^.entry.PCAPngStatistics.SectionCount;
              priv_fileprogressbar.Max := NodeData^.entry.PCAPngStatistics.SectionCount;

              if FormTaskSeparation.RadioButtonFileOutputSameDirectory.Checked then
                 begin
                      LocationType := ltSameDirectory;
                      Outputdir := fileentry.FilePath;
                 end;

              if FormTaskSeparation.RadioButtonFileOutputToSubdirectory.Checked then
                 begin
                      LocationType := ltSubdirectory;
                      Outputdir := FormTaskSeparation.LabeledEditOutputToSubdirectory.Text;
                 end;

              if FormTaskSeparation.RadioButtonFileOutputToAbsoluteDirectory.Checked then
                 begin
                      LocationType := ltAbsoluteDirectory;
                      Outputdir := FormTaskSeparation.LabeledEditOutputToAbsoluteDirectory.Text;
                 end;

              OutputParams.initialize (LocationType, fileentry.FullName, Outputdir, FormTaskSeparation.EditOutputFilename.Text);

              taskprocessor := tTaskProcessorSeparate.create (FileEntry, outputparams, TaskParams);

              // Run the task

              ErrorCode := taskprocessor.execute;
              taskprocessor.free;

              // Update list status

              NodeData^.processingstatus := psTaskComplete;

//            NodeData^.progressbar.Position := NodeData^.progressbar.Max;
              priv_fileprogressbar.Position := priv_fileprogressbar.Max;
              VSTTracefilelist.RepaintNode (priv_CurrentDetailNode);
         end;
end;

(* ------------------------------------------- *)

procedure TFormMain.ExecuteTask (const CurrentTask : tTaskEntry);

begin
     case CurrentTask.TaskType of
      ttAnonymize : ExecuteAnonymizationTask (CurrentTask);
      ttExtract   : ExecuteExtractionTask (CurrentTask);
      ttEdit      : ExecuteEditTask (CurrentTask);
      ttMerge     : ExecuteMergeTask (CurrentTask);
      ttSeparate  : ExecuteSeparationTask (CurrentTask);
     end;
end;

(* ------------------------------------------- *)

procedure TFormMain.onStartScanOfFile (Sender : tObject;  const Status : tProcessingStatus);

var NodeData  : pVSTFileListEntry;
    FileEntry : tTraceFileEntry;

begin
     FileEntry := (Sender as tTracefileEntry);
     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

     NodeData^.processingstatus := Status;
{
     NodeData^.progressbar.Max := 100;
     NodeData^.progressbar.Position := 0;
     NodeData^.progressbar.Visible := true;
}

     PrepareProgressbarForNode (FileEntry.AssociatedTreeNode);

     VSTTraceFilelist.ScrollIntoView (FileEntry.AssociatedTreeNode, true);
     VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);

     LabelValueCurrentFilename.Caption := Fileentry.FileName;

     case Status of
      psScanningBasics        : LabelValueCurrentStatus.Caption := 'Scanning (Frame Details)';
      psScanningPCAPngStruct  : LabelValueCurrentStatus.Caption := 'Scanning (PCAPng Details)';
      psScanningConversations : LabelValueCurrentStatus.Caption := 'Scanning (Full Scan)';
     end;

     // Status panel

     if priv_totalscanfileindex = 1 then
        begin
             LabelValueEthernetEndpoints.Caption := '0';
             LabelValueIPv4Addresses.Caption := '0';
             LabelValueIPv6Addresses.Caption := '0';
             LabelValueEthernetConversations.Caption := '0';
             LabelValueIPv4Conversations.Caption := '0';
             LabelValueIPv6Conversations.Caption := '0';
             LabelValueTCPConversations.Caption := '0';
             LabelValueUDPConversations.Caption := '0';
        end;

     PageControlMainDetails.ActivePageIndex := PageScanStatus;
     PageControlProcessingStatusDetails.ActivePageIndex := PageScanDetails;

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.onFileAdvancePercentScanned (Sender : tObject; const PercentageScanned, FramesPerSecond : integer; var AbortScan : boolean);

var NodeData  : pVSTFileListEntry;
    FileEntry : tTraceFileEntry;
    Counters  : tConversationCountTable;

begin
     FileEntry := (Sender as tTracefileEntry);
     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

//   NodeData^.progressbar.Position := PercentageScanned;
     priv_fileprogressbar.Position := PercentageScanned;
     VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);

     // Update display

     LabelValueCurrentScanFpS.Caption := PointText (FramesPerSecond);

     ProgressBarTotal.Position := 100 * (priv_totalscanfileindex - 1) + PercentageScanned;

     counters := FileEntry.ConversationStore.GetCountTable;
{
     if priv_totalscanfileindex > 1 then
        begin
             Disabled because for this to be exact we'd need to aggregate conversations into a global conversation store, and that probably takes too much RAM/Time at

             LabelValueEthernetEndpoints.Caption := PointText (counters.EtherAddressCount) + '(' + PointText (priv_TotalConvCounters.EtherAddressCount + counters.EtherAddressCount) + ')';
             LabelValueIPv4Addresses.Caption := PointText (counters.IPv4AddressCount) + '(' + PointText (priv_TotalConvCounters.IPv4AddressCount + counters.IPv4AddressCount) + ')';
             LabelValueIPv6Addresses.Caption := PointText (counters.IPv6AddressCount) + '(' + PointText (priv_TotalConvCounters.IPv6AddressCount + counters.IPv6AddressCount) + ')';
             LabelValueEthernetConversations.Caption := PointText (counters.EtherPairCount) + '(' + PointText (priv_TotalConvCounters.EtherPairCount + counters.EtherPairCount) + ')';
             LabelValueIPv4Conversations.Caption := PointText (counters.IPv4PairCount) + '(' + PointText (priv_TotalConvCounters.IPv4PairCount + counters.IPv4PairCount) + ')';
             LabelValueIPv6Conversations.Caption := PointText (counters.IPv6PairCount) + '(' + PointText (priv_TotalConvCounters.IPv6PairCount + counters.IPv6PairCount) + ')';
             LabelValueTCPConversations.Caption := PointText (counters.TCPPairCount) + '(' + PointText (priv_TotalConvCounters.TCPPairCount + counters.TCPPairCount) + ')';
             LabelValueUDPConversations.Caption := PointText (counters.UDPPairCount) + '(' + PointText (priv_TotalConvCounters.UDPPairCount + counters.UDPPairCount) + ')';
        end
     else
         begin
}
              LabelValueEthernetEndpoints.Caption := PointText (counters.EtherAddressCount);
              LabelValueIPv4Addresses.Caption := PointText (counters.IPv4AddressCount);
              LabelValueIPv6Addresses.Caption := PointText (counters.IPv6AddressCount);
              LabelValueEthernetConversations.Caption := PointText (counters.EtherPairCount);
              LabelValueIPv4Conversations.Caption := PointText (counters.IPv4PairCount);
              LabelValueIPv6Conversations.Caption := PointText (counters.IPv6PairCount);
              LabelValueTCPConversations.Caption := PointText (counters.TCPPairCount);
              LabelValueUDPConversations.Caption := PointText (counters.UDPPairCount);
{
         end;
}
     // Set abort state

     AbortScan := priv_abortscanrequested;

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.onEndScanOfFile (Sender : tObject; const Status: tProcessingStatus);

var NodeData  : pVSTFileListEntry;
    FileEntry : tTraceFileEntry;
    NextNode  : pVirtualNode;

begin
     FileEntry := (Sender as tTracefileEntry);

     // Update total counters

     priv_TotalConvCounters.accumulate (FileEntry.ConversationStore.GetCountTable);

     // Update status

     case Status of
      psScanningBasics        : begin
                                     RichEditLog.Lines.Add ('Completed scanning file "' + FileEntry.FileName + '" for frame details in ' + IntToStr (FileEntry.ScanDuration) + ' seconds');
                                end;
      psScanningPCAPngStruct  : begin
                                     RichEditLog.Lines.Add ('Completed scanning file "' + FileEntry.FileName + '" for PCAPng structure details in ' + IntToStr (FileEntry.ScanDuration) + ' seconds');
                                end;
      psScanningConversations : begin
                                     RichEditLog.Lines.Add ('Completed scanning file "' + FileEntry.FileName + '" completely in ' + IntToStr (FileEntry.ScanDuration) + ' seconds');
                                end;
     end;

     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

     // PreProcessing is done, so now tasks are pending

     if TaskListManager.count > 0 then
        FileEntry.ProcessingStatus := psTaskPending
     else
         FileEntry.ProcessingStatus := psNoTaskAssigned;

     NodeData^.processingstatus := FileEntry.ProcessingStatus;
{
     NodeData^.progressbar.Max := 100;
     NodeData^.progressbar.Position := 0;
     NodeData^.progressbar.Visible := false;
}
     priv_fileprogressbar.Max := 100;
     priv_fileprogressbar.Position := 0;
     priv_fileprogressbar.Visible := false;

     VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);
{
     if VSTTracefilelist.SelectedCount > 0 then
        NextNode := VSTTracefilelist.GetNextSelected (FileEntry.AssociatedTreeNode)
     else
         NextNode := VSTTracefilelist.GetNext(FileEntry.AssociatedTreeNode);

     if NextNode = nil then
        begin
             case Status of
              psScanningBasics       : PageControlMainDetails.ActivePageIndex := PageQuickInfo;
              psScanningPCAPngStruct : PageControlMainDetails.ActivePageIndex := PagePCAPngStruct;
             end;

             ButtonAbortScan.Enabled := false;
        end;
}
     Application.ProcessMessages;
end;

(* ------------------------------------------- *)
{ deprecated
procedure TFormMain.onScanAdvancePercentProcessed (Sender : tObject; const PercentageScanned: integer);

var NodeData : pVSTFileListEntry;
    FileEntry : tTraceFileEntry;

begin
     FileEntry := (Sender as tTracefileEntry);
     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

     NodeData^.progressbar.Position := PercentageScanned;
end;
}
(* ------------------------------------------- *)

procedure TFormMain.onFileStatusChange (Sender: tObject; const Status: tProcessingStatus);

var NodeData : pVSTFileListEntry;
    FileEntry : tTraceFileEntry;

begin
     FileEntry := (Sender as tTracefileEntry);
     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

     NodeData^.processingstatus := Status;
     VSTTracefilelist.RepaintNode (FileEntry.AssociatedTreeNode);
end;

(* ------------------------------------------- *)

procedure TFormMain.onPreparseFrame (const FileID: integer; FileEntry: tTracefileEntry; const FrameIndex: integer);

begin
     StatusBarMain.Panels[2].Text := 'Parsing Frame ' + IntToStr (FrameIndex);
     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.onPreparserErrorParsingFrame (const FileID: integer; FileEntry: tTracefileEntry; const FrameIndex: uint64);

var sLine : string;

begin
     sLine := 'Preparser encountered an error while parsing frame #' + IntToStr (FrameIndex) + ' in file "' + FileEntry.FileName + '"';

     RichEditLog.Lines.Add (sLine);
end;

(* ------------------------------------------- *)

procedure TFormMain.onCompleteScanOfFile(const FileID: integer; FileEntry: tTracefileEntry; const ErrorCount : integer; const CacheHitRatioSummary : string);

var NodeData : pVSTFileListEntry;

begin
     RichEditLog.Lines.Add ('Completed preparing file "' + FileEntry.FileName + '" with ' + IntToStr (ErrorCount) + ' errors');
     RichEditLog.Lines.Add (CacheHitRatioSummary);

     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

     // PreProcessing is done, so now tasks are pending

     NodeData^.processingstatus := psTaskPending;
{
     NodeData^.progressbar.Max := 100;
     NodeData^.progressbar.Position := 0;
     NodeData^.progressbar.Visible := false;
}
     priv_fileprogressbar.Max := 100;
     priv_fileprogressbar.Position := 0;
     priv_fileprogressbar.Visible := false;

     VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.onTaskAnonymizeQueryPCAPngHeaderDetails (FileEntry: tTracefileEntry; OptionQueryList: tNGSHBParsedOptionValues);

begin
     ShowMessage ('TODO: PCAPng Header wants to be edited. Click Ok to ignore for now.');    // TODO: implement dialog to allow editing the PCAPng header values
end;

(* ------------------------------------------- *)

procedure TFormMain.onTaskStartProcessingOfFile (FileEntry: tTracefileEntry);

var NodeData : pVSTFileListEntry;

begin
     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

     NodeData^.processingstatus := psTaskProcessing;
{
     NodeData^.progressbar.Max := 100;
     NodeData^.progressbar.Position := 0;
     NodeData^.progressbar.Visible := true;
}
     PrepareProgressbarForNode (FileEntry.AssociatedTreeNode);
     VSTTraceFilelist.ScrollIntoView (FileEntry.AssociatedTreeNode, true);
     VSTTracefilelist.RepaintNode (FileEntry.AssociatedTreeNode);

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.onTaskSkippingFile (FileEntry : tTracefileEntry);

var NodeData : pVSTFileListEntry;

begin
     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

     NodeData^.processingstatus := psTaskSkipped;

     PrepareProgressbarForNode (FileEntry.AssociatedTreeNode);
     VSTTraceFilelist.ScrollIntoView (FileEntry.AssociatedTreeNode, true);
     VSTTracefilelist.RepaintNode (FileEntry.AssociatedTreeNode);

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)

procedure TFormMain.FinalizeProcessStatus (FileEntry: tTracefileEntry; const ErrorCount: integer);

var NodeData : pVSTFileListEntry;

begin
     RichEditLog.Lines.Add ('Completed processing file "' + FileEntry.FileName + '" with ' + IntToStr (ErrorCount) + ' errors');

     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

     NodeData^.processingstatus := psTaskComplete;
{
     NodeData^.progressbar.Max := 100;
     NodeData^.progressbar.Position := 0;
     NodeData^.progressbar.Visible := false;
}
     PrepareProgressbarForNode (FileEntry.AssociatedTreeNode);
     VSTTracefilelist.RepaintNode (FileEntry.AssociatedTreeNode);

     Application.ProcessMessages;
end;

(* ------------------------------------------- *)
{
procedure TFormMain.FinalizeScanStatus (FileEntry: tTracefileEntry);

var NodeData : pVSTFileListEntry;

begin
     RichEditLog.Lines.Add ('Completed scanning file "' + FileEntry.FileName + '"');

     NodeData := VSTTracefilelist.GetNodeData (FileEntry.AssociatedTreeNode);

     if TaskListManager.count > 0 then
        begin
             FileEntry.ProcessingStatus := psTaskPending;
             NodeData^.processingstatus := psTaskPending;
        end
     else
         begin
              FileEntry.ProcessingStatus := psNoTaskAssigned;
              NodeData^.processingstatus := psNoTaskAssigned;
         end;

     NodeData^.progressbar.Max := 100;
     NodeData^.progressbar.Position := 0;
     NodeData^.progressbar.Visible := false;
     VSTTracefilelist.RepaintNode (fileentry.AssociatedTreeNode);

     StatusbarMain.Panels[0].Text := 'Status: Idle';
     StatusBarMain.Panels[1].Text := 'Files: ' + IntToStr (TraceSetLoader.FileCount);

     Application.ProcessMessages;
end;
}
(* ------------------------------------------- *)

procedure TFormMain.onTaskAnonymizeEditNameResolution (FileEntry: tTracefileEntry; IPv4List: tSimpleIPv4NameResolutionList; IPv6List: tSimpleIPv6NameResolutionList);

begin







end;

(* ------------------------------------------- *)

procedure TFormMain.onTaskErrorParsingFrame (const FileEntry: tTracefileEntry; const FrameIndex: uint64; const ErrorLocation : tATErrorLocation; var AbortTask: boolean);

begin
     case ErrorLocation of
      ateUnknown         : AbortTask := (MessageDlg('Error processing frame ' + IntToStr (FrameIndex) + ' in file ' + FileEntry.FileName, mtError, [mbAbort, mbIgnore], 0) = mrAbort);
      ateLoader          : AbortTask := (MessageDlg('Error loading frames after ' + IntToStr (FrameIndex) + ' frames had been processed in file ' + FileEntry.FileName, mtError, [mbAbort, mbIgnore], 0) = mrAbort);
      ateFrameProcessing : AbortTask := (MessageDlg('Error processing frame ' + IntToStr (FrameIndex) + ' in file ' + FileEntry.FileName, mtError, [mbAbort, mbIgnore], 0) = mrAbort);
      ateWriter          : AbortTask := (MessageDlg('Error writing frame ' + IntToStr (FrameIndex) + ' in file ' + FileEntry.FileName, mtError, [mbAbort, mbIgnore], 0) = mrAbort);
     end;
end;

(* ------------------------------------------- *)

{$ifndef disableupdatecheck}

function TFormMain.getVersionFromWeb (Params : string) : tVersionStruct;

var content       : string;
    version       : string;
    infostruct    : tVersionStruct;
    help          : string;
    day           : integer;
    month         : integer;
    year          : integer;
    dummy         : integer;
    port          : integer;
    ProxyEnable   : boolean;
    sslhandler    : TIdSSLIOHandlerSocketOpenSSL;
//  reghandler    : tRegistry;
    TestResult    : DWORD;
    ProxyInfo     : TProxyInfo;

begin
     infostruct.initialize;
     priv_HTTPClient := tIDHTTP.Create(nil);
     sslhandler := TIdSSLIOHandlerSocketOpenSSL.Create (priv_HTTPClient);

     priv_HTTPClient.HandleRedirects := true;
     priv_HTTPClient.IOHandler := sslHandler;
     priv_HTTPClient.OnProxyAuthorization := onHTTPProxyAuthorization;
     priv_HTTPClient.HTTPOptions := priv_HTTPClient.HTTPOptions + [hoInProcessAuth];

     // Set Proxy, if configured

     if FormPreferences.RadioButtonUseSystemProxy.Checked then
        begin
{
             reghandler := tRegistry.Create;
             reghandler.RootKey := HKEY_CURRENT_USER;

             if reghandler.OpenKey ('SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings', false) then
                begin
                     if reghandler.ValueExists ('ProxyEnable') then
                        ProxyEnable := reghandler.ReadBool ('ProxyEnable')
                     else
                         ProxyEnable := false;

                     if ProxyEnable and reghandler.ValueExists ('ProxyServer') then
                        begin
                             help := reghandler.ReadString ('ProxyServer');

                             priv_HTTPClient.ProxyParams.ProxyServer := getEntry (help, ':', 1);

                             help := getEntry (help, ':', 2);
                             val (help, port, dummy);
                             priv_HTTPClient.ProxyParams.ProxyPort := port;
                        end
                     else
                         begin
                              priv_HTTPClient.ProxyParams.ProxyServer := '';
                              priv_HTTPClient.ProxyParams.ProxyPort := 0;
                         end;

                     reghandler.CloseKey;
                end;

             reghandler.Free;
}

             TestResult := GetProxyInfo (TracebusterVersionURL, ProxyInfo);

             case TestResult of
               0: begin
                       if pos (':', ProxyInfo.ProxyURL) > 0 then
                          begin
                               priv_HTTPClient.ProxyParams.ProxyServer := getEntry (ProxyInfo.ProxyURL, ':', 1);

                               help := getEntry (ProxyInfo.ProxyURL, ':', 2);
                               val (help, port, dummy);
                               priv_HTTPClient.ProxyParams.ProxyPort := port;
                          end
                       else
                           begin
                                infostruct.status := vsProxyAutoConfigError;
                                exit;
                           end;
                  end;
               12166: begin
                           infostruct.status := vsProxyAutoConfigError;
                           exit;
                      end;
               12167: begin
                           infostruct.status := vsProxyScriptDownloadFail;
                           exit;
                      end;
               12180: begin
                           infostruct.status := vsWPADDetectionFail;
                           exit;
                      end;
             else
                 infostruct.status := vsConnectionFail;
             end;

             priv_HTTPClient.ProxyParams.ProxyUsername := FormPreferences.EditProxyUser.Text;
             priv_HTTPClient.ProxyParams.ProxyPassword := FormPreferences.EditProxyPassword.Text;
        end;

     if FormPreferences.RadioButtonUseProxyServer.Checked then
        begin
             priv_HTTPClient.ProxyParams.ProxyServer := FormPreferences.EditProxyAddress.Text;
             priv_HTTPClient.ProxyParams.ProxyPort := StrToInt (FormPreferences.EditProxyPort.Text);
             priv_HTTPClient.ProxyParams.ProxyUsername := FormPreferences.EditProxyUser.Text;
             priv_HTTPClient.ProxyParams.ProxyPassword := FormPreferences.EditProxyPassword.Text;
        end;

     try
        content := priv_HTTPClient.Get (TracebusterVersionURL + params);
     except
           if FormPreferences.RadioButtonDirectConnetion.Checked then
              begin
                   infostruct.status := vsConnectionFail;
                   Exit (infostruct);
              end
           else
               begin
                    // Proxy fail

                    infostruct.status := vsProxyFail;
                    infostruct.content := content;
                    exit (infostruct);
               end;
     end;

     infostruct.version := getTaggedValue (content, 'version');
     infostruct.changelog := getTaggedValue (content, 'changelog');

     // Replace leading CRLF

     if (infostruct.changelog[1] = chr($0d)) and (infostruct.changelog[2] = chr($0a)) then
        infostruct.changelog := StringReplace (infostruct.changelog, CRLF, '', []);

     help := getTaggedValue (content, 'builddate');

     TryStrToInt (copy (help, 1, 2), day);
     TryStrToInt (copy (help, 4, 2), month);
     TryStrToInt (copy (help, 7, 4), year);

     infostruct.builddate := EncodeDateTime (year, month, day, 0,0,0,0);

     sslhandler.Free;
     priv_HTTPClient.Free;

     result := infostruct;
end;

{$endif}

(* ------------------------------------------- *)

procedure TFormMain.MenuDebugTestClick(Sender: TObject);

var help  : tAnonymizeParameters;
    value : string;

begin
     help.initialize;
//   help.SaveToConfigFile ('d:\AnonTaskDefault.tcf', false);
//   value := help.LoadFromConfigFile ('d:\anontask.tcf');
     FormTaskAnonymize.setAnonymizationParameters (help);
     FormTaskAnonymize.ShowModal;

//   showmessage ('Result: ' + value);
end;

(* ------------------------------------------- *)

end.

