{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_assembly_icmpv4;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, base_checksums, base_structures, class_parser_icmpv4,
  class_assembly_baseclass, definition_ip_addresses, class_assembly_icmpv4;

type
  // Test methods for class tICMPv4Assembler

  TesttICMPv4Assembler = class(TTestCase)
  strict private
    FtICMPv4Assembler: tICMPv4Assembler;
  public
  published
    procedure TestCopyFromParser;
  end;

implementation


uses class_rawframe,
     class_loader_pcapng,
     class_parser_ipv4,
     class_parsemaster;

(* ------------------------------------------- *)

procedure TesttICMPv4Assembler.TestCopyFromParser;

var FtParseMaster : tParseMaster;
    FtLoader      : tPCAPNGLoader;
    Parser        : tICMPv4Parser;
    OpenResult    : boolean;
    Frame         : tRawFrame;
    PseudoHdr     : tIPv4PseudoHeader;
    testbuf       : tBufferWords;
    layerdata     : tFrameChunk;

begin
{
     FtICMPv4Assembler.CopyFromParser(Parser);

     FtLoader := tPCAPNGLoader.create ('d:\traces\TCP-ShortSampleConversation.pcapng');
     OpenResult := FtLoader.openFile;

     CheckEquals (true, Openresult, 'PCAPNGLoader.OpenFile Failed');

     FtLoader.readTraceFileheader;
     FtLoader.readBatchFromDisk;

     Frame := FtLoader.getRawFrame(1);

     FtParseMaster := tParseMaster.create(Frame);

     // Get IP Parser for the Pseudo header

     FtIPParser := (FtParseMaster.getParserByIndex(2) as tIPv4Parser);
     FtTCPParser := (FtParseMaster.getParserByIndex(3) as tTCPParser);
     PseudoHdr := FtIPParser.PseudoHeader;

     // Set parameters for assembly

     if FtParseMaster.HasRemainingPayload then
        begin
             // test

             testbuf := getWordsStructFromOffset (FtParseMaster.RemainingPayloadCopy.Data, 0, FtParseMaster.RemainingPayloadCopy.Len);

             FtTCPAssembler := tTCPAssembler.create (PseudoHdr, FtParseMaster.RemainingPayloadCopy);
        end
     else
         FtTCPAssembler := tTCPAssembler.create (PseudoHdr);

     FtTCPAssembler.CopyFromParser (FtTCPParser);

     // Assemble

     layerdata := FtTCPAssembler.GetAssembly;

     // Clean Up

     layerdata.free;                         // This crashes after CopyFromParser but not when setting by Hand without options

     FtTCPAssembler.Free;
     FtParseMaster.free;

     FtLoader.Free;
     FtLoader := nil;
}
end;

(* ------------------------------------------- *)

initialization
              // Register any test cases with the test runner

              RegisterTest(TesttICMPv4Assembler.Suite);
end.

