{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_beaconfile;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, class_beaconfile, definition_filter_structures, class_rawframe;

type
    // Test methods for class tBeaconFile

    TesttBeaconFile = class (TTestCase)
                            strict private

                            public

                            published
                                     procedure TestDetermineFilterList;
                                     procedure TestSnortFile;
                      end;

implementation

(* ------------------------------------------- *)

procedure TesttBeaconFile.TestDetermineFilterList;

var BeaconFile : tBeaconFile;
    list       : tFilterSet;
    filter     : tFrameFilter;

begin
     BeaconFile := tBeaconfile.create ('D:\Software Development\Jays Utilities\Trace Wrangler\test\traces\HTTP-Sample.pcapng');
     BeaconFile.DetermineFilterList;

     list := BeaconFile.FilterList;

     BeaconFile.Free;

//   CheckEquals (1, length (list), 'Length of filter list');
     CheckEquals (1, list.count, 'Length of filter list');

//   filter := list[0];
     filter := list.getFirst;

     CheckEquals ('192.168.124.100', filter.IPv4Filter.SourceAddress.ValueAsString, 'Source Address');
     CheckEquals ('81.209.179.69', filter.IPv4Filter.DestinationAddress.ValueAsString, 'Destination Address');
     CheckEquals (50272, filter.PortFilter.SourcePort, 'Source Port');
     CheckEquals (80, filter.PortFilter.DestinationPort, 'Destination Port');
end;

(* ------------------------------------------- *)

procedure TesttBeaconFile.TestSnortFile;

var BeaconFile : tBeaconFile;
    list       : tFilterSet;
    filter     : tFrameFilter;

begin
     BeaconFile := tBeaconfile.create ('P:\Traces\SnortTest\snort.log.1425510133');
     BeaconFile.IgnoreSYN := false;
     BeaconFile.IgnoreICMP := false;
     BeaconFile.DetermineFilterList;

     list := BeaconFile.FilterList;

     BeaconFile.Free;

//   CheckEquals (310, length (list), 'Length of filter list');
     CheckEquals (310, list.count, 'Length of filter list');

//   filter := list[0];
     filter := list.getFirst;
end;

(* ------------------------------------------- *)

initialization
              // Register any test cases with the test runner

              RegisterTest(TesttBeaconFile.Suite);
end.

