{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_definition_tcp_structures;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, Types, definition_tcp_structures;

type
  // Test methods for class

  TestTCPRoutines = class (TTestCase)

                        strict private

                        public

                        published
                                 procedure TestLoadSimpleHTTPTrace;
                                 procedure TestCheckRoutines;
                                 procedure TestSequenceType;
                  end;

implementation

uses SysUtils,
     class_rawframe,
     class_loader_pcapng,
     class_parsemaster,
     class_parser_tcp;

(* -------------------------------------- *)
{ TestAddresses }
(* -------------------------------------- *)

procedure TestTCPRoutines.TestCheckRoutines;

begin


end;

(* -------------------------------------- *)

procedure TestTCPRoutines.TestLoadSimpleHTTPTrace;

var Loader      : tPCAPngLoader;
    ParseMaster : tParseMaster;
    TCPParser   : tTCPParser;
    Frame       : tRawFrame;
    FlowState   : tTCPFlowState;
    i           : integer;

begin
     loader := tPCAPngLoader.create ('D:\Software Development\Jays Utilities\Trace Wrangler\test\traces\HTTP-Sample.pcapng');

     Loader.openFile;
     Loader.readTraceFileheader;
     Loader.readBatchFromDisk;

     for i := 1 to Loader.FramesAvailable do
         begin
              Frame := Loader.getRawFrame(i);
              ParseMaster := tParseMaster.create (Frame, ppmParseAll);

              TCPParser := ParseMaster.getParserByProtocol (ppTCP) as tTCPParser;

              CheckFalse (TCPParser = nil, 'TCP Parser found');

              FlowState := TCPParser.GetFlowStateRecord;

              // Verify the flow state per each packet

              case i of
               1 : begin
                        CheckEquals (FlowState.InitialSeq.Value, 419451623, 'Initial Sequence Number');
                        CheckEquals (FlowState.NextExpectedSeq.Value, 419451624, 'Next Expected Sequence Number');
                        CheckEquals (FlowState.LastWindow, 8192, 'Window Size');
                        CheckEquals (FlowState.WindowMultiplier, 4, 'Window Scale Multiplier');
                   end;
               2 : begin
                        CheckEquals (FlowState.InitialSeq.Value, 978444122, 'Initial Sequence Number');
                        CheckEquals (FlowState.NextExpectedSeq.Value, 978444123, 'Next Expected Sequence Number');
                        CheckEquals (FlowState.LastWindow, 8192, 'Window Size');
                        CheckEquals (FlowState.WindowMultiplier, 256, 'Window Scale Multiplier');
                   end;
               3 : begin
                        CheckEquals (FlowState.InitialSeq.Value, 419451623, 'Initial Sequence Number');
                        CheckEquals (FlowState.NextExpectedSeq.Value, 419451624, 'Next Expected Sequence Number');
                        CheckEquals (FlowState.LastWindow, 16425, 'Window Size');
                        CheckEquals (FlowState.WindowMultiplier, -1, 'Window Scale Multiplier');
                   end;
              end;

              Parsemaster.free;
              Frame.free;
         end;

     Loader.Free;
     Loader := nil;
end;

(* -------------------------------------- *)

procedure TestTCPRoutines.TestSequenceType;

var a : tTCPSequence;
    b : tTCPSequence;

begin
     a.initialize ($fffffe54);
     a := a + 1348;

     CheckEquals (1, a.WrapCount, 'WrapCount should be 1');
     CheckEquals (920, a.Value, 'Sequence Number should be 920');

     b.initialize (920, 1);
     b := b - 1348;

     CheckEquals (0, b.WrapCount, 'WrapCount should be 0');
     CheckEquals (4294966868, b.Value, 'Sequence Number should be 1542045220');
end;

(* -------------------------------------- *)

initialization
              // Register any test cases with the test runner

              RegisterTest(TestTCPRoutines.Suite);
end.

