{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_ipfragment_manager;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, class_rawframe, base_structures, System.Generics.Collections,
  definition_ip_addresses, class_ipfragment_manager;

type
  // Test methods for class tFragmentedPacket

  TesttFragmentedPacket = class (TTestCase)
                                strict private

                                public

                                published
                                         procedure TestAddFrame;
                          end;
  // Test methods for class tIPFragmentManager

  TesttIPFragmentManager = class (TTestCase)
                                 strict private

                                 public

                                 published

                                 end;

implementation

uses class_loader_pcapng,
     class_writer_pcapng,
     class_parsemaster,
     class_parser_ipv4;

(* -------------------------------------- *)

procedure TesttFragmentedPacket.TestAddFrame;

var Loader      : tPCAPngLoader;
    Writer      : tPCAPngWriter;
    ParseMaster : tParseMaster;
    IPParser    : tIPv4Parser;
    IPAddress   : tIPAddress;
    Frame       : tRawFrame;
    NewFrame    : tRawFrame;
    FragPacket  : tFragmentedPacket;
    FragFrame   : tRawFrame;
    i           : integer;

begin
     loader := tPCAPngLoader.create ('P:\Traces\RTPS\Fragments.pcapng');

     Loader.openFile;
     Loader.readTraceFileheader;
     Loader.readBatchFromDisk;

     for i := 1 to Loader.FramesAvailable do
         begin
              Frame := Loader.getRawFrame(i);
              ParseMaster := tParseMaster.create (Frame, ppmParseAll);

              IPParser := ParseMaster.getParserByProtocol (ppIPv4) as tIPv4Parser;

              if i = 1 then
                 begin
                      IPAddress.initialize (IPParser.Source);

                      FragPacket := tFragmentedPacket.create (IPAddress, IPParser.Identification);
                 end;

              FragPacket.AddPacket (Frame, IPParser.Offset, IPParser.IPPayloadLength, IPParser.Flags);

              // Verify the flow state per each packet

              Parsemaster.free;
         end;

     NewFrame := FragPacket.GetReassembledFrame;

     CheckTrue (not FragPacket.isIncomplete, 'Packet fragments are not incomplete');
     CheckFalse (FragPacket.FragmentsAreOutOfOrder, 'Fragments are in order');

     FragPacket.Free;

     Writer := tPCAPngWriter.create ('P:\Traces\RTPS\ReassembledFrame.pcapng', true);
     Writer.Open;

     Writer.CopyPCAPngHeaderDetailsFromLoader (Loader);
     Writer.addFrameToList (NewFrame);

     // Refragment and save

     FragFrame := GetFragmentFromPacket (NewFrame, 0, 1480, NewFrame.Ticks, NewFrame.Timestamp);
     Writer.addFrameToList (FragFrame);
     FragFrame := GetFragmentFromPacket (NewFrame, 1480, 1480, NewFrame.Ticks, NewFrame.Timestamp);
     Writer.addFrameToList (FragFrame);
     FragFrame := GetFragmentFromPacket (NewFrame, 1480*2, 1480, NewFrame.Ticks, NewFrame.Timestamp);
     Writer.addFrameToList (FragFrame);
     FragFrame := GetFragmentFromPacket (NewFrame, 1480*3, 1480, NewFrame.Ticks, NewFrame.Timestamp);
     Writer.addFrameToList (FragFrame);

     if Writer.FramesInMem > 0 then
        (Writer as tPCAPNGWriter).Flush;

     Writer.Close;
     Writer.free;

     Loader.Free;
     Loader := nil;
end;

(* -------------------------------------- *)

initialization
  // Register any test cases with the test runner
  RegisterTest(TesttFragmentedPacket.Suite);
  RegisterTest(TesttIPFragmentManager.Suite);
end.

