{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_ipv6subnethandler;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, class_ipv6subnethandler, contnrs, definition_ip_addresses;

type
    TesttIPv6SubnetHandler = class (TTestCase)

                                   strict private
                                                 FtIPv6SubnetHandler: tIPv6SubnetHandler;

                                                 procedure AddSubnet (Address : string; const MaskBits : byte = 64);

                                   public
                                         procedure SetUp; override;
                                         procedure TearDown; override;

                                   published
                                            procedure TestGetSubnetIndexForIPAddress;
                             end;

implementation

(* -------------------------------------- *)

procedure TesttIPv6SubnetHandler.SetUp;

begin
     FtIPv6SubnetHandler := tIPv6SubnetHandler.Create;
end;

(* -------------------------------------- *)

procedure TesttIPv6SubnetHandler.TearDown;

begin
     FtIPv6SubnetHandler.Free;
     FtIPv6SubnetHandler := nil;
end;

(* -------------------------------------- *)

procedure TesttIPv6SubnetHandler.AddSubnet (Address: string; const MaskBits : byte = 64);

var IPAddress   : tIPv6Address;
    subnet      : tIPv6SubnetDefinition;

begin
     IPAddress.setValueFromString(Address);
     IPAddress.MaskBitCount := MaskBits;

     subnet := tIPv6SubnetDefinition.create (IPAddress);
     FtIPv6SubnetHandler.AddSubnet(subnet);
end;

(* -------------------------------------- *)

procedure TesttIPv6SubnetHandler.TestGetSubnetIndexForIPAddress;

var NetIndex    : Integer;
    IPAddress   : tIPv6Address;
    subnet      : tIPv6SubnetDefinition;
    i           : integer;

begin
     AddSubnet ('2001:470:b45e::', 48);
     AddSubnet ('2001:470:b45e:10::');
     AddSubnet ('2001:470:b45e:20::');
     AddSubnet ('2001:470:b45e:30::');

     IPAddress.setValueFromString ('2001:470:b45e:10::1');
     NetIndex := FtIPv6SubnetHandler.GetSubnetIndexForIPAddress(IPAddress);
     subnet := FtIPv6SubnetHandler.GetSubnetByIndex(NetIndex);
     CheckEquals ('2001:470:b45e:10::', subnet.SubnetAddress.ValueAsString, 'Public147');
end;

(* -------------------------------------- *)

initialization
              // Register any test cases with the test runner

              RegisterTest(TesttIPv6SubnetHandler.Suite);
end.

