{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_parser_juniper;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, class_parser_baseclass, class_parser_juniper, base_structures, class_parsemaster;

type
  // Test methods for class tJuniperMetaParser

  TesttJuniperParser = class(TTestCase)
  strict private
                Parsemaster : tParseMaster;

                function PrepareTest (Tracefile : string) : tJuniperParser;
  public
  published
           procedure ParseInboundFrame;
  end;

implementation

uses class_rawframe,
     class_loader_pcapng;


(* ------------------------------------------- *)

function TesttJuniperParser.PrepareTest(Tracefile: string) : tJuniperParser;

var Loader      : tPCAPNGLoader;
    Frame       : tRawFrame;
    JuniperParser  : tJuniperParser;
    OpenResult  : boolean;

begin
     Loader := tPCAPNGLoader.create (Tracefile);
     OpenResult := Loader.openFile;

     Loader.readTraceFileheader;
     Loader.readBatchFromDisk;

     Frame := Loader.getRawFrame(1);

     ParseMaster := tParseMaster.create (Frame, ppmParseAll);

     Loader.Free;
     Loader := nil;

     CheckEquals (true, Openresult, 'PCAPNGLoader.OpenFile Failed');

     if (Parsemaster.getParserTypeByIndex (1) = NEXT_HEADER_JUNIPER) then
        JuniperParser := (Parsemaster.getParserByIndex (1) as tJuniperParser)
     else
         JuniperParser := nil;

     result := JuniperParser;
end;

(* ------------------------------------------- *)

procedure TesttJuniperParser.ParseInboundFrame;

var JuniperParser  : tJuniperParser;

begin
     JuniperParser := PrepareTest ('D:\Software Development\Jays Utilities\Trace Wrangler\test\traces\Juniper-Incoming.pcapng');

     if JuniperParser <> nil then
        begin
             CheckEquals (12, JuniperParser.LayerSize, 'LayerSize');
             CheckTrue (JuniperParser.Direction = pdInbound, 'Packet Direction');
             CheckFalse (JuniperParser.Layer2HeaderStripped, 'Header Stripped');
             CheckEquals (6, JuniperParser.ExtensionTotalLength, 'Extension Total Length');
             CheckEquals (NEXT_HEADER_ETHERNET, JuniperParser.NextAnchor.HeaderType, 'Next Header');
             CheckEquals (12, JuniperParser.NextAnchor.Offset, 'Next Offset');
        end;
end;

(* ------------------------------------------- *)

initialization
  // Register any test cases with the test runner
  RegisterTest(TesttJuniperParser.Suite);
end.

