{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_taskprocessor_sanitize;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, class_writer_pcapng, class_parser_ethernet, base_structures,
  class_parsemaster, class_taskprocessor_sanitize, base_checksums, class_rawframe,
  class_parser_ipv4, class_parser_mpls, pcapng_structures, class_parser_tokenring,
  definition_anonymization_struct, class_loader_pcapng, class_parser_ayiya,
  class_parser_ipv6, class_parser_udp, class_parser_tcp, class_replacement_manager,
  definition_simple_nameresolution, class_parser_802dot1q, class_parser_baseclass,
  class_parser_arp, class_tracefilelist, class_parser_gre, class_tracewriter,
  class_parser_icmpv4, class_taskprocessor_baseclass;

type
  // Test methods for class tTaskProcessorAnonymize

  TesttTaskProcessorAnonymize = class(TTestCase)
  strict private
    FtTaskProcessorAnonymize: tTaskProcessorAnonymize;
  public
  published
    procedure ReadAndWriteFrameTime;
  end;

implementation

uses class_traceloader;


procedure TesttTaskProcessorAnonymize.ReadAndWriteFrameTime;

var traceloader : tPCAPNGLoader;
    tracewriter : tPCAPNGWriter;
    frame       : tRawFrame;

const readfilename = 'D:\Software Development\Jays Utilities\Trace Wrangler\test\traces\Time-SingleSYNPacket.pcapng';
      writefilename = 'D:\Software Development\Jays Utilities\Trace Wrangler\test\traces\Time-SingleSYNPacket-new.pcapng';

begin
     traceloader := tPCAPNGLoader.create (readfilename);
     checkEquals (true, traceloader.openFile, 'Trace Open');
     traceloader.readTraceFileheader;

     tracewriter := tPCAPngWriter.create (writefilename);
     tracewriter.Open;
     tracewriter.CopyPCAPngHeaderDetailsFromLoader (traceloader);

     traceloader.readBatchFromDisk;

     frame := traceloader.getRawFrame(1);

     tracewriter.addFrameToList(frame);

     tracewriter.Flush;
     tracewriter.Close;
     traceloader.closeFile;
end;

initialization
              // Register any test cases with the test runner
              RegisterTest(TesttTaskProcessorAnonymize.Suite);
end.

