{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
program TraceWranglerTests;
{

  Delphi DUnit Test Project
  -------------------------
  This project contains the DUnit test framework and the GUI/Console test runners.
  Add "CONSOLE_TESTRUNNER" to the conditional defines entry in the project options
  to use the console test runner.  Otherwise the GUI test runner will be used by
  default.

}

{$IFDEF CONSOLE_TESTRUNNER}
{$APPTYPE CONSOLE}
{$ENDIF}

{$R *.dres}

uses
  SiAuto,
  Forms,
  TestFramework,
  GUITestRunner,
  TextTestRunner,
  base_checksums in '..\base\base_checksums.pas',
  base_determine_protocols in '..\base\base_determine_protocols.pas',
  base_messages in '..\base\base_messages.pas',
  base_structures in '..\base\base_structures.pas',
  definition_ip_addresses in '..\base\definition_ip_addresses.pas',
  definition_simple_nameresolution in '..\base\definition_simple_nameresolution.pas',
  toolkit in '..\base\toolkit.pas',
  pcapng_structures in '..\loader\pcapng_structures.pas',
  class_assembly_ethernet in '..\assembly\class_assembly_ethernet.pas',
  class_assembly_baseclass in '..\assembly\class_assembly_baseclass.pas',
  class_parser_802dot1q in '..\parser\class_parser_802dot1q.pas',
  class_parser_arp in '..\parser\class_parser_arp.pas',
  class_parser_baseclass in '..\parser\class_parser_baseclass.pas',
  class_parser_dhcpv4 in '..\parser\class_parser_dhcpv4.pas',
  class_parser_dns in '..\parser\class_parser_dns.pas',
  class_parser_ethernet in '..\parser\class_parser_ethernet.pas',
  class_parser_framerelay in '..\parser\class_parser_framerelay.pas',
  class_parser_icmpv4 in '..\parser\class_parser_icmpv4.pas',
  class_parser_ipv4 in '..\parser\class_parser_ipv4.pas',
  class_parser_ipv6_fragmentationheader in '..\parser\class_parser_ipv6_fragmentationheader.pas',
  class_parser_mpls in '..\parser\class_parser_mpls.pas',
  class_parser_tcp in '..\parser\class_parser_tcp.pas',
  class_parser_tokenring in '..\parser\class_parser_tokenring.pas',
  class_parser_udp in '..\parser\class_parser_udp.pas',
  class_formstorage in '..\base\class_formstorage.pas',
  class_rawframe in '..\base\class_rawframe.pas',
  class_timezonedetails in '..\base\class_timezonedetails.pas',
  class_assembly_ipv6 in '..\assembly\class_assembly_ipv6.pas',
  class_parsemaster in '..\parser\class_parsemaster.pas',
  class_dupechecker in '..\loader\class_dupechecker.pas',
  class_interfacelist in '..\loader\class_interfacelist.pas',
  class_interfacestatistics in '..\loader\class_interfacestatistics.pas',
  class_loader_enc in '..\loader\class_loader_enc.pas',
  class_loader_naicap in '..\loader\class_loader_naicap.pas',
  class_loader_pcap in '..\loader\class_loader_pcap.pas',
  class_loader_pcapng in '..\loader\class_loader_pcapng.pas',
  class_tracefilelist in '..\loader\class_tracefilelist.pas',
  class_tracefilesetloader in '..\loader\class_tracefilesetloader.pas',
  class_traceloader in '..\loader\class_traceloader.pas',
  class_tracewriter in '..\loader\class_tracewriter.pas',
  class_dnsserverlist in '..\storage\class_dnsserverlist.pas',
  class_ipv4subnethandler in '..\storage\class_ipv4subnethandler.pas',
  class_replacement_manager in '..\storage\class_replacement_manager.pas',
  class_simpleframestorage in '..\storage\class_simpleframestorage.pas',
  class_assembly_arp in '..\assembly\class_assembly_arp.pas',
  class_assembly_ipv4 in '..\assembly\class_assembly_ipv4.pas',
  class_assembly_udp in '..\assembly\class_assembly_udp.pas',
  Testclass_replacement_manager in 'Testclass_replacement_manager.pas',
  Testclass_assembly_ethernet in 'Testclass_assembly_ethernet.pas',
  Testclass_ipv4subnethandler in 'Testclass_ipv4subnethandler.pas',
  Testclass_parser_ipv4 in 'Testclass_parser_ipv4.pas',
  Testclass_assembly_ipv4 in 'Testclass_assembly_ipv4.pas',
  class_assembly_tcp in '..\assembly\class_assembly_tcp.pas',
  Testclass_parser_tcp in 'Testclass_parser_tcp.pas',
  Testclass_assembly_tcp in 'Testclass_assembly_tcp.pas',
  class_assembly_802dot1q in '..\assembly\class_assembly_802dot1q.pas',
  class_ipv6subnethandler in '..\storage\class_ipv6subnethandler.pas',
  Testclass_ipv6subnethandler in 'Testclass_ipv6subnethandler.pas',
  class_inteldb_manager in '..\storage\class_inteldb_manager.pas',
  Testclass_loader_pcapng in 'Testclass_loader_pcapng.pas',
  databasetools in '..\base\databasetools.pas',
  class_parser_ayiya in '..\parser\class_parser_ayiya.pas',
  class_writer_pcapng in '..\loader\class_writer_pcapng.pas',
  Testclass_writer_pcapng in 'Testclass_writer_pcapng.pas',
  class_tasklistmanager in '..\tasks\class_tasklistmanager.pas',
  class_taskprocessor_baseclass in '..\tasks\class_taskprocessor_baseclass.pas',
  class_taskprocessor_edit in '..\tasks\class_taskprocessor_edit.pas',
  class_taskprocessor_sanitize in '..\tasks\class_taskprocessor_sanitize.pas',
  class_taskprocessor_separate in '..\tasks\class_taskprocessor_separate.pas',
  definition_anonymization_struct in '..\base\definition_anonymization_struct.pas',
  form_task_anonymize in '..\tasks\form_task_anonymize.pas' {FormTaskAnonymize},
  form_task_edit in '..\tasks\form_task_edit.pas' {FormTaskEdit},
  form_task_separate in '..\tasks\form_task_separate.pas' {FormTaskSeparation},
  form_taskparameters_deduplicate in '..\tasks\form_taskparameters_deduplicate.pas' {FormTaskParametersDeduplicate},
  Testclass_parser_icmpv4 in 'Testclass_parser_icmpv4.pas',
  class_assembly_ayiya in '..\assembly\class_assembly_ayiya.pas',
  dialog_anon_replacementdetails in '..\dialogs\dialog_anon_replacementdetails.pas' {FormReplacementDetails},
  class_formstorage_anontask in '..\tasks\class_formstorage_anontask.pas',
  dialog_anon_editvlanid in '..\dialogs\dialog_anon_editvlanid.pas' {FormEditVLANID},
  class_assembly_icmpv4 in '..\assembly\class_assembly_icmpv4.pas',
  Testclass_assembly_icmpv4 in 'Testclass_assembly_icmpv4.pas',
  Testclass_taskprocessor_sanitize in 'Testclass_taskprocessor_sanitize.pas',
  Testclass_parser_dhcpv4 in 'Testclass_parser_dhcpv4.pas',
  class_parser_ipv6 in '..\parser\class_parser_ipv6.pas',
  class_assembly_linux_sll in '..\assembly\class_assembly_linux_sll.pas',
  class_parser_linux_sll in '..\parser\class_parser_linux_sll.pas',
  class_assembly_ipv6_fragmentationheader in '..\assembly\class_assembly_ipv6_fragmentationheader.pas',
  class_assembly_dhcpv4 in '..\assembly\class_assembly_dhcpv4.pas',
  class_parser_icmpv6 in '..\parser\class_parser_icmpv6.pas',
  Testclass_parser_icmpv6 in 'Testclass_parser_icmpv6.pas',
  common_parse_helpers in '..\parser\common_parse_helpers.pas',
  class_assembly_mpls in '..\assembly\class_assembly_mpls.pas',
  class_assembly_icmpv6 in '..\assembly\class_assembly_icmpv6.pas',
  class_assembly_gre in '..\assembly\class_assembly_gre.pas',
  Testclass_parser_juniper in 'Testclass_parser_juniper.pas',
  class_parser_juniper in '..\parser\class_parser_juniper.pas',
  class_parser_gtpv1 in '..\parser\class_parser_gtpv1.pas',
  Testclass_parser_gtpv1 in 'Testclass_parser_gtpv1.pas',
  class_parser_gre in '..\parser\class_parser_gre.pas',
  class_frameprocessor_baseclass in '..\frameprocessors\class_frameprocessor_baseclass.pas',
  class_frameprocessor_gre in '..\frameprocessors\class_frameprocessor_gre.pas',
  class_frameprocessor_gtpu in '..\frameprocessors\class_frameprocessor_gtpu.pas',
  class_frameprocessor_juniper in '..\frameprocessors\class_frameprocessor_juniper.pas',
  Testclass_taskprocessor_edit in 'Testclass_taskprocessor_edit.pas',
  class_diagmessagehandler in '..\storage\class_diagmessagehandler.pas',
  class_frameprocessor_replaceSLL in '..\frameprocessors\class_frameprocessor_replaceSLL.pas',
  Testclass_conversationstorage in 'Testclass_conversationstorage.pas',
  Testclass_definition_ip_addresses in 'Testclass_definition_ip_addresses.pas',
  definition_filter_structures in '..\base\definition_filter_structures.pas',
  definition_tcp_structures in '..\base\definition_tcp_structures.pas',
  Testclass_definition_filter_structures in 'Testclass_definition_filter_structures.pas',
  tracefile_utils in '..\loader\tracefile_utils.pas',
  Testclass_loader_naicap in 'Testclass_loader_naicap.pas',
  class_dirparser in '..\base\class_dirparser.pas',
  definition_conversation_types in '..\base\definition_conversation_types.pas',
  class_conversationstorage in '..\storage\class_conversationstorage.pas',
  class_frameprocessor_filter in '..\frameprocessors\class_frameprocessor_filter.pas',
  Testclass_frameprocessor_filter in 'Testclass_frameprocessor_filter.pas',
  definition_interface_mapping_types in '..\base\definition_interface_mapping_types.pas',
  inteldb_tools in '..\storage\inteldb_tools.pas',
  dialog_anon_selectaddresses in '..\dialogs\dialog_anon_selectaddresses.pas' {FormSelectAddresses},
  class_processchain in '..\tasks\class_processchain.pas',
  class_frameprocessor_stub in '..\frameprocessors\class_frameprocessor_stub.pas',
  class_taskprocessor_extract in '..\tasks\class_taskprocessor_extract.pas',
  class_interfacemapper in '..\storage\class_interfacemapper.pas',
  Testclass_parser_dns in 'Testclass_parser_dns.pas',
  Testclass_parser_ipv6 in 'Testclass_parser_ipv6.pas',
  class_parser_hsrp in '..\parser\class_parser_hsrp.pas',
  class_parser_netflow in '..\parser\class_parser_netflow.pas',
  class_parser_geneve in '..\parser\class_parser_geneve.pas',
  class_assembly_hsrp in '..\assembly\class_assembly_hsrp.pas',
  class_assembly_netflow in '..\assembly\class_assembly_netflow.pas',
  dialog_anon_selectconversations in '..\dialogs\dialog_anon_selectconversations.pas' {FormSelectAnonConversations},
  Testclass_definition_tcp_structures in 'Testclass_definition_tcp_structures.pas',
  class_parser_llc in '..\parser\class_parser_llc.pas',
  class_parser_vxlan in '..\parser\class_parser_vxlan.pas',
  class_assembly_vxlan in '..\assembly\class_assembly_vxlan.pas',
  Testclass_frameprocessor_juniper in 'Testclass_frameprocessor_juniper.pas',
  base_testhelpers in 'base_testhelpers.pas',
  Testclass_base_structures in 'Testclass_base_structures.pas',
  class_beaconfile in '..\storage\class_beaconfile.pas',
  Testclass_beaconfile in 'Testclass_beaconfile.pas',
  class_frameprocessor_multiwriter in '..\frameprocessors\class_frameprocessor_multiwriter.pas',
  class_formstorage_extracttask in '..\tasks\class_formstorage_extracttask.pas',
  class_parse_snortalertlog in '..\base\class_parse_snortalertlog.pas',
  Testclass_parse_snortalertlog in 'Testclass_parse_snortalertlog.pas',
  Testclass_loader_general in 'Testclass_loader_general.pas',
  class_frameprocessor_mpls in '..\frameprocessors\class_frameprocessor_mpls.pas',
  class_assembly_gtpv1 in '..\assembly\class_assembly_gtpv1.pas',
  class_frameprocessor_metaupdate in '..\frameprocessors\class_frameprocessor_metaupdate.pas',
  class_parser_http in '..\parser\class_parser_http.pas',
  class_parser_erspan in '..\parser\class_parser_erspan.pas',
  vstedit_payloadreplacement in '..\base\vstedit_payloadreplacement.pas',
  definition_http_structures in '..\base\definition_http_structures.pas',
  Testclass_conversationstore_tcpcheck in 'Testclass_conversationstore_tcpcheck.pas',
  class_conversationstore_tcpcheck in '..\analysis\class_conversationstore_tcpcheck.pas',
  class_parser_rtps in '..\parser\class_parser_rtps.pas',
  class_assembly_rtps in '..\assembly\class_assembly_rtps.pas',
  class_ipfragment_manager in '..\storage\class_ipfragment_manager.pas',
  Testclass_ipfragment_manager in 'Testclass_ipfragment_manager.pas',
  common_assembly_helpers in '..\assembly\common_assembly_helpers.pas',
  definition_5tuple in '..\base\definition_5tuple.pas',
  class_tcpconversation_manager in '..\storage\class_tcpconversation_manager.pas',
  class_fqdnmanager in '..\storage\class_fqdnmanager.pas',
  class_frameprocessor_metaenhancer in '..\frameprocessors\class_frameprocessor_metaenhancer.pas',
  class_parser_capwap in '..\parser\class_parser_capwap.pas',
  class_frameprocessor_capwap in '..\frameprocessors\class_frameprocessor_capwap.pas',
  definition_symptoms in '..\base\definition_symptoms.pas',
  class_frameprocessor_fixethertypes in '..\frameprocessors\class_frameprocessor_fixethertypes.pas',
  class_assembly_llc in '..\assembly\class_assembly_llc.pas',
  class_parser_802dot11_radiotap in '..\parser\class_parser_802dot11_radiotap.pas',
  class_parser_802dot11header in '..\parser\class_parser_802dot11header.pas',
  class_parser_802dot11management in '..\parser\class_parser_802dot11management.pas',
  class_parser_ntp in '..\parser\class_parser_ntp.pas',
  class_assembly_802dot11_radiotap in '..\assembly\class_assembly_802dot11_radiotap.pas',
  class_assembly_802dot11header in '..\assembly\class_assembly_802dot11header.pas',
  class_assembly_802dot11management in '..\assembly\class_assembly_802dot11management.pas';

{R *.RES}

begin
     Si.Enabled := true;

  if Si.Enabled then
     SiMain.LogMessage ('SmartInspect enabled');

  Application.Initialize;

  if IsConsole then
    with TextTestRunner.RunRegisteredTests do
      Free
  else
    GUITestRunner.RunRegisteredTests;
end.

