{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit base_testhelpers;

interface

uses class_rawframe;

         function ReadSingleFrameFromDisk (const Filename : string) : tRawFrame;
         procedure WriteSingleFrameToDisk (const Filename : string; const Frame : tRawFrame);

implementation

uses base_structures,
     definition_ip_addresses,
     class_interfacelist,
     class_traceloader,
     class_writer_pcapng,
     tracefile_utils;

(* ------------------------------------------- *)

function ReadSingleFrameFromDisk (const Filename : string) : tRawFrame;

var Loader      : tTraceLoader;
    newframe    : tRawFrame;

begin
     Loader := createTraceLoader (Filename);

     // open Loader

     Loader.openFile;                        // TODO: handle failure of opening trace files
     Loader.readTraceFileheader;

     Loader.MaxFramesInMem := 10000;

     Loader.readBatchFromDisk;
     newFrame := Loader.getRawFrame(1);
     Loader.free;

     result := newFrame;
end;

(* ------------------------------------------- *)

procedure WriteSingleFrameToDisk (const Filename : string; const Frame : tRawFrame);

var Writer : tPCAPngWriter;
    iFace  : tCaptureInterface;

begin
     // Open writer

     Writer := tPCAPngWriter.create (Filename);
     Writer.Open;

     Writer.WriteGenericHeader (Frame.LinkType);

     // Force the Frame to be a match the pseudo interface

     iFace := Writer.InterfaceList.getInterfaceByIndex(0);
     Frame.InterfaceID := iFace.InterfaceID;
     Frame.InterfaceLinkID := iFace.PacketLinkID;

     // Write to disk

     Writer.addFrameToList(Frame);

     (Writer as tPCAPNGWriter).Flush;

     // Cleanup

     Writer.Close;
     Writer.free;
end;

(* ------------------------------------------- *)

end.
