{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

unit form_task_anonymize;

interface

uses Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
     Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls,
     Vcl.Grids, Vcl.ValEdit, Vcl.ExtCtrls, Vcl.Menus, VirtualTrees,

     base_structures,
     definition_ip_addresses,
     definition_anonymization_struct,
     dialog_anon_replacementdetails,
     class_tracefilelist,
     class_conversationstorage;


const WM_STARTEDITING = WM_USER + 778;       // Helper message to decouple node change handling from edit handling.

      TabCount = 15;                         // Number of settings tabs (zero based, 0..n)

type tAnonTabValues     = record
                                Node         : pVirtualNode;
                          end;

  TFormTaskAnonymize = class(TForm)
    PageControlSettings: TPageControl;
    TabSheetEthernet: TTabSheet;
    TabSheetIPv4: TTabSheet;
    TabSheetIPv6: TTabSheet;
    GroupBoxEthernetAction: TGroupBox;
    RadioButtonEthernetActionPassthrough: TRadioButton;
    RadioButtonEthernetActionReplace: TRadioButton;
    MemoEthernetActionHint: TMemo;
    TabSheetPayload: TTabSheet;
    GroupBoxEthernetActionSettingsReplacement: TGroupBox;
    CheckboxEthernetActionLeaveVendorIntact: TCheckBox;
    CheckboxEthernetActionReplaceByList: TCheckBox;
    CheckBoxProcessRemainingEthernetAddresses: TCheckBox;
    TabsheetOutput: TTabSheet;
    GroupBoxOutputLocation: TGroupBox;
    RadioButtonFileOutputSameDirectory: TRadioButton;
    RadioButtonFileOutputToSubdirectory: TRadioButton;
    LabeledEditOutputToSubdirectory: TLabeledEdit;
    RadioButtonFileOutputToAbsoluteDirectory: TRadioButton;
    LabeledEditOutputToDirectory: TLabeledEdit;
    ButtonSelectOutputDirectory: TButton;
    GroupBoxFileOutputNamingOptions: TGroupBox;
    EditOutputFilename: TEdit;
    ButtonOkay: TButton;
    ButtonCancel: TButton;
    MemoOutputHint: TMemo;
    TabSheetVLAN: TTabSheet;
    TabSheetTunnel: TTabSheet;
    TabSheetTCP: TTabSheet;
    TabSheetUDP: TTabSheet;
    ButtonEthernetMACListAdd: TButton;
    ButtonEthernetMACListEdit: TButton;
    ButtonEthernetMACListRemove: TButton;
    GroupBoxVLANAction: TGroupBox;
    RadioButtonVLANActionPassthrough: TRadioButton;
    RadioButtonVLANActionReplace: TRadioButton;
    MemoVLANActionHint: TMemo;
    TabSheetPCAPng: TTabSheet;
    GroupBoxPCAPngActionSettingsReplacement: TGroupBox;
    GroupBoxPCAPngAction: TGroupBox;
    RadioButtonPCAPngActionPassthrough: TRadioButton;
    RadioButtonPCAPngActionReplace: TRadioButton;
    MemoPCAPngActionHint: TMemo;
    CheckboxPCAPngActionSanitizeComments: TCheckBox;
    ComboBoxPCAPngActionSanitizeCommentMethod: TComboBox;
    CheckboxPCAPngActionSanitizeInterfaceBlocks: TCheckBox;
    ComboBoxPCAPngActionSanitizeIHBInterfaceNames: TComboBox;
    CheckboxPCAPngActionSanitizeNameResolutionBlocks: TCheckBox;
    ComboBoxPCAPngActionSanitizeNRBMethod: TComboBox;
    LabelPCAPngActionCommentMethod: TLabel;
    LabelPCAPngActionSanitizeIHBInterfaceNames: TLabel;
    LabelPCAPngActionSanitizeNRBMethod: TLabel;
    GroupBoxGeneralSettingTruncate: TGroupBox;
    CheckboxGeneralActionPacketTruncateAfterLayer: TCheckBox;
    ComboBoxGeneralPacketSlicingLayer: TComboBox;
    GroupBoxIPv6Action: TGroupBox;
    RadioButtonIPv6ActionPassThrough: TRadioButton;
    RadioButtonIPv6ActionReplace: TRadioButton;
    MemoIPv6ActionHint: TMemo;
    GroupBoxIPv4Action: TGroupBox;
    RadioButtonIPv4ActionPassThrough: TRadioButton;
    RadioButtonIPv4ActionReplace: TRadioButton;
    MemoIPv4ActionHint: TMemo;
    GroupBoxTCPAction: TGroupBox;
    RadioButtonTCPActionPassthrough: TRadioButton;
    RadioButtonTCPActionReplace: TRadioButton;
    MemoTCPActionHint: TMemo;
    GroupBoxActionUDP: TGroupBox;
    RadioButtonUDPActionPassthrough: TRadioButton;
    RadioButtonUDPActionReplace: TRadioButton;
    MemoUDPActionHint: TMemo;
    LabelOutputFilename: TLabel;
    GroupBoxTunnelAction: TGroupBox;
    RadioButtonTunnelActionPassthrough: TRadioButton;
    RadioButtonTunnelActionReplace: TRadioButton;
    MemoTunnelActionHint: TMemo;
    CheckboxPCAPngActionSanitizePacketOptions: TCheckBox;
    GroupBoxIPv4ActionSettingsReplacement: TGroupBox;
    GroupBoxTCPReplacementSettings: TGroupBox;
    GroupBoxUDPReplacementSettings: TGroupBox;
    CheckBoxProcessRemainingIPv4Addresses: TCheckBox;
    CheckBoxReplaceIPv4AddressesByList: TCheckBox;
    ButtonIPv4AddressListAdd: TButton;
    ButtonIPv4AddressListEdit: TButton;
    ButtonIPv4AddressListRemove: TButton;
    CheckBoxReplaceIPv4AddressesBySubnets: TCheckBox;
    ButtonIPv4SubnetListAdd: TButton;
    ButtonIPv4SubnetListEdit: TButton;
    ButtonIPv4SubnetListRemove: TButton;
    GroupBoxVLANActionSettingsReplacement: TGroupBox;
    CheckboxVLANActionReplaceByList: TCheckBox;
    CheckBoxVLANActionRandomizeIDs: TCheckBox;
    ButtonVLANListAdd: TButton;
    ButtonVLANListEdit: TButton;
    ButtonVLANListRemove: TButton;
    ComboBoxIPv4ActionSubnetListMode: TComboBox;
    GroupBoxIPv6ActionSettingsReplacement: TGroupBox;
    CheckBoxProcessRemainingIPv6Addresses: TCheckBox;
    CheckBoxReplaceIPv6AddressesByList: TCheckBox;
    ButtonIPv6AddressListAdd: TButton;
    ButtonIPv6AddressListEdit: TButton;
    ButtonIPv6AddressListRemove: TButton;
    CheckBoxReplaceIPv6AddressesBySubnets: TCheckBox;
    ButtonIPv6SubnetListAdd: TButton;
    ButtonIPv6SubnetListEdit: TButton;
    ButtonIPv6SubnetListRemove: TButton;
    CheckBoxReplaceTCPPortsByList: TCheckBox;
    ButtonTCPPortListAdd: TButton;
    ButtonTCPPortListEdit: TButton;
    ButtonTCPPortListRemove: TButton;
    CheckBoxTCPRandomizePorts: TCheckBox;
    CheckBoxTCPRecalculateCRC: TCheckBox;
    ComboBoxTCPRecalculateCRCMode: TComboBox;
    CheckBoxRandomizeIPv4ID: TCheckBox;
    CheckBoxReplaceUDPPortsByList: TCheckBox;
    ButtonUDPPortListAdd: TButton;
    ButtonUDPPortListEdit: TButton;
    ButtonUDPPortListRemove: TButton;
    CheckBoxUDPRandomizePorts: TCheckBox;
    CheckBoxUDPRecalculateCRC: TCheckBox;
    ComboBoxUDPRecalculateCRCMode: TComboBox;
    CheckBoxIPRecalculateCRC: TCheckBox;
    ComboBoxIPRecalculateCRCMode: TComboBox;
    CheckboxVLANActionRemoveTag: TCheckBox;
    ComboBoxVLANActionRemoveTag: TComboBox;
    ListBoxVLANActionRemoveVLANIDs: TListBox;
    ButtonListBoxVLANActionRemoveVLANIDsClear: TButton;
    CheckboxGeneralActionPacketTruncateAfterOffset: TCheckBox;
    EditGeneralPacketSlicingOffset: TEdit;
    UpDownGeneralPacketSlicingOffset: TUpDown;
    CheckboxGeneralActionPacketTruncateUnknownPayload: TCheckBox;
    PopupMenuVirtualStringTrees: TPopupMenu;
    PopUpMenuImport: TMenuItem;
    PopUpMenuExport: TMenuItem;
    PopUpMenuClear: TMenuItem;
    PopUpMenuImportFromConversationStore: TMenuItem;
    PopUpMenuImportFromFile: TMenuItem;
    OpenDialogImport: TOpenDialog;
    SaveDialogExport: TSaveDialog;
    VSTMACAddressList: TVirtualStringTree;
    VSTIPv4AddressList: TVirtualStringTree;
    VSTIPv4SubnetList: TVirtualStringTree;
    VSTIPv6SubnetList: TVirtualStringTree;
    VSTIPv6AddressList: TVirtualStringTree;
    VSTTCPPortList: TVirtualStringTree;
    VSTUDPPortList: TVirtualStringTree;
    VSTVLANIDList: TVirtualStringTree;
    ButtonListBoxVLANActionRemoveVLANIDsRemove: TButton;
    ButtonListBoxVLANActionRemoveVLANIDsAdd: TButton;
    GroupBoxTunnelActionSettingsAYIYAReplacement: TGroupBox;
    CheckboxAYIYAActionReplace: TCheckBox;
    LabelPCAPngActionSanitizeIHBCaptureFilters: TLabel;
    ComboBoxPCAPngActionSanitizeIHBCaptureFilters: TComboBox;
    TabSheetICMPv4: TTabSheet;
    TabSheetDHCPv4: TTabSheet;
    GroupBoxICMPv4Action: TGroupBox;
    RadioButtonICMPv4ActionPassThrough: TRadioButton;
    RadioButtonICMPv4ActionReplace: TRadioButton;
    MemoICMPv4ActionHint: TMemo;
    GroupBoxDHCPv4Action: TGroupBox;
    RadioButtonDHCPv4ActionPassthrough: TRadioButton;
    RadioButtonDHCPv4ActionReplace: TRadioButton;
    MemoDHCPv4ActionHint: TMemo;
    GroupBoxICMPv4ActionSettingsReplacement: TGroupBox;
    CheckBoxICMPv4RemovePingPayload: TCheckBox;
    GroupBoxDHCPv4ActionSettingsReplacement: TGroupBox;
    CheckBoxDHCPv4HandleFQDNs: TCheckBox;
    ComboBoxDHCPv4ActionFQDNReplaceMode: TComboBox;
    CheckBoxICMPv4RecalculateCRC: TCheckBox;
    ComboBoxICMPv4RecalculateCRCMode: TComboBox;
    CheckBoxRandomizeIPv4Multicast: TCheckBox;
    CheckBoxRandomizeIPv4APIPA: TCheckBox;
    LabelRandomizeIPv4Include: TLabel;
    CheckBoxTCPRandomizePortsKeepSystemPorts: TCheckBox;
    CheckBoxUDPRandomizePortsKeepSystemPorts: TCheckBox;
    TabSheetICMPv6: TTabSheet;
    GroupBoxICMPv6Action: TGroupBox;
    RadioButtonICMPv6ActionPassThrough: TRadioButton;
    RadioButtonICMPv6ActionReplace: TRadioButton;
    MemoICMPv6ActionHint: TMemo;
    GroupBoxICMPv6ActionSettingsReplacement: TGroupBox;
    CheckBoxICMPv6RemovePingPayload: TCheckBox;
    CheckBoxICMPv6RecalculateCRC: TCheckBox;
    ComboBoxICMPv6RecalculateCRCMode: TComboBox;
    CheckBoxRandomizeIPv6DocumentationAddresses: TCheckBox;
    LabelRandomizeIPv6Include: TLabel;
    CheckBoxICMPv6RemoveDNSServerFQDNs: TCheckBox;
    ButtonTools: TButton;
    PopupMenuTools: TPopupMenu;
    PopupMenuToolsClearAllSettings: TMenuItem;
    PopupMenuToolsSetAsDefault: TMenuItem;
    CheckBoxSetFileDateTo: TCheckBox;
    ComboBoxSetFileTimestampScope: TComboBox;
    PopupMenuToolsResetSettingsToFactory: TMenuItem;
    MenuSeparator1: TMenuItem;
    CheckBoxEthernetRecalculateCRC: TCheckBox;
    ComboBoxEthernetRecalculateCRCMode: TComboBox;
    PopupMenuAddButtons: TPopupMenu;
    PopUpMenuAddButtonImport: TMenuItem;
    PopUpMenuAddButtonLookup: TMenuItem;
    ComboBoxPCAPngActionSanitizeCommentScope: TComboBox;
    CheckboxReplacePayloadStrings: TCheckBox;
    CheckboxReplacePayloadStringsCaseInsensitive: TCheckBox;
    PopupMenuReplacementStrings: TPopupMenu;
    MenuImportReplacementStrings: TMenuItem;
    MenuExportReplacementStrings: TMenuItem;
    PopupMenuToolsSpecial: TMenuItem;
    PopupMenuToolsSpecialSwapConversationAddresses: TMenuItem;
    CheckBoxRandomizeIPv4DocumentationAddresses: TCheckBox;
    VSTTCPSocketList: TVirtualStringTree;
    ButtonTCPSocketListRemove: TButton;
    ButtonTCPSocketListEdit: TButton;
    ButtonTCPSocketListAdd: TButton;
    CheckBoxReplaceTCPPortsBySocketList: TCheckBox;
    CheckBoxReplaceUDPPortsBySocketList: TCheckBox;
    VSTUDPSocketList: TVirtualStringTree;
    ButtonUDPSocketListAdd: TButton;
    ButtonUDPSocketListEdit: TButton;
    ButtonUDPSocketListRemove: TButton;
    LabelRandomizeIPv4PrivateMode: TLabel;
    ComboBoxIPRandomizePrivateRangeMode: TComboBox;
    VSTICMPv4RemoveMessages: TVirtualStringTree;
    CheckBoxICMPv4RemoveMessages: TCheckBox;
    ComboBoxRandominzeIPv6AddressMode: TComboBox;
    TabsheetSettings: TTabSheet;
    GroupBoxAnonymizationDBSettings: TGroupBox;
    CheckBoxUseDiskBasedDatabaseFile: TCheckBox;
    CheckBoxKeepDatabaseFileAfterFinish: TCheckBox;
    CheckBoxForceDatabasePath: TCheckBox;
    EditReplacementDBPath: TEdit;
    ButtonSelectDBPath: TButton;
    CheckBoxWipeDatabaseOnJobStart: TCheckBox;
    ComboBoxGeneralPayloadRemovalMode: TComboBox;
    LabelReplacePayloadPattern: TLabel;
    EditPayloadOverwritePattern: TEdit;
    MemoPayloadHint: TMemo;
    CheckBoxEthernetPreserveTrailer: TCheckBox;
    VSTPayloadReplacementStrings: TVirtualStringTree;
    CheckboxGeneralActionPacketTruncateReAddPadding: TCheckBox;
    CheckboxReplacePayloadStringsDoNotEnforceSameLength: TCheckBox;
    ComboBoxRemainingIPv4AddressesProcessMode: TComboBox;
    ComboBoxRemainingEthernetAddressesProcessMode: TComboBox;
    TabSheetRTPS: TTabSheet;
    GroupBox1: TGroupBox;
    RadioButtonRTPSActionPassthrough: TRadioButton;
    RadioButtonRTPSActionReplace: TRadioButton;
    MemoRTPSActionHint: TMemo;
    GroupBoxRTPSActionSettingsReplacement: TGroupBox;
    LabelRTPSReplacementMode: TLabel;
    ComboBoxRTPSActionReplaceMode: TComboBox;
    GroupBoxAdvancedSettings: TGroupBox;
    CheckBoxAdvReassembleIPFragments: TCheckBox;
    LabelAdvReassemblyTimeout: TLabel;
    EditAdvReassemblyChainTimeout: TEdit;
    UpDownAdvReassemblyChainTimeout: TUpDown;
    EditFormGenerationIndex: TEdit;
    LabelDirectoryWarning: TLabel;
    PopUpMenuAddButtonAuto: TMenuItem;
    CheckBoxReplaceIPv4AddressesAutoMode: TCheckBox;
    CheckBoxReplaceIPv6AddressesAutoMode: TCheckBox;
    TimerAutoMode: TTimer;
    VSTNavigation: TVirtualStringTree;
    TabSheet802dot11: TTabSheet;
    GroupBox802dot11Action: TGroupBox;
    RadioButton802dot11ActionPassthrough: TRadioButton;
    RadioButton802dot11ActionReplace: TRadioButton;
    Memo802dot11ActionHint: TMemo;
    GroupBox802dot11ActionSettingsReplacement: TGroupBox;
    Checkbox802dot11ActionReplaceSSIDByList: TCheckBox;
    VST802dot11SSIDReplacementList: TVirtualStringTree;
    CheckBox802dot11AutoReplaceRemainingSSIDs: TCheckBox;
    CheckBox802dot11KeepUnknownTaggedParameters: TCheckBox;
    LabelHintPayloadEditor: TLabel;
    LabelHintSSIDReplacementList: TLabel;
    Edit802dot11AutoReplaceRemainingSSIDsPrefix: TEdit;
    GroupBoxTunnelActionSettingsMPLSReplacement: TGroupBox;
    CheckBoxRandomizeLabels: TCheckBox;
    LabelMPLSMaximumLabelValue: TLabel;
    EditMPLSMaximumLabelValue: TEdit;
    UpDownMPLSMaximumLabelValue: TUpDown;
    procedure onShow (Sender: TObject);
    procedure onChangeEthernetSettings(Sender: TObject);
    procedure onChangeOutputSettings(Sender: TObject);
    procedure onChangePCAPngSettings(Sender: TObject);
    procedure onChangeGeneralSettings(Sender: TObject);
    procedure onKeyPressNumbersAllowedOnly(Sender: TObject; var Key: Char);

//  procedure onChangeTreeViewNavigation(Sender: TObject; Node: TTreeNode);
    procedure onChangeIPv4Settings(Sender: TObject);
    procedure onKeyPressHexAndColonsOnly(Sender: TObject; var Key: Char);
    procedure onKeyPressNumbersAndDotsOnly(Sender: TObject; var Key: Char);
    procedure onKeyPressNumbersDashesCommasOnly(Sender: TObject; var Key: Char);
    procedure ButtonEthernetMACListAddClick(Sender: TObject);
    procedure ButtonVLANListAddClick(Sender: TObject);
    procedure ButtonIPv4AddressListAddClick(Sender: TObject);
    procedure ButtonIPv4SubnetListAddClick(Sender: TObject);
    procedure ButtonIPv6AddressListAddClick(Sender: TObject);
    procedure ButtonIPv6SubnetListAddClick(Sender: TObject);
    procedure ButtonTCPPortListAddClick(Sender: TObject);
    procedure ButtonUDPPortListAddClick(Sender: TObject);
    procedure onChangeIPv6Settings(Sender: TObject);
    procedure onChangeTCPSettings(Sender: TObject);
    procedure onChangeUDPSettings(Sender: TObject);
    procedure onClickOutputsettings(Sender: TObject);
    procedure onChangeVLANSettings(Sender: TObject);
    procedure onKeyPressNumbersDotsAndSlashes(Sender: TObject; var Key: Char);
    procedure onPopUpPopupMenuVirtualStringTrees(Sender: TObject);
    procedure onCreate(Sender: TObject);
    procedure PopUpMenuClearClick(Sender: TObject);
    procedure onVSTMACAddressListDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
    procedure onVSTMACAddressListEditing(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);
    procedure onVSTMACAddressListNewText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);
    procedure onVSTMACAddressListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onKeyDownGeneralVSTAddressList(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ButtonEthernetMACListEditClick(Sender: TObject);
    procedure ButtonEthernetMACListRemoveClick(Sender: TObject);
    procedure onVSTMACAddressListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onVSTMACAddressListDblClick(Sender: TObject);
    procedure onVSTIPv4AddressListDblClick(Sender: TObject);
    procedure onVSTIPv4AddressListDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
    procedure onVSTIPv4AddressListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onVSTIPv4AddressListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTIPv4AddressListNewText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);
    procedure ButtonIPv4AddressListEditClick(Sender: TObject);
    procedure ButtonIPv4AddressListRemoveClick(Sender: TObject);
    procedure onVSTIPv4SubnetListDblClick(Sender: TObject);
    procedure onVSTIPv4SubnetListDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
    procedure onVSTIPv4SubnetListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onVSTIPv4SubnetListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTIPv4SubnetListNewText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);
    procedure ButtonIPv4SubnetListRemoveClick(Sender: TObject);
    procedure ButtonIPv4SubnetListEditClick(Sender: TObject);
    procedure onVSTIPv6AddressListDblClick(Sender: TObject);
    procedure onVSTIPv6AddressListDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
    procedure onVSTIPv6AddressListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onVSTIPv6AddressListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTIPv6AddressListNewText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);
    procedure ButtonIPv6AddressListEditClick(Sender: TObject);
    procedure ButtonIPv6AddressListRemoveClick(Sender: TObject);
    procedure onVSTIPv6SubnetListDblClick(Sender: TObject);
    procedure onVSTIPv6SubnetListDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
    procedure onVSTIPv6SubnetListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onVSTIPv6SubnetListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTIPv6SubnetListNewText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);
    procedure ButtonIPv6SubnetListEditClick(Sender: TObject);
    procedure ButtonIPv6SubnetListRemoveClick(Sender: TObject);
    procedure onVSTVLANIDListNewText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);
    procedure onVSTVLANIDGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTVLANIDFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onVSTVLANIDDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
    procedure onVSTVLANIDDblClick(Sender: TObject);
    procedure ButtonVLANListEditClick(Sender: TObject);
    procedure ButtonVLANListRemoveClick(Sender: TObject);
    procedure onVSTTCPPortListDblClick(Sender: TObject);
    procedure onVSTTCPPortListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onVSTTCPPortListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTTCPPortListNewText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);
    procedure ButtonTCPPortListEditClick(Sender: TObject);
    procedure ButtonTCPPortListRemoveClick(Sender: TObject);
    procedure onUDPPortListDblClick(Sender: TObject);
    procedure onUDPPortListDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
    procedure onUDPPortListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onUDPPortListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onUDPPortListNewText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);
    procedure ButtonUDPPortListRemoveClick(Sender: TObject);
    procedure ButtonUDPPortListEditClick(Sender: TObject);
    procedure ButtonListBoxVLANActionRemoveVLANIDsClearClick(Sender: TObject);
    procedure onChangeTunnelSettings(Sender: TObject);
    procedure ButtonListBoxVLANActionRemoveVLANIDsAddClick(Sender: TObject);
    procedure ButtonListBoxVLANActionRemoveVLANIDsRemoveClick(Sender: TObject);
    procedure PopUpMenuExportClick(Sender: TObject);
    procedure PopUpMenuImportFromFileClick(Sender: TObject);
    procedure onChangeICMPv4Settings(Sender: TObject);
    procedure onChangeDHCPv4Settings(Sender: TObject);
    procedure onChangeICMPv6Settings(Sender: TObject);
    procedure ButtonToolsClick(Sender: TObject);
    procedure PopupMenuToolsClearAllSettingsClick(Sender: TObject);
    procedure PopupMenuToolsSetAsDefaultClick(Sender: TObject);
    procedure ButtonSelectOutputDirectoryClick(Sender: TObject);
    procedure ButtonSelectDBPathClick(Sender: TObject);
    procedure onChangeReplacementDBPath(Sender: TObject);
    procedure PopupMenuToolsResetSettingsToFactoryClick(Sender: TObject);
    procedure PopUpMenuImportFromConversationStoreClick(Sender: TObject);
    procedure onButtonAddDropDownClick(Sender: TObject);
    procedure PopUpMenuAddButtonLookupClick(Sender: TObject);
    procedure MenuExportReplacementStringsClick(Sender: TObject);
    procedure MenuImportReplacementStringsClick(Sender: TObject);
    procedure onPopUpReplacementStrings(Sender: TObject);
    procedure onPopUpTools(Sender: TObject);
    procedure PopupMenuToolsSpecialSwapConversationAddressesClick (Sender: TObject);
    procedure ButtonTCPSocketListAddClick(Sender: TObject);
    procedure ButtonTCPSocketListEditClick(Sender: TObject);
    procedure ButtonTCPSocketListRemoveClick(Sender: TObject);
    procedure onVSTTCPSocketListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTTCPSocketListDblClick(Sender: TObject);
    procedure onVSTTCPSocketListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onVSTUDPSocketListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTUDPSocketListDblClick(Sender: TObject);
    procedure onVSTUDPSocketListFocusChanged(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure ButtonUDPSocketListAddClick(Sender: TObject);
    procedure ButtonUDPSocketListEditClick(Sender: TObject);
    procedure ButtonUDPSocketListRemoveClick(Sender: TObject);
    procedure onVSTICMPv4RemoveMessageGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTICMPv4RemoveMessagesChecked(Sender: TBaseVirtualTree;Node: PVirtualNode);
    procedure onChangePayloadSettings(Sender: TObject);
    procedure onEditKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure onLabeledEditKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure onVSTPayloadReplacementStringsGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTReplacementStringsChange (Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVSTReplacementStringsCreateEditor (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; out EditLink: IVTEditLink);
    procedure onVSTReplacementStringsEdited (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);
    procedure onVSTPayloadReplacementStringsPaintText (Sender: TBaseVirtualTree; const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType);
    procedure onChangeRTPSSettings(Sender: TObject);
    procedure onChangeOutputToDirectory(Sender: TObject);
    procedure onPopUpAddButtonImport(Sender: TObject);
    procedure onVSTTCPSocketListDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
    procedure PopUpMenuAddButtonAutoClick(Sender: TObject);
    procedure onTimerAutoMode(Sender: TObject);
    procedure onVSTNavigationGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onVSTNavigationPaintText(Sender: TBaseVirtualTree; const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType);
    procedure onVSTNavigationChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVST802dot11ReplacementListGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);
    procedure onChange802dot11Settings(Sender: TObject);
    procedure onResize(Sender: TObject);
    procedure onVSTIPv4AddressListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVSTIPv6AddressListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVSTMACAddressListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVSTIPv4AddressListEditing(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);
    procedure onVSTIPv6AddressListEditing(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);
    procedure onVSTIPv4SubnetListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVSTIPv6SubnetListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVSTTCPSocketListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVSTTCPPortListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVSTUDPSocketListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onVSTUDPPortListChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure onExitMPLSMaximumLabelValue(Sender: TObject);
    procedure ButtonOkayClick(Sender: TObject);
  private
         { Private declarations }

         priv_comboboxPacketSliceParamOldIndex : integer;
         priv_comboboxPacketSliceParamOldValue : integer;

         priv_CatchKeys                        : boolean;

         // Other stuff

         priv_defaultsettingspath              : string;
         priv_outputpathchecked                : string;

         priv_filelist                         : tTracefileList;
         priv_conversationstore                : tConversationStorage;

         priv_tabvalues                        : array [0..tabcount] of tAnonTabValues;

         function BrowseDialog (const Title: string; const Flag: integer): string;

         procedure onReplacementPairAddAndNew (const ReplacementEditType : tReplacementEditType; Original, Replacement : string);

         procedure InitializeVSTLists;
         procedure PrepareICMPv4TypeCodeList;

         function AddNavigationContentNode (const TopicNode : pVirtualNode; const TabIndex : integer) : pVirtualNode;
         function AddNavigationTopicNode (const ParentNode : pVirtualNode; const TopicIndex : integer; const TabIndex : integer) : pVirtualNode;

         procedure BuildNavigationTree;
//       procedure UpdateTreeNode (TreeNode : TTreeNode; SetBold : boolean); overload;
         procedure UpdateTreeNode (TabIndex : integer; Status : tNavigationNodeStatusSet); overload;
         procedure UpdateTreeNode (TabIndex : integer; SetActive : boolean); overload;
         procedure SetTreeNodeStatusFlag (TabIndex : integer; Status : tNavigationNodeStatus);
         procedure ClearTreeNodeStatusFlag (TabIndex : integer; Status : tNavigationNodeStatus);
         procedure UpdateTreeNodesStatus;
         function GetHeaderStringForTree (Treename : string) : string;
         function GetOutputStringForTreeRow (Treename : string; Node : PVirtualNode) : string;
         function SettingIsActive (Checkbox : tCheckbox) : boolean;
         function AddressExistsInList (const NewAddress : tMACAddress) : boolean; overload;
         function AddressExistsInList (const NewAddress : tIPv4Address) : boolean; overload;
         function AddressExistsInList (const NewAddress : tIPv6Address) : boolean; overload;
         procedure AutoReplaceMACAddresses;
         procedure AutoReplaceIPv4Addresses;
         procedure AutoReplaceIPv6Addresses;
//       procedure ValidateReplacementString;

         /// <summary>
         ///   This routine makes sure that the Replacement string editor is
         ///   ready for more input by the user
         /// </summary>
         procedure PrepareReplacementStringEditor (Tree : tVirtualStringTree);

         {$REGION 'Documentation'}
         ///	<returns>
         ///	  true if everything was okay, false if a parser error occured
         ///	</returns>
         {$ENDREGION}
         function AddNodeDataToTree (Tree: tVirtualStringTree; ImportLine : string) : boolean;

         procedure ClearAllSettings;

         procedure GetPayloadActionParameters (var value : tAnonymizeParameters);
         procedure GetPCAPngActionParameters (var value : tAnonymizeParameters);
         procedure Get802dot11ActionParameters (var value : tAnonymizeParameters);
         procedure GetEthernetActionParameters (var value : tAnonymizeParameters);
         procedure GetVLANActionParameters (var value : tAnonymizeParameters);
         procedure GetIPv4ActionParameters (var value : tAnonymizeParameters);
         procedure GetIPv6ActionParameters (var value : tAnonymizeParameters);
         procedure GetICMPv4ActionParameters (var value : tAnonymizeParameters);
         procedure GetICMPv6ActionParameters (var value : tAnonymizeParameters);
         procedure GetTCPActionParameters (var value : tAnonymizeParameters);
         procedure GetUDPActionParameters (var value : tAnonymizeParameters);
         procedure GetTunnelingParameters (var value : tAnonymizeParameters);
         procedure GetDHCPv4ActionParameters (var value : tAnonymizeParameters);
         procedure GetApplicationParameters (var value : tAnonymizeParameters);
         procedure GetOutputParameters (var value : tAnonymizeParameters);
         {$REGION 'Documentation'}
         /// <summary>
         ///   Writes setting from the form into the settings record
         /// </summary>
         {$ENDREGION}
         procedure GetSettingsParameters (var value : tAnonymizeParameters);

         procedure SetPayloadActionParameters (const value : tAnonymizeParameters);
         procedure SetPCAPngActionParameters (const value : tAnonymizeParameters);
         procedure Set802dot11ActionParameters (const value : tAnonymizeParameters);
         procedure SetEthernetActionParameters (const value : tAnonymizeParameters);
         procedure SetVLANActionParameters (const value : tAnonymizeParameters);
         procedure SetIPv4ActionParameters (const value : tAnonymizeParameters);
         procedure SetIPv6ActionParameters (const value : tAnonymizeParameters);
         procedure SetICMPv4ActionParameters (const value : tAnonymizeParameters);
         procedure SetICMPv6ActionParameters (const value : tAnonymizeParameters);
         procedure SetTCPActionParameters (const value : tAnonymizeParameters);
         procedure SetUDPActionParameters (const value : tAnonymizeParameters);
         procedure SetTunnelingParameters (const value : tAnonymizeParameters);
         procedure SetDHCPv4ActionParameters (const value : tAnonymizeParameters);
         procedure SetApplicationParameters (const value : tAnonymizeParameters);
         procedure SetOutputParameters (const value : tAnonymizeParameters);
         {$REGION 'Documentation'}
         /// <summary>
         ///   Writes setting from the settings record into the form
         /// </summary>
         {$ENDREGION}
         procedure SetSettingsParameters (const value : tAnonymizeParameters);

         /// <summary>
         ///   Checks if replacements are making sense for the current file
         ///   set.
         /// </summary>
         procedure RunPlausibilityChecks;
         procedure RefreshFormItemsDisplay;
         procedure UpdateOkayButtonStatus;

         procedure LookupMACAddresses;
         procedure LookupIPv4Addresses;
         procedure LookupIPv6Addresses;

         // Windows messaging routines

         procedure WMStartVSTPayloadReplacementStringsEditing (var Message: TMessage); message WM_STARTEDITING;
         procedure CMDialogKey (var Msg: TCMDialogKey); message CM_DIALOGKEY;

  public
        { Public declarations }

        property FileList : tTracefileList read priv_filelist write priv_filelist;
        property PathToDefaultSettings : string read priv_defaultsettingspath write priv_defaultsettingspath;
        property ConversationStore : tConversationStorage read priv_conversationstore write priv_conversationstore;

        procedure LoadSettings (const Filename : string);
        procedure SaveSettings (const Filename : string);

        {$REGION 'Documentation'}
        ///	<summary>
        ///	  This function returns the settings made on the edit task form as
        ///	  a parameter record which is then used by the task processor
        ///	</summary>
        {$ENDREGION}
        function getAnonymizationParameters : tAnonymizeParameters;
        {$REGION 'Documentation'}
        /// <summary>
        ///   Sets the form according to the parameter settings structure
        /// </summary>
        {$ENDREGION}
        procedure setAnonymizationParameters (const value : tAnonymizeParameters);
        {$REGION 'Documentation'}
        /// <summary>
        ///   Returns the task details as string, for display in the task
        ///   detail pane
        /// </summary>
        {$ENDREGION}
        function GetTaskDescription : string;
  end;

const TaskTypeAnonymize = 'TaskAnonymize';
      DefaultReassemblyChainTimeout = 100;

var
  FormTaskAnonymize: TFormTaskAnonymize;

implementation

{$R *.dfm}

uses ShlObj,
     CommCtrl,
     Math,
     VCL.Clipbrd,
     vstedit_payloadreplacement,
     toolkit,
     definition_conversation_types,
     class_formstorage_anontask,
     dialog_anon_editvlanid,
     dialog_anon_selectaddresses,
     dialog_anon_selectconversations, form_task_separate;

type tDefinedBy = (defUser, defAuto);
     tNaviNode = record
                       Caption     : string;
                       TabIndex    : integer;
                       Status      : tNavigationNodeStatusSet;
                 end;
     pNaviNode = ^tNaviNode;

     tReplacementMACNode = record
                                  Original     : tMACAddress;
                                  Replacement  : tMACAddress;
                                  DefinedBy    : tDefinedBy;
                            end;
     pReplacementMACNode = ^tReplacementMACNode;

     tReplacementIPv4Node = record
                                  Original     : tIPv4Address;
                                  Replacement  : tIPv4Address;
                                  DefinedBy    : tDefinedBy;
                            end;
     pReplacementIPv4Node = ^tReplacementIPv4Node;

     tReplacementIPv6Node = record
                                  Original     : tIPv6Address;
                                  Replacement  : tIPv6Address;
                                  DefinedBy    : tDefinedBy;
                            end;
     pReplacementIPv6Node = ^tReplacementIPv6Node;

const TabIndexPayload  = 0;
      TabIndexPCAPNg   = 1;
      TabIndex802dot11 = 2;
      TabIndexEthernet = 3;
      TabIndexVLAN     = 4;
      TabIndexTunnel   = 5;
      TabIndexIPv4     = 6;
      TabIndexIPv6     = 7;
      TabIndexICMPv4   = 8;
      TabIndexICMPv6   = 9;
      TabIndexTCP      = 10;
      TabIndexUDP      = 11;
      TabIndexDHCPv4   = 12;
      TabIndexRTPS     = 13;
      TabIndexOutput   = 14;
      TabIndexSettings = 15;

      TopicIndexLayer2      = 100;
      TopicIndexLayer3      = 101;
      TopicIndexLayer4      = 102;
      TopicIndexSupport     = 103;
      TopicIndexApplication = 104;

(* ------------------------------------------- *)

function DefinedByToString (const value : tDefinedBy) : string;

begin
     case value of
      defUser : result := 'User Input';
      defAuto : result := 'Automatic';
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onCreate (Sender: TObject);

begin
     // Workaround for scaling problems: look for /noscale command line option

     self.Scaled := FindCmdLineSwitch ('noscale');

     assert (PageControlSettings.PageCount = TabCount + 1, 'TabCount mismatch (TFormTaskAnonymize.onCreate)');

     // VST Node Sizes

     InitializeVSTLists;
     priv_defaultsettingspath := '';

     priv_CatchKeys := False;

     PrepareICMPv4TypeCodeList;

     UpDownAdvReassemblyChainTimeout.Position := DefaultReassemblyChainTimeout;
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.BrowseDialog (const Title: string; const Flag: integer): string;

var lpItemID    : PItemIDList;
    BrowseInfo  : TBrowseInfo;
    DisplayName : array[0..MAX_PATH] of char;
    TempPath    : array[0..MAX_PATH] of char;

begin
     Result:='';
     FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);

     with BrowseInfo do
          begin
               hwndOwner := Application.Handle;
               pszDisplayName := @DisplayName;
               lpszTitle := PChar(Title);
               ulFlags := Flag;
          end;

  lpItemID := SHBrowseForFolder(BrowseInfo);

  if lpItemId <> nil then
     begin
          SHGetPathFromIDList(lpItemID, TempPath);
          Result := TempPath;
          GlobalFreePtr(lpItemID);
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.InitializeVSTLists;

begin
     vSTNavigation.NodeDataSize := sizeOf (tNaviNode);

     VSTPayloadReplacementStrings.NodeDataSize := sizeOf (tReplacementEditorData);

     VST802dot11SSIDReplacementList.NodeDataSize := sizeOf (tReplacementEditorData);

     VSTMACAddressList.NodeDataSize := sizeOf (tReplacementMACNode);
     VSTIPv4AddressList.NodeDataSize := sizeOf (tReplacementIPv4Node);
     VSTIPv4SubnetList.NodeDataSize := sizeOf (tIPv4AddressPair);
     VSTIPv6AddressList.NodeDataSize := sizeOf (tReplacementIPv6Node);
     VSTIPv6SubnetList.NodeDataSize := sizeOf (tIPv6AddressPair);
     VSTICMPv4RemoveMessages.NodeDataSize := sizeOf (tICMPv4TreeEntry);
     VSTVLANIDList.NodeDataSize := sizeOf (tVLANPair);
     VSTTCPSocketList.NodeDataSize := sizeOf (tSocketListEntry);
     VSTTCPPortList.NodeDataSize := sizeOf (tPortPair);
     VSTUDPSocketList.NodeDataSize := sizeOf (tSocketListEntry);
     VSTUDPPortList.NodeDataSize := sizeOf (tPortPair);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PrepareICMPv4TypeCodeList;

var node     : pVirtualNode;
    pnode    : pVirtualNode;
    data     : pICMPv4TreeEntry;
    res      : TResourceStream;
    list     : tStringList;
    help     : string;
    sub      : string;
    icmptype : integer;
    lasttype : integer;
    addsub   : boolean;
    i        : integer;

begin
     // Get structure from Ressource (configured at Project -> Resources and Images)

     res := TResourceStream.Create (HInstance, 'ICMPv4Types', RT_RCDATA);

     list := tStringList.Create;
     list.LoadFromStream(res);

     lasttype := -1;
     pnode := nil;

     VSTICMPv4RemoveMessages.BeginUpdate;

     for i := 1 to list.Count do
         begin
              help := list[i-1];

              sub := getEntry (help, ';', 1);

              // check if the string is a number, not something from the header line

              if (length (sub) < 4) then
                 begin
                      tryStrToInt (sub, icmptype);

                      // Add a new type node when it is not the same as the last one

                      if icmpType <> lasttype then
                         begin
                              node := VSTICMPv4RemoveMessages.AddChild (nil);
                              node.CheckType := ctCheckbox;

                              data := VSTICMPv4RemoveMessages.GetNodeData (node);

                              data^.TypeCode.ICMPv4Type := icmptype;
                              data^.TypeCode.ICMPv4Code := -1;

                              case icmptype of
                                3 : begin
                                         addsub := true;
                                         data^.Description := 'Destination unreachable';
                                         data^.ICMPShowCode := false;
                                    end;
                                5 : begin
                                         addsub := true;
                                         data^.Description := 'Redirect';
                                         data^.ICMPShowCode := false;
                                    end;
                               11 : begin
                                         addsub := true;
                                         data^.Description := 'Time exceeded';
                                         data^.ICMPShowCode := false;
                                    end
                              else
                                  addsub := false;
                                  data^.ICMPShowType := true;
                              end;

                              lasttype := icmptype;
                              pnode := node;
                         end;

                      if addsub then
                         begin
                              data^.ICMPShowType := true;

                              node := VSTICMPv4RemoveMessages.AddChild (pNode);
                              node.CheckType := ctCheckbox;

                              data := VSTICMPv4RemoveMessages.GetNodeData (node);
                              data^.ICMPShowType := false;
                              data^.TypeCode.ICMPv4Type := lasttype;
                         end;

                      data^.ICMPShowCode := true;

                      sub := getEntry (help, ';', 2);
                      tryStrToInt (sub, data^.TypeCode.ICMPv4Code);

                      sub := getEntry (help, ';', 3);
                      data^.Description := sub;
                 end;
         end;

     VSTICMPv4RemoveMessages.FullExpand;
     VSTICMPv4RemoveMessages.EndUpdate;

     list.Free;
     res.Free;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetPayloadActionParameters (const value: tAnonymizeParameters);

var Node : pVirtualNode;
    Data : pReplacementEditorData;
    i    : integer;

begin
     CheckboxGeneralActionPacketTruncateUnknownPayload.Checked := value.PayloadTruncateUnknownLayers;

     EditPayloadOverwritePattern.Text := value.PayloadOverwritePattern;

     case value.PayloadRemovalMode of
      prmCut     : ComboBoxGeneralPayloadRemovalMode.ItemIndex := 0;
      prmZero    : ComboBoxGeneralPayloadRemovalMode.ItemIndex := 1;
      prmString  : ComboBoxGeneralPayloadRemovalMode.ItemIndex := 2;
     end;

     CheckboxGeneralActionPacketTruncateAfterLayer.Checked := value.PayloadDoTruncateAfterLayer;
     ComboBoxGeneralPacketSlicingLayer.ItemIndex := value.PayloadTruncateAfterLayer - 2;

     CheckboxGeneralActionPacketTruncateAfterOffset.Checked := value.PayloadDoTruncateAtOffset;
     UpDownGeneralPacketSlicingOffset.Position := value.PayloadTruncateAtOffset;
     CheckboxReplacePayloadStrings.Checked := value.PayLoadDoReplaceStrings;

     CheckboxGeneralActionPacketTruncateReAddPadding.Checked := value.PayloadReAddPaddingIfSliced;

     CheckboxReplacePayloadStringsCaseInsensitive.Checked := value.PayLoadDoReplaceCaseInsensitve;
     CheckboxReplacePayloadStringsDoNotEnforceSameLength.Checked := value.PayloadDoNotEnforceSameLength;

     VSTPayloadReplacementStrings.BeginUpdate;
     VSTPayloadReplacementStrings.Clear;

     for i := 1 to length (value.PayloadReplacementStrings) do
         begin
              Node := VSTPayloadReplacementStrings.AddChild (nil);
              Data := VSTPayloadReplacementStrings.GetNodeData (Node);

              Data^.original := value.PayloadReplacementStrings[i-1].Original;
              Data^.replacement := value.PayloadReplacementStrings[i-1].Replacement;
              Data^.deltalen := value.PayloadReplacementStrings[i-1].getLengthDelta;
         end;

     VSTPayloadReplacementStrings.EndUpdate;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetPCAPngActionParameters (const value: tAnonymizeParameters);

begin
     RadioButtonPCAPngActionReplace.Checked := value.PCAPngDoReplace;

     CheckboxPCAPngActionSanitizeComments.Checked := not (value.PCAPngSanitizeCommentsScope = scsNone);

     case value.PCAPngSanitizeCommentsScope of
      scsNone,
      scsFile   : ComboBoxPCAPngActionSanitizeCommentScope.ItemIndex := 0;
      scsPacket : ComboBoxPCAPngActionSanitizeCommentScope.ItemIndex := 1;
      scsBoth   : ComboBoxPCAPngActionSanitizeCommentScope.ItemIndex := 2;
     end;

     case value.PCAPngSanitizeCommentsMode of
      scmRemoveAll : ComboBoxPCAPngActionSanitizeCommentMethod.ItemIndex := 0;
      scmAsk       : ComboBoxPCAPngActionSanitizeCommentMethod.ItemIndex := 1;
     end;

     CheckboxPCAPngActionSanitizeInterfaceBlocks.Checked := value.PCAPngIHBDoReplace;

     case value.PCAPngSanitizeIHBInterfaceName of
      simNone,
      simReplaceGeneric : ComboBoxPCAPngActionSanitizeIHBInterfaceNames.ItemIndex := 0;
      simSetToBlank     : ComboBoxPCAPngActionSanitizeIHBInterfaceNames.ItemIndex := 1;
      simAsk            : ComboBoxPCAPngActionSanitizeIHBInterfaceNames.ItemIndex := 2;
     end;

     case value.PCAPngSanitizeIHBCaptureFilter of
      cfmRemoveFilter : ComboBoxPCAPngActionSanitizeIHBCaptureFilters.ItemIndex := 0;
      cfmKeepFilter   : ComboBoxPCAPngActionSanitizeIHBCaptureFilters.ItemIndex := 1;
     end;

     CheckboxPCAPngActionSanitizeNameResolutionBlocks.Checked := not (value.PCAPngSanitizeNRB = snmNone);

     case value.PCAPngSanitizeNRB of
      snmNone,
      snmReplaceIPs  : ComboBoxPCAPngActionSanitizeNRBMethod.ItemIndex := 0;
      snmRemoveBlock : ComboBoxPCAPngActionSanitizeNRBMethod.ItemIndex := 1;
      snmAsk         : ComboBoxPCAPngActionSanitizeNRBMethod.ItemIndex := 2;
     end;

     CheckboxPCAPngActionSanitizePacketOptions.Checked := value.PCAPngSanitizePacketOptions;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.Set802dot11ActionParameters (const value: tAnonymizeParameters);

var Node : pVirtualNode;
    Data : pReplacementEditorData;
    i    : integer;

begin
     RadioButton802dot11ActionReplace.Checked := value.WiFiDoReplace;
     Checkbox802dot11ActionReplaceSSIDByList.Checked := value.WiFiReplaceBySSIDList;

     VST802dot11SSIDReplacementList.BeginUpdate;
     VST802dot11SSIDReplacementList.Clear;

     for i := 1 to length (value.WiFiSSIDReplacementStrings) do
         begin
              Node := VST802dot11SSIDReplacementList.AddChild (nil);
              Data := VST802dot11SSIDReplacementList.GetNodeData (Node);

              Data^.original := value.WiFiSSIDReplacementStrings[i-1].original;
              Data^.replacement := value.WiFiSSIDReplacementStrings[i-1].Replacement;
              Data^.deltalen := value.WiFiSSIDReplacementStrings[i-1].getLengthDelta;
         end;

     VST802dot11SSIDReplacementList.EndUpdate;

     CheckBox802dot11AutoReplaceRemainingSSIDs.Checked := value.WiFiReplaceRemainingSSIDs;
     Edit802dot11AutoReplaceRemainingSSIDsPrefix.Text := value.WiFiReplaceRemainingSSIDsPrefix;
     CheckBox802dot11KeepUnknownTaggedParameters.Checked := value.WiFiKeepUnknownTaggedParams;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetEthernetActionParameters (const value: tAnonymizeParameters);

var Node : pVirtualNode;
    Data : pReplacementMACNode;
    i    : integer;

begin
     RadioButtonEthernetActionReplace.Checked := value.EthernetDoReplace;
     CheckboxEthernetActionReplaceByList.Checked := value.EthernetReplaceByMACList;

     VSTMACAddressList.BeginUpdate;
     VSTMACAddressList.Clear;

     for i := 1 to length (value.EthernetMACList) do
         begin
              Node := VSTMACAddressList.AddChild (nil);
              Data := VSTMACAddressList.GetNodeData (Node);

              Data^.Original := value.EthernetMACList[i-1].Source;
              Data^.Replacement := value.EthernetMACList[i-1].Destination;
         end;

     VSTMACAddressList.EndUpdate;

     if value.EthernetRandomizeMACAddress then
        begin
             CheckBoxProcessRemainingEthernetAddresses.Checked := true;
             ComboBoxRemainingEthernetAddressesProcessMode.ItemIndex := 0;
        end
     else
         if value.EthernetBlackMarkerMACAddress then
            begin
                 CheckBoxProcessRemainingEthernetAddresses.Checked := true;
                 ComboBoxRemainingEthernetAddressesProcessMode.ItemIndex := 1;
            end
         else
             begin
                 CheckBoxProcessRemainingEthernetAddresses.Checked := false;
                 ComboBoxRemainingEthernetAddressesProcessMode.ItemIndex := 0;
             end;

     CheckboxEthernetActionLeaveVendorIntact.Checked := value.EthernetLeaveVendorIntact;

     CheckBoxEthernetRecalculateCRC.Checked := (value.EthernetRecalculateFCSMode = rcmKeepCRC);

     case value.EthernetRecalculateFCSMode of
      rcmKeepCRC,
      rcmKeepBadCRC : ComboBoxEthernetRecalculateCRCMode.ItemIndex := 0;
      rcmFixAll     : ComboBoxEthernetRecalculateCRCMode.ItemIndex := 1;
     end;

     CheckBoxEthernetPreserveTrailer.Checked := value.EthernetPreserveTrailingBytes;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetVLANActionParameters (const value: tAnonymizeParameters);

var Node : pVirtualNode;
    Data : pVLANPair;
    i    : integer;

begin
     RadioButtonVLANActionReplace.Checked := value.VLANDoReplace;
     CheckboxVLANActionReplaceByList.Checked := value.VLANDoReplaceVLANByIDList;

     VSTVLANIDList.BeginUpdate;
     VSTVLANIDList.Clear;

     for i := 1 to length (value.VLANReplaceByVLANIDList) do
         begin
              Node := VSTVLANIDList.AddChild (nil);
              Data := VSTVLANIDList.GetNodeData (Node);

              Data^.Value1 := value.VLANReplaceByVLANIDList[i-1].Value1;
              Data^.Value2 := value.VLANReplaceByVLANIDList[i-1].Value2;
         end;

     VSTVLANIDList.EndUpdate;

     CheckboxVLANActionRemoveTag.Checked := not (value.VLANRemoveMode = vrmNone);

     case value.VLANRemoveMode of
      vrmNone,
      vrmRemoveAll         : ComboBoxVLANActionRemoveTag.ItemIndex := 0;
      vrmRemoveAllListed   : ComboBoxVLANActionRemoveTag.ItemIndex := 1;
      vrmRemoveAllUnlisted : ComboBoxVLANActionRemoveTag.ItemIndex := 2;
     end;

     if CheckboxVLANActionRemoveTag.Checked then
        begin
             for i := 0 to 4096 do
                 begin
                      if value.VLANRemoveList[i] then
                         ListBoxVLANActionRemoveVLANIDs.Items.Add (i.ToString);
                 end;
        end;

        CheckBoxVLANActionRandomizeIDs.Checked := value.VLANRandomizeVLANIDs;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetTunnelingParameters (const value: tAnonymizeParameters);

begin
     RadioButtonTunnelActionReplace.Checked := value.TunnelDoReplace;

     CheckboxAYIYAActionReplace.Checked := (value.TunnelAYIYASanitizeIdentity = aisZero);

     CheckBoxRandomizeLabels.Checked := value.MPLSRandomizeLabel;
     UpDownMPLSMaximumLabelValue.Position := value.MPLSMaximumLabelValue;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetIPv4ActionParameters (const value: tAnonymizeParameters);

var Node : pVirtualNode;
    Data : pReplacementIPv4Node;
    i    : integer;

begin
     RadioButtonIPv4ActionReplace.Checked := value.IPv4DoReplace;
     CheckBoxReplaceIPv4AddressesByList.Checked := value.IPv4DoReplaceByIPList;

     VSTIPv4AddressList.BeginUpdate;
     VSTIPv4AddressList.Clear;

     for i := 1 to length (value.IPv4AddressList) do
         begin
              Node := VSTIPv4AddressList.AddChild (nil);
              Data := VSTIPv4AddressList.GetNodeData (Node);

              Data^.Original := value.IPv4AddressList[i-1].Source;
              Data^.Replacement := value.IPv4AddressList[i-1].Destination
         end;

     VSTIPv4AddressList.EndUpdate;

     CheckBoxReplaceIPv4AddressesAutoMode.Checked := value.IPV4AddressAutoMode;
     CheckBoxReplaceIPv4AddressesBySubnets.Checked := value.IPv4ReplaceBySubnetlist;

     if value.IPv4KeepHostPart then
        ComboBoxIPv4ActionSubnetListMode.ItemIndex := 0
     else
         ComboBoxIPv4ActionSubnetListMode.ItemIndex := 1;

     VSTIPv4SubnetList.BeginUpdate;
     VSTIPv4SubnetList.Clear;

     for i := 1 to length (value.IPv4SubnetList) do
         begin
              Node := VSTIPv4SubnetList.AddChild (nil);
              Data := VSTIPv4SubnetList.GetNodeData (Node);

              Data^.Original := value.IPv4SubnetList[i-1].Source;
              Data^.Replacement := value.IPv4SubnetList[i-1].Destination
         end;

     VSTIPv4SubnetList.EndUpdate;

     if value.IPv4RandomizeIPAddress then
        begin
             CheckBoxProcessRemainingIPv4Addresses.Checked := true;
             ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex := 0;
        end;

     if value.IPv4BlackMarkerIPAddress then
        begin
             CheckBoxProcessRemainingIPv4Addresses.Checked;
             ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex := 1
        end;

     CheckBoxRandomizeIPv4Multicast.Checked := value.IPv4RandomizeMulticast;
     CheckBoxRandomizeIPv4APIPA.Checked := value.IPv4RandomizeAPIPA;

     case value.IPv4PrivateAddressRandomizeMode of
      parRandomizeToPrivate : ComboBoxIPRandomizePrivateRangeMode.ItemIndex := 0;
      parRandomizeFullRange : ComboBoxIPRandomizePrivateRangeMode.ItemIndex := 1;
      parKeepOriginal       : ComboBoxIPRandomizePrivateRangeMode.ItemIndex := 2;
     end;

     CheckBoxRandomizeIPv4ID.Checked := value.IPv4RandomizeIPID;
     CheckBoxRandomizeIPv4DocumentationAddresses.Checked := value.IPv4RandomizeDocumentation;

     CheckBoxIPRecalculateCRC.Checked := (value.IPv4RecalculateCRCMode = rcmKeepCRC);

     case value.IPv4RecalculateCRCMode of
      rcmKeepCRC,
      rcmKeepBadCRC : ComboBoxIPRecalculateCRCMode.ItemIndex := 0;
      rcmFixAll     : ComboBoxIPRecalculateCRCMode.ItemIndex := 1;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetIPv6ActionParameters (const value: tAnonymizeParameters);

var node  : pVirtualNode;
    data  : pReplacementIPv6Node;
    i     : integer;

begin
     RadioButtonIPv6ActionReplace.Checked := value.IPv6DoReplace;
     CheckBoxReplaceIPv6AddressesByList.Checked := value.IPv6DoReplaceByIPList;

     VSTIPv6AddressList.BeginUpdate;
     VSTIPv6AddressList.Clear;

     for i := 1 to length (value.IPv6AddressList) do
         begin
              Node := VSTIPv6AddressList.AddChild (nil);
              Data := VSTIPv6AddressList.GetNodeData (Node);

              Data^.Original := value.IPv6AddressList[i-1].Source;
              Data^.Replacement := value.IPv6AddressList[i-1].Destination;
         end;

     VSTIPv6AddressList.EndUpdate;

     CheckBoxReplaceIPv6AddressesAutoMode.Checked := value.IPV6AddressAutoMode;
     CheckBoxReplaceIPv6AddressesBySubnets.Enabled := value.IPv6ReplaceBySubnetlist;

     VSTIPv6SubnetList.BeginUpdate;
     VSTIPv6SubnetList.Clear;

     for i := 1 to length (value.IPv4SubnetList) do
         begin
              Node := VSTIPv6SubnetList.AddChild (nil);
              Data := VSTIPv6SubnetList.GetNodeData (Node);

              Data^.Original := value.IPv6SubnetList[i-1].Source;
              Data^.Replacement := value.IPv6SubnetList[i-1].Destination;
         end;

     VSTIPv6SubnetList.EndUpdate;

     CheckBoxProcessRemainingIPv6Addresses.Enabled := not (value.IPv6RandomizeAddressMode = iprNone);

     case value.IPv6RandomizeAddressMode of
      iprNone,
      iprRandomizeAndKeepPrefix     : ComboBoxRandominzeIPv6AddressMode.ItemIndex := 0;
      iprRandomizeBothAndKeepPrefix : ComboBoxRandominzeIPv6AddressMode.ItemIndex := 1;
      iprFullStatelessRandomization : ComboBoxRandominzeIPv6AddressMode.ItemIndex := 2;
      iprBlackMarker                : ComboBoxRandominzeIPv6AddressMode.ItemIndex := 3;
     end;

     CheckBoxRandomizeIPv6DocumentationAddresses.Enabled := value.IPv6RandomizeDocumentationAddr;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetICMPv4ActionParameters (const value: tAnonymizeParameters);

var node : pVirtualNode;
    data : pICMPv4TreeEntry;
    i    : integer;

begin
     RadioButtonICMPv4ActionReplace.Checked := value.ICMPv4DoReplace;
     CheckBoxICMPv4RemovePingPayload.Checked := value.ICMPv4RemovePingPayload;

     CheckBoxICMPv4RemoveMessages.Checked := value.ICMPv4RemoveICMPTypeCodes;

     VSTICMPv4RemoveMessages.BeginUpdate;

     // do not clear tree, as it is predefined for the structure

     node := VSTICMPv4RemoveMessages.GetFirst;

     while assigned (node) do
           begin
                data := VSTICMPv4RemoveMessages.GetNodeData(node);

                for i := 1 to length (value.ICMPv4RemoveByTypeCode) do
                    begin
                         if data^.TypeCode = value.ICMPv4RemoveByTypeCode[i-1] then
                            node.CheckState := csCheckedNormal;
                    end;

                node := VSTICMPv4RemoveMessages.GetNext (node);
           end;

     VSTICMPv4RemoveMessages.EndUpdate;

     CheckBoxICMPv4RecalculateCRC.Checked := (value.ICMPv4RecalculateCRCMode = rcmKeepCRC);

     case value.ICMPv4RecalculateCRCMode of
      rcmKeepCRC,
      rcmKeepBadCRC : ComboBoxICMPv4RecalculateCRCMode.ItemIndex := 0;
      rcmFixAll     : ComboBoxICMPv4RecalculateCRCMode.ItemIndex := 1;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetICMPv6ActionParameters (const value: tAnonymizeParameters);

begin
     RadioButtonICMPv6ActionReplace.Checked := value.ICMPv6DoReplace;
     CheckBoxICMPv6RemoveDNSServerFQDNs.Checked := value.ICMPv6RemoveDNSFQDNsFromOptions;
     CheckBoxICMPv6RemovePingPayload.Checked := value.ICMPv6RemovePingPayload;

     CheckBoxICMPv6RecalculateCRC.Checked := (value.ICMPv6RecalculateCRCMode = rcmKeepCRC);

     case value.ICMPv6RecalculateCRCMode of
      rcmKeepCRC,
      rcmKeepBadCRC : ComboBoxICMPv6RecalculateCRCMode.ItemIndex := 0;
      rcmFixAll     : ComboBoxICMPv6RecalculateCRCMode.ItemIndex := 1;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetTCPActionParameters (const value: tAnonymizeParameters);

var node       : pVirtualNode;
    socketdata : pSocketListEntry;
    portdata   : pPortPair;
    i          : Integer;

begin
     RadioButtonTCPActionReplace.Checked := value.TCPDoReplace;
     CheckBoxReplaceTCPPortsBySocketList.Checked := value.TCPReplaceSocketsByList;

     VSTTCPSocketList.BeginUpdate;
     VSTTCPSocketList.Clear;

     for i := 1 to length (value.TCPSocketPortList) do
         begin
              node := VSTTCPSocketList.AddChild (nil);
              socketdata := VSTTCPSocketList.GetNodeData (node);

              socketdata^.Socket := value.TCPSocketPortList[i-1];
         end;

     VSTTCPSocketList.EndUpdate;

     CheckBoxReplaceTCPPortsByList.Checked := value.TCPReplacePortsByList;

     VSTTCPPortList.BeginUpdate;
     VSTTCPPortList.Clear;

     for i := 1 to length (value.TCPPortList) do
         begin
              node := VSTTCPPortList.AddChild (nil);
              portdata := VSTTCPSocketList.GetNodeData (node);

              portdata^ := value.TCPPortList[i-1];
         end;

     VSTTCPSocketList.EndUpdate;

     CheckBoxTCPRandomizePorts.Checked := value.TCPRandomizePorts;
     CheckBoxTCPRandomizePortsKeepSystemPorts.Checked := value.TCPIgnoreSystemPorts;

     CheckBoxTCPRecalculateCRC.Checked := (value.TCPRecalculateCRC = rcmKeepCRC);

     case value.TCPRecalculateCRC of
      rcmKeepCRC,
      rcmKeepBadCRC : ComboBoxTCPRecalculateCRCMode.ItemIndex := 0;
      rcmFixAll     : ComboBoxTCPRecalculateCRCMode.ItemIndex := 1;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetUDPActionParameters (const value: tAnonymizeParameters);

var node       : pVirtualNode;
    socketdata : pSocketListEntry;
    portdata   : pPortPair;
    i          : Integer;

begin
     RadioButtonUDPActionReplace.Checked := value.UDPDoReplace;
     CheckBoxReplaceUDPPortsBySocketList.Checked := value.UDPReplaceSocketsByList;

     VSTUDPSocketList.BeginUpdate;
     VSTUDPSocketList.Clear;

     for i := 1 to length (value.UDPSocketPortList) do
         begin
              node := VSTUDPSocketList.AddChild (nil);
              socketdata := VSTUDPSocketList.GetNodeData (node);

              socketdata^.Socket := value.UDPSocketPortList[i-1];
         end;

     VSTUDPSocketList.EndUpdate;

     CheckBoxReplaceUDPPortsByList.Checked := value.UDPReplacePortsByList;

     VSTUDPPortList.BeginUpdate;
     VSTUDPPortList.Clear;

     for i := 1 to length (value.UDPPortList) do
         begin
              node := VSTUDPPortList.AddChild (nil);
              portdata := VSTUDPSocketList.GetNodeData (node);

              portdata^ := value.UDPPortList[i-1];
         end;

     VSTUDPSocketList.EndUpdate;

     CheckBoxUDPRandomizePorts.Checked := value.UDPRandomizePorts;
     CheckBoxUDPRandomizePortsKeepSystemPorts.Checked := value.UDPIgnoreSystemPorts;

     CheckBoxUDPRecalculateCRC.Checked := (value.UDPRecalculateCRC = rcmKeepCRC);

     case value.UDPRecalculateCRC of
      rcmKeepCRC,
      rcmKeepBadCRC : ComboBoxUDPRecalculateCRCMode.ItemIndex := 0;
      rcmFixAll     : ComboBoxUDPRecalculateCRCMode.ItemIndex := 1;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetDHCPv4ActionParameters (const value: tAnonymizeParameters);

begin
     RadioButtonDHCPv4ActionReplace.Checked := value.DHCPv4DoReplace;
     CheckBoxDHCPv4HandleFQDNs.Checked := value.DHCPv4ReplaceHostName;

     case value.DHCPv4ReplaceHostnameMode of
      rhnUsePlaceholders : ComboBoxDHCPv4ActionFQDNReplaceMode.ItemIndex := 0;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetApplicationParameters (const value: tAnonymizeParameters);

begin
     RadioButtonRTPSActionReplace.Checked := value.RTPSDoReplace;

     if value.RTPSReplacementBlackMarker then
        ComboBoxRTPSActionReplaceMode.ItemIndex := 0
     else
         ComboBoxRTPSActionReplaceMode.ItemIndex := 1;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetOutputParameters (const value: tAnonymizeParameters);

begin
     EditOutputFilename.text := value.OutputFilename;

     case value.OutputTargetLocation of
      ltSameDirectory     : begin
                                 RadioButtonFileOutputSameDirectory.Checked := true;

                            end;
      ltSubdirectory      : begin
                                 RadioButtonFileOutputToSubdirectory.Checked := true;
                                 LabeledEditOutputToSubdirectory.Text := value.OutputPath;
                            end;
      ltAbsoluteDirectory : begin
                                 RadioButtonFileOutputToAbsoluteDirectory.Checked := true;
                                 LabeledEditOutputToDirectory.Text := value.OutputPath;
                            end;
     end;

     EditOutputFilename.Text := value.OutputFilename;

     CheckBoxSetFileDateTo.Checked := (value.OutputTimestamp <> tsmNone);

     case value.OutputTimestamp of
      tsmNone,
      tsmOriginalFile : ComboBoxSetFileTimestampScope.ItemIndex := 0;
      tsmFirstFrame   : ComboBoxSetFileTimestampScope.ItemIndex := 1;
      tsmLastFrame    : ComboBoxSetFileTimestampScope.ItemIndex := 2;
     end;

end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetSettingsParameters (const value: tAnonymizeParameters);

begin
     CheckBoxUseDiskBasedDatabaseFile.Checked :=  value.ReplacementDBUseDiskFile;

     CheckBoxKeepDatabaseFileAfterFinish.Checked := value.ReplacementDBKeepDiskFile;
     CheckBoxWipeDatabaseOnJobStart.Checked := value.ReplacementDBWipeOnStart;
     CheckBoxForceDatabasePath.Checked := value.ReplacementDBForcePath;

     EditReplacementDBPath.Text := value.ReplacementDBFilePath;

     CheckboxAdvReassembleIPFragments.Checked := not value.AdvDoNotReassembleIPFragments;
     UpDownAdvReassemblyChainTimeout.Position := value.AdvReassemblyChainTimeoutMS;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.setAnonymizationParameters (const value: tAnonymizeParameters);

begin
     SetPayloadActionParameters (value);
     SetPCAPngActionParameters (value);
     Set802dot11ActionParameters (value);
     SetEthernetActionParameters (value);
     SetVLANActionParameters (value);
     SetTunnelingParameters (value);
     SetIPv4ActionParameters (value);
     SetIPv6ActionParameters (value);
     SetICMPv4ActionParameters (value);
     SetICMPv6ActionParameters (value);
     SetTCPActionParameters (value);
     SetUDPActionParameters (value);
     SetDHCPv4ActionParameters (value);
     SetApplicationParameters (value);
     SetOutputParameters (value);
     SetSettingsParameters (value);
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.SettingIsActive (Checkbox : tCheckbox) : boolean;

begin
     result := Checkbox.Enabled and Checkbox.Checked;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.UpdateTreeNode (TabIndex: integer; Status: tNavigationNodeStatusSet);

var node : pVirtualNode;
    data : pNaviNode;

begin
     node := priv_tabvalues[TabIndex].Node;

     if assigned (node) then
        begin
             data := VSTNavigation.GetNodeData (node);

             data^.Status := Status;
             VSTNavigation.RepaintNode (node);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.UpdateTreeNode (TabIndex: integer; SetActive: boolean);

begin
     if SetActive then
        SetTreeNodeStatusFlag (TabIndex, nsActive)
     else
         ClearTreeNodeStatusFlag (TabIndex, nsActive);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SetTreeNodeStatusFlag (TabIndex: integer; Status : tNavigationNodeStatus);

var node : pVirtualNode;
    data : pNaviNode;

begin
     node := priv_tabvalues[TabIndex].Node;

     if assigned (node) then
        begin
             data := VSTNavigation.GetNodeData (node);

             data^.Status := data^.Status + [Status];
             VSTNavigation.RepaintNode (node);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ClearTreeNodeStatusFlag (TabIndex: integer; Status: tNavigationNodeStatus);

var node : pVirtualNode;
    data : pNaviNode;

begin
     node := priv_tabvalues[TabIndex].Node;

     if assigned (node) then
        begin
             data := VSTNavigation.GetNodeData (node);

             data^.Status := data^.Status - [Status];
             VSTNavigation.RepaintNode (node);
        end;
end;

(* ------------------------------------------- *)
{
procedure TFormTaskAnonymize.UpdateTreeNode (TreeNode: TTreeNode; SetBold: boolean);

var treeItem: TTVItem;

begin
     if not Assigned (treeNode) then
        Exit;

     with treeItem do
          begin
               hItem := treeNode.ItemId;
               stateMask := TVIS_BOLD;
               mask := TVIF_HANDLE or TVIF_STATE;

               if SetBold then
                  state := TVIS_BOLD
               else
                   state := 0;
          end;

     TreeView_SetItem(treeNode.Handle, treeItem) ;
end;
}
(* ------------------------------------------- *)

procedure TFormTaskAnonymize.LoadSettings (const Filename: string);

var StorMan : tAnonTaskFormStorageManager;

begin
     StorMan := tAnonTaskFormStorageManager.create(self);

     StorMan.retrieveFormFromDB (Filename);
     StorMan.CheckAddOnTablesBeforeLoad;

     // Load Trees

     StorMan.LoadMACAddressList (VSTMACAddressList);
     StorMan.LoadIPv4AddressList (VSTIPv4AddressList);
     StorMan.LoadIPv4SubnetList (VSTIPv4SubnetList);
     StorMan.LoadIPv6AddressList (VSTIPv6AddressList);
     StorMan.LoadIPv6SubnetList (VSTIPv6SubnetList);
     StorMan.LoadICMPv4TypeList (VSTICMPv4RemoveMessages);
     StorMan.LoadVLANIDList (VSTVLANIDList);
     StorMan.LoadTCPSocketList (VSTTCPSocketList);
     StorMan.LoadTCPPortList (VSTTCPPortList);
     StorMan.LoadUDPSocketList (VSTTCPSocketList);
     StorMan.LoadUDPPortList (VSTUDPPortList);
     StorMan.LoadPayloadReplacementStrings (VSTPayloadReplacementStrings);
     StorMan.Load802dot11SSIDList (VST802dot11SSIDReplacementList);

     // Clean Up

     StorMan.free;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.SaveSettings (const Filename: string);

var StorMan : tAnonTaskFormStorageManager;

begin
     try
        if fileexists (Filename) then
           deletefile (Filename);
     except
           MessageDlg('Error: cannot store task settings to file "' + Filename + '". It may be write protected.', mtError, [mbOK], 0);
     end;

     StorMan := tAnonTaskFormStorageManager.create(self);

     StorMan.storeFormToDB (Filename, TaskTypeAnonymize);

     // Store Trees

     StorMan.StoreMACAddressList (VSTMACAddressList);
     StorMan.StoreIPv4AddressList (VSTIPv4AddressList);
     StorMan.StoreIPv4SubnetList (VSTIPv4SubnetList);
     StorMan.StoreIPv6AddressList (VSTIPv6AddressList);
     StorMan.StoreIPv6SubnetList (VSTIPv6SubnetList);
     StorMan.StoreICMPv4TypeList (VSTICMPv4RemoveMessages);
     StorMan.StoreVLANIDList (VSTVLANIDList);
     StorMan.StoreTCPSocketList (VSTTCPSocketList);
     StorMan.StoreTCPPortList (VSTTCPPortList);
     StorMan.StoreUDPSocketList (VSTTCPSocketList);
     StorMan.StoreUDPPortList (VSTUDPPortList);
     StorMan.StorePayLoadReplacementStrings (VSTPayloadReplacementStrings);
     StorMan.Store802dot11SSIDList (VST802dot11SSIDReplacementList);

     // Clean up

     StorMan.free;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onEditKeyUp (Sender: TObject; var Key: Word; Shift: TShiftState);

begin
     if ssCtrl in Shift then
        begin
             case key of
              65 : (Sender as TEdit).SelectAll;
              67 : Clipboard.AsText := (Sender as TEdit).Text;
              86 : (Sender as TEdit).Text := Clipboard.AsText;
             end;
        end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onExitMPLSMaximumLabelValue(Sender: TObject);

var value : integer;
    dummy : integer;

begin
     val (EditMPLSMaximumLabelValue.Text, value, dummy);

     if value < 32 then
        EditMPLSMaximumLabelValue.Text := '32';
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onLabeledEditKeyUp (Sender: TObject; var Key: Word; Shift: TShiftState);

begin
     if ssCtrl in Shift then
        begin
             case key of
              65 : (Sender as TLabeledEdit).SelectAll;
              67 : Clipboard.AsText := (Sender as TLabeledEdit).Text;
              86 : (Sender as TLabeledEdit).Text := Clipboard.AsText;
             end;
        end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTICMPv4RemoveMessageGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var data     : pICMPv4TreeEntry;

begin
     data := VSTICMPv4RemoveMessages.GetNodeData (node);

     case column of
      0 : if data^.ICMPShowType then
             CellText := IntToStr (data^.TypeCode.ICMPv4Type)
          else
              CellText := '';
      1 : if data^.ICMPShowCode then
             CellText := IntToStr (data^.TypeCode.ICMPv4Code)
          else
              CellText := '';
      2 : CellText := data^.Description;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTICMPv4RemoveMessagesChecked (Sender: TBaseVirtualTree; Node: PVirtualNode);

var cnode    : pVirtualNode;

begin
     cnode := VSTICMPv4RemoveMessages.GetFirstChild (node);

     // Set checked state to that of the parent node

     while cnode <> nil do
           begin
                cnode.CheckState := node.CheckState;
                VSTICMPv4RemoveMessages.RepaintNode (cnode);

                cnode := VSTICMPv4RemoveMessages.GetNextSibling(cnode);
           end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4AddressListDblClick (Sender: TObject);

begin
     ButtonIPv4AddressListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4AddressListDrawText (Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);

var Data     : pReplacementIPv4Node;
    CellText : string;

begin
     Data := VSTIPv4AddressList.GetNodeData (Node);

     case Column of
      0 : CellText := Data^.Original.ValueAsString;
      1 : CellText := Data^.Replacement.ValueAsString;
      2 : CellText := DefinedByToString (Data^.DefinedBy);
     end;

     TargetCanvas.TextOut(CellRect.Left, CellRect.Top + 2, CellText);

     DefaultDraw := false;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4AddressListEditing (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);

begin
     Allowed := (column < 2);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4AddressListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     ButtonIPv4AddressListEdit.Enabled := (Sender.SelectedCount = 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4AddressListFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTIPv4AddressList.FocusedNode = nil then
        begin
             ButtonIPv4AddressListEdit.Enabled := false;
             ButtonIPv4AddressListRemove.Enabled := false;
        end
     else
         begin
              ButtonIPv4AddressListEdit.Enabled := (Sender.SelectedCount = 1);
              ButtonIPv4AddressListRemove.Enabled := true;
         end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4AddressListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var Data : pReplacementIPv4Node;

begin
     Data := VSTIPv4AddressList.GetNodeData(Node);

     case Column of
      0 : CellText := Data^.Original.ValueAsString;
      1 : CellText := Data^.Replacement.ValueAsString;
      2 : CellText := DefinedByToString (Data^.DefinedBy);
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4AddressListNewText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);

var Data : pReplacementIPv4Node;

begin
     Data := VSTIPv4AddressList.GetNodeData(Node);

     if isValidIPv4String (NewText) then
        begin
             case Column of
              0 : Data^.Original.setValueFromString (NewText);
              1 : Data^.Replacement.setValueFromString (NewText);
             end;

             Data^.DefinedBy := defUser;
        end
     else
         MessageDlg('Error: invalid address format!', mtError, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4SubnetListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     ButtonIPv4SubnetListEdit.Enabled := (Sender.SelectedCount = 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4SubnetListDblClick (Sender: TObject);

begin
     ButtonIPv4SubnetListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4SubnetListDrawText (Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);

var Data     : pReplacementIPv4Node;
    CellText : string;

begin
     Data := VSTIPv4SubnetList.GetNodeData(Node);

     case Column of
      0 : CellText := Data^.Original.ValueAsCIDRString;
      1 : CellText := Data^.Replacement.ValueAsCIDRString;
     end;

     TargetCanvas.TextOut(CellRect.Left, CellRect.Top + 2, CellText);

     DefaultDraw := false;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4SubnetListFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTIPv4SubnetList.FocusedNode = nil then
        begin
             ButtonIPv4SubnetListEdit.Enabled := false;
             ButtonIPv4SubnetListRemove.Enabled := false;
        end
     else
         begin
              ButtonIPv4SubnetListEdit.Enabled := true;
              ButtonIPv4SubnetListRemove.Enabled := true;
         end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4SubnetListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var data : pReplacementIPv4Node;

begin
     data := VSTIPv4SubnetList.GetNodeData(Node);

     case column of
     0 : CellText := data^.Original.ValueAsCIDRString;
     1 : CellText := data^.Replacement.ValueAsCIDRString;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv4SubnetListNewText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);

var Data : pReplacementIPv4Node;

begin
     Data := VSTIPv4AddressList.GetNodeData(Node);

     if isValidIPv4Subnet (NewText) then
        begin
             case Column of
              0 : Data^.Original.setValueFromCIDRString(NewText);
              1 : Data^.Replacement.setValueFromCIDRString(NewText);
             end;
        end
     else
         MessageDlg('Error: invalid address format!', mtError, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6AddressListDblClick (Sender: TObject);

begin
     ButtonIPv6AddressListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6AddressListDrawText (Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);

var Data     : pReplacementIPv6Node;
    CellText : string;

begin
     Data := VSTIPv6AddressList.GetNodeData (Node);

     case Column of
      0 : CellText := Data^.Original.ValueAsString;
      1 : CellText := Data^.Replacement.ValueAsString;
      2 : CellText := DefinedByToString (Data^.DefinedBy);
     end;

     TargetCanvas.TextOut(CellRect.Left, CellRect.Top + 2, CellText);

     DefaultDraw := false;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6AddressListEditing (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);

begin
     Allowed := (column < 2);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6AddressListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     ButtonIPv6AddressListEdit.Enabled := (Sender.SelectedCount = 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6AddressListFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTIPv6AddressList.FocusedNode = nil then
        begin
             ButtonIPv6AddressListEdit.Enabled := false;
             ButtonIPv6AddressListRemove.Enabled := false;
        end
     else
         begin
              ButtonIPv6AddressListEdit.Enabled := (Sender.SelectedCount = 1);;
              ButtonIPv6AddressListRemove.Enabled := true;
         end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6AddressListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var data : pReplacementIPv6Node;

begin
     data := VSTIPv6AddressList.GetNodeData (Node);

     case column of
     0 : CellText := data^.Original.ValueAsString;
     1 : CellText := data^.Replacement.ValueAsString;
     2 : CellText := DefinedByToString (data^.DefinedBy);
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6AddressListNewText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);

var Data : pReplacementIPv6Node;

begin
     Data := VSTIPv6AddressList.GetNodeData (Node);

     if isValidIPv6String (NewText) then
        begin
             case Column of
              0 : Data^.Original.setValueFromString (NewText);
              1 : Data^.Replacement.setValueFromString (NewText);
             end;

             Data^.DefinedBy := defUser;
        end
     else
         MessageDlg('Error: invalid address format!', mtError, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6SubnetListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     ButtonIPv6SubnetListEdit.Enabled := (Sender.SelectedCount = 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6SubnetListDblClick (Sender: TObject);

begin
     ButtonIPv6SubnetListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6SubnetListDrawText (Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);

var Data     : pReplacementIPv6Node;
    CellText : string;

begin
     Data := VSTIPv6SubnetList.GetNodeData(Node);

     case Column of
      0 : CellText := Data^.Original.ValueAsSlashedNotationString;
      1 : CellText := Data^.Replacement.ValueAsSlashedNotationString;
     end;

     TargetCanvas.TextOut(CellRect.Left, CellRect.Top + 2, CellText);

     DefaultDraw := false;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6SubnetListFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTIPv6SubnetList.FocusedNode = nil then
        begin
             ButtonIPv6SubnetListEdit.Enabled := false;
             ButtonIPv6SubnetListRemove.Enabled := false;
        end
     else
         begin
              ButtonIPv6SubnetListEdit.Enabled := true;
              ButtonIPv6SubnetListRemove.Enabled := true;
         end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6SubnetListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var data : pReplacementIPv6Node;

begin
     data := VSTIPv6SubnetList.GetNodeData(Node);

     case column of
     0 : CellText := data^.Original.ValueAsSlashedNotationString;
     1 : CellText := data^.Replacement.ValueAsSlashedNotationString
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTIPv6SubnetListNewText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);

var Data : pReplacementIPv6Node;

begin
     Data := VSTIPv6AddressList.GetNodeData(Node);

     if isValidIPv6Subnet (NewText) then
        begin
             case Column of
              0 : Data^.Original.setValueFromStringWithMask (NewText);
              1 : Data^.Replacement.setValueFromStringWithMask (NewText);
             end;
        end
     else
         MessageDlg('Error: invalid address format!', mtError, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PrepareReplacementStringEditor (Tree : tVirtualStringTree);

var node  : PVirtualNode;
    data  : pReplacementEditorData;

begin
     if Tree.RootNodeCount = 0 then
        begin
             // Create the first, emtpy row

             node := Tree.AddChild (nil);
             data := Tree.GetNodeData (node);

             data^.initialize;
        end
     else
         begin
              node := Tree.GetLast(nil);
              data := Tree.GetNodeData (node);

              if (data^.original <> '') then
                 begin
                      // Last node is already in use, add another emtpy one

                      node := Tree.AddChild (nil);
                      data := Tree.GetNodeData (node);

                      data^.initialize;
                 end;
         end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangePayloadSettings (Sender: TObject);

var help  : boolean;
    help2 : string;

begin
     ComboBoxGeneralPayloadRemovalMode.Enabled := CheckboxGeneralActionPacketTruncateUnknownPayload.Enabled and CheckboxGeneralActionPacketTruncateUnknownPayload.Checked;
     CheckboxGeneralActionPacketTruncateReAddPadding.Enabled := ComboBoxGeneralPayloadRemovalMode.Enabled and (ComboBoxGeneralPayloadRemovalMode.ItemIndex > 0);
     CheckboxGeneralActionPacketTruncateReAddPadding.Visible := ComboBoxGeneralPayloadRemovalMode.Enabled and (ComboBoxGeneralPayloadRemovalMode.ItemIndex > 0);

     LabelReplacePayloadPattern.Enabled := ComboBoxGeneralPayloadRemovalMode.Enabled and (ComboBoxGeneralPayloadRemovalMode.ItemIndex = 2);
     EditPayloadOverwritePattern.Enabled := LabelReplacePayloadPattern.Enabled;
     ComboBoxGeneralPacketSlicingLayer.Enabled := CheckboxGeneralActionPacketTruncateAfterLayer.Enabled and CheckboxGeneralActionPacketTruncateAfterLayer.Checked;
     EditGeneralPacketSlicingOffset.Enabled := CheckboxGeneralActionPacketTruncateAfterOffset.Enabled and CheckboxGeneralActionPacketTruncateAfterOffset.Checked;
     UpDownGeneralPacketSlicingOffset.Enabled := EditGeneralPacketSlicingOffset.Enabled;

     CheckboxReplacePayloadStrings.Enabled := not (CheckboxGeneralActionPacketTruncateUnknownPayload.Checked or CheckboxGeneralActionPacketTruncateAfterLayer.Checked);
     CheckboxReplacePayloadStringsCaseInsensitive.Enabled := CheckboxReplacePayloadStrings.Enabled and CheckboxReplacePayloadStrings.Checked;
     CheckboxReplacePayloadStringsDoNotEnforceSameLength.Enabled := CheckboxReplacePayloadStrings.Enabled and CheckboxReplacePayloadStrings.Checked;

     VSTPayloadReplacementStrings.Enabled := CheckboxReplacePayloadStringsCaseInsensitive.Enabled;
     LabelHintPayloadEditor.Enabled := VSTPayloadReplacementStrings.Enabled;

     if CheckboxReplacePayloadStrings.Enabled and CheckboxReplacePayloadStrings.Checked then
        PrepareReplacementStringEditor (VSTPayloadReplacementStrings);

     if FormTaskAnonymize.Visible then
        begin
             help := CheckboxGeneralActionPacketTruncateUnknownPayload.Checked or
                     CheckboxGeneralActionPacketTruncateAfterLayer.Checked or
                     CheckboxGeneralActionPacketTruncateAfterOffset.Checked;

//           UpdateTreeNode (TreeViewNavigation.Items[0], help);

             if help then
                UpdateTreeNode (TabIndexPayload, [nsActive])
             else
                 UpdateTreeNode (TabIndexPayload, []);
        end;

     MemoPayloadHint.Text := '';

     if CheckboxGeneralActionPacketTruncateUnknownPayload.Checked then
        begin
             case ComboBoxGeneralPayloadRemovalMode.ItemIndex of
              0 : MemoPayloadHint.Text := 'All protocols and layers that cannot be understood or sanitized will be cut away from each packet. The resulting capture file size may turn out to be significantly smaller than the original.';
              1 : begin
                       if CheckboxGeneralActionPacketTruncateReAddPadding.Enabled and CheckboxGeneralActionPacketTruncateReAddPadding.Checked then
                          MemoPayloadHint.Text := 'All protocols and layers that cannot be understood or sanitized will be replaced by zeroes in each packet. Packets where the wiresize is greater than the capture size will be padded to the original wiresize.'
                       else
                           MemoPayloadHint.Text := 'All protocols and layers that cannot be understood or sanitized will be replaced by zeroes in each packet.';
                  end;
              2 : begin
                       if CheckboxGeneralActionPacketTruncateReAddPadding.Enabled and CheckboxGeneralActionPacketTruncateReAddPadding.Checked then
                          MemoPayloadHint.Text := 'All protocols and layers that cannot be understood or sanitized will be replaced by a pattern of the same length as the original bytes in each packet. Packets where the wiresize is greater than the capture size will be padded to the original wiresize.'
                       else
                           MemoPayloadHint.Text := 'All protocols and layers that cannot be understood or sanitized will be replaced by a pattern of the same length as the original bytes in each packet.';
                  end;
             end;
        end;

     if CheckboxGeneralActionPacketTruncateAfterLayer.Checked then
        begin
             case ComboBoxGeneralPacketSlicingLayer.ItemIndex of
              0 : help2 := 'packet will be cut exactly after the layer 2 (e.g Ethernet) protocol header in each packet.';
              1 : help2 := 'packet will be cut exactly after the layer 3 (e.g. IPv4/IPv6) protocol header in each packet.';
              2 : help2 := 'packet will be cut exactly after the layer 4 (e.g. TCP/UDP) protocol header in each packet.';
             end;

             if MemoPayloadHint.Text = '' then
                MemoPayloadHint.Text := 'Each ' + help2
             else
                 MemoPayloadHint.Text := MemoPayloadHint.Text + ' After that each ' + help2
        end;

     if CheckboxGeneralActionPacketTruncateAfterOffset.Checked then
        MemoPayloadHint.Text := MemoPayloadHint.Text + 'When all sanitization steps have been performed on a packet, it will be truncated at offset ' + EditGeneralPacketSlicingOffset.Text + '.';

     if MemoPayloadHint.Text = '' then
        begin
             if CheckboxReplacePayloadStrings.Checked then
                MemoPayloadHint.Text := 'WARNING: All unknown protocols and layers will not be modified, unless they contain strings found in the string replacement list. This may expose sensitive data!'
             else
                 MemoPayloadHint.Text := 'WARNING: All unknown protocols and layers will not be modified. This may expose sensitive data!'
        end
     else
         if CheckboxReplacePayloadStrings.Checked then
            MemoPayloadHint.Text := MemoPayloadHint.Text + ' Strings found in the payload will be replaced according to the string replacement list.'
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangePCAPngSettings (Sender: TObject);

begin
     GroupBoxPCAPngActionSettingsReplacement.Enabled := RadioButtonPCAPngActionReplace.Checked;
     CheckboxPCAPngActionSanitizeComments.Enabled := GroupBoxPCAPngActionSettingsReplacement.Enabled;
     ComboBoxPCAPngActionSanitizeCommentScope.Enabled := CheckboxPCAPngActionSanitizeComments.Enabled and CheckboxPCAPngActionSanitizeComments.Checked;
     LabelPCAPngActionCommentMethod.Enabled := CheckboxPCAPngActionSanitizeComments.Enabled and CheckboxPCAPngActionSanitizeComments.Checked;
     ComboBoxPCAPngActionSanitizeCommentMethod.Enabled := LabelPCAPngActionCommentMethod.Enabled;

     CheckboxPCAPngActionSanitizeInterfaceBlocks.Enabled := GroupBoxPCAPngActionSettingsReplacement.Enabled;
     LabelPCAPngActionSanitizeIHBInterfaceNames.Enabled := CheckboxPCAPngActionSanitizeInterfaceBlocks.Enabled and CheckboxPCAPngActionSanitizeInterfaceBlocks.Checked;
     ComboBoxPCAPngActionSanitizeIHBInterfaceNames.Enabled := LabelPCAPngActionSanitizeIHBInterfaceNames.Enabled;

     LabelPCAPngActionSanitizeIHBCaptureFilters.Enabled := CheckboxPCAPngActionSanitizeInterfaceBlocks.Enabled and CheckboxPCAPngActionSanitizeInterfaceBlocks.Checked;
     ComboBoxPCAPngActionSanitizeIHBCaptureFilters.Enabled := LabelPCAPngActionSanitizeIHBCaptureFilters.Enabled;

     CheckboxPCAPngActionSanitizeNameResolutionBlocks.Enabled := GroupBoxPCAPngActionSettingsReplacement.Enabled;
     LabelPCAPngActionSanitizeNRBMethod.Enabled := CheckboxPCAPngActionSanitizeNameResolutionBlocks.Enabled and CheckboxPCAPngActionSanitizeNameResolutionBlocks.Checked;
     ComboBoxPCAPngActionSanitizeNRBMethod.Enabled := LabelPCAPngActionSanitizeNRBMethod.Enabled;

     CheckboxPCAPngActionSanitizePacketOptions.Enabled := GroupBoxPCAPngActionSettingsReplacement.Enabled;

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[1], RadioButtonPCAPngActionReplace.Checked);

             if RadioButtonPCAPngActionReplace.Checked then
                UpdateTreeNode (TabIndexPCAPng, [nsActive])
             else
                 UpdateTreeNode (TabIndexPCAPng, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChange802dot11Settings (Sender: TObject);

begin
     GroupBox802dot11ActionSettingsReplacement.Enabled := RadioButton802dot11ActionReplace.Checked;
     Checkbox802dot11ActionReplaceSSIDByList.Enabled := GroupBox802dot11ActionSettingsReplacement.Enabled;
     VST802dot11SSIDReplacementList.Enabled := SettingIsActive (Checkbox802dot11ActionReplaceSSIDByList);
     LabelHintSSIDReplacementList.Enabled := VST802dot11SSIDReplacementList.Enabled;

     if VST802dot11SSIDReplacementList.Enabled then
        PrepareReplacementStringEditor (VST802dot11SSIDReplacementList);

     CheckBox802dot11AutoReplaceRemainingSSIDs.Enabled := GroupBox802dot11ActionSettingsReplacement.Enabled;
     Edit802dot11AutoReplaceRemainingSSIDsPrefix.Enabled := SettingIsActive (CheckBox802dot11AutoReplaceRemainingSSIDs);
     CheckBox802dot11KeepUnknownTaggedParameters.Enabled := GroupBox802dot11ActionSettingsReplacement.Enabled;

     if RadioButton802dot11ActionPassthrough.Checked then
        Memo802dot11ActionHint.Text := 'The 802.11 layer will not be modified.';

     if RadioButton802dot11ActionReplace.Checked then
        Memo802dot11ActionHint.Text := '802.11 content will be replaced based on the replacement settings below.';

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
             if RadioButton802dot11ActionReplace.Checked then
                UpdateTreeNode (TabIndex802dot11, [nsActive])
             else
                 UpdateTreeNode (TabIndex802dot11, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeEthernetSettings (Sender: TObject);

var basetext : string;

begin
     GroupBoxEthernetActionSettingsReplacement.Enabled := RadioButtonEthernetActionReplace.Checked;
     CheckboxEthernetActionReplaceByList.Enabled := GroupBoxEthernetActionSettingsReplacement.Enabled;

     VSTMACAddressList.Enabled := CheckboxEthernetActionReplaceByList.Enabled and CheckboxEthernetActionReplaceByList.Checked;
     ButtonEthernetMACListAdd.Enabled := VSTMACAddressList.Enabled;
     ButtonEthernetMACListEdit.Enabled := VSTMACAddressList.Enabled and (VSTMACAddressList.FocusedNode <> nil);
     ButtonEthernetMACListRemove.Enabled := VSTMACAddressList.Enabled and (VSTMACAddressList.FocusedNode <> nil);

     CheckboxEthernetActionReplaceByList.Enabled := GroupBoxEthernetActionSettingsReplacement.Enabled;
     CheckBoxProcessRemainingEthernetAddresses.Enabled := GroupBoxEthernetActionSettingsReplacement.Enabled;

     CheckboxEthernetActionLeaveVendorIntact.Enabled := GroupBoxEthernetActionSettingsReplacement.Enabled and CheckBoxProcessRemainingEthernetAddresses.Checked and (ComboBoxRemainingEthernetAddressesProcessMode.ItemIndex = 0);

     CheckBoxEthernetRecalculateCRC.Enabled := RadioButtonEthernetActionReplace.Checked;
     ComboBoxEthernetRecalculateCRCMode.Enabled := RadioButtonEthernetActionReplace.Enabled and RadioButtonEthernetActionReplace.Checked;

     CheckBoxEthernetPreserveTrailer.Enabled := GroupBoxEthernetActionSettingsReplacement.Enabled;

     // Hint box

     if RadioButtonEthernetActionPassthrough.Checked then
        MemoEthernetActionHint.Text := 'The Ethernet layer will not be modified.';

     if RadioButtonEthernetActionReplace.Checked then
        begin
             basetext := 'Ethernet MAC addresses will be replaced based on the replacement settings below.';

             if SettingIsActive (CheckboxEthernetActionReplaceByList) then
                begin
                     if SettingIsActive (CheckBoxProcessRemainingEthernetAddresses) then
                        begin
                             case ComboBoxRemainingEthernetAddressesProcessMode.ItemIndex of
                              0 : MemoEthernetActionHint.Text := basetext + ' The MAC address lists has priority over randomization, so only MAC addresses that are not found in the list are randimized.';
                              1 : MemoEthernetActionHint.Text := basetext + ' The MAC address lists has priority over randomization, so only MAC addresses that are not found in the list are set to zero.';
                             end;
                        end
                     else
                         MemoEthernetActionHint.Text := basetext + ' Only addresses found in the MAC address list will be replaced.';
                end
             else
                 begin
                      if SettingIsActive (CheckBoxProcessRemainingEthernetAddresses) then
                         begin
                              case ComboBoxRemainingEthernetAddressesProcessMode.ItemIndex of
                               0 : MemoEthernetActionHint.Text := basetext + ' All MAC addresses will be randomized.';
                               1 : MemoEthernetActionHint.Text := basetext + ' All MAC addresses will be zeroed.';
                              end;
                         end
                      else
                          MemoEthernetActionHint.Text := 'The Ethernet layer will not be modified because no replacement option is set.'
                 end;
        end;

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[3], RadioButtonEthernetActionReplace.Checked);

             if RadioButtonEthernetActionReplace.Checked then
                UpdateTreeNode (TabIndexEthernet, [nsActive])
             else
                 UpdateTreeNode (TabIndexEthernet, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeVLANSettings (Sender: TObject);

var RemoveAllVlans : boolean;

begin
     CheckboxVLANActionReplaceByList.Enabled := RadioButtonVLANActionReplace.Checked;
     VSTVLANIDList.Enabled := CheckboxVLANActionReplaceByList.Enabled and CheckboxVLANActionReplaceByList.Checked;
     ButtonVLANListAdd.Enabled := VSTVLANIDList.Enabled;
     ButtonVLANListEdit.Enabled := VSTVLANIDList.Enabled and (VSTVLANIDList.SelectedCount > 0);
     ButtonVLANListRemove.Enabled := VSTVLANIDList.Enabled and (VSTVLANIDList.SelectedCount > 0);

     CheckboxVLANActionRemoveTag.Enabled := RadioButtonVLANActionReplace.Checked;
     ComboBoxVLANActionRemoveTag.Enabled := CheckboxVLANActionRemoveTag.Enabled and CheckboxVLANActionRemoveTag.Checked;
     ListBoxVLANActionRemoveVLANIDs.Enabled := ComboBoxVLANActionRemoveTag.Enabled and (ComboBoxVLANActionRemoveTag.ItemIndex > 0);

     ButtonListBoxVLANActionRemoveVLANIDsAdd.Enabled := ListBoxVLANActionRemoveVLANIDs.Enabled;
     ButtonListBoxVLANActionRemoveVLANIDsRemove.Enabled := ListBoxVLANActionRemoveVLANIDs.Enabled and (ListBoxVLANActionRemoveVLANIDs.ItemIndex > -1);
     ButtonListBoxVLANActionRemoveVLANIDsClear.Enabled := ListBoxVLANActionRemoveVLANIDs.Enabled and (ListBoxVLANActionRemoveVLANIDs.Items.Count > 0);

     RemoveAllVlans := ComboBoxVLANActionRemoveTag.Enabled and (ComboBoxVLANActionRemoveTag.ItemIndex = 0);

     CheckBoxVLANActionRandomizeIDs.Enabled := RadioButtonVLANActionReplace.Checked and not RemoveAllVLANs;

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[4], RadioButtonVLANActionReplace.Checked);

             if RadioButtonVLANActionReplace.Checked then
                UpdateTreeNode (TabIndexVLAN, [nsActive])
             else
                 UpdateTreeNode (TabIndexVLAN, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeTunnelSettings (Sender: TObject);

begin
     // Settings

     GroupBoxTunnelActionSettingsAYIYAReplacement.Enabled := RadioButtonTunnelActionReplace.Checked;
     GroupBoxTunnelActionSettingsMPLSReplacement.Enabled := RadioButtonTunnelActionReplace.Checked;

     CheckboxAYIYAActionReplace.Enabled := GroupBoxTunnelActionSettingsAYIYAReplacement.Enabled;

     CheckBoxRandomizeLabels.Enabled := GroupBoxTunnelActionSettingsMPLSReplacement.Enabled;
     LabelMPLSMaximumLabelValue.Enabled := SettingIsActive (CheckBoxRandomizeLabels);
     EditMPLSMaximumLabelValue.Enabled := LabelMPLSMaximumLabelValue.Enabled;
     UpDownMPLSMaximumLabelValue.Enabled := EditMPLSMaximumLabelValue.Enabled;

     // Hint box

     if RadioButtonTunnelActionReplace.Checked then
        MemoTunnelActionHint.Text := 'Tunnel layers will be modified based on the settings below.'
     else
         MemoTunnelActionHint.Text := 'Tunnel layer information will not be modified.';

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[5], RadioButtonTunnelActionReplace.Checked);

             if RadioButtonTunnelActionReplace.Checked then
                UpdateTreeNode (TabIndexTunnel, [nsActive])
             else
                 UpdateTreeNode (TabIndexTunnel, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeIPv4Settings (Sender: TObject);

var basetext : string;

begin
     CheckBoxReplaceIPv4AddressesByList.Enabled := RadioButtonIPv4ActionReplace.Checked;
     CheckBoxReplaceIPv4AddressesAutoMode.Enabled := CheckBoxReplaceIPv4AddressesByList.Enabled and CheckBoxReplaceIPv4AddressesByList.Checked;
     VSTIPv4AddressList.Enabled := CheckBoxReplaceIPv4AddressesByList.Enabled and CheckBoxReplaceIPv4AddressesByList.Checked;
     ButtonIPv4AddressListAdd.Enabled := VSTIPv4AddressList.Enabled;
     ButtonIPv4AddressListEdit.Enabled := VSTIPv4AddressList.Enabled;
     ButtonIPv4AddressListRemove.Enabled := VSTIPv4AddressList.Enabled and (VSTIPv4AddressList.SelectedCount > 0);

     CheckBoxReplaceIPv4AddressesBySubnets.Enabled := RadioButtonIPv4ActionReplace.Checked;
     ComboBoxIPv4ActionSubnetListMode.Enabled := CheckBoxReplaceIPv4AddressesBySubnets.Enabled and CheckBoxReplaceIPv4AddressesBySubnets.Checked;
     VSTIPv4SubnetList.Enabled := ComboBoxIPv4ActionSubnetListMode.Enabled;
     ButtonIPv4SubnetListAdd.Enabled := VSTIPv4SubnetList.Enabled;
     ButtonIPv4SubnetListEdit.Enabled := VSTIPv4SubnetList.Enabled and (VSTIPv4SubnetList.SelectedCount > 0);
     ButtonIPv4SubnetListRemove.Enabled := VSTIPv4SubnetList.Enabled and (VSTIPv4SubnetList.SelectedCount > 0);

     CheckBoxProcessRemainingIPv4Addresses.Enabled := RadioButtonIPv4ActionReplace.Checked;
     ComboBoxRemainingIPv4AddressesProcessMode.Enabled := CheckBoxProcessRemainingIPv4Addresses.Enabled and CheckBoxProcessRemainingIPv4Addresses.Checked;
     LabelRandomizeIPv4Include.Enabled := CheckBoxProcessRemainingIPv4Addresses.Enabled and CheckBoxProcessRemainingIPv4Addresses.Checked and (ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex = 0);
     CheckBoxRandomizeIPv4Multicast.Enabled := LabelRandomizeIPv4Include.Enabled;
     CheckBoxRandomizeIPv4APIPA.Enabled := LabelRandomizeIPv4Include.Enabled;
     CheckBoxRandomizeIPv4DocumentationAddresses.Enabled := LabelRandomizeIPv4Include.Enabled;
     LabelRandomizeIPv4PrivateMode.Enabled := LabelRandomizeIPv4Include.Enabled;
     ComboBoxIPRandomizePrivateRangeMode.Enabled := LabelRandomizeIPv4PrivateMode.Enabled;

     CheckBoxRandomizeIPv4ID.Enabled := RadioButtonIPv4ActionReplace.Checked;
     CheckBoxIPRecalculateCRC.Enabled := RadioButtonIPv4ActionReplace.Checked;
     ComboBoxIPRecalculateCRCMode.Enabled := CheckBoxIPRecalculateCRC.Enabled and CheckBoxIPRecalculateCRC.Checked;

     // Hint Box

     if RadioButtonIPv4ActionPassThrough.Checked then
        MemoIPv4ActionHint.Text := 'The IPv4 layer will not be modified.';

     if RadioButtonIPv4ActionReplace.Checked then
        begin
             basetext := 'IPv4 addresses will be replaced based on the replacement settings below.';

             if SettingIsActive (CheckBoxReplaceIPv4AddressesByList) then
                begin
                     // Replace by Address List

                     if SettingIsActive (CheckBoxReplaceIPv4AddressesBySubnets) then
                        begin
                             if SettingIsActive (CheckBoxProcessRemainingIPv4Addresses) then
                                begin
                                     case ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex of
                                      0 : MemoIPv4ActionHint.Text := basetext + ' The IPv4 address lists has priority over the Subnet List, which has priority over randomization. Addresses not found in either list are randomized.';
                                      1 : MemoIPv4ActionHint.Text := basetext + ' The IPv4 address lists has priority over the Subnet List, which has priority over randomization. Addresses not found in either list are zeroed.';
                                     end;
                                end
                             else
                                 MemoIPv4ActionHint.Text := basetext + ' The IPv4 address lists has priority over the Subnet List. If an address matches neither list it will not be replaced.';
                        end
                     else
                         if SettingIsActive (CheckBoxProcessRemainingIPv4Addresses) then
                            begin
                                 case ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex of
                                  0 : MemoIPv4ActionHint.Text := basetext + ' The IPv4 address lists has priority over randomization, so only addresses that are not found in the list are randomized.';
                                  1 : MemoIPv4ActionHint.Text := basetext + ' The IPv4 address lists has priority over randomization, so only addresses that are not found in the list are zeroed.';
                                 end;
                            end
                         else
                             MemoIPv4ActionHint.Text := basetext + ' Only addresses found in the IP address list will be replaced.';
                end
             else
                 begin
                     if SettingIsActive (CheckBoxReplaceIPv4AddressesBySubnets) then
                        begin
                             if SettingIsActive (CheckBoxProcessRemainingIPv4Addresses) then
                                begin
                                     case ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex of
                                      0 : MemoIPv4ActionHint.Text := basetext + ' The IPv4 subnet lists has priority over randomization.';
                                      1 : MemoIPv4ActionHint.Text := basetext + ' The IPv4 subnet lists has priority over zeroing.';
                                     end;
                                end
                             else
                                 MemoIPv4ActionHint.Text := basetext + ' Only addresses found in the IPv4 subnet list will be replaced.'
                        end
                     else
                         if SettingIsActive (CheckBoxProcessRemainingIPv4Addresses) then
                            begin
                                 case ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex of
                                  0 : MemoIPv4ActionHint.Text := basetext + ' All IPv4 addresses will be randomized.';
                                  1 : MemoIPv4ActionHint.Text := basetext + ' All IPv4 addresses will be zeroed.';
                                 end;
                            end
                         else
                             MemoIPv4ActionHint.Text := 'The IPv4 layer will not be modified because no replacement option is active.'
                 end;
        end;

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[7], RadioButtonIPv4ActionReplace.Checked);

             if RadioButtonIPv4ActionReplace.Checked then
                UpdateTreeNode (TabIndexIPv4, [nsActive])
             else
                 UpdateTreeNode (TabIndexIPv4, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeIPv6Settings (Sender: TObject);

var basetext : string;

begin
     CheckBoxReplaceIPv6AddressesByList.Enabled := RadioButtonIPv6ActionReplace.Checked;
     CheckBoxReplaceIPv6AddressesAutoMode.Enabled := CheckBoxReplaceIPv6AddressesByList.Enabled and CheckBoxReplaceIPv6AddressesByList.Checked;
     VSTIPv6AddressList.Enabled := CheckBoxReplaceIPv6AddressesByList.Enabled and CheckBoxReplaceIPv6AddressesByList.Checked;
     ButtonIPv6AddressListAdd.Enabled := VSTIPv6AddressList.Enabled;
     ButtonIPv6AddressListEdit.Enabled := VSTIPv6AddressList.Enabled and (VSTIPv6AddressList.SelectedCount > 0);
     ButtonIPv6AddressListRemove.Enabled := VSTIPv6AddressList.Enabled and (VSTIPv6AddressList.SelectedCount > 0);

     CheckBoxReplaceIPv6AddressesBySubnets.Enabled := RadioButtonIPv6ActionReplace.Checked;
     VSTIPv6SubnetList.Enabled := CheckBoxReplaceIPv6AddressesBySubnets.Enabled and CheckBoxReplaceIPv6AddressesBySubnets.Checked;
     ButtonIPv6SubnetListAdd.Enabled := VSTIPv6SubnetList.Enabled;
     ButtonIPv6SubnetListEdit.Enabled := VSTIPv6SubnetList.Enabled and (VSTIPv6SubnetList.SelectedCount > 0);
     ButtonIPv6SubnetListRemove.Enabled := VSTIPv6SubnetList.Enabled and (VSTIPv6SubnetList.SelectedCount > 0);
     CheckBoxProcessRemainingIPv6Addresses.Enabled := RadioButtonIPv6ActionReplace.Checked;
     ComboBoxRandominzeIPv6AddressMode.Enabled := CheckBoxProcessRemainingIPv6Addresses.Enabled and CheckBoxProcessRemainingIPv6Addresses.Checked;
     LabelRandomizeIPv6Include.Enabled := CheckBoxProcessRemainingIPv6Addresses.Enabled and CheckBoxProcessRemainingIPv6Addresses.Checked and (ComboBoxRandominzeIPv6AddressMode.ItemIndex < 3);
     CheckBoxRandomizeIPv6DocumentationAddresses.Enabled := LabelRandomizeIPv6Include.Enabled;

     // Hint Box

     if RadioButtonIPv6ActionPassThrough.Checked then
        MemoIPv6ActionHint.Text := 'The IPv6 layer will not be modified.';

     if RadioButtonIPv6ActionReplace.Checked then
        begin
             basetext := 'IPv6 addresses will be replaced based on the replacement settings below.';

             if SettingIsActive (CheckBoxReplaceIPv6AddressesByList) then
                begin
                     // Replace by Address List

                     if SettingIsActive (CheckBoxReplaceIPv6AddressesBySubnets) then
                        begin
                             if SettingIsActive (CheckBoxProcessRemainingIPv6Addresses) then
                                begin
                                     case ComboBoxRandominzeIPv6AddressMode.ItemIndex of
                                      0 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 address lists has priority over the Subnet List, which has priority over randomization. Prefixes of addresses not found in either list will be randomized while ' +
                                         'keeping the Interface IDs intact.';
                                      1 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 address lists has priority over the Subnet List, which has priority over randomization. Prefixes and Interface IDs of addresses not found in either list will be ' +
                                          'randomized while synchronizing prefixes.';
                                      2 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 address lists has priority over the Subnet List, which has priority over randomization. Prefixes and Interface IDs of addresses not found in either list will be ' +
                                          'randomized without synchronizing prefixes.';
                                      3 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 address lists has priority over the Subnet List, which has priority over randomization. Prefixes and Interface IDs of addresses not found in either list will be ' +
                                          'zeroed.'
                                     end;
                                end
                             else
                                 MemoIPv6ActionHint.Text := basetext + ' The IPv6 address lists has priority over the Subnet List. If an address matches neither list it will not be replaced.';
                        end
                     else
                         if SettingIsActive (CheckBoxProcessRemainingIPv6Addresses) then
                            begin
                                 case ComboBoxRandominzeIPv6AddressMode.ItemIndex of
                                  0 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 address lists has priority over randomization, so only addresses that are not found in the list are randomized keeping the Interface IDs intact.';
                                  1 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 address lists has priority over randomization, so only addresses that are not found in the list are randomized while synchronizing prefixes.';
                                  2 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 address lists has priority over randomization, so only addresses that are not found in the list are randomized without synchronizing prefixes.';
                                  3 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 address lists has priority over randomization, so only addresses that are not found in the list are zeroed.';
                                 end;
                            end
                         else
                             MemoIPv6ActionHint.Text := basetext + ' Only addresses found in the IP address list will be replaced.';
                end
             else
                 begin
                     if SettingIsActive (CheckBoxReplaceIPv6AddressesBySubnets) then
                        begin
                             if SettingIsActive (CheckBoxProcessRemainingIPv6Addresses) then
                                begin
                                     case ComboBoxRandominzeIPv6AddressMode.ItemIndex of
                                      0 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 subnet lists has priority over randomization, keeping the Interface IDs intact.';
                                      1 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 subnet lists has priority over randomization while synchronizing prefixes.';
                                      2 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 subnet lists has priority over randomization while not synchronizing prefixes.';
                                      3 : MemoIPv6ActionHint.Text := basetext + ' The IPv6 subnet lists has priority over zeroing addresses.';
                                     end;
                                end
                             else
                                 MemoIPv6ActionHint.Text := basetext + ' Only addresses found in the IPv6 subnet list will be replaced.'
                        end
                     else
                         if SettingIsActive (CheckBoxProcessRemainingIPv6Addresses) then
                            begin
                                 case ComboBoxRandominzeIPv6AddressMode.ItemIndex of
                                  0 : MemoIPv6ActionHint.Text := basetext + ' All IPv6 addresses will be randomized.';
                                  1 : MemoIPv6ActionHint.Text := basetext + ' All IPv6 addresses will be randomized while synchronizing prefixes.';
                                  2 : MemoIPv6ActionHint.Text := basetext + ' All IPv6 addresses will be randomized while not synchronizing prefixes.';
                                  3 : MemoIPv6ActionHint.Text := basetext + ' All IPv6 addresses will be zeroed.';
                                 end;
                            end
                         else
                             MemoIPv6ActionHint.Text := 'The IPv6 layer will not be modified because no replacement option is active.'
                 end;
        end;

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
//             UpdateTreeNode (TreeViewNavigation.Items[8], RadioButtonIPv6ActionReplace.Checked);

             if RadioButtonIPv6ActionReplace.Checked then
                UpdateTreeNode (TabIndexIPv6, [nsActive])
             else
                 UpdateTreeNode (TabIndexIPv6, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeICMPv4Settings (Sender: TObject);

begin
     GroupBoxICMPv4ActionSettingsReplacement.Enabled := RadioButtonICMPv4ActionReplace.Checked;
     CheckBoxICMPv4RemovePingPayload.Enabled := GroupBoxICMPv4ActionSettingsReplacement.Enabled;

     CheckBoxICMPv4RemoveMessages.Enabled := RadioButtonICMPv4ActionReplace.Checked;
     VSTICMPv4RemoveMessages.Enabled := SettingIsActive (CheckBoxICMPv4RemoveMessages);

     CheckBoxICMPv4RecalculateCRC.Enabled := RadioButtonICMPv4ActionReplace.Checked;
     ComboBoxICMPv4RecalculateCRCMode.Enabled := CheckBoxICMPv4RecalculateCRC.Enabled and CheckBoxICMPv4RecalculateCRC.Checked;

     // Hint Box

     if RadioButtonICMPv4ActionReplace.Checked then
        MemoICMPv4ActionHint.Text := 'ICMP values will be replaced based on the replacement settings below.'
     else
         MemoICMPv4ActionHint.Text := 'ICMP values will not be modified.';

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[9], RadioButtonICMPv4ActionReplace.Checked);

             if RadioButtonICMPv4ActionReplace.Checked then
                UpdateTreeNode (TabIndexICMPv4, [nsActive])
             else
                 UpdateTreeNode (TabIndexICMPv4, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeICMPv6Settings (Sender: TObject);

begin
     GroupBoxICMPv6ActionSettingsReplacement.Enabled := RadioButtonICMPv6ActionReplace.Checked;

     CheckBoxICMPv6RemoveDNSServerFQDNs.Enabled := GroupBoxICMPv6ActionSettingsReplacement.Enabled;
     CheckBoxICMPv6RemovePingPayload.Enabled := GroupBoxICMPv6ActionSettingsReplacement.Enabled;
     CheckBoxICMPv6RecalculateCRC.Enabled := RadioButtonICMPv6ActionReplace.Checked;
     ComboBoxICMPv6RecalculateCRCMode.Enabled := CheckBoxICMPv6RecalculateCRC.Enabled and CheckBoxICMPv6RecalculateCRC.Checked;

     // Hint Box

     if RadioButtonICMPv6ActionReplace.Checked then
        MemoICMPv6ActionHint.Text := 'ICMPv6 values will be replaced based on the replacement settings below.'
     else
         MemoICMPv6ActionHint.Text := 'ICMPv6 values will not be modified.';

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[10], RadioButtonICMPv6ActionReplace.Checked);

             if RadioButtonICMPv6ActionReplace.Checked then
                UpdateTreeNode (TabIndexICMPv6, [nsActive])
             else
                 UpdateTreeNode (TabIndexICMPv6, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeTCPSettings (Sender: TObject);

var basetext : string;

begin
     CheckBoxReplaceTCPPortsBySocketList.Enabled := RadioButtonTCPActionReplace.Checked;
     VSTTCPSocketList.Enabled := CheckBoxReplaceTCPPortsBySocketList.Enabled and CheckBoxReplaceTCPPortsBySocketList.Checked;
     ButtonTCPSocketListAdd.Enabled := VSTTCPSocketList.Enabled;
     ButtonTCPSocketListEdit.Enabled := VSTTCPSocketList.Enabled and (VSTTCPSocketList.SelectedCount > 0);
     ButtonTCPSocketListRemove.Enabled := VSTTCPSocketList.Enabled and (VSTTCPSocketList.SelectedCount > 0);

     CheckBoxReplaceTCPPortsByList.Enabled := RadioButtonTCPActionReplace.Checked;
     VSTTCPPortList.Enabled := CheckBoxReplaceTCPPortsByList.Enabled and CheckBoxReplaceTCPPortsByList.Checked;
     ButtonTCPPortListAdd.Enabled := VSTTCPPortList.Enabled;
     ButtonTCPPortListEdit.Enabled := VSTTCPPortList.Enabled and (VSTTCPPortList.SelectedCount > 0);
     ButtonTCPPortListRemove.Enabled := VSTTCPPortList.Enabled and (VSTTCPPortList.SelectedCount > 0);

     CheckBoxTCPRandomizePorts.Enabled := RadioButtonTCPActionReplace.Checked;
     CheckBoxTCPRandomizePortsKeepSystemPorts.Enabled := CheckBoxTCPRandomizePorts.Enabled and CheckBoxTCPRandomizePorts.Checked;
     CheckBoxTCPRecalculateCRC.Enabled := RadioButtonTCPActionReplace.Checked;
     ComboBoxTCPRecalculateCRCMode.Enabled := CheckBoxTCPRecalculateCRC.Enabled and CheckBoxTCPRecalculateCRC.Checked;

     // Hint Box

     if RadioButtonTCPActionPassthrough.Checked then
        MemoTCPActionHint.Text := 'The TCP layer will not be modified.';

     if RadioButtonTCPActionReplace.Checked then
        begin
             basetext := 'TCP ports will be replaced based on the replacement settings below.';

             if SettingIsActive (CheckBoxReplaceTCPPortsByList) or SettingIsActive (CheckBoxReplaceTCPPortsBySocketList) then
                begin
                     if SettingIsActive (CheckBoxTCPRandomizePorts) then
                        MemoTCPActionHint.Text := basetext + ' The socket list and port list have priority over randomization, so only ports that are not found in the list are randimized.'
                     else
                         MemoTCPActionHint.Text := basetext + ' Only ports found in the port list will be replaced.';
                end
             else
                 begin
                      if SettingIsActive (CheckBoxTCPRandomizePorts) then
                         MemoTCPActionHint.Text := basetext + ' All ports will be randomized.'
                      else
                          MemoTCPActionHint.Text := 'The TCP layer will not be modified because no replacement option is set.'
                 end;
        end;

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[12], RadioButtonTCPActionReplace.Checked);

             if RadioButtonTCPActionReplace.Checked then
                UpdateTreeNode (TabIndexTCP, [nsActive])
             else
                 UpdateTreeNode (TabIndexTCP, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeUDPSettings (Sender: TObject);

var Basetext : string;

begin
     // Settings

     CheckBoxReplaceUDPPortsBySocketList.Enabled := RadioButtonUDPActionReplace.Checked;
     VSTUDPSocketList.Enabled := CheckBoxReplaceUDPPortsBySocketList.Enabled and CheckBoxReplaceUDPPortsBySocketList.Checked;
     ButtonUDPSocketListAdd.Enabled := VSTUDPSocketList.Enabled;
     ButtonUDPSocketListEdit.Enabled := VSTUDPSocketList.Enabled and (VSTUDPSocketList.SelectedCount > 0);
     ButtonUDPSocketListRemove.Enabled := VSTUDPSocketList.Enabled and (VSTUDPSocketList.SelectedCount > 0);

     CheckBoxReplaceUDPPortsByList.Enabled := RadioButtonUDPActionReplace.Checked;
     VSTUDPPortList.Enabled := CheckBoxReplaceUDPPortsByList.Enabled and CheckBoxReplaceUDPPortsByList.Checked;
     ButtonUDPPortListAdd.Enabled := VSTUDPPortList.Enabled;
     ButtonUDPPortListEdit.Enabled := VSTUDPPortList.Enabled and (VSTUDPPortList.SelectedCount > 0);
     ButtonUDPPortListRemove.Enabled := VSTUDPPortList.Enabled and (VSTUDPPortList.SelectedCount > 0);

     CheckBoxUDPRandomizePorts.Enabled := RadioButtonUDPActionReplace.Checked;
     CheckBoxUDPRandomizePortsKeepSystemPorts.Enabled := CheckBoxUDPRandomizePorts.Enabled and CheckBoxUDPRandomizePorts.Checked;
     CheckBoxUDPRecalculateCRC.Enabled := RadioButtonUDPActionReplace.Checked;
     ComboBoxUDPRecalculateCRCMode.Enabled := CheckBoxUDPRecalculateCRC.Enabled and CheckBoxUDPRecalculateCRC.Checked;

     // Hint Box

     if RadioButtonUDPActionPassthrough.Checked then
        MemoUDPActionHint.Text := 'The UDP layer will not be modified.';

     if RadioButtonUDPActionReplace.Checked then
        begin
             basetext := 'UDP ports will be replaced based on the replacement settings below.';

             if SettingIsActive (CheckBoxReplaceUDPPortsByList) then
                begin
                     if SettingIsActive (CheckBoxUDPRandomizePorts) then
                        MemoUDPActionHint.Text := basetext + ' The port list has priority over randomization, so only ports that are not found in the list are randimized.'
                     else
                         MemoUDPActionHint.Text := basetext + ' Only ports found in the port list will be replaced.';
                end
             else
                 begin
                      if SettingIsActive (CheckBoxUDPRandomizePorts) then
                         MemoUDPActionHint.Text := basetext + ' All ports will be randomized.'
                      else
                          MemoUDPActionHint.Text := 'The UDP layer will not be modified because no replacement option is set.'
                 end;
        end;

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[13], RadioButtonUDPActionReplace.Checked);

             if RadioButtonUDPActionReplace.Checked then
                UpdateTreeNode (TabIndexUDP, [nsActive])
             else
                 UpdateTreeNode (TabIndexUDP, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeDHCPv4Settings (Sender: TObject);

begin
     GroupBoxDHCPv4ActionSettingsReplacement.Enabled := RadioButtonDHCPv4ActionReplace.Checked;

     CheckBoxDHCPv4HandleFQDNs.Enabled := GroupBoxDHCPv4ActionSettingsReplacement.Enabled;
     ComboBoxDHCPv4ActionFQDNReplaceMode.Enabled := CheckBoxDHCPv4HandleFQDNs.Enabled and CheckBoxDHCPv4HandleFQDNs.Checked;

     // Update Treeview

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[15], RadioButtonDHCPv4ActionReplace.Checked);

             if RadioButtonDHCPv4ActionReplace.Checked then
                UpdateTreeNode (TabIndexDHCPv4, [nsActive])
             else
                 UpdateTreeNode (TabIndexDHCPv4, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeRTPSSettings (Sender: TObject);

begin
     GroupBoxRTPSActionSettingsReplacement.Enabled := RadioButtonRTPSActionReplace.Checked;

     LabelRTPSReplacementMode.Enabled := RadioButtonRTPSActionReplace.Checked;
     ComboBoxRTPSActionReplaceMode.Enabled := LabelRTPSReplacementMode.Enabled;

     if RadioButtonRTPSActionReplace.Checked then
        MemoRTPSActionHint.Lines.Text := 'The RTPS layer will be modified by sanitizing DATA, DATA_FRAG and DATA_BATCH SubMessages. DATA SubMessages with a WriterEntity of 0x3c2 or 0x4c2 will only have the PID_TYPECODE and PID_TYPEOBJECT values sanitized.'
     else
         MemoRTPSActionHint.Lines.Text := 'The RTPS layer will not be modified.';

     if FormTaskAnonymize.Visible then
        begin
//           UpdateTreeNode (TreeViewNavigation.Items[17], RadioButtonRTPSActionReplace.Checked);

             if RadioButtonRTPSActionReplace.Checked then
                UpdateTreeNode (TabIndexRTPS, [nsActive])
             else
                 UpdateTreeNode (TabIndexRTPS, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeOutputSettings (Sender: TObject);

begin
     LabeledEditOutputToSubdirectory.Enabled := RadioButtonFileOutputToSubdirectory.Checked;
     LabeledEditOutputToDirectory.Enabled := RadioButtonFileOutputToAbsoluteDirectory.Checked;
     ButtonSelectOutputDirectory.Enabled := LabeledEditOutputToDirectory.Enabled;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeGeneralSettings (Sender: TObject);

var help  : boolean;

begin
     // Replacement DB Settings

{$ifdef WIN32}
     CheckBoxKeepDatabaseFileAfterFinish.Enabled := true;
     CheckBoxForceDatabasePath.Enabled := true;
{$else}
     CheckBoxKeepDatabaseFileAfterFinish.Enabled := CheckBoxUseDiskBasedDatabaseFile.Enabled and CheckBoxUseDiskBasedDatabaseFile.Checked;
     CheckBoxForceDatabasePath.Enabled := CheckBoxUseDiskBasedDatabaseFile.Enabled and CheckBoxUseDiskBasedDatabaseFile.Checked;
{$endif}
     CheckBoxWipeDatabaseOnJobStart.Enabled := CheckBoxKeepDatabaseFileAfterFinish.Enabled and CheckBoxKeepDatabaseFileAfterFinish.Checked;
     EditReplacementDBPath.Enabled := CheckBoxForceDatabasePath.Enabled and CheckBoxForceDatabasePath.Checked;
     ButtonSelectDBPath.Enabled := EditReplacementDBPath.Enabled;

     LabelAdvReassemblyTimeout.Enabled := CheckBoxAdvReassembleIPFragments.Enabled and CheckBoxAdvReassembleIPFragments.Checked;
     EditAdvReassemblyChainTimeout.Enabled := LabelAdvReassemblyTimeout.Enabled;
     UpDownAdvReassemblyChainTimeout.Enabled := LabelAdvReassemblyTimeout.Enabled;

     if CheckBoxForceDatabasePath.Enabled and CheckBoxForceDatabasePath.Checked then
        begin
             if DirectoryExists (EditReplacementDBPath.Text) then
                EditReplacementDBPath.Font.Color := clWindowText
             else
                 EditReplacementDBPath.Font.Color := clRed;
        end;

     UpdateOkayButtonStatus;

     if FormTaskAnonymize.Visible then
        begin
             help := not // CheckBoxUseDiskBasedDatabaseFile.Checked or         removed, because 32bit enforces disk based DB now
                         CheckBoxAdvReassembleIPFragments.Checked or
                         (UpDownAdvReassemblyChainTimeout.Position <> DefaultReassemblyChainTimeout);

//           UpdateTreeNode (TreeViewNavigation.Items[19], help);

             if help then
                UpdateTreeNode (TabIndexSettings, [nsActive])
             else
                 UpdateTreeNode (TabIndexSettings, []);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onClickOutputsettings (Sender: TObject);

begin
     LabeledEditOutputToSubdirectory.Enabled := RadioButtonFileOutputToSubdirectory.Checked;
     LabeledEditOutputToDirectory.Enabled := RadioButtonFileOutputToAbsoluteDirectory.Checked;

     ComboBoxSetFileTimestampScope.Enabled := CheckBoxSetFileDateTo.Checked;
     ButtonSelectOutputDirectory.Enabled := LabeledEditOutputToDirectory.enabled;

     UpdateOkayButtonStatus;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onButtonAddDropDownClick (Sender: TObject);

var name : string;

begin
     name := (Sender as tButton).Name;

     if name = 'ButtonEthernetMACListAdd' then
        begin
             PopUpMenuAddButtonLookup.Enabled := (priv_conversationstore.GetMACEndpointCount > 0);
             PopUpMenuAddButtonAuto.Enabled := (priv_conversationstore.GetMACEndpointCount = 2);
        end
     else
     if name = 'ButtonIPv4AddressListAdd' then
        begin
             PopUpMenuAddButtonLookup.Enabled := (priv_conversationstore.GetIPv4EndpointCount > 0);
             PopUpMenuAddButtonAuto.Enabled := (priv_conversationstore.GetIPv4EndpointCount = 2);
        end
     else
     if name = 'ButtonIPv6AddressListAdd' then
        begin
             PopUpMenuAddButtonLookup.Enabled := (priv_conversationstore.GetIPv6EndpointCount > 0);
             PopUpMenuAddButtonAuto.Enabled := (priv_conversationstore.GetIPv6EndpointCount = 2);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeOutputToDirectory (Sender: TObject);

begin
     UpdateOkayButtonStatus;
end;

(* ------------------------------------------- *)
{
procedure TFormTaskAnonymize.onChangeTreeViewNavigation(Sender: TObject; Node: TTreeNode);

var PageIndex : integer;

begin
     PageIndex := -1;

     case TreeViewNavigation.Selected.AbsoluteIndex of
      0,1   : PageIndex := TreeViewNavigation.Selected.AbsoluteIndex;
      2,3   : PageIndex := 2;
      4     : PageIndex := 3;
      5     : PageIndex := 4;
      6,7   : PageIndex := 5;
      8     : PageIndex := 6;
      9     : PageIndex := 7;
      10    : PageIndex := 8;
      11,12 : PageIndex := 9;
      13    : PageIndex := 10;
      14,15 : PageIndex := 11;
      16,17 : PageIndex := 12;
      18    : PageIndex := 13;
      19    : PageIndex := 14;
     end;

     if PageIndex > -1 then
        PageControlSettings.ActivePageIndex := PageIndex;
end;
}
(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onChangeReplacementDBPath (Sender: TObject);

begin
     if DirectoryExists (EditReplacementDBPath.Text) then
        EditReplacementDBPath.Font.Color := clWindowText
     else
         EditReplacementDBPath.Font.Color := clRed;

     UpdateOkayButtonStatus;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.UpdateTreeNodesStatus;

var help : boolean;

begin
     // Bold Tree Nodes

     help := CheckboxGeneralActionPacketTruncateUnknownPayload.Checked or
             CheckboxGeneralActionPacketTruncateAfterLayer.Checked or
             CheckboxGeneralActionPacketTruncateAfterOffset.Checked;
{
     UpdateTreeNode (TreeViewNavigation.Items[0], help);
     UpdateTreeNode (TreeViewNavigation.Items[1], RadioButtonPCAPngActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[3], RadioButtonEthernetActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[4], RadioButtonVLANActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[5], RadioButtonTunnelActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[7], RadioButtonIPv4ActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[8], RadioButtonIPv6ActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[9], RadioButtonICMPv4ActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[10], RadioButtonICMPv6ActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[12], RadioButtonTCPActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[13], RadioButtonUDPActionReplace.Checked);
     UpdateTreeNode (TreeViewNavigation.Items[15], RadioButtonDHCPv4ActionReplace.Checked);
}
     UpdateTreeNode (TabIndexPayload, help);
     UpdateTreeNode (TabIndexPCAPng, RadioButtonPCAPngActionReplace.Checked);
     UpdateTreeNode (TabIndexEthernet, RadioButtonEthernetActionReplace.Checked);
     UpdateTreeNode (TabIndexVLAN, RadioButtonVLANActionReplace.Checked);
     UpdateTreeNode (TabIndexTunnel, RadioButtonTunnelActionReplace.Checked);
     UpdateTreeNode (TabIndexIPv4, RadioButtonIPv4ActionReplace.Checked);
     UpdateTreeNode (TabIndexIPv6, RadioButtonIPv6ActionReplace.Checked);
     UpdateTreeNode (TabIndexICMPv4, RadioButtonICMPv4ActionReplace.Checked);
     UpdateTreeNode (TabIndexICMPv6, RadioButtonICMPv6ActionReplace.Checked);
     UpdateTreeNode (TabIndexTCP, RadioButtonTCPActionReplace.Checked);
     UpdateTreeNode (TabIndexUDP, RadioButtonUDPActionReplace.Checked);
     UpdateTreeNode (TabIndexDHCPv4, RadioButtonDHCPv4ActionReplace.Checked);
     UpdateTreeNode (TabIndexRTPS, RadioButtonRTPSActionReplace.Checked);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.UpdateOkayButtonStatus;

var boOkay : boolean;

begin
     // Check database path

     if CheckBoxForceDatabasePath.Enabled and CheckBoxForceDatabasePath.Checked then
        begin
             if DirectoryExists (EditReplacementDBPath.Text) then
                boOkay := true
             else
                 boOkay := false;
        end
     else
         boOkay := true;

     // Check output is writeable

     if (RadioButtonFileOutputSameDirectory.Checked or RadioButtonFileOutputToSubdirectory.Checked) then
        begin
             // after loading a task from disk on startup the filelist isn't available immediately when
             // some form triggers run this code, so we need to make sure it's assigned

             if assigned (priv_filelist) then
                begin
                     if not priv_filelist.AllDirectoriesAreWriteable then
                        begin
                             LabelDirectoryWarning.Caption := '** Warning: One or more target directories not writeable **';
                             LabelDirectoryWarning.Visible := true;

                             SetTreeNodeStatusFlag (TabIndexOutput, nsAlert);

                             boOkay := false;
                        end;
                end;
        end
     else
         begin
              if directoryexists (LabeledEditOutputToDirectory.Text) then
                 begin
                      if not isDirectoryWriteable (LabeledEditOutputToDirectory.Text) then
                         begin
                              LabeledEditOutputToDirectory.Font.Color := clRed;
                              LabelDirectoryWarning.Caption := '** Warning: target directory not writeable **';
                              LabelDirectoryWarning.Visible := true;

                              SetTreeNodeStatusFlag (TabIndexOutput, nsAlert);

                              boOkay := false;
                         end
                      else
                          begin
                               LabeledEditOutputToDirectory.Font.Color := clWindowText;
                               LabelDirectoryWarning.Visible := false;

                               boOkay := true;
                          end;
                 end
              else
                  begin
                       LabeledEditOutputToDirectory.Font.Color := clRed;
                       LabelDirectoryWarning.Caption := '** Warning: target directory does not exist **';
                       LabelDirectoryWarning.Visible := true;

                       SetTreeNodeStatusFlag (TabIndexOutput, nsAlert);

                       boOkay := false;
                  end;
         end;

     if boOkay then
        begin
             LabelDirectoryWarning.Visible := false;

             ClearTreeNodeStatusFlag (TabIndexOutput, nsAlert);
        end;

     ButtonOkay.Enabled := boOkay;
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.AddNavigationContentNode (const TopicNode : pVirtualNode; const TabIndex: integer): pVirtualNode;

var node       : pVirtualNode;
    data       : pNaviNode;

begin
     node := VSTNavigation.AddChild (TopicNode);
     data := VSTNavigation.GetNodeData (node);

     data^.TabIndex := TabIndex;
     data^.Caption := PageControlSettings.Pages[TabIndex].Caption;
     data^.Status := [];

     priv_tabvalues[TabIndex].Node := node;
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.AddNavigationTopicNode (const ParentNode : pVirtualNode; const TopicIndex: integer; const TabIndex : integer): pVirtualNode;

var node       : pVirtualNode;
    data       : pNaviNode;

begin
     node := VSTNavigation.AddChild (ParentNode);
     data := VSTNavigation.GetNodeData (node);

     case TopicIndex of
      TopicIndexLayer2      : data^.Caption := 'Layer 2';
      TopicIndexLayer3      : data^.Caption := 'Layer 3';
      TopicIndexLayer4      : data^.Caption := 'Layer 4';
      TopicIndexSupport     : data^.Caption := 'Support';
      TopicIndexApplication : data^.Caption := 'Application';
     end;

     data^.TabIndex := TabIndex;
     data^.Status := [];

     result := node;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.BuildNavigationTree;

var parentnode : pVirtualNode;

begin
     VSTNavigation.Clear;
     VSTNavigation.BeginUpdate;

     parentnode := nil;

     AddNavigationContentNode (parentnode, TabIndexPayload);
     AddNavigationContentNode (parentnode, TabIndexPCAPNg);

     parentnode := AddNavigationTopicNode (nil, TopicIndexLayer2, TabIndexEthernet);

     AddNavigationContentNode (parentnode, TabIndex802dot11);
     AddNavigationContentNode (parentnode, TabIndexEthernet);
     AddNavigationContentNode (parentnode, TabIndexVLAN);
     AddNavigationContentNode (parentnode, TabIndexTunnel);

     parentnode := AddNavigationTopicNode (nil, TopicIndexLayer3, TabIndexIPv4);

     AddNavigationContentNode (parentnode, TabIndexIPv4);
     AddNavigationContentNode (parentnode, TabIndexIPv6);
     AddNavigationContentNode (parentnode, TabIndexICMPv4);
     AddNavigationContentNode (parentnode, TabIndexICMPv6);

     parentnode := AddNavigationTopicNode (nil, TopicIndexLayer4, TabIndexTCP);

     AddNavigationContentNode (parentnode, TabIndexTCP);
     AddNavigationContentNode (parentnode, TabIndexUDP);

     parentnode := AddNavigationTopicNode (nil, TopicIndexSupport, TabIndexDHCPv4);

     AddNavigationContentNode (parentnode, TabIndexDHCPv4);

     parentnode := AddNavigationTopicNode (nil, TopicIndexApplication, TabIndexRTPS);

     AddNavigationContentNode (parentnode, TabIndexRTPS);

     parentnode := nil;

     AddNavigationContentNode (parentnode, TabIndexOutput);
     AddNavigationContentNode (parentnode, TabIndexSettings);

     VSTNavigation.FullExpand;
     VSTNavigation.EndUpdate;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.RefreshFormItemsDisplay;

var node : pVirtualNode;
    i    : integer;

begin
//   TreeViewNavigation.FullExpand;

     priv_comboboxPacketSliceParamOldIndex := 0;
     priv_comboboxPacketSliceParamOldValue := 54;

     FormReplacementDetails.onAddAndNew := onReplacementPairAddAndNew;

     for i := 1 to PageControlSettings.PageCount do
         PageControlSettings.Pages[i-1].TabVisible := false;

     if VSTNavigation.RootNodeCount = 0 then
        BuildNavigationTree;

     // Update enable states

     onChangeGeneralSettings (nil);
     onChangePCAPngSettings (nil);
     onChange802dot11Settings (nil);
     onChangeEthernetSettings (nil);
     onChangeVLANSettings (nil);
     onChangeTunnelSettings (nil);
     onChangeIPv4Settings (nil);
     onChangeIPv6Settings (nil);
     onChangeICMPv4Settings (nil);
     onChangeICMPv6Settings (nil);
     onChangeTCPSettings (nil);
     onChangeUDPSettings (nil);
     onChangeDHCPv4Settings (nil);
     onChangeRTPSSettings (nil);
     onChangeOutputSettings (nil);

     // Bold Tree Nodes

//   UpdateTreeNodesStatus;

     // Make sure the first node is active

//   TreeViewNavigation.Select(TreeViewNavigation.Items[0]);

     node := VSTNavigation.GetFirst;

     VSTNavigation.Selected[node] := true;
//   VSTNavigation.ScrollIntoView (node, true);             // Not neccessary yet
     VSTNavigation.FocusedNode := node;

     PageControlSettings.ActivePageIndex := 0;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onShow (Sender: TObject);

begin
     RunPlausibilityChecks;
     RefreshFormItemsDisplay;

{$ifdef WIN32}

     CheckBoxUseDiskBasedDatabaseFile.Checked := true;
     CheckBoxUseDiskBasedDatabaseFile.Enabled := false;

{$endif}

     // Prepare details form

     FormReplacementDetails.ConversationStore := priv_conversationstore;

     PageControlSettings.ActivePageIndex := 0;

     TimerAutoMode.Enabled := true;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onTimerAutoMode (Sender: TObject);

begin
     TimerAutoMode.Enabled := false;

     if (CheckBoxReplaceIPv4AddressesAutoMode.Enabled and CheckBoxReplaceIPv4AddressesAutoMode.Checked) and (priv_conversationstore.GetIPv4EndpointCount = 2) then
        AutoReplaceIPv4Addresses;

     if (CheckBoxReplaceIPv6AddressesAutoMode.Enabled and CheckBoxReplaceIPv6AddressesAutoMode.Checked) and (priv_conversationstore.GetIPv6EndpointCount = 2) then
        AutoReplaceIPv6Addresses;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.RunPlausibilityChecks;

var node          : pVirtualNode;
    socketdata    : pSocketListEntry;
    socketdetails : tSocketDetails;

begin
     // Plausibility Checks

     assert (assigned (priv_Conversationstore), 'Error: cannot access Conversationstore (TFormTaskAnonymize.RunPlausibilityChecks)');

     if priv_Conversationstore.HasRecords then
        begin
             // TCP Socket Pairs

             node := VSTTCPSocketList.GetFirst;

             while assigned (node) do
                   begin
                        socketdata := VSTTCPSocketList.GetNodeData (node);
                        socketdetails := priv_Conversationstore.GetSocketEntry (protTCP, socketdata^.Socket.Source);

                        socketdata^.isPlausible := not (socketdetails.UseCount = 0);

                        node := VSTTCPSocketList.GetNext (node);
                   end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTNavigationChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

var data : pNaviNode;

begin
     if VSTNavigation.SelectedCount > 0 then
        begin
             VSTNavigation.GetFirstSelected;

             data := VSTNavigation.GetNodeData (node);

             PageControlSettings.ActivePageIndex := data^.TabIndex;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTNavigationGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var data : pNaviNode;

begin
     data := VSTNavigation.GetNodeData (node);
     CellText := data^.Caption;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTNavigationPaintText (Sender: TBaseVirtualTree; const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType);

var data   : pNaviNode;
    status : tNavigationNodeStatus;

begin
     data := VSTNavigation.GetNodeData (node);

     TargetCanvas.Font.Color := clWindowText;
     TargetCanvas.Font.Style := [];

     for status in data^.Status do
         case status of
          nsWarning : TargetCanvas.Font.Color := $000080FF;
          nsAlert   : TargetCanvas.Font.Color := clRed;
          nsActive  : TargetCanvas.Font.Style := TargetCanvas.Font.Style + [fsBold];
         end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onUDPPortListDblClick (Sender: TObject);

begin
     ButtonUDPPortListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onUDPPortListDrawText (Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);

var Data     : pPortPair;
    CellText : string;

begin
     Data := VSTUDPPortList.GetNodeData (Node);

     case Column of
      0 : CellText := IntTostr (Data^.Value1);
      1 : CellText := IntTostr (Data^.Value2);
     end;

     TargetCanvas.TextOut(CellRect.Left, CellRect.Top + 2, CellText);

     DefaultDraw := false;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onUDPPortListFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTUDPPortList.FocusedNode = nil then
        begin
             ButtonUDPPortListEdit.Enabled := false;
             ButtonUDPPortListRemove.Enabled := false;
        end
     else
         begin
              ButtonUDPPortListEdit.Enabled := true;
              ButtonUDPPortListRemove.Enabled := true;
         end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onUDPPortListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var Data : pPortPair;

begin
     Data := VSTUDPPortList.GetNodeData (Node);

     case Column of
      0 : CellText := IntTostr (Data^.Value1);
      1 : CellText := IntTostr (Data^.Value2);
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onUDPPortListNewText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);

var Data  : pPortPair;
    Value : integer;

begin
     Data := VSTUDPPortList.GetNodeData (Node);

     TryStrToInt (NewText, Value);

     if ((Value > 0) and (Value <= 65535)) then
        begin
             case Column of
              0 : Data^.Value1 := StrToInt (NewText);
              1 : Data^.Value2 := StrToInt (NewText);
             end;
        end
     else
         MessageDlg('Error: invalid address format!', mtError, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTMACAddressListDrawText (Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);

var Data     : pReplacementMACNode;
    CellText : string;

begin
     Data := VSTMACAddressList.GetNodeData(Node);

     case Column of
      0 : CellText := Data^.Original.asString(':');
      1 : CellText := Data^.Replacement.asString(':');
      2 : CellText := DefinedByToString (data^.DefinedBy);
     end;

     TargetCanvas.TextOut(CellRect.Left, CellRect.Top + 2, CellText);

     DefaultDraw := false;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTMACAddressListEditing (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);

begin
     Allowed := (column < 2);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTMACAddressListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     ButtonEthernetMACListEdit.Enabled := (Sender.SelectedCount = 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTMACAddressListFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTMACAddressList.FocusedNode = nil then
        begin
             ButtonEthernetMACListEdit.Enabled := false;
             ButtonEthernetMACListRemove.Enabled := false;
        end
     else
         begin
              ButtonEthernetMACListEdit.Enabled := true;
              ButtonEthernetMACListRemove.Enabled := true;
         end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onKeyDownGeneralVSTAddressList (Sender: TObject; var Key: Word; Shift: TShiftState);

var Tree : TVirtualStringTree;
    Node : pVirtualNode;

begin
     Tree := (Sender as TVirtualStringTree);

     case Key of
       VK_LEFT   : Tree.FocusedColumn := Max (0, Tree.FocusedColumn - 1);
       VK_RIGHT  : Tree.FocusedColumn := Min (Tree.RootNodeCount, Tree.FocusedColumn + 1);
       VK_RETURN : Tree.EditNode (Tree.FocusedNode, Tree.FocusedColumn);
       VK_DELETE : begin
                        Node := Tree.GetFirstSelected;

                        while assigned (Node) do
                              begin
                                   Tree.DeleteNode (Node);
                                   Node := Tree.GetNextSelected (Node);
                              end;
                   end;
     end;
end;

(* ------------------------------------------- *)

// Needed when editing text of a node; text output of cells will be done by DrawText

procedure TFormTaskAnonymize.onVSTMACAddressListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var data : pReplacementMACNode;

begin
     data := VSTMACAddressList.GetNodeData(Node);

     case column of
     0 : CellText := data^.Original.asString (':');
     1 : CellText := data^.Replacement.asString (':');
     2 : CellText := DefinedByToString (data^.DefinedBy);
     end;
end;

(* ------------------------------------------- *)

// Event that triggers when edit is done

procedure TFormTaskAnonymize.onVSTMACAddressListNewText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);

var Data      : pReplacementMACNode;
    Separator : string;

begin
     Data := VSTMACAddressList.GetNodeData(Node);

     if isValidMAC (NewText) then
        begin
             Separator := '';

             if pos (':', NewText) > 0 then
                Separator := ':';

             if pos ('-', NewText) > 0 then
                Separator := '-';

             case Column of
              0 : Data^.Original.setfromString (NewText, Separator);
              1 : Data^.Replacement.setfromString (NewText, Separator);
             end;
        end
     else
         begin
              MessageDlg('Error: invalid address format!', mtError, [mbOK], 0);
         end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPPortListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     ButtonTCPPortListEdit.Enabled := (Sender.SelectedCount = 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPPortListDblClick(Sender: TObject);

begin
     ButtonTCPPortListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPPortListFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTTCPPortList.FocusedNode = nil then
        begin
             ButtonTCPPortListEdit.Enabled := false;
             ButtonTCPPortListRemove.Enabled := false;
        end
     else
         begin
              ButtonTCPPortListEdit.Enabled := true;
              ButtonTCPPortListRemove.Enabled := true;
         end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPPortListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var Data : pPortPair;

begin
     Data := VSTTCPPortList.GetNodeData (Node);

     case Column of
      0 : CellText := IntTostr (Data^.Value1);
      1 : CellText := IntTostr (Data^.Value2);
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPPortListNewText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);

var Data  : pPortPair;
    Value : integer;

begin
     Data := VSTTCPPortList.GetNodeData (Node);

     TryStrToInt (NewText, Value);

     if ((Value > 0) and (Value <= 65535)) then
        begin
             case Column of
              0 : Data^.Value1 := StrToInt (NewText);
              1 : Data^.Value2 := StrToInt (NewText);
             end;
        end
     else
         MessageDlg('Error: invalid address format!', mtError, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPSocketListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var Data : pSocketListEntry;

begin
     Data := VSTTCPSocketList.GetNodeData (Node);

     case Column of
      0 : CellText := Data^.Socket.Source.IPAddress.ValueAsString;
      1 : CellText := Data^.Socket.Source.Port.ToString;
      2 : CellText := Data^.Socket.Destination.IPAddress.ValueAsString;
      3 : CellText := Data^.Socket.Destination.Port.ToString;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPSocketListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     ButtonTCPSocketListEdit.Enabled := (Sender.SelectedCount = 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPSocketListDblClick (Sender: TObject);

begin
     ButtonTCPSocketListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPSocketListDrawText (Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);

var data : pSocketListEntry;

begin
     data := Sender.GetNodeData (Node);

     if not data^.isPlausible then
        TargetCanvas.Font.Color := clGray;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTTCPSocketListFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTTCPSocketList.FocusedNode = nil then
        begin
             ButtonTCPSocketListEdit.Enabled := false;
             ButtonTCPSocketListRemove.Enabled := false;
        end
     else
         begin
              ButtonTCPSocketListEdit.Enabled := true;
              ButtonTCPSocketListRemove.Enabled := true;
         end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTUDPSocketListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var Data : pSocketListEntry;

begin
     Data := VSTTCPSocketList.GetNodeData (Node);

     case Column of
      0 : CellText := Data^.Socket.Source.IPAddress.ValueAsString;
      1 : CellText := Data^.Socket.Source.Port.ToString;
      2 : CellText := Data^.Socket.Destination.IPAddress.ValueAsString;
      3 : CellText := Data^.Socket.Destination.Port.ToString;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTUDPPortListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     ButtonUDPPortListEdit.Enabled := (Sender.SelectedCount = 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTUDPSocketListChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     ButtonUDPSocketListEdit.Enabled := (Sender.SelectedCount = 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTUDPSocketListDblClick(Sender: TObject);

begin
     ButtonUDPSocketListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTUDPSocketListFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTUDPSocketList.FocusedNode = nil then
        begin
             ButtonUDPSocketListEdit.Enabled := false;
             ButtonUDPSocketListRemove.Enabled := false;
        end
     else
         begin
              ButtonUDPSocketListEdit.Enabled := true;
              ButtonUDPSocketListRemove.Enabled := true;
         end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTVLANIDDblClick (Sender: TObject);

begin
     ButtonVLANListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTVLANIDDrawText (Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);

var Data     : pVLANPair;
    CellText : string;

begin
     Data := VSTVLANIDList.GetNodeData(Node);

     case Column of
      0 : CellText := IntTostr (Data^.Value1);
      1 : CellText := IntTostr (Data^.Value2);
     end;

     TargetCanvas.TextOut(CellRect.Left, CellRect.Top + 2, CellText);

     DefaultDraw := false;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTVLANIDFocusChanged (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

begin
     if VSTVLANIDList.FocusedNode = nil then
        begin
             ButtonVLANListEdit.Enabled := false;
             ButtonVLANListRemove.Enabled := false;
        end
     else
         begin
              ButtonVLANListEdit.Enabled := true;
              ButtonVLANListRemove.Enabled := true;
         end
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTVLANIDGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var Data : pVLANPair;

begin
     Data := VSTVLANIDList.GetNodeData (Node);

     case Column of
      0 : CellText := IntTostr (Data^.Value1);
      1 : CellText := IntTostr (Data^.Value2);
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTVLANIDListNewText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; NewText: string);

var Data : pVLANPair;

begin
     Data := VSTVLANIDList.GetNodeData (Node);

     if isValidIPv4String (NewText) then
        begin
             case Column of
              0 : Data^.Value1 := StrToInt (NewText);
              1 : Data^.Value2 := StrToInt (NewText);
             end;
        end
     else
         MessageDlg('Error: invalid address format!', mtError, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTReplacementStringsChange (Sender: TBaseVirtualTree; Node: PVirtualNode);

begin
     if assigned (Node) and (Node.Parent <> Sender.RootNode) and not (tsIncrementalSearching in Sender.TreeStates) then
        begin
             // We want to start editing the currently selected node. However it might well happen that this change event
             // here is caused by the node editor if another node is currently being edited. It causes trouble
             // to start a new edit operation if the last one is still in progress. So we post us a special message and
             // in the message handler we then can start editing the new node. This works because the posted message
             // is first executed *after* this event and the message, which triggered it is finished.

             PostMessage(Self.Handle, WM_STARTEDITING, WPARAM(Node), 0);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTReplacementStringsCreateEditor (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; out EditLink: IVTEditLink);

begin
     if assigned (Node) then
        begin
             priv_CatchKeys := True;

             EditLink := TPropertyEditLink.Create (mEdit);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTReplacementStringsEdited (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex);

var data : pReplacementEditorData;

begin
     priv_CatchKeys := false;

     data := Sender.GetNodeData (Node);

     // Automatically edit second column if first was edited and second is empty

     if (Column = 0) and (data^.replacement = '') then
        Sender.EditNode (Node, 1)
     else
         begin
              // if we just edited the last node, add a new row

              if Node.Index = ((Sender as tVirtualStringTree).RootNodeCount - 1) then
                 begin
                      node := Sender.AddChild(nil);
                      data := Sender.GetNodeData (node);

                      data^.initialize;

                      Sender.EditNode (Node, 0);
                 end;
         end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTPayloadReplacementStringsGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var data : pReplacementEditorData;

begin
     data := VSTPayloadReplacementStrings.GetNodeData (Node);

     case column of
      0 : CellText := data^.original;
      1 : CellText := data^.replacement;
      2 : begin
               if (data^.original <> '') or (data^.replacement <> '') then
                  CellText := IntToStr (data^.deltalen)
               else
                   CellText := '';
          end;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTPayloadReplacementStringsPaintText (Sender: TBaseVirtualTree; const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType);

var data : pReplacementEditorData;

begin
     data := VSTPayloadReplacementStrings.GetNodeData (Node);

     if (Column = 2) and (data^.deltalen <> 0) then
        TargetCanvas.Font.Color := clRed;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVST802dot11ReplacementListGetText (Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: string);

var data : pReplacementEditorData;

begin
     data := VST802dot11SSIDReplacementList.GetNodeData (Node);

     case column of
      0 : CellText := data^.original;
      1 : CellText := data^.replacement;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonEthernetMACListAddClick (Sender: TObject);

var Original    : tMACAddress;
    Replacement : tMACAddress;
    Node        : PVirtualNode;
    Data        : pReplacementMACNode;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETMACAddress;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';
//   FormReplacementDetails.MemoActionHint.Text := 'Enter MAC addresses with the octets seprarated by colons.' + CRLF + CRLF + 'Example: 01:02:03:04:05:06';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original.setfromString (StringReplace (FormReplacementDetails.EditOriginal.Text, '-', ':', [rfReplaceAll]));
             Replacement.setfromString (StringReplace (FormReplacementDetails.EditReplacement.Text, '-', ':', [rfReplaceAll]));

             if not AddressExistsInList (Original) then
                begin
                     Node := VSTMACAddressList.AddChild (nil);
                     Data := VSTMACAddressList.GetNodeData (Node);

                     Data^.Original := Original;
                     Data^.Replacement := Replacement;
                     Data^.DefinedBy := defUser;

                     VSTMACAddressList.RepaintNode(Node);
                     VSTMACAddressList.FocusedNode := Node;
                end
             else
                 showMessage ('IP Address ' + Original.asString (':') + ' already exists, cannot add');
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonEthernetMACListEditClick (Sender: TObject);

var Node        : PVirtualNode;
    Data        : pReplacementMACNode;
    Original    : string;
    Replacement : string;
begin
     Node := VSTMACAddressList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTMACAddressList.GetNodeData(Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETMACAddress;
             FormReplacementDetails.EditOriginal.Text := Data^.Original.asString(':');
             FormReplacementDetails.EditReplacement.Text := Data^.Replacement.asString(':');
             // FormReplacementDetails.MemoActionHint.Text := 'Enter MAC addresses with the octets seprarated by colons.' + CRLF + CRLF + 'Example: 01:02:03:04:05:06';

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Original := StringReplace (FormReplacementDetails.EditOriginal.Text, '-', ':', [rfReplaceAll]);
                     Replacement := StringReplace (FormReplacementDetails.EditReplacement.Text, '-', ':', [rfReplaceAll]);

                     Data^.Original.setfromString (Original, ':');
                     Data^.Replacement.setfromString(Replacement, ':');
                     Data^.DefinedBy := defUser;

                     VSTMACAddressList.RepaintNode(Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onVSTMACAddressListDblClick(Sender: TObject);

begin
     ButtonEthernetMACListEdit.Click;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonEthernetMACListRemoveClick (Sender: TObject);

var Node : PVirtualNode;

begin
     Node := VSTMACAddressList.FocusedNode;

     if Node <> nil then
        VSTMACAddressList.DeleteNode(node);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onReplacementPairAddAndNew (const ReplacementEditType : tReplacementEditType; Original, Replacement: string);

var Node        : PVirtualNode;
    MACData     : pReplacementMACNode;
    IPv4Data    : pReplacementIPv4Node;
    IPv6Data    : pReplacementIPv6Node;
    PortData    : pPortPair;
    Help        : integer;

begin
     case ReplacementEditType of
      tETMACAddress   : begin
                             Original := StringReplace (Original, '-', ':', [rfReplaceAll]);
                             Replacement := StringReplace (Replacement, '-', ':', [rfReplaceAll]);

                             Node := VSTMACAddressList.AddChild (nil);
                             MACData := VSTMACAddressList.GetNodeData (Node);

                             MACData^.Original.setfromString (Original, ':');
                             MACData^.Replacement.setfromString(Replacement, ':');

                             VSTMACAddressList.RepaintNode (Node);
                             VSTMACAddressList.FocusedNode := Node;
                        end;
      tETIPv4Address  : begin
                             Node := VSTIPv4AddressList.AddChild (nil);
                             IPv4Data := VSTIPv4AddressList.GetNodeData (Node);

                             IPv4Data^.Original.setValueFromString (Original);
                             IPv4Data^.Replacement.setValueFromString (Replacement);

                             VSTIPv4AddressList.RepaintNode (Node);
                             VSTIPv4AddressList.FocusedNode := Node;
                        end;
      tETIPv4Subnet   : begin
                             Node := VSTIPv4SubnetList.AddChild (nil);
                             IPv4Data := VSTIPv4SubnetList.GetNodeData (Node);

                             IPv4Data^.Original.setValueFromCIDRString (Original);
                             IPv4Data^.Replacement.setValueFromCIDRString (Replacement);

                             VSTIPv4SubnetList.RepaintNode (Node);
                             VSTIPv4SubnetList.FocusedNode := Node;
                        end;
      tETIPv6Address  : begin
                             Node := VSTIPv6AddressList.AddChild (nil);
                             IPv6Data := VSTIPv6AddressList.GetNodeData (Node);

                             IPv6Data^.Original.setValueFromString (Original);
                             IPv6Data^.Replacement.setValueFromString (Replacement);

                             VSTIPv6AddressList.RepaintNode (Node);
                             VSTIPv6AddressList.FocusedNode := Node;
                        end;
      tETIPv6Subnet   : begin
                             Node := VSTIPv6SubnetList.AddChild (nil);
                             IPv6Data := VSTIPv6SubnetList.GetNodeData (Node);

                             IPv6Data^.Original.setValueFromStringWithMask (Original);
                             IPv6Data^.Replacement.setValueFromStringWithMask (Replacement);

                             VSTIPv6SubnetList.RepaintNode (Node);
                             VSTIPv6SubnetList.FocusedNode := Node;
                        end;
      tETTCPPort      : begin
                             Node := VSTTCPPortList.AddChild (nil);
                             PortData := VSTTCPPortList.GetNodeData (Node);

                             TryStrToInt (Original, Help);
                             PortData^.Value1 := Help;
                             TryStrToInt (Replacement, Help);
                             PortData^.Value2 := Help;

                             VSTTCPPortList.RepaintNode (Node);
                             VSTTCPPortList.FocusedNode := Node;
                        end;
      tETUDPPort      : begin
                             Node := VSTUDPPortList.AddChild(nil);
                             PortData := VSTUDPPortList.GetNodeData(Node);

                             TryStrToInt (Original, Help);
                             PortData^.Value1 := Help;
                             TryStrToInt (Replacement, Help);
                             PortData^.Value2 := Help;

                             VSTUDPPortList.RepaintNode (Node);
                             VSTUDPPortList.FocusedNode := Node;
                        end;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onKeyPressNumbersAndDotsOnly(Sender: TObject; var Key: Char);

begin
     if not (key in [#8, #9, '0' .. '9', '.']) then
        key:=#0
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onKeyPressNumbersDashesCommasOnly (Sender: TObject; var Key: Char);

begin
     if not (key in [#8, #9, '0' .. '9', '-',',']) then
        key:=#0
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onKeyPressNumbersDotsAndSlashes (Sender: TObject; var Key: Char);

begin
     if not (key in [#8, #9, '0' .. '9', '.', '/']) then
        key:=#0
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onKeyPressHexAndColonsOnly (Sender: TObject; var Key: Char);

begin
     if not (key in [#8, #9, '0' .. '9', 'a'..'f','A'..'F', ':']) then
        key:=#0
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onKeyPressNumbersAllowedOnly (Sender: TObject; var Key: Char);

begin
     if not (key in [#8, #9, '0' .. '9']) then
        key:=#0
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.GetHeaderStringForTree (Treename: string): string;

begin
     if (TreeName = 'VSTTCPSocketList') or
        (TreeName = 'VSTUDPSocketList') then
        result := '# IPVersion,Original IP,Original Port,Replacement Port'
     else
         result := '# Original,Replacement'
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.GetOutputStringForTreeRow (TreeName : string; Node : PVirtualNode) : string;

var MACData    : pReplacementMACNode;
    VLANData   : pVLANPair;
    IPv4Data   : pReplacementIPv4Node;
    IPv6Data   : pReplacementIPv6Node;
    PortData   : pPortPair;
//  SocketData : pSocketPortPair;
    SocketData : pSocketListEntry;

begin
     if TreeName = 'VSTMACAddressList' then
        begin
             MACData := VSTMACAddressList.GetNodeData (Node);

             result := MACData^.Original.asString(':') + ',' + MACData^.Replacement.asString(':');
        end;

     if TreeName = 'VSTVLANIDList' then
        begin
             VLANData := VSTVLANIDList.GetNodeData (Node);

             result := IntToStr (VLANData^.Value1) + ',' + IntToStr (VLANData^.Value2);
        end;

     if TreeName = 'VSTIPv4AddressList' then
        begin
             IPv4Data := VSTIPv4AddressList.GetNodeData (Node);

             result := IPv4Data^.Original.ValueAsString + ',' + IPv4Data^.Replacement.ValueAsString;
        end;

     if TreeName = 'VSTIPv4SubnetList' then
        begin
             IPv4Data := VSTIPv4SubnetList.GetNodeData (Node);

             result := IPv4Data^.Original.ValueAsCIDRString + ',' + IPv4Data^.Replacement.ValueAsCIDRString;
        end;

     if TreeName = 'VSTIPv6AddressList' then
        begin
             IPv6Data := VSTIPv6AddressList.GetNodeData (Node);

             result := IPv6Data^.Original.ValueAsString + ',' + IPv6Data^.Replacement.ValueAsString;
        end;

     if TreeName = 'VSTIPv6SubnetList' then
        begin
             IPv6Data := VSTIPv6SubnetList.GetNodeData (Node);

             result := IPv6Data^.Original.ValueAsSlashedNotationString + ',' + IPv6Data^.Replacement.ValueAsSlashedNotationString;
        end;

     if TreeName = 'VSTTCPSocketList' then
        begin
             SocketData := VSTTCPSocketList.GetNodeData (Node);
{
             if SocketData^.IPVersion = 4 then
                result := '4,' + SocketData^.OriginalIPv4Socket.IPAddress.ValueAsString + ',' + IntToStr (SocketData^.OriginalIPv4Socket.Port) + ',' + IntToStr (SocketData^.NewPort)
             else
                 result := '6,' + SocketData^.OriginalIPv6Socket.IPAddress.ValueAsString + ',' + IntToStr (SocketData^.OriginalIPv6Socket.Port) + ',' + IntToStr (SocketData^.NewPort)
}
             if SocketData^.Socket.Source.IPAddress.IPVersion = 4 then
                result := '4,' + SocketData^.Socket.Source.IPAddress.ValueAsString + ',' + SocketData^.Socket.Source.Port.ToString + ',' + SocketData^.Socket.Destination.IPAddress.ValueAsString + ',' + SocketData^.Socket.Destination.Port.ToString
             else
                 result := '6,' + SocketData^.Socket.Source.IPAddress.ValueAsString + ',' + SocketData^.Socket.Source.Port.ToString + ',' + SocketData^.Socket.Destination.IPAddress.ValueAsString + ',' + SocketData^.Socket.Destination.Port.ToString;
        end;

     if TreeName = 'VSTTCPPortList' then
        begin
             PortData := VSTTCPPortList.GetNodeData (Node);

             result := IntToStr (PortData^.Value1) + ',' + IntToStr (PortData^.Value2);
        end;

     if TreeName = 'VSTUDPSocketList' then
        begin
             SocketData := VSTUDPSocketList.GetNodeData (Node);
{
             if SocketData^.IPVersion = 4 then
                result := '4,' + SocketData^.OriginalIPv4Socket.IPAddress.ValueAsString + ',' + IntToStr (SocketData^.OriginalIPv4Socket.Port) + ',' + IntToStr (SocketData^.NewPort)
             else
                 result := '6,' + SocketData^.OriginalIPv6Socket.IPAddress.ValueAsString + ',' + IntToStr (SocketData^.OriginalIPv6Socket.Port) + ',' + IntToStr (SocketData^.NewPort)
}
             if SocketData^.Socket.Source.IPAddress.IPVersion = 4 then
                result := '4,' + SocketData^.Socket.Source.IPAddress.ValueAsString + ',' + SocketData^.Socket.Source.Port.ToString + ',' + SocketData^.Socket.Destination.IPAddress.ValueAsString + ',' + SocketData^.Socket.Destination.Port.ToString
             else
                 result := '6,' + SocketData^.Socket.Source.IPAddress.ValueAsString + ',' + SocketData^.Socket.Source.Port.ToString + ',' + SocketData^.Socket.Destination.IPAddress.ValueAsString + ',' + SocketData^.Socket.Destination.Port.ToString;
        end;

     if TreeName = 'VSTUDPPortList' then
        begin
             PortData := VSTUDPPortList.GetNodeData (Node);

             result := IntToStr (PortData^.Value1) + ',' + IntToStr (PortData^.Value2);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onPopUpPopupMenuVirtualStringTrees(Sender: TObject);

var Tree : tVirtualStringTree;

begin
     if (PopupMenuVirtualStringTrees.PopupComponent.ClassType = TVirtualStringTree) then
        begin
             Tree := (PopupMenuVirtualStringTrees.PopupComponent as tVirtualStringTree);

             if not Tree.Enabled then
                Abort;

             if Tree.RootNodeCount > 0 then
                begin
                     PopUpMenuClear.Enabled := true;
                     PopUpMenuExport.Enabled := true;
                end
             else
                 begin
                      PopUpMenuClear.Enabled := false;
                      PopUpMenuExport.Enabled := false;
                 end;

             PopUpMenuImportFromConversationStore.Enabled := false;

             if Tree.Name = 'VSTMACAddressList' then
                PopUpMenuImportFromConversationStore.Enabled := (priv_conversationstore.GetMACEndpointCount > 0)
             else
             if Tree.Name = 'VSTIPv4AddressList' then
                PopUpMenuImportFromConversationStore.Enabled := (priv_conversationstore.GetIPv4EndpointCount > 0)
             else
             if Tree.Name = 'VSTIPv6AddressList' then
                PopUpMenuImportFromConversationStore.Enabled := (priv_conversationstore.GetIPv6EndpointCount > 0);
        end
     else
         Abort;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onPopUpReplacementStrings(Sender: TObject);

begin
//   MenuExportReplacementStrings.Enabled := (ValueListEditorPayloadReplacementStrings.Strings.Count > 0);
     MenuExportReplacementStrings.Enabled := (VSTPayloadReplacementStrings.RootNodeCount > 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onPopUpTools(Sender: TObject);

begin
//   PopupMenuToolsSpecialSwapConversationAddresses.Enabled := (priv_conversationstore.GetTCPIpv4ConversationCount > 0) or (priv_conversationstore.GetTCPIpv6ConversationCount > 0);
     PopupMenuToolsSpecialSwapConversationAddresses.Enabled := (priv_conversationstore.GetTCPConversationCount > 0);
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.AddressExistsInList (const NewAddress: tMACAddress): boolean;

var Node     : pVirtualNode;
    MACData  : pReplacementMACNode;
    value    : boolean;

begin
     value := false;

     node := VSTMACAddressList.GetFirst;

     while not value and (node <> nil) do
           begin
                MACData := VSTMACAddressList.GetNodeData(Node);

                if MACData^.Original = NewAddress then
                   value := true;

                node := VSTMACAddressList.GetNext (node);
           end;

     result := value;
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.AddressExistsInList (const NewAddress: tIPv4Address) : boolean;

var Node     : pVirtualNode;
    IPv4Data : pReplacementIPv4Node;
    value    : boolean;

begin
     value := false;

     node := VSTIPv4AddressList.GetFirst;

     while not value and (node <> nil) do
           begin
                IPv4Data := VSTIPv4AddressList.GetNodeData(Node);

                if IPv4Data^.Original = NewAddress then
                   value := true;

                node := VSTIPv4AddressList.GetNext (node);
           end;

     result := value;
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.AddressExistsInList (const NewAddress: tIPv6Address): boolean;

var Node     : pVirtualNode;
    IPv6Data : pReplacementIPv6Node;
    value    : boolean;

begin
     value := false;

     node := VSTIPv6AddressList.GetFirst;

     while not value and (node <> nil) do
           begin
                IPv6Data := VSTIPv6AddressList.GetNodeData(Node);

                if IPv6Data^.Original = NewAddress then
                   value := true;

                node := VSTIPv6AddressList.GetNext (node);
           end;

     result := value;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.AutoReplaceMACAddresses;

var MACAddressList  : tMACEndpointList;
    Replacement     : string;
    Node            : pVirtualNode;
    MACData         : pReplacementMACNode;
    iMacCount       : integer;
    boAdd           : boolean;
    i               : integer;

begin
     MACAddressList := priv_conversationstore.GetMACEndpointList;
     iMacCount := 0;

     for i := 1 to length (MACAddressList) do
         begin
              boAdd := not (MACAddressList[i-1].MACAddress.isBroadcast or MACAddressList[i-1].MACAddress.isMulticast);

              if boAdd and not AddressExistsInList (MACAddressList[i-1].MACAddress) then
                 begin
                      inc (iMACCount);

                      Replacement := 'f2:00:00:' + format ('%.2d', [iMACCount]) + ':' + format ('%.2d', [iMACCount]) + ':' + format ('%.2d', [iMACCount]);

                      Node := VSTMACAddressList.AddChild (nil);
                      MACData := VSTMACAddressList.GetNodeData (Node);

                      MACData^.Original := MACAddressList[i-1].MACAddress;
                      MACData^.Replacement.setfromString (Replacement, ':');
                      MACData^.DefinedBy := defAuto;

                      VSTMACAddressList.RepaintNode (Node);
                      VSTMACAddressList.FocusedNode := Node;
                 end;
         end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.AutoReplaceIPv4Addresses;

var IPv4AddressList : tIPv4EndpointList;
    SameSubNet      : boolean;
    Node            : pVirtualNode;
    IPv4Data        : pReplacementIPv4Node;
    iClientCount    : integer;
    iServerCount    : integer;
    i               : integer;
    boAdd           : boolean;

begin
     IPv4AddressList := priv_conversationstore.GetIPv4EndpointsList;

     iClientCount := 0;
     iServerCount := 0;

     // Special check if both client and server are in the same subnet
     // We do this only if there exactly 2 different IPs in the trace(s)

     if length (IPv4AddressList) = 2 then
        begin
             if (getHopDistanceEstimate (IPv4AddressList[0].TTL) = 0) and (getHopDistanceEstimate (IPv4AddressList[1].TTL) = 0) then
                begin
                     // both IPs are zero hops away, now check if they are at least in the same /16

                     SameSubnet := (IPv4AddressList[0].IPv4Address.ValueAsLong and $ffff0000) = (IPv4AddressList[1].IPv4Address.ValueAsLong and $ffff0000);
                end
             else
                 SameSubNet := false;
        end
     else
         SameSubnet := false;

     // Replace, unless we don't know who client and who server is

     if ((IPv4AddressList[0].ClientCount > 0) and (IPv4AddressList[1].ClientCount = 0)) or ((IPv4AddressList[0].ClientCount = 0) and (IPv4AddressList[1].ClientCount > 0)) then
        begin
             for i := 1 to length (IPv4AddressList) do
                 begin
                      // Check if this is a normal node address and if it doesn't exist in the list yet

                      boAdd := IPv4AddressList[i-1].IPv4Address.isCommon and not AddressExistsInList (IPv4AddressList[i-1].IPv4Address);

                      if boAdd then
                         begin
                              Node := VSTIPv4AddressList.AddChild (nil);
                              IPv4Data := VSTIPv4AddressList.GetNodeData (Node);

                              IPv4Data^.Original := IPv4AddressList[i-1].IPv4Address;

                              if IPv4AddressList[i-1].ClientCount > 0 then
                                 begin
                                      inc (iClientCount);

                                      IPv4Data^.Replacement.setValueFromString('192.168.0.' + iClientCount.ToString)
                                 end
                              else
                                  begin
                                       inc (iServerCount);

                                       // If both client and server are apparently in the same subnet, put them there again

                                       if SameSubnet then
                                          IPv4Data^.Replacement.setValueFromString('192.168.0.10' + iServerCount.ToString)
                                       else
                                           IPv4Data^.Replacement.setValueFromString('10.10.10.' + iServerCount.ToString);
                                  end;

                              IPv4Data^.DefinedBy := defAuto;

                              VSTIPv4AddressList.RepaintNode (Node);
                              VSTIPv4AddressList.FocusedNode := Node;
                         end;
                 end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.AutoReplaceIPv6Addresses;


var IPv6AddressList : tIPv6EndpointList;
    SameSubNet      : boolean;
    Prefix          : tIPv6Address;
    Node            : pVirtualNode;
    IPv6Data        : pReplacementIPv6Node;
    iClientCount    : integer;
    iServerCount    : integer;
    i               : integer;
    boAdd           : boolean;

begin
     IPv6AddressList := priv_conversationstore.GetIPv6EndpointsList;

     iClientCount := 0;
     iServerCount := 0;

     // Special check if both client and server are in the same subnet
     // We do this only if there exactly 2 different IPs in the trace(s)

     if length (IPv6AddressList) = 2 then
        begin
             if (getHopDistanceEstimate (IPv6AddressList[0].HopLimit) = 0) and (getHopDistanceEstimate (IPv6AddressList[1].HopLimit) = 0) then
                begin
                     Prefix.initialize;
                     Prefix.CopyPrefixFrom (IPv6AddressList[0].IPv6Address, 64);

                     // both IPs are zero hops away, now check if they are at least in the same /16

                     SameSubnet := (IPv6AddressList[1].IPv6Address.BelongsToSubnet (Prefix));
                end
             else
                 SameSubNet := false;
        end
     else
         SameSubnet := false;

     if ((IPv6AddressList[0].ClientCount > 0) and (IPv6AddressList[1].ClientCount = 0)) or ((IPv6AddressList[0].ClientCount = 0) and (IPv6AddressList[1].ClientCount > 0)) then
        begin
             for i := 1 to length (IPv6AddressList) do
                 begin
                      // Check if this is a normal node address and if it doesn't exist in the list yet

                      boAdd := IPv6AddressList[i-1].IPv6Address.isCommon and not AddressExistsInList (IPv6AddressList[i-1].IPv6Address);

                      if boAdd then
                         begin
                              Node := VSTIPv6AddressList.AddChild (nil);
                              IPv6Data := VSTIPv6AddressList.GetNodeData (Node);

                              IPv6Data^.Original := IPv6AddressList[i-1].IPv6Address;

                              if IPv6AddressList[i-1].ClientCount > 0 then
                                 begin
                                      inc (iClientCount);

                                      IPv6Data^.Replacement.setValueFromString('2001:DB8:1::' + iClientCount.ToString)
                                 end
                              else
                                  begin
                                       inc (iServerCount);

                                       if SameSubnet then
                                          IPv6Data^.Replacement.setValueFromString('2001:DB8:1::10' + iServerCount.ToString)
                                       else
                                           IPv6Data^.Replacement.setValueFromString('2001:DB8:200::' + iServerCount.ToString);
                                  end;

                              IPv6Data^.DefinedBy := defAuto;

                              VSTIPv6AddressList.RepaintNode (Node);
                              VSTIPv6AddressList.FocusedNode := Node;
                         end;
                 end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopUpMenuAddButtonAutoClick(Sender: TObject);

begin
     case PageControlSettings.ActivePageIndex of
      TabIndexEthernet : begin
                               // MAC Addresses

                               AutoReplaceMACAddresses;
                          end;
      TabIndexIPv4     : begin
                              // IPv4 Addresses

                              AutoReplaceIPv4Addresses;
                         end;
      TabIndexIPv6     : begin
                              // IPv6 Addresses

                              AutoReplaceIPv6Addresses;
                         end;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopUpMenuAddButtonLookupClick (Sender: TObject);

begin
     case PageControlSettings.ActivePageIndex of
      TabIndexEthernet : LookupMACAddresses;
      TabIndexIPv4     : LookupIPv4Addresses;
      TabIndexIPv6     : LookupIPv6Addresses;
     end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopUpMenuClearClick(Sender: TObject);

var Tree : tVirtualStringTree;

begin
     Tree := (PopupMenuVirtualStringTrees.PopupComponent as tVirtualStringTree);

     if (MessageDlg('Do you really want to remove all items in the list?', mtConfirmation, [mbYes, mbNo], 0) in [mrYes]) then
        Tree.Clear;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopUpMenuExportClick(Sender: TObject);

var Tree    : tVirtualStringTree;
    fHandle : textfile;
    Node    : PVirtualNode;
    sLine   : string;
    boOkay  : boolean;

begin
     Tree := (PopupMenuVirtualStringTrees.PopupComponent as tVirtualStringTree);

     if SaveDialogExport.Execute then
        begin
             // Check if file exists

             if FileExists (SaveDialogExport.FileName) then
                boOkay := (MessageDlg('Warning: file exists, do you want to overwrite it?', mtWarning, [mbYes, mbNo], 0) in [mrYes])
             else
                 boOkay := true;

             // Export if all is okay

             if boOkay then
                begin
                     assignFile (fHandle, SaveDialogExport.FileName);
                     rewrite (fHandle);

                     sLine := GetHeaderStringForTree (Tree.name);
                     writeln (fHandle, sLine);

                     Node := Tree.GetFirst;

                     while Node <> nil do
                           begin
                                sLine := GetOutputStringForTreeRow (Tree.name, Node);

                                writeln (fHandle, sLine);

                                Node := Tree.GetNext(Node);
                           end;

                     Closefile (fHandle);
                end;
        end;
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.AddNodeDataToTree (Tree: tVirtualStringTree; ImportLine : string) : boolean;

var MACData    : pReplacementMACNode;
    VLANData   : pVLANPair;
    IPv4Data   : pReplacementIPv4Node;
    IPv6Data   : pReplacementIPv6Node;
    PortData   : pPortPair;
    SocketData : pSocketListEntry;
    Node       : PVirtualNode;
    value1     : string;
    value2     : string;
    value3     : string;
    value4     : string;
    value5     : string;
    Num1       : integer;
    Num2       : integer;
    valid      : boolean;
    Details    : tSocketDetails;

begin
     valid := true;

     value1 := GetEntry (ImportLine, ',', 1);
     value2 := GetEntry (ImportLine, ',', 2);
     value3 := GetEntry (ImportLine, ',', 3);
     value4 := GetEntry (ImportLine, ',', 4);
     value5 := GetEntry (ImportLine, ',', 5);

     TryStrToInt (value1, Num1);
     TryStrToInt (value2, Num2);

     if Tree.Name = 'VSTMACAddressList' then
        begin
             if isValidMAC (value1) and isValidMAC (value2) then
                begin
                     Node := Tree.AddChild(nil);
                     MACData := Tree.GetNodeData (Node);

                     MACData^.Original.setfromString (value1, ':');
                     MACData^.Replacement.setfromString (value2, ':');
                end
             else
                 valid := false;
        end;

     if Tree.Name = 'VSTVLANIDList' then
        begin
             if (Num1 > 0) and (Num2 > 0) then
                begin
                     Node := Tree.AddChild(nil);
                     VLANData := Tree.GetNodeData (node);

                     VLANData^.Value1 := Num1;
                     VLANData^.Value2 := Num2;
                end
             else
                 valid := false;
        end;

     if Tree.Name = 'VSTIPv4AddressList' then
        begin
             if isValidIPv4String (value1) and isValidIPv4String (value2 ) then
                begin
                     Node := Tree.AddChild(nil);
                     IPv4Data := Tree.GetNodeData (node);

                     IPv4Data^.Original.setValueFromString (value1);
                     IPv4Data^.Replacement.setValueFromString (value2);
                end
             else
                 valid := false;
        end;

     if Tree.Name = 'VSTIPv4SubnetList' then
        begin
             if isValidIPv4Subnet (value1) and isValidIPv4Subnet (value2 ) then
                begin
                     Node := Tree.AddChild(nil);
                     IPv4Data := Tree.GetNodeData (node);

                     IPv4Data^.Original.setValueFromCIDRString (value1);
                     IPv4Data^.Replacement.setValueFromCIDRString (value2);
                end
             else
                 valid := false;
        end;

     if Tree.Name = 'VSTIPv6AddressList' then
        begin
             if isValidIPv6String (value1) and isValidIPv6String (value2 ) then
                begin
                     Node := Tree.AddChild(nil);
                     IPv6Data := Tree.GetNodeData (node);

                     IPv6Data^.Original.setValueFromString (value1);
                     IPv6Data^.Replacement.setValueFromString (value2);
                end
             else
                 valid := false;
        end;

     if Tree.Name = 'VSTIPv6SubnetList' then
        begin
             if isValidIPv6Subnet (value1) and isValidIPv6Subnet (value2 ) then
                begin
                     Node := Tree.AddChild(nil);
                     IPv6Data := Tree.GetNodeData (node);

                     IPv6Data^.Original.setValueFromStringWithMask (value1);
                     IPv6Data^.Replacement.setValueFromStringWithMask (value2);
                end
             else
                 valid := false;        end;

     if Tree.Name = 'VSTTCPSocketList' then
        begin
             if (Num1 > 0) and (Num2 > 0) then
                begin
                     Node := Tree.AddChild(nil);
                     SocketData := Tree.GetNodeData (node);

                     tryStrToInt (value1, Num1);

                     if num1 = 4 then
                        SocketData^.Socket.Source.IPAddress.IPVersion := 4
                     else
                         SocketData^.Socket.Source.IPAddress.IPVersion := 6;

                     SocketData^.Socket.Source.IPAddress.setValueFromString (value2);
                     tryStrToInt (value3, Num2);
                     SocketData^.Socket.Source.Port := Num2;
                     SocketData^.Socket.Destination.IPAddress.setValueFromString(value4);
                     tryStrToInt (value5, Num2);
                     SocketData^.Socket.Destination.Port := Num2;

                     // If possible do some plausibility checks

                     if priv_conversationstore.HasRecords then
                        begin
                             Details := priv_conversationstore.GetSocketEntry (protTCP, SocketData^.Socket.Source);

                             SocketData^.isPlausible := not (Details.UseCount = 0);
                        end
                     else
                         SocketData^.isPlausible := true;
                end
             else
                 valid := false;
        end;

     if Tree.Name = 'VSTTCPPortList' then
        begin
             if (Num1 > 0) and (Num2 > 0) then
                begin
                     Node := Tree.AddChild(nil);
                     PortData := Tree.GetNodeData (node);

                     PortData^.Value1 := Num1;
                     PortData^.Value2 := Num2;
                end
             else
                 valid := false;
        end;

     if Tree.Name = 'VSTUDPSocketList' then
        begin
             if (Num1 > 0) and (Num2 > 0) then
                begin
                     Node := Tree.AddChild(nil);
                     SocketData := Tree.GetNodeData (node);

                     tryStrToInt (value1, Num1);
{
                     case num1 of
                      4 : begin
                               SocketData^.IPVersion := 4;
                               SocketData^.OriginalIPv4Socket.IPAddress.setValueFromString (value2);
                               tryStrToInt (value3, Num2);
                               SocketData^.OriginalIPv4Socket.Port := Num2;
                               tryStrToInt (value4, Num2);
                               SocketData^.NewPort := Num2;
                          end;
                      6 : begin
                               SocketData^.IPVersion := 6;
                               SocketData^.OriginalIPv6Socket.IPAddress.setValueFromString (value2);
                               tryStrToInt (value3, Num2);
                               SocketData^.OriginalIPv4Socket.Port := Num2;
                               tryStrToInt (value4, Num2);
                               SocketData^.NewPort := Num2;
                          end;
                     end;
}
                     if num1 = 4 then
                        SocketData^.Socket.Source.IPAddress.IPVersion := 4
                     else
                         SocketData^.Socket.Source.IPAddress.IPVersion := 6;

                     SocketData^.Socket.Source.IPAddress.setValueFromString (value2);
                     tryStrToInt (value3, Num2);
                     SocketData^.Socket.Source.Port := Num2;
                     SocketData^.Socket.Destination.IPAddress.setValueFromString(value4);
                     tryStrToInt (value5, Num2);
                     SocketData^.Socket.Destination.Port := Num2;
                end
             else
                 valid := false;
        end;

     if Tree.Name = 'VSTUDPPortList' then
        begin
             if (Num1 > 0) and (Num2 > 0) then
                begin
                     Node := Tree.AddChild(nil);
                     PortData := Tree.GetNodeData (node);

                     PortData^.Value1 := Num1;
                     PortData^.Value2 := Num2;
                end
             else
                 valid := false;
        end;

     result := valid;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopUpMenuImportFromFileClick (Sender: TObject);

var Tree : tVirtualStringTree;
    fHandle : textfile;
    iCount  : integer;
    sLine   : string;
    valid   : boolean;

begin
     Tree := (PopupMenuVirtualStringTrees.PopupComponent as tVirtualStringTree);

     if OpenDialogImport.Execute then
        begin
             assignFile (fHandle, OpenDialogImport.FileName);
             reset (fHandle);

             valid := true;
             iCount := 0;

             while valid and (not eof (fHandle)) do
                   begin
                        readln (fHandle, sLine);
                        inc (iCount);

                        if pos ('#', sLine) = 0 then
                           begin
                                valid := AddNodeDataToTree (Tree, sLine);

                                if not valid then
                                   MessageDlg('Error: cannot parse line #' + IntToStr (iCount) + ',aborting', mtError, [mbOK], 0);
                           end;
                   end;

             closefile (fHandle);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopUpMenuImportFromConversationStoreClick (Sender: TObject);

var Tree : tVirtualStringTree;

begin
     if (PopupMenuVirtualStringTrees.PopupComponent.ClassType = TVirtualStringTree) then
        begin
             Tree := (PopupMenuVirtualStringTrees.PopupComponent as tVirtualStringTree);

             if Tree.Name = 'VSTMACAddressList' then
                LookupMACAddresses;

             if Tree.Name = 'VSTIPv4AddressList' then
                LookupIPv4Addresses;

             if Tree.Name = 'VSTIPv6AddressList' then
                LookupIPv6Addresses;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onPopUpAddButtonImport (Sender: TObject);

var Tree    : tVirtualStringTree;
    fHandle : textfile;
    iCount  : integer;
    sLine   : string;
    valid   : boolean;

begin
     if PageControlSettings.ActivePage.Name = 'TabSheetEthernet' then
        Tree := VSTMACAddressList
     else
         if PageControlSettings.ActivePage.Name = 'TabSheetIPv4' then
            Tree := VSTIPv4AddressList
         else
             if PageControlSettings.ActivePage.Name = 'TabSheetIPv6' then
                Tree := VSTIPv6AddressList;

     if OpenDialogImport.Execute then
        begin
             assignFile (fHandle, OpenDialogImport.FileName);
             reset (fHandle);

             valid := true;
             iCount := 0;

             while valid and (not eof (fHandle)) do
                   begin
                        readln (fHandle, sLine);
                        inc (iCount);

                        if pos ('#', sLine) = 0 then
                           begin
                                valid := AddNodeDataToTree (Tree, sLine);

                                if not valid then
                                   MessageDlg('Error: cannot parse line #' + IntToStr (iCount) + ',aborting', mtError, [mbOK], 0);
                           end;
                   end;

             closefile (fHandle);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.LookupMACAddresses;

var MACList  : tMACEndpointList;
    values   : tStringList;
    Node     : pVirtualNode;
    Data     : pReplacementMACNode;
    Original : string;
    Replace  : string;
    i        : integer;

begin
     MACList := priv_conversationstore.GetMACEndpointList;

     FormSelectAddresses.Caption := 'Select Ethernet Addresses';
     FormSelectAddresses.PrepareValues (MACList);
     FormSelectAddresses.ShowModal;

     if FormSelectAddresses.ModalResult = mrOk then
        begin
             values := tStringList.Create;
             FormSelectAddresses.getReplacementPairs (values);

             for i := 1 to values.Count do
                 begin
                      Original := values.Names[i-1];
                      Replace := values.ValueFromIndex[i-1];

                      Node := VSTMACAddressList.AddChild(nil);
                      Data := VSTMACAddressList.GetNodeData(Node);

                      Data^.Original.setfromString (Original, ':');
                      Data^.Replacement.setFromString (Replace, ':');

                      VSTMACAddressList.RepaintNode(Node);
                      VSTMACAddressList.FocusedNode := Node;
                 end;

             values.Free;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.LookupIPv4Addresses;

var IPv4List : tIPv4EndpointList;
    values   : tStringList;
    Node     : pVirtualNode;
    Data     : pReplacementIPv4Node;
    Original : string;
    Replace  : string;
    i        : integer;

begin
     IPv4List := priv_conversationstore.GetIPv4EndpointsList;

     FormSelectAddresses.Caption := 'Select IPv4 Addresses';
     FormSelectAddresses.PrepareValues (IPv4List);
     FormSelectAddresses.ShowModal;

     if FormSelectAddresses.ModalResult = mrOk then
        begin
             values := tStringList.Create;
             FormSelectAddresses.getReplacementPairs (values);

             for i := 1 to values.Count do
                 begin
                      Original := values.Names[i-1];
                      Replace := values.ValueFromIndex[i-1];

                      Node := VSTIPv4AddressList.AddChild (nil);
                      Data := VSTIPv4AddressList.GetNodeData (Node);

                      Data^.Original.setValueFromString (Original,32);
                      Data^.Replacement.setValueFromString (Replace,32);

                      VSTIPv4AddressList.RepaintNode(Node);
                      VSTIPv4AddressList.FocusedNode := Node;
                 end;

             values.Free;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.LookupIPv6Addresses;

var IPv6List : tIPv6EndpointList;
    values   : tStringList;
    Node     : pVirtualNode;
    Data     : pReplacementIPv6Node;
    Original : string;
    Replace  : string;
    i        : integer;

begin
     IPv6List := priv_conversationstore.GetIPv6EndpointsList;

     FormSelectAddresses.Caption := 'Select IPv6 Addresses';
     FormSelectAddresses.PrepareValues (IPv6List);
     FormSelectAddresses.ShowModal;

     if FormSelectAddresses.ModalResult = mrOk then
        begin
             values := tStringList.Create;
             FormSelectAddresses.getReplacementPairs (values);

             for i := 1 to values.Count do
                 begin
                      Original := values.Names[i-1];
                      Replace := values.ValueFromIndex[i-1];

                      Node := VSTIPv6AddressList.AddChild (nil);
                      Data := VSTIPv6AddressList.GetNodeData (Node);

                      Data^.Original.setValueFromString (Original, 64);
                      Data^.Replacement.setValueFromString (Replace, 64);

                      VSTIPv6AddressList.RepaintNode (Node);
                      VSTIPv6AddressList.FocusedNode := Node;
                 end;

             values.Free;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.MenuExportReplacementStringsClick (Sender: TObject);

var key     : string;
    value   : string;
    fHandle : textfile;
    Node    : PVirtualNode;
    Data    : pReplacementEditorData;

begin
     if SaveDialogExport.Execute then
        begin
             assignFile (fHandle, SaveDialogExport.FileName);
             rewrite (fHandle);

             writeln (fHandle, '# Original,Replacement');

             Node := VSTPayloadReplacementStrings.GetFirst;

             while assigned (Node) do
                  begin
                       Data := VSTPayloadReplacementStrings.GetNodeData (Node);

                       key := stringReplace (Data^.original, ',', '\,', [rfReplaceAll]);
                       value := stringReplace (Data^.replacement, ',', '\,', [rfReplaceAll]);

                       if (Trim (key) <> '') then
                          writeln (fHandle, key + ',' + value);

                       Node := VSTPayloadReplacementStrings.GetNext (Node);
                 end;

             closefile (fHandle);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.MenuImportReplacementStringsClick (Sender: TObject);

var sline   : string;
    fHandle : textfile;
    value   : tANSIStringPair;
    iCount  : integer;
    doclear : boolean;
    Node    : PVirtualNode;
    Data    : pReplacementEditorData;

begin
     if VSTPayloadReplacementStrings.RootNodeCount > 0 then
        doclear := (MessageDlg('Do you want to clear existing entries before importing from file?', mtConfirmation, [mbYes, mbNo], 0) = mrYes)
     else
         doclear := True;

     if OpenDialogImport.Execute then
        begin
             VSTPayloadReplacementStrings.BeginUpdate;

             if doclear then
                VSTPayloadReplacementStrings.Clear
             else
                 begin
                      // Remove empty "next edit" row if it exists

                      Node := VSTPayloadReplacementStrings.GetLast (nil);
                      Data := VSTPayloadReplacementStrings.GetNodeData (node);

                      if (Data^.original = '') then
                         VSTPayloadReplacementStrings.DeleteNode (Node);
                 end;

             assignFile (fHandle, OpenDialogImport.FileName);
             reset (fHandle);

//           iCount := 0;

             while not eof (fHandle) do
                   begin
                        readln (fHandle, sLine);
//                      inc (iCount);

                        if pos ('#', sLine) = 0 then
                           begin
                                value.original := getEntry (sLine, ',', 1);
                                value.replacement := getEntry (sLine, ',', 2);

                                value.original := stringReplace (value.original, '\,', ',', [rfReplaceAll]);
                                value.replacement := stringReplace (value.replacement, '\,', ',', [rfReplaceAll]);

                                Node := VSTPayloadReplacementStrings.AddChild (nil);
                                Data := VSTPayloadReplacementStrings.GetNodeData (node);

                                Data^.original := value.original;
                                Data^.replacement := value.replacement;
                                Data^.deltalen := value.getLengthDelta;
                           end;
                   end;

             VSTPayloadReplacementStrings.EndUpdate;

             closefile (fHandle);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ClearAllSettings;

var Node : pVirtualNode;

begin
     // Payload

     CheckboxGeneralActionPacketTruncateUnknownPayload.Checked := false;
     ComboBoxGeneralPayloadRemovalMode.ItemIndex := 0;
     EditPayloadOverwritePattern.Text := '';
     CheckboxGeneralActionPacketTruncateAfterLayer.Checked := false;
     CheckboxGeneralActionPacketTruncateAfterOffset.Checked := false;
     CheckboxReplacePayloadStrings.Checked := false;
//   ValueListEditorPayloadReplacementStrings.Strings.Clear;
     VSTPayloadReplacementStrings.Clear;
     CheckboxReplacePayloadStringsCaseInsensitive.Checked := false;
     CheckboxReplacePayloadStringsDoNotEnforceSameLength.Checked := false;

     // PCAPng

     RadioButtonPCAPngActionPassthrough.Checked := true;

     CheckboxPCAPngActionSanitizeComments.Checked := false;
     CheckboxPCAPngActionSanitizeInterfaceBlocks.Checked := false;
     CheckboxPCAPngActionSanitizeNameResolutionBlocks.Checked := false;
     CheckboxPCAPngActionSanitizePacketOptions.Checked := false;

     // 802.11

     RadioButton802dot11ActionPassthrough.Checked := true;

     Checkbox802dot11ActionReplaceSSIDByList.Checked := false;
     VST802dot11SSIDReplacementList.Clear;
     CheckBox802dot11AutoReplaceRemainingSSIDs.Checked := true;
     Edit802dot11AutoReplaceRemainingSSIDsPrefix.Text := 'Redacted SSID #';
     CheckBox802dot11KeepUnknownTaggedParameters.Checked := false;

     // Ethernet

     RadioButtonEthernetActionPassthrough.Checked := true;

     CheckboxEthernetActionReplaceByList.Checked := false;
     CheckBoxProcessRemainingEthernetAddresses.Checked := false;
     ComboBoxRemainingEthernetAddressesProcessMode.ItemIndex := 0;
     CheckboxEthernetActionLeaveVendorIntact.Checked := false;
     CheckBoxEthernetRecalculateCRC.Enabled := false;
     ComboBoxEthernetRecalculateCRCMode.ItemIndex := 0;
     CheckBoxEthernetPreserveTrailer.Checked := False;

     // VLAN

     RadioButtonVLANActionPassthrough.Checked := true;

     CheckboxVLANActionReplaceByList.Checked := false;
     VSTVLANIDList.Clear;
     CheckboxVLANActionRemoveTag.Checked := false;
     ListBoxVLANActionRemoveVLANIDs.Clear;
     CheckBoxVLANActionRandomizeIDs.Checked := false;

     // Tunnel

     RadioButtonTunnelActionPassthrough.Checked := true;

     CheckboxAYIYAActionReplace.Checked := false;
     CheckBoxRandomizeLabels.Checked := false;
     UpDownMPLSMaximumLabelValue.Position := UpDownMPLSMaximumLabelValue.Max;

     // IPv4

     RadioButtonIPv4ActionPassThrough.Checked := true;

     CheckBoxReplaceIPv4AddressesByList.Checked := false;
     VSTIPv4AddressList.Clear;
     CheckBoxReplaceIPv4AddressesBySubnets.Checked := false;
     VSTIPv4SubnetList.Clear;
     CheckBoxProcessRemainingIPv4Addresses.Checked := false;
     ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex := 0;
     CheckBoxRandomizeIPv4Multicast.Checked := false;
     CheckBoxRandomizeIPv4APIPA.Checked := false;
     CheckBoxRandomizeIPv4DocumentationAddresses.Checked := false;
     ComboBoxIPRandomizePrivateRangeMode.ItemIndex := 0;
     CheckBoxRandomizeIPv4ID.Checked := false;
     CheckBoxIPRecalculateCRC.Checked := false;
     ComboBoxIPRecalculateCRCMode.ItemIndex := 0;

     // IPv6

     RadioButtonIPv6ActionPassThrough.Checked := true;

     CheckBoxReplaceIPv6AddressesByList.Checked := false;
     VSTIPv6AddressList.Clear;
     CheckBoxReplaceIPv6AddressesBySubnets.Checked := false;
     VSTIPv6SubnetList.Clear;
     CheckBoxProcessRemainingIPv6Addresses.Checked := false;
     ComboBoxRandominzeIPv6AddressMode.ItemIndex := 0;
     CheckBoxRandomizeIPv6DocumentationAddresses.Checked := false;

     // ICMPv4

     RadioButtonICMPv4ActionPassThrough.Checked := true;

     CheckBoxICMPv4RemovePingPayload.Checked := false;
     CheckBoxICMPv4RemoveMessages.Checked := false;

     node := VSTICMPv4RemoveMessages.GetFirst;

     while node <> nil do
           begin
                node.CheckState := csUncheckedNormal;
                node := VSTICMPv4RemoveMessages.GetNext (node)
           end;

     CheckBoxICMPv4RecalculateCRC.Checked := false;
     ComboBoxICMPv4RecalculateCRCMode.ItemIndex := 0;

     // ICMPv6

     RadioButtonICMPv6ActionPassThrough.Checked := true;

     CheckBoxICMPv6RemoveDNSServerFQDNs.Checked := false;
     CheckBoxICMPv6RemovePingPayload.Checked := false;
     CheckBoxICMPv6RecalculateCRC.Checked := false;
     ComboBoxICMPv6RecalculateCRCMode.ItemIndex := 0;

     // TCP

     RadioButtonTCPActionPassthrough.Checked := true;

     CheckBoxReplaceTCPPortsByList.Checked := false;
     VSTTCPPortList.Clear;
     CheckBoxTCPRandomizePorts.Checked := false;
     CheckBoxTCPRandomizePortsKeepSystemPorts.Checked := false;
     CheckBoxTCPRecalculateCRC.Checked := false;
     ComboBoxTCPRecalculateCRCMode.ItemIndex := 0;

     // UDP

     RadioButtonUDPActionPassthrough.Checked := true;

     CheckBoxReplaceUDPPortsByList.Checked := false;
     VSTUDPPortList.Clear;
     CheckBoxUDPRandomizePorts.Checked := false;
     CheckBoxUDPRandomizePortsKeepSystemPorts.Checked := false;
     CheckBoxUDPRecalculateCRC.Checked := false;
     ComboBoxUDPRecalculateCRCMode.ItemIndex := 0;

     // DHCPv4

     RadioButtonDHCPv4ActionPassthrough.Checked := true;
     CheckBoxDHCPv4HandleFQDNs.Checked := false;

     // Application

     RadioButtonRTPSActionPassthrough.Checked := True;
     ComboBoxRTPSActionReplaceMode.ItemIndex := 0;

     // Output

     RadioButtonFileOutputSameDirectory.Checked := true;

     // Trigger Tree update

     // Settings

//   CheckBoxUseDiskBasedDatabaseFile.Checked := false;
     CheckBoxKeepDatabaseFileAfterFinish.Checked := false;
     CheckBoxForceDatabasePath.Checked := false;
     EditReplacementDBPath.Text := '';

     CheckboxAdvReassembleIPFragments.Checked := true;
     UpDownAdvReassemblyChainTimeout.Position := DefaultReassemblyChainTimeout;

     UpdateTreeNodesStatus;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopupMenuToolsClearAllSettingsClick (Sender: TObject);

begin
     ClearAllSettings;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopupMenuToolsResetSettingsToFactoryClick (Sender: TObject);

begin
     if FileExists (priv_defaultsettingspath + 'Factory\anonymize.task') then
        begin
             LoadSettings (priv_defaultsettingspath + 'Factory\anonymize.task');
             RefreshFormItemsDisplay;
        end
     else
         MessageDlg('Cannot determine path of factory default settings file, aborting.', mtError, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopupMenuToolsSetAsDefaultClick (Sender: TObject);

begin
     if priv_defaultsettingspath <> '' then
        SaveSettings (priv_defaultsettingspath + 'anonymize.task')
     else
         MessageDlg('Cannot determine path of default settings file, aborting.', mtError, [mbOK], 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.PopupMenuToolsSpecialSwapConversationAddressesClick (Sender: TObject);
{
var IPv4ConvList : tIPv4ConversationList;
    Entry        : tIPv4Conversation;
    Node         : pVirtualNode;
    EthData      : pMACAddressPair;
}
begin
     // This was a routine for Larry Greenblatt which needs more groundwork first, e.g. MAC to IP mappings

{
     IPv4ConvList := priv_conversationstore.GetIPv4ConversationList;

     FormSelectAnonConversations.prepareConversationlist (IPv4ConvList);
     FormSelectAnonConversations.Caption := 'Select Conversations to swap';
     FormSelectAnonConversations.ShowModal;

     if FormSelectAnonConversations.ModalResult = mrOk then
        begin
             for i := 1 to length (FormSelectAnonConversations.ResultList) do
                 begin
                      entry := FormSelectAnonConversations.ResultList[i-1];

                      // Add Ethernet replacement rules

                      Node := VSTMACAddressList.AddChild(nil);
                      EthData := VSTMACAddressList.GetNodeData(Node);

                      EthData^.Source.setfromString (Original, ':');
                      EthData^.Destination.setfromString(Replacement, ':');

                      VSTMACAddressList.RepaintNode(Node);
                      VSTMACAddressList.FocusedNode := Node;


                 end;
        end;
}
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv4AddressListAddClick (Sender: TObject);

var Original    : tIPv4Address;
    Replacement : tIPv4Address;
    Node        : PVirtualNode;
    Data        : pReplacementIPv4Node;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETIPv4Address;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';
//   FormReplacementDetails.MemoActionHint.Text := 'Enter IPv4 addresses.' + CRLF + CRLF + 'Example: 192.168.0.1';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original.setValueFromString (FormReplacementDetails.EditOriginal.Text, 32);
             Replacement.setValueFromString (FormReplacementDetails.EditReplacement.Text, 32);

             if not AddressExistsInList (Original) then
                begin
                     Node := VSTIPv4AddressList.AddChild (nil);
                     Data := VSTIPv4AddressList.GetNodeData (Node);

                     Data^.Original := Original;
                     Data^.Replacement := Replacement;
                     Data^.DefinedBy := defUser;

                     VSTIPv4AddressList.RepaintNode (Node);
                     VSTIPv4AddressList.FocusedNode := Node;
                end
             else
                 showMessage ('IP Address ' + Original.ValueAsString + ' already exists, cannot add');
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv4AddressListEditClick (Sender: TObject);

var Node : PVirtualNode;
    Data : pReplacementIPv4Node;

begin
     Node := VSTIPv4AddressList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTIPv4AddressList.GetNodeData(Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETIPv4Address;
             FormReplacementDetails.EditOriginal.Text := Data^.Original.ValueAsString;
             FormReplacementDetails.EditReplacement.Text := Data^.Replacement.ValueAsString;
//           FormReplacementDetails.MemoActionHint.Text := 'Enter IPv4 addresses.' + CRLF + CRLF + 'Example: 192.168.0.1';

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Data^.Original.setValueFromString (FormReplacementDetails.EditOriginal.Text,32);
                     Data^.Replacement.setValueFromString (FormReplacementDetails.EditReplacement.Text,32);
                     Data^.DefinedBy := defUser;

                     VSTIPv4AddressList.RepaintNode (Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv4AddressListRemoveClick (Sender: TObject);

var Node : PVirtualNode;

begin
{
     Node := VSTIPv4AddressList.FocusedNode;

     if Node <> nil then
        VSTIPv4AddressList.DeleteNode (node);
}
     Node := VSTIPv4AddressList.GetFirstSelected;

     while assigned (node) do
           begin
                VSTIPv4AddressList.DeleteNode (node);
                node := VSTIPv4AddressList.GetNextSelected (node);
           end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv4SubnetListAddClick (Sender: TObject);

var Original    : string;
    Replacement : string;
    Node        : PVirtualNode;
    Data        : pReplacementIPv4Node;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETIPv4Subnet;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';
//   FormReplacementDetails.MemoActionHint.Text := 'Enter IPv4 subnets using slashed notation. Original and replacement must have the same mask bit count.' + CRLF + CRLF + 'Example: 192.168.0.0/24';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original := FormReplacementDetails.EditOriginal.Text;
             Replacement := FormReplacementDetails.EditReplacement.Text;

             Node := VSTIPv4SubnetList.AddChild(nil);
             Data := VSTIPv4SubnetList.GetNodeData(Node);

             Data^.Original.setValueFromCIDRString (Original);
             Data^.Replacement.setValueFromCIDRString (Replacement);

             VSTIPv4SubnetList.RepaintNode(Node);
             VSTIPv4SubnetList.FocusedNode := Node;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv4SubnetListEditClick (Sender: TObject);

var Node : PVirtualNode;
    Data : pReplacementIPv4Node;

begin
     Node := VSTIPv4SubnetList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTIPv4SubnetList.GetNodeData(Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETIPv4Subnet;
             FormReplacementDetails.EditOriginal.Text := Data^.Original.ValueAsCIDRString;
             FormReplacementDetails.EditReplacement.Text := Data^.Replacement.ValueAsCIDRString;
//           FormReplacementDetails.MemoActionHint.Text := 'Enter IPv4 subnets using slashed notation. Original and replacement must have the same mask bit count.' + CRLF + CRLF + 'Example: 192.168.0.0/24';

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Data^.Original.setValueFromCIDRString (FormReplacementDetails.EditOriginal.Text);
                     Data^.Replacement.setValueFromCIDRString (FormReplacementDetails.EditReplacement.Text);

                     VSTIPv4SubnetList.RepaintNode(Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv4SubnetListRemoveClick (Sender: TObject);

var Node : PVirtualNode;

begin
     Node := VSTIPv4SubnetList.GetFirstSelected;

     while assigned (Node) do
           begin
                VSTIPv4SubnetList.DeleteNode (node);
                Node := VSTIPv4SubnetList.GetNextSelected (Node);
           end;
{
     Node := VSTIPv4SubnetList.FocusedNode;

     if Node <> nil then
        VSTIPv4SubnetList.DeleteNode(node);
}
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv6AddressListAddClick (Sender: TObject);

var Original    : tIPv6Address;
    Replacement : tIPv6Address;
    Node        : PVirtualNode;
    Data        : pReplacementIPv6Node;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETIPv6Address;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';
//   FormReplacementDetails.MemoActionHint.Text := 'Enter IPv6 addresses in long or shortened notation.' + CRLF + CRLF + 'Example: 2001:db8:1234::1';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original.setValueFromString (FormReplacementDetails.EditOriginal.Text, 128);
             Replacement.setValueFromString (FormReplacementDetails.EditReplacement.Text, 128);

             if not AddressExistsInList (Original) then
                begin
                     Node := VSTIPv6AddressList.AddChild (nil);
                     Data := VSTIPv6AddressList.GetNodeData (Node);

                     Data^.Original := Original;
                     Data^.Replacement := Replacement;
                     Data^.DefinedBy := defUser;

                     VSTIPv6AddressList.RepaintNode (Node);
                     VSTIPv6AddressList.FocusedNode := Node;
                end
             else
                 showMessage ('IP Address ' + Original.ValueAsString + ' already exists, cannot add');
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv6AddressListEditClick(Sender: TObject);

var Node : PVirtualNode;
    Data : pReplacementIPv6Node;

begin
     Node := VSTIPv6AddressList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTIPv6AddressList.GetNodeData (Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETIPv6Address;
             FormReplacementDetails.EditOriginal.Text := Data^.Original.ValueAsString;
             FormReplacementDetails.EditReplacement.Text := Data^.Replacement.ValueAsString;
//           FormReplacementDetails.MemoActionHint.Text := 'Enter IPv6 addresses in long or shortened notation.' + CRLF + CRLF + 'Example: 2001:db8:1234::1';

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Data^.Original.setValueFromString (FormReplacementDetails.EditOriginal.Text, 128);
                     Data^.Replacement.setValueFromString (FormReplacementDetails.EditReplacement.Text, 128);
                     Data^.DefinedBy := defUser;

                     VSTIPv6AddressList.RepaintNode (Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv6AddressListRemoveClick (Sender: TObject);

var Node : PVirtualNode;

begin
     Node := VSTIPv6AddressList.GetFirstSelected;

     while assigned (Node) do
           begin
                VSTIPv6AddressList.DeleteNode (Node);
                Node := VSTIPv6AddressList.GetNextSelected (Node);
           end;

{
     Node := VSTIPv6AddressList.FocusedNode;

     if Node <> nil then
        VSTIPv6AddressList.DeleteNode (node);
}
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv6SubnetListAddClick (Sender: TObject);

var Original    : string;
    Replacement : string;
    Node        : PVirtualNode;
    Data        : pReplacementIPv6Node;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETIPv6Subnet;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';
//   FormReplacementDetails.MemoActionHint.Text := 'Enter IPv6 subnets using slashed notation. Original and replacement must have the same mask bit count.' + CRLF + 'Example: 2001:db8:1234:5678::/64';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original := FormReplacementDetails.EditOriginal.Text;
             Replacement := FormReplacementDetails.EditReplacement.Text;

             Node := VSTIPv6SubnetList.AddChild(nil);
             Data := VSTIPv6SubnetList.GetNodeData(Node);

             Data^.Original.setValueFromStringWithMask (Original);
             Data^.Replacement.setValueFromStringWithMask (Replacement);

             VSTIPv6SubnetList.RepaintNode(Node);
             VSTIPv6SubnetList.FocusedNode := Node;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv6SubnetListEditClick (Sender: TObject);

var Node : PVirtualNode;
    Data : pReplacementIPv6Node;

begin
     Node := VSTIPv6SubnetList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTIPv6SubnetList.GetNodeData(Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETIPv6Subnet;
             FormReplacementDetails.EditOriginal.Text := Data^.Original.ValueAsSlashedNotationString;
             FormReplacementDetails.EditReplacement.Text := Data^.Replacement.ValueAsSlashedNotationString;
//           FormReplacementDetails.MemoActionHint.Text := 'Enter IPv6 subnets using slashed notation. Original and replacement must have the same mask bit count.' + CRLF + 'Example: 2001:db8:1234:5678::/64';

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Data^.Original.setValueFromStringWithMask (FormReplacementDetails.EditOriginal.Text);
                     Data^.Replacement.setValueFromStringWithMask (FormReplacementDetails.EditReplacement.Text);

                     VSTIPv6SubnetList.RepaintNode(Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonIPv6SubnetListRemoveClick (Sender: TObject);

var Node : PVirtualNode;

begin
     Node := VSTIPv6SubnetList.GetFirstSelected;

     while assigned (Node) do
           begin
                VSTIPv6SubnetList.DeleteNode(node);

                Node := VSTIPv6SubnetList.GetNextSelected (Node);
           end;
{
     Node := VSTIPv6SubnetList.FocusedNode;

     if Node <> nil then
        VSTIPv6SubnetList.DeleteNode(node);
}
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonListBoxVLANActionRemoveVLANIDsAddClick (Sender: TObject);

begin
     FormEditVLANID.ShowModal;

     if FormEditVLANID.ModalResult = mrOK then
        begin
             if ListBoxVLANActionRemoveVLANIDs.Items.IndexOf (FormEditVLANID.EditVLANID.Text) = -1 then
                ListBoxVLANActionRemoveVLANIDs.Items.Add (FormEditVLANID.EditVLANID.Text);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonListBoxVLANActionRemoveVLANIDsClearClick (Sender: TObject);

begin
     ListBoxVLANActionRemoveVLANIDs.Clear;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonListBoxVLANActionRemoveVLANIDsRemoveClick (Sender: TObject);

begin
     ListBoxVLANActionRemoveVLANIDs.Items.Delete(ListBoxVLANActionRemoveVLANIDs.ItemIndex);

     ButtonListBoxVLANActionRemoveVLANIDsRemove.Enabled := (ListBoxVLANActionRemoveVLANIDs.ItemIndex > -1);
end;

procedure TFormTaskAnonymize.ButtonOkayClick(Sender: TObject);
begin

end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonSelectDBPathClick(Sender: TObject);

var sPath : string;

begin
     sPath := BrowseDialog ('Select Path', BIF_RETURNONLYFSDIRS);

     if DirectoryExists (sPath) then
        EditReplacementDBPath.Text := sPath;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonSelectOutputDirectoryClick (Sender: TObject);

var sPath : string;

begin
     sPath := BrowseDialog ('Select Path', BIF_RETURNONLYFSDIRS);

     if DirectoryExists (sPath) then
        LabeledEditOutputToDirectory.Text := sPath;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonTCPSocketListAddClick(Sender: TObject);

var Original    : string;
    Replacement : string;
    Node        : PVirtualNode;
    Data        : pSocketListEntry;
    Details     : tSocketDetails;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETTCPSocketPort;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original := FormReplacementDetails.EditOriginal.Text;
             Replacement := FormReplacementDetails.EditReplacement.Text;

             Node := VSTTCPSocketList.AddChild (nil);
             Data := VSTTCPSocketList.GetNodeData (Node);

             if isValidIPv4Socket (Original) then
                Data^.Socket.Source.IPAddress.IPVersion := 4
             else
                 Data^.Socket.Source.IPAddress.IPVersion := 6;

             Data^.Socket.Source.initialize (Original);
             Data^.Socket.Destination.initialize (Replacement);

             // If possible do some plausibility checks

             if priv_conversationstore.HasRecords then
                begin
                     Details := priv_conversationstore.GetSocketEntry (protTCP, Data^.Socket.Source);

                     Data^.isPlausible := not (Details.UseCount = 0);
                end;

             VSTTCPSocketList.RepaintNode(Node);
             VSTTCPSocketList.FocusedNode := Node;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonTCPSocketListEditClick(Sender: TObject);

var Original    : string;
    Replacement : string;
    Node        : PVirtualNode;
    Data        : pSocketListEntry;
    Details     : tSocketDetails;

begin
     Node := VSTTCPSocketList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTTCPSocketList.GetNodeData(Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETTCPSocketPort;

             FormReplacementDetails.EditOriginal.Text := Data^.Socket.Source.ValueAsString;
             FormReplacementDetails.EditReplacement.Text := Data^.Socket.Destination.ValueAsString;

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Original := FormReplacementDetails.EditOriginal.Text;
                     Replacement := FormReplacementDetails.EditReplacement.Text;

                     if isValidIPv4Socket (Original) then
                        Data^.Socket.Source.IPAddress.IPVersion := 4
                     else
                         Data^.Socket.Source.IPAddress.IPVersion := 6;

                     Data^.Socket.Source.initialize (Original);
                     Data^.Socket.Destination.initialize (Replacement);

                     // If possible do some plausibility checks

                     if priv_conversationstore.HasRecords then
                        begin
                             Details := priv_conversationstore.GetSocketEntry (protTCP, Data^.Socket.Source);

                             Data^.isPlausible := not (Details.UseCount = 0);
                        end;

                     VSTTCPSocketList.RepaintNode(Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonTCPSocketListRemoveClick (Sender: TObject);

var Node : PVirtualNode;

begin
     Node := VSTTCPSocketList.GetFirstSelected;

     while assigned (Node) do
           begin
                VSTTCPSocketList.DeleteNode (node);

                Node := VSTTCPSocketList.GetNextSelected (Node);
           end;

{
     Node := VSTTCPSocketList.FocusedNode;

     if Node <> nil then
        VSTTCPSocketList.DeleteNode(node);
}
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonTCPPortListAddClick(Sender: TObject);

var Original    : string;
    Replacement : string;
    Node        : PVirtualNode;
    Data        : pPortPair;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETTCPPort;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';
//   FormReplacementDetails.MemoActionHint.Text := 'Enter TCP Port number.' + CRLF + CRLF + 'Example: 49152';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original := FormReplacementDetails.EditOriginal.Text;
             Replacement := FormReplacementDetails.EditReplacement.Text;

             Node := VSTTCPPortList.AddChild (nil);
             Data := VSTTCPPortList.GetNodeData (Node);

             Data^.Value1 := StrToInt (Original);
             Data^.Value2 := StrToInt (Replacement);

             VSTTCPPortList.RepaintNode(Node);
             VSTTCPPortList.FocusedNode := Node;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonTCPPortListEditClick(Sender: TObject);

var Node : PVirtualNode;
    Data : pPortPair;

begin
     Node := VSTTCPPortList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTTCPPortList.GetNodeData(Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETTCPPort;
             FormReplacementDetails.EditOriginal.Text := IntToStr (Data^.Value1);
             FormReplacementDetails.EditReplacement.Text := IntToStr (Data^.Value2);
//           FormReplacementDetails.MemoActionHint.Text := 'Enter TCP Port number.' + CRLF + CRLF + 'Example: 49152';

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Data^.Value1 := StrToInt (FormReplacementDetails.EditOriginal.Text);
                     Data^.Value2 := StrToInt (FormReplacementDetails.EditReplacement.Text);

                     VSTTCPPortList.RepaintNode(Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonTCPPortListRemoveClick(Sender: TObject);

var Node : PVirtualNode;

begin
     Node := VSTTCPPortList.GetFirstSelected;

     while assigned (Node) do
           begin
                VSTTCPPortList.DeleteNode(node);

                Node := VSTTCPPortList.GetNextSelected (Node);
           end;
{
     Node := VSTTCPPortList.FocusedNode;

     if Node <> nil then
        VSTTCPPortList.DeleteNode(node);
}
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonToolsClick(Sender: TObject);

var popupPoint : TPoint;

begin
     if Assigned (PopupMenuTools) then
        begin
             popupPoint.X := ButtonTools.Left + (ButtonTools.Width DIV 2) ;
             popupPoint.Y := ButtonTools.Top + (ButtonTools.Height DIV 2) ;
             popupPoint := ClientToScreen (popupPoint) ;

             //display the popup in the center of the "menu button"

             PopupMenuTools.Popup(popupPoint.X, popupPoint.Y) ;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonUDPSocketListAddClick (Sender: TObject);

var Original    : string;
    Replacement : string;
    Node        : PVirtualNode;
//  Data        : pSocketPortPair;
    Data        : pSocketListEntry;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETUDPSocketPort;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original := FormReplacementDetails.EditOriginal.Text;
             Replacement := FormReplacementDetails.EditReplacement.Text;

             Node := VSTUDPSocketList.AddChild (nil);
             Data := VSTUDPSocketList.GetNodeData (Node);

             if isValidIPv4Socket (Original) then
                Data^.Socket.Source.IPAddress.IPVersion := 4
             else
                 Data^.Socket.Source.IPAddress.IPVersion := 6;

             Data^.Socket.Source.initialize (Original);
             Data^.Socket.Destination.initialize (Replacement);

             VSTUDPSocketList.RepaintNode(Node);
             VSTUDPSocketList.FocusedNode := Node;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonUDPSocketListEditClick (Sender: TObject);

var Original    : string;
    Replacement : string;
    Node        : PVirtualNode;
//  Data        : pSocketPortPair;
    Data        : pSocketListEntry;

begin
     Node := VSTUDPSocketList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTUDPSocketList.GetNodeData(Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETTCPSocketPort;
{
             case Data^.IPVersion of
              4 : FormReplacementDetails.EditOriginal.Text := Data^.OriginalIPv4Socket.ValueAsString;
              6 : FormReplacementDetails.EditOriginal.Text := Data^.OriginalIPv6Socket.ValueAsString;
             end;

             FormReplacementDetails.EditReplacement.Text := IntToStr (Data^.NewPort);
}
             FormReplacementDetails.EditOriginal.Text := Data^.Socket.Source.ValueAsString;
             FormReplacementDetails.EditReplacement.Text := Data^.Socket.Destination.ValueAsString;

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Original := FormReplacementDetails.EditOriginal.Text;
                     Replacement := FormReplacementDetails.EditReplacement.Text;
{
                     if isValidIPv4Socket (Original) then
                        Data^.OriginalIPv4Socket.initialize (Original)
                     else
                         Data^.OriginalIPv6Socket.initialize (Original);

                     Data^.NewPort := StrToInt (Replacement);
}
                     if isValidIPv4Socket (Original) then
                        Data^.Socket.Source.IPAddress.IPVersion := 4
                     else
                         Data^.Socket.Source.IPAddress.IPVersion := 6;

                     Data^.Socket.Source.initialize (Original);
                     Data^.Socket.Destination.initialize (Replacement);

                     VSTUDPSocketList.RepaintNode(Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonUDPSocketListRemoveClick (Sender: TObject);

var Node : PVirtualNode;

begin
     Node := VSTUDPSocketList.GetFirstSelected;

     while assigned (Node) do
           begin
                VSTUDPSocketList.DeleteNode(node);

                Node := VSTUDPSocketList.GetNextSelected (Node);
           end;
{
     Node := VSTUDPSocketList.FocusedNode;

     if Node <> nil then
        VSTUDPSocketList.DeleteNode(node);
}
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonUDPPortListAddClick(Sender: TObject);

var Original    : string;
    Replacement : string;
    Node        : PVirtualNode;
    Data        : pPortPair;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETUDPPort;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';
//   FormReplacementDetails.MemoActionHint.Text := 'Enter UDP Port number.' + CRLF + CRLF + 'Example: 49152';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original := FormReplacementDetails.EditOriginal.Text;
             Replacement := FormReplacementDetails.EditReplacement.Text;

             Node := VSTUDPPortList.AddChild (nil);
             Data := VSTUDPPortList.GetNodeData (Node);

             Data^.Value1 := StrToInt (Original);
             Data^.Value2 := StrToInt (Replacement);

             VSTUDPPortList.RepaintNode(Node);
             VSTUDPPortList.FocusedNode := Node;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonUDPPortListEditClick(Sender: TObject);

var Node : PVirtualNode;
    Data : pPortPair;

begin
     Node := VSTUDPPortList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTUDPPortList.GetNodeData(Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETUDPPort;
             FormReplacementDetails.EditOriginal.Text := IntToStr (Data^.Value1);
             FormReplacementDetails.EditReplacement.Text := IntToStr (Data^.Value2);
//           FormReplacementDetails.MemoActionHint.Text := 'Enter UDP Port number.' + CRLF + CRLF + 'Example: 49152';

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Data^.Value1 := StrToInt (FormReplacementDetails.EditOriginal.Text);
                     Data^.Value2 := StrToInt (FormReplacementDetails.EditReplacement.Text);

                     VSTUDPPortList.RepaintNode(Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonUDPPortListRemoveClick(Sender: TObject);

var Node : PVirtualNode;

begin
     Node := VSTUDPPortList.GetFirstSelected;

     while assigned (Node) do
           begin
                VSTUDPPortList.DeleteNode(node);

                Node := VSTUDPPortList.GetNextSelected (Node);
           end;

{
     Node := VSTUDPPortList.FocusedNode;

     if Node <> nil then
        VSTUDPPortList.DeleteNode(node);
}
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonVLANListAddClick(Sender: TObject);

var Original    : string;
    Replacement : string;
    Node        : PVirtualNode;
    Data        : pVLANPair;

begin
     FormReplacementDetails.ReplacementEditMode := tEMAdd;
     FormReplacementDetails.ReplacementEditType := tETVLANID;
     FormReplacementDetails.EditOriginal.Text := '';
     FormReplacementDetails.EditReplacement.Text := '';
//   FormReplacementDetails.MemoActionHint.Text := 'Enter VLAN ID between 0 and 4095.' + CRLF + CRLF + 'Example: 1234';

     FormReplacementDetails.showmodal;

     if FormReplacementDetails.ModalResult = mrOK then
        begin
             Original := FormReplacementDetails.EditOriginal.Text;
             Replacement := FormReplacementDetails.EditReplacement.Text;

             Node := VSTVLANIDList.AddChild(nil);
             Data := VSTVLANIDList.GetNodeData(Node);

             Data^.Value1 := StrToInt (Original);
             Data^.Value2 := StrToInt (Replacement);

             VSTVLANIDList.RepaintNode(Node);
             VSTVLANIDList.FocusedNode := Node;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonVLANListEditClick(Sender: TObject);

var Node : PVirtualNode;
    Data : pVLANPair;

begin
     Node := VSTVLANIDList.FocusedNode;

     if Node <> nil then
        begin
             Data := VSTVLANIDList.GetNodeData(Node);

             FormReplacementDetails.ReplacementEditMode := tEMEdit;
             FormReplacementDetails.ReplacementEditType := tETVLANID;
             FormReplacementDetails.EditOriginal.Text := IntToStr (Data^.Value1);
             FormReplacementDetails.EditReplacement.Text := IntToStr (Data^.Value2);
//           FormReplacementDetails.MemoActionHint.Text := 'Enter VLAN ID between 0 and 4095.' + CRLF + CRLF + 'Example: 1234';

             FormReplacementDetails.showmodal;

             if FormReplacementDetails.ModalResult = mrOK then
                begin
                     Data^.Value1 := StrToInt (FormReplacementDetails.EditOriginal.Text);
                     Data^.Value2 := StrToInt (FormReplacementDetails.EditReplacement.Text);

                     VSTVLANIDList.RepaintNode(Node);
                end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.ButtonVLANListRemoveClick(Sender: TObject);

var Node : PVirtualNode;

begin
     Node := VSTVLANIDList.FocusedNode;

     if Node <> nil then
        VSTVLANIDList.DeleteNode(node);
end;

(* ------------------------------------------- *)
{ Transfer replacement parameters }
(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetPayloadActionParameters (var value: tAnonymizeParameters);

var count : integer;
    Node  : PVirtualNode;
    Data  : pReplacementEditorData;

begin
     value.KeepOriginalApplicationString := false;      // TODO: make KeepOriginalApplicationString changeable?

     value.PayloadTruncateUnknownLayers := CheckboxGeneralActionPacketTruncateUnknownPayload.Checked;
     value.PayloadOverwritePattern := '';

     case ComboBoxGeneralPayloadRemovalMode.ItemIndex of
      0 : value.PayloadRemovalMode := prmCut;
      1 : value.PayloadRemovalMode := prmZero;
      2 : begin
               value.PayloadRemovalMode := prmString;
               value.PayloadOverwritePattern := EditPayloadOverwritePattern.Text;
          end;
     end;

     value.PayloadDoTruncateAfterLayer := CheckboxGeneralActionPacketTruncateAfterLayer.Checked;
     value.PayloadTruncateAfterLayer := ComboBoxGeneralPacketSlicingLayer.ItemIndex + 2;

     value.PayloadDoTruncateAtOffset := CheckboxGeneralActionPacketTruncateAfterOffset.Checked;
     value.PayloadTruncateAtOffset := UpDownGeneralPacketSlicingOffset.Position;
     value.PayLoadDoReplaceStrings := CheckboxReplacePayloadStrings.Enabled and CheckboxReplacePayloadStrings.checked;

     value.PayloadReAddPaddingIfSliced := CheckboxGeneralActionPacketTruncateReAddPadding.Enabled and CheckboxGeneralActionPacketTruncateReAddPadding.Checked;

     if value.PayLoadDoReplaceStrings then
        begin
             value.PayLoadDoReplaceCaseInsensitve := CheckboxReplacePayloadStringsCaseInsensitive.Checked and CheckboxReplacePayloadStringsCaseInsensitive.Enabled;
             value.PayloadDoNotEnforceSameLength := CheckboxReplacePayloadStringsDoNotEnforceSameLength.Checked and CheckboxReplacePayloadStringsDoNotEnforceSameLength.Enabled;

             setLength (value.PayloadReplacementStrings, VSTPayloadReplacementStrings.RootNodeCount);

             Node := VSTPayloadReplacementStrings.GetFirst;
             count := 0;

             while assigned (Node) do
                   begin
                        Data := VSTPayloadReplacementStrings.GetNodeData (Node);

                        if (Data^.original <> '') then
                           begin
                                value.PayloadReplacementStrings[count].original := Data^.original;
                                value.PayloadReplacementStrings[count].replacement := Data^.replacement;

                                inc (count);
                           end;

                        Node := VSTPayloadReplacementStrings.GetNext (Node);
                   end;

             // Cut down to the real length in case we skipped some values in the loop for being empty

             setLength (value.PayloadReplacementStrings, count);
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetPCAPngActionParameters (var value: tAnonymizeParameters);

begin
     value.PCAPngDoReplace := RadioButtonPCAPngActionReplace.Checked;

     if CheckboxPCAPngActionSanitizeComments.Checked then
        begin
             case ComboBoxPCAPngActionSanitizeCommentScope.ItemIndex of
              0 : value.PCAPngSanitizeCommentsScope := scsBoth;
              1 : value.PCAPngSanitizeCommentsScope := scsFile;
              2 : value.PCAPngSanitizeCommentsScope := scsPacket;
             end;

             case ComboBoxPCAPngActionSanitizeCommentMethod.ItemIndex of
              0 : value.PCAPngSanitizeCommentsMode := scmRemoveAll;
              1 : value.PCAPngSanitizeCommentsMode := scmAsk;
             end;
        end
     else
         begin
              value.PCAPngSanitizeCommentsScope := scsNone;
              value.PCAPngSanitizeCommentsMode := scmRemoveAll;
         end;

     value.PCAPngIHBDoReplace := CheckboxPCAPngActionSanitizeInterfaceBlocks.Checked;

     if CheckboxPCAPngActionSanitizeInterfaceBlocks.Checked then
        begin
             case ComboBoxPCAPngActionSanitizeIHBInterfaceNames.ItemIndex of
              0 : value.PCAPngSanitizeIHBInterfaceName := simReplaceGeneric;
              1 : value.PCAPngSanitizeIHBInterfaceName := simSetToBlank;
              2 : value.PCAPngSanitizeIHBInterfaceName := simNone;
             end;

             case ComboBoxPCAPngActionSanitizeIHBCaptureFilters.ItemIndex of
              0 : value.PCAPngSanitizeIHBCaptureFilter := cfmRemoveFilter;
              1 : value.PCAPngSanitizeIHBCaptureFilter := cfmKeepFilter;
             end;
        end
     else
         begin
              value.PCAPngSanitizeIHBInterfaceName := simNone;
              value.PCAPngSanitizeIHBCaptureFilter := cfmNone;
         end;

{
Set according to IP replacement settings
Ask for each entry
}

     if CheckboxPCAPngActionSanitizeNameResolutionBlocks.Checked then
        begin
             case ComboBoxPCAPngActionSanitizeNRBMethod.ItemIndex of
              0 : value.PCAPngSanitizeNRB := snmRemoveBlock;
              1 : value.PCAPngSanitizeNRB := snmReplaceIPs;
              2 : value.PCAPngSanitizeNRB := snmAsk;
             end;
        end
     else
         value.PCAPngSanitizeNRB := snmNone;

     value.PCAPngSanitizePacketOptions := CheckboxPCAPngActionSanitizePacketOptions.Checked;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.Get802dot11ActionParameters (var value : tAnonymizeParameters);

var count : integer;
    Node  : PVirtualNode;
    Data  : pReplacementEditorData;

begin
     value.WiFiDoReplace := RadioButton802dot11ActionReplace.Checked;
     value.WiFiReplaceBySSIDList := Checkbox802dot11ActionReplaceSSIDByList.Checked;

     if value.WiFiReplaceBySSIDList then
        begin
             setLength (value.WiFiSSIDReplacementStrings, VST802dot11SSIDReplacementList.RootNodeCount);

             Node := VST802dot11SSIDReplacementList.GetFirst;
             count := 0;

             while assigned (Node) do
                   begin
                        Data := VST802dot11SSIDReplacementList.GetNodeData (Node);

                        if (Data^.original <> '') then
                           begin
                                value.WiFiSSIDReplacementStrings[count].original := Data^.original;
                                value.WiFiSSIDReplacementStrings[count].replacement := Data^.replacement;

                                inc (count);
                           end;

                        Node := VST802dot11SSIDReplacementList.GetNext (Node);
                   end;

             // Cut down to the real length in case we skipped some values in the loop for being empty

             setLength (value.WiFiSSIDReplacementStrings, count);
        end;

     value.WiFiReplaceRemainingSSIDs := CheckBox802dot11AutoReplaceRemainingSSIDs.Checked;
     value.WiFiReplaceRemainingSSIDsPrefix := Edit802dot11AutoReplaceRemainingSSIDsPrefix.Text;
     value.WiFiKeepUnknownTaggedParams := CheckBox802dot11KeepUnknownTaggedParameters.Checked;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetEthernetActionParameters (var value: tAnonymizeParameters);

var count : integer;
    node  : pVirtualNode;
    data  : pReplacementMACNode;

begin
     value.EthernetDoReplace := RadioButtonEthernetActionReplace.Checked;
     value.EthernetReplaceByMACList := CheckboxEthernetActionReplaceByList.Checked;

     if value.EthernetReplaceByMACList then
        begin
             count := 0;
             setLength (value.EthernetMACList, VSTMACAddressList.RootNodeCount);
             node := VSTMACAddressList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        data := VSTMACAddressList.GetNodeData(Node);

                        value.EthernetMACList[count-1].Source := data^.Original;
                        value.EthernetMACList[count-1].Destination := data^.Replacement;

                        node := VSTMACAddressList.GetNext (Node);
                   end;
        end
     else
         setLength (value.EthernetMACList, 0);

     value.EthernetRandomizeMACAddress := CheckBoxProcessRemainingEthernetAddresses.Enabled and CheckBoxProcessRemainingEthernetAddresses.Checked and (ComboBoxRemainingEthernetAddressesProcessMode.ItemIndex = 0);
     value.EthernetBlackMarkerMACAddress := CheckBoxProcessRemainingEthernetAddresses.Enabled and CheckBoxProcessRemainingEthernetAddresses.Checked and (ComboBoxRemainingEthernetAddressesProcessMode.ItemIndex = 1);
     value.EthernetLeaveVendorIntact := CheckboxEthernetActionLeaveVendorIntact.Checked;

     if CheckBoxEthernetRecalculateCRC.Checked then
        begin
             case ComboBoxEthernetRecalculateCRCMode.ItemIndex of
              0 : value.EthernetRecalculateFCSMode := rcmKeepBadCRC;
              1 : value.EthernetRecalculateFCSMode := rcmFixAll;
             end;
        end
     else
         value.EthernetRecalculateFCSMode := rcmKeepCRC;

     value.EthernetPreserveTrailingBytes := CheckBoxEthernetPreserveTrailer.Checked;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetVLANActionParameters (var value: tAnonymizeParameters);

var help  : integer;
    count : integer;
    node  : pVirtualNode;
    data  : pVLANPair;
    i     : integer;

begin
     value.VLANDoReplace := RadioButtonVLANActionReplace.Checked;

     value.VLANDoReplaceVLANByIDList := CheckboxVLANActionReplaceByList.Checked;

     if value.VLANDoReplaceVLANByIDList then
        begin
             count := 0;
             setLength (value.VLANReplaceByVLANIDList, VSTVLANIDList.RootNodeCount);
             node := VSTVLANIDList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        data := VSTVLANIDList.GetNodeData(Node);

                        value.VLANReplaceByVLANIDList[count-1] := data^;
                        node := VSTVLANIDList.GetNextSibling (Node);
                   end;
        end
     else
         setLength (value.VLANReplaceByVLANIDList, 0);

     if CheckboxVLANActionRemoveTag.Checked then
        begin
             case ComboBoxVLANActionRemoveTag.ItemIndex of
              0 : value.VLANRemoveMode := vrmRemoveAll;
              1 : value.VLANRemoveMode := vrmRemoveAllListed;
              2 : value.VLANRemoveMode := vrmRemoveAllUnlisted;
             end;
        end
     else
         value.VLANRemoveMode := vrmNone;

     for i := 0 to 4096 do
         value.VLANRemoveList[i] := false;

     if not (value.VLANRemoveMode = vrmNone) then
        begin
             for i := 1 to ListBoxVLANActionRemoveVLANIDs.Items.Count do
                 begin
                      TryStrToInt (ListBoxVLANActionRemoveVLANIDs.Items[i-1], help);

                      value.VLANRemoveList[help] := true;
                 end;
        end;

     value.VLANRandomizeVLANIDs := CheckBoxVLANActionRandomizeIDs.Checked;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetTunnelingParameters (var value: tAnonymizeParameters);

begin
     value.TunnelDoReplace := RadioButtonTunnelActionReplace.Checked;

     if CheckboxAYIYAActionReplace.Enabled and CheckboxAYIYAActionReplace.Checked then
        begin
             value.TunnelAYIYASanitizeIdentity := aisZero;
             value.TunnelAYIYASanitizeSignature := assZero;
        end
     else
         begin
             value.TunnelAYIYASanitizeIdentity := aisNone;
             value.TunnelAYIYASanitizeSignature := assNone;
         end;

     value.MPLSRandomizeLabel := value.TunnelDoReplace and CheckBoxRandomizeLabels.Checked;
     value.MPLSMaximumLabelValue := UpDownMPLSMaximumLabelValue.Position;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetIPv4ActionParameters (var value: tAnonymizeParameters);

var node  : pVirtualNode;
    data  : pReplacementIPv4Node;
    count : integer;

begin
     value.IPV4StoreGeneratedSubnetIPsToDB := true;

     value.IPv4DoReplace := RadioButtonIPv4ActionReplace.Checked;
     value.IPv4DoReplaceByIPList := CheckBoxReplaceIPv4AddressesByList.Checked;

     // IP Address List

     if value.IPv4DoReplaceByIPList then
        begin
             count := 0;
             setLength (value.IPv4AddressList, VSTIPv4AddressList.RootNodeCount);
             node := VSTIPv4AddressList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        data := VSTIPv4AddressList.GetNodeData (Node);

                        value.IPv4AddressList[count-1].Source := data^.Original;
                        value.IPv4AddressList[count-1].Destination := data^.Replacement;
                        node := VSTIPv4AddressList.GetNext (Node);
                   end;
        end;

     value.IPV4AddressAutoMode := CheckBoxReplaceIPv4AddressesAutoMode.Checked;

     value.IPv4ReplaceBySubnetlist := CheckBoxReplaceIPv4AddressesBySubnets.Checked;
     value.IPv4KeepHostPart := ComboBoxIPv4ActionSubnetListMode.ItemIndex = 0;

     // IP Subnet List

     if value.IPv4ReplaceBySubnetlist then
        begin
             count := 0;
             setLength (value.IPv4SubnetList, VSTIPv4SubnetList.RootNodeCount);
             node := VSTIPv4SubnetList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        data := VSTIPv4SubnetList.GetNodeData(Node);

                        value.IPv4SubnetList[count-1].Source := data^.Original;
                        value.IPv4SubnetList[count-1].Destination := data^.Replacement;
                        node := VSTIPv4SubnetList.GetNext (Node);
                   end;
        end;

     value.IPv4RandomizeIPAddress := CheckBoxProcessRemainingIPv4Addresses.Checked and (ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex = 0);
     value.IPv4BlackMarkerIPAddress := CheckBoxProcessRemainingIPv4Addresses.Checked and (ComboBoxRemainingIPv4AddressesProcessMode.ItemIndex = 1);
     value.IPv4RandomizeMulticast := CheckBoxRandomizeIPv4Multicast.Checked and CheckBoxRandomizeIPv4Multicast.Enabled;
     value.IPv4RandomizeAPIPA := CheckBoxRandomizeIPv4APIPA.Checked and CheckBoxRandomizeIPv4APIPA.Enabled;

     case ComboBoxIPRandomizePrivateRangeMode.ItemIndex of
      0 : value.IPv4PrivateAddressRandomizeMode := parRandomizeToPrivate;
      1 : value.IPv4PrivateAddressRandomizeMode := parRandomizeFullRange;
      2 : value.IPv4PrivateAddressRandomizeMode := parKeepOriginal;
     end;

     value.IPv4RandomizeIPID := CheckBoxRandomizeIPv4ID.Checked;
     value.IPv4RandomizeDocumentation := CheckBoxRandomizeIPv4DocumentationAddresses.Checked;

     if CheckBoxIPRecalculateCRC.Checked then
        begin
             case ComboBoxIPRecalculateCRCMode.ItemIndex of
              0 : value.IPv4RecalculateCRCMode := rcmKeepBadCRC;
              1 : value.IPv4RecalculateCRCMode := rcmFixAll;
             end;
        end
     else
         value.IPv4RecalculateCRCMode := rcmKeepCRC;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetIPv6ActionParameters (var value: tAnonymizeParameters);

var node  : pVirtualNode;
    data  : pReplacementIPv6Node;
    count : integer;

begin
     value.IPV6StoreGeneratedSubnetIPsToDB := true;

     value.IPv6DoReplace := RadioButtonIPv6ActionReplace.Checked;
     value.IPv6DoReplaceByIPList := CheckBoxReplaceIPv6AddressesByList.Enabled and CheckBoxReplaceIPv6AddressesByList.Checked;

     // IP Address List

     if value.IPv6DoReplaceByIPList then
        begin
             count := 0;
             setLength (value.IPv6AddressList, VSTIPv6AddressList.RootNodeCount);
             node := VSTIPv6AddressList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        data := VSTIPv6AddressList.GetNodeData (Node);

                        value.IPv6AddressList[count-1].Source := data^.Original;
                        value.IPv6AddressList[count-1].Destination := data^.Replacement;
                        node := VSTIPv6AddressList.GetNext (Node);
                   end;
        end
     else
         setLength (value.IPv6AddressList, 0);

     value.IPV6AddressAutoMode := CheckBoxReplaceIPv6AddressesAutoMode.Checked;

     value.IPv6ReplaceBySubnetlist := CheckBoxReplaceIPv6AddressesBySubnets.Enabled and CheckBoxReplaceIPv6AddressesBySubnets.Checked;
//   value.IPv6KeepHostPart := ComboBoxIPv6ActionSubnetListMode.ItemIndex = 0;
     value.IPv6KeepHostPart := true;                                      // TODO: implement handling like in IPv6 or remove this option

     // IP Subnet List

     if value.IPv6ReplaceBySubnetlist then
        begin
             count := 0;
             setLength (value.IPv6SubnetList, VSTIPv6SubnetList.RootNodeCount);
             node := VSTIPv6SubnetList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        data := VSTIPv6SubnetList.GetNodeData(Node);

                        value.IPv6SubnetList[count-1].Source := data^.Original;
                        value.IPv6SubnetList[count-1].Destination := data^.Replacement;
                        node := VSTIPv6SubnetList.GetNext (Node);
                   end;
        end
     else
         setLength (value.IPv6SubnetList, 0);

//   value.IPv6RandomizeIPAddress := CheckBoxProcessRemainingIPv6Addresses.Enabled and CheckBoxProcessRemainingIPv6Addresses.Checked and (ComboBoxRandominzeIPv6AddressMode.ItemIndex < 3);
     value.IPv6RandomizeIPAddress := CheckBoxProcessRemainingIPv6Addresses.Enabled and CheckBoxProcessRemainingIPv6Addresses.Checked and (ComboBoxRandominzeIPv6AddressMode.ItemIndex < 3);

     if value.IPv6RandomizeIPAddress then
        begin
             case ComboBoxRandominzeIPv6AddressMode.ItemIndex of
              0 : value.IPv6RandomizeAddressMode := iprRandomizeAndKeepPrefix;
              1 : value.IPv6RandomizeAddressMode := iprRandomizeBothAndKeepPrefix;
              2 : value.IPv6RandomizeAddressMode := iprFullStatelessRandomization;
              3 : value.IPv6RandomizeAddressMode := iprBlackMarker;
             end;
        end
     else
         value.IPv6RandomizeAddressMode := iprNone;
{
     else
         begin
              if CheckBoxProcessRemainingIPv6Addresses.Enabled and CheckBoxProcessRemainingIPv6Addresses.Checked and (ComboBoxRandominzeIPv6AddressMode.ItemIndex = 3) then
                 begin
                      value.IPv6BlackMarkerIPAddress := True;
                      value.IPv6RandomizeAddressMode := iprNone;
                 end
              else
                  begin
                       value.IPv6BlackMarkerIPAddress := False;
                       value.IPv6RandomizeAddressMode := iprNone;
                  end;
         end;
}
     value.IPv6RandomizeDocumentationAddr := CheckBoxRandomizeIPv6DocumentationAddresses.Enabled and CheckBoxRandomizeIPv6DocumentationAddresses.Checked;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetICMPv4ActionParameters (var value: tAnonymizeParameters);

var node : pVirtualNode;
    data : pICMPv4TreeEntry;
    i    : integer;

begin
     value.ICMPv4DoReplace := RadioButtonICMPv4ActionReplace.Checked;
     value.ICMPv4RemovePingPayload := CheckBoxICMPv4RemovePingPayload.Enabled and CheckBoxICMPv4RemovePingPayload.Checked;

     value.ICMPv4RemoveICMPTypeCodes := SettingIsActive (CheckBoxICMPv4RemoveMessages);

     if value.ICMPv4RemoveICMPTypeCodes then
        begin
             setLength (value.ICMPv4RemoveByTypeCode, VSTICMPv4RemoveMessages.CheckedCount);
             i := 0;

             // Transfer all selected nodes to the type/code list

             node := VSTICMPv4RemoveMessages.GetFirstChecked;

             while node <> nil do
                   begin
                        data := VSTICMPv4RemoveMessages.GetNodeData (node);

                        value.ICMPv4RemoveByTypeCode[i] := data^.TypeCode;
                        inc (i);

                        node := VSTICMPv4RemoveMessages.GetNextChecked (node);
                   end;
        end
     else
         setLength (value.ICMPv4RemoveByTypeCode, 0);

     if CheckBoxICMPv4RecalculateCRC.Enabled and CheckBoxICMPv4RecalculateCRC.Checked then
        begin
             case ComboBoxICMPv4RecalculateCRCMode.ItemIndex of
               0 : value.ICMPv4RecalculateCRCMode := rcmKeepBadCRC;
               1 : value.ICMPv4RecalculateCRCMode := rcmFixAll;
             end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetICMPv6ActionParameters (var value: tAnonymizeParameters);

begin
     value.ICMPv6DoReplace := RadioButtonICMPv6ActionReplace.Checked;
     value.ICMPv6RemoveDNSFQDNsFromOptions := CheckBoxICMPv6RemoveDNSServerFQDNs.Checked and CheckBoxICMPv6RemoveDNSServerFQDNs.Enabled;
     value.ICMPv6RemovePingPayload := CheckBoxICMPv6RemovePingPayload.Enabled and CheckBoxICMPv6RemovePingPayload.Checked;

     if CheckBoxICMPv6RecalculateCRC.Enabled and CheckBoxICMPv6RecalculateCRC.Checked then
        begin
             case ComboBoxICMPv6RecalculateCRCMode.ItemIndex of
               0 : value.ICMPv6RecalculateCRCMode := rcmKeepBadCRC;
               1 : value.ICMPv6RecalculateCRCMode := rcmFixAll;
             end;
        end;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetTCPActionParameters (var value: tAnonymizeParameters);

var count      : integer;
    node       : pVirtualNode;
    socketdata : pSocketListEntry;
    portdata   : pPortPair;

begin
     value.TCPDoReplace := RadioButtonTCPActionReplace.Checked;
     value.TCPReplaceSocketsByList := CheckBoxReplaceTCPPortsBySocketList.Checked and value.TCPDoReplace;

     if value.TCPReplaceSocketsByList then
        begin
             count := 0;
             setLength (value.TCPSocketPortList, VSTTCPSocketList.RootNodeCount);
             node := VSTTCPSocketList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        socketdata := VSTTCPSocketList.GetNodeData (Node);

                        value.TCPSocketPortList[count-1] := socketdata^.Socket;
                        value.TCPSocketPortList[count-1].normalize;

                        node := VSTTCPSocketList.GetNext (Node);
                   end;
        end
     else
         setLength (value.TCPSocketPortList, 0);

     value.TCPReplacePortsByList := CheckBoxReplaceTCPPortsByList.Checked and value.TCPDoReplace;

     if value.TCPReplacePortsByList then
        begin
             count := 0;
             setLength (value.TCPPortList, VSTTCPPortList.RootNodeCount);
             node := VSTTCPPortList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        portdata := VSTTCPPortList.GetNodeData (Node);

                        value.TCPPortList[count-1] := portdata^;
                        node := VSTTCPPortList.GetNext (Node);
                   end;
        end
     else
          setLength (value.TCPPortList, 0);

     value.TCPRandomizePorts := CheckBoxTCPRandomizePorts.Checked and value.TCPDoReplace;
     value.TCPIgnoreSystemPorts := CheckBoxTCPRandomizePortsKeepSystemPorts.Checked and CheckBoxTCPRandomizePortsKeepSystemPorts.Enabled;

     if CheckBoxTCPRecalculateCRC.Checked and value.TCPDoReplace then
        begin
             case ComboBoxTCPRecalculateCRCMode.ItemIndex of
              0 : value.TCPRecalculateCRC := rcmKeepBadCRC;
              1 : value.TCPRecalculateCRC := rcmFixAll;
             end;
        end
     else
         value.TCPRecalculateCRC := rcmKeepCRC;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetUDPActionParameters (var value: tAnonymizeParameters);

var count      : integer;
    node       : pVirtualNode;
    socketdata : pSocketListEntry;
    data       : pPortPair;

begin
     value.UDPDoReplace := RadioButtonUDPActionReplace.Checked;
     value.UDPReplaceSocketsByList := CheckBoxReplaceTCPPortsBySocketList.Checked and value.UDPDoReplace;

     if value.UDPReplaceSocketsByList then
        begin
             count := 0;
             setLength (value.UDPSocketPortList, VSTUDPSocketList.RootNodeCount);
             node := VSTUDPSocketList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        socketdata := VSTUDPSocketList.GetNodeData (Node);

                        value.UDPSocketPortList[count-1] := socketdata^.Socket;
                        value.UDPSocketPortList[count-1].normalize;

                        node := VSTUDPSocketList.GetNext (Node);
                   end;
        end
     else
         setLength (value.UDPSocketPortList, 0);

     value.UDPReplacePortsByList := CheckBoxReplaceUDPPortsByList.Checked and value.UDPDoReplace;

     if value.UDPReplacePortsByList then
        begin
             count := 0;
             setLength (value.UDPPortList, VSTUDPPortList.RootNodeCount);
             node := VSTUDPPortList.GetFirst;

             while node <> nil do
                   begin
                        inc (count);
                        data := VSTUDPPortList.GetNodeData (Node);

                        value.UDPPortList[count-1] := data^;
                        node := VSTUDPPortList.GetNext (Node);
                   end;
        end
     else
         setLength (value.UDPPortList, 0);

     value.UDPRandomizePorts := CheckBoxUDPRandomizePorts.Checked and value.UDPDoReplace;
     value.UDPIgnoreSystemPorts := CheckBoxUDPRandomizePortsKeepSystemPorts.Checked and CheckBoxUDPRandomizePortsKeepSystemPorts.Enabled;

     if CheckBoxUDPRecalculateCRC.Checked and value.UDPDoReplace then
        begin
             case ComboBoxUDPRecalculateCRCMode.ItemIndex of
              0 : value.UDPRecalculateCRC := rcmKeepBadCRC;
              1 : value.UDPRecalculateCRC := rcmFixAll;
             end;
        end
     else
         value.UDPRecalculateCRC := rcmKeepCRC;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetDHCPv4ActionParameters(var value: tAnonymizeParameters);

begin
     value.DHCPv4DoReplace := RadioButtonDHCPv4ActionReplace.Checked;
     value.DHCPv4ReplaceHostName := CheckBoxDHCPv4HandleFQDNs.Checked and value.DHCPv4DoReplace;

     if value.DHCPv4ReplaceHostName then
        begin
             case ComboBoxDHCPv4ActionFQDNReplaceMode.ItemIndex of
              0 : value.DHCPv4ReplaceHostnameMode := rhnUsePlaceholders;
             end;
        end
     else
         value.DHCPv4ReplaceHostnameMode := rhnKeepHostname;

     // Hint Box

     if RadioButtonICMPv4ActionReplace.Checked then
        MemoDHCPv4ActionHint.Text := 'DHCP values will be replaced based on the replacement settings below.'
     else
         MemoDHCPv4ActionHint.Text := 'DHCP values will not be modified.';
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetApplicationParameters (var value: tAnonymizeParameters);

begin
     value.RTPSDoReplace := RadioButtonRTPSActionReplace.Checked;
     value.RTPSReplacementBlackMarker := (ComboBoxRTPSActionReplaceMode.ItemIndex = 0);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.getOutputParameters (var value : tAnonymizeParameters);

begin
     value.OutputFilename := EditOutputFilename.text;

     if RadioButtonFileOutputSameDirectory.Checked then
        begin
             value.OutputTargetLocation := ltSameDirectory;
             value.OutputPath := '';
        end;

     if RadioButtonFileOutputToSubdirectory.Checked then
        begin
             value.OutputTargetLocation :=  ltSubdirectory;
             value.OutputPath := LabeledEditOutputToSubdirectory.Text;
        end;

     if RadioButtonFileOutputToAbsoluteDirectory.Checked then
        begin
             value.OutputTargetLocation := ltAbsoluteDirectory;
             value.OutputPath := LabeledEditOutputToDirectory.Text;
        end;

     value.OutputFilename := EditOutputFilename.Text;

     if CheckBoxSetFileDateTo.Checked then
        begin
             case FormTaskAnonymize.ComboBoxSetFileTimestampScope.ItemIndex of
              0 : value.OutputTimestamp := tsmOriginalFile;
              1 : value.OutputTimestamp := tsmFirstFrame;
              2 : value.OutputTimestamp := tsmLastFrame;
             end;
        end
     else
         value.OutputTimestamp := tsmNone;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.GetSettingsParameters (var value: tAnonymizeParameters);

begin
     // Replacement DB Settings

{$ifdef WIN32}
     value.ReplacementDBUseDiskFile := true;
{$else}
     value.ReplacementDBUseDiskFile := CheckBoxUseDiskBasedDatabaseFile.Enabled and CheckBoxUseDiskBasedDatabaseFile.Checked;
{$endif}

     value.ReplacementDBKeepDiskFile := CheckBoxKeepDatabaseFileAfterFinish.Enabled and CheckBoxKeepDatabaseFileAfterFinish.Checked;
     value.ReplacementDBWipeOnStart := CheckBoxWipeDatabaseOnJobStart.enabled and CheckBoxWipeDatabaseOnJobStart.Checked;
     value.ReplacementDBForcePath := CheckBoxForceDatabasePath.Enabled and CheckBoxForceDatabasePath.Checked;

     if value.ReplacementDBForcePath then
        value.ReplacementDBFilePath := EditReplacementDBPath.Text
     else
         value.ReplacementDBFilePath := '';

     // Advanced

     value.AdvDoNotReassembleIPFragments := not CheckboxAdvReassembleIPFragments.Checked;
     value.AdvReassemblyChainTimeoutMS := UpDownAdvReassemblyChainTimeout.Position;
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.getAnonymizationParameters : tAnonymizeParameters;

var value : tAnonymizeParameters;

begin
     GetPayloadActionParameters (value);
     GetPCAPngActionParameters (value);
     Get802dot11ActionParameters (value);
     GetEthernetActionParameters (value);
     GetVLANActionParameters (value);
     GetIPv4ActionParameters (value);
     GetIPv6ActionParameters (value);
     GetICMPv4ActionParameters (value);
     GetICMPv6ActionParameters (value);
     GetTCPActionParameters (value);
     GetUDPActionParameters (value);
     GetTunnelingParameters (value);
     GetDHCPv4ActionParameters (value);
     GetApplicationParameters (value);
     GetOutputParameters (value);
     GetSettingsParameters (value);

     // Final adjustments

     // Force DB based Ethernet replacement if IPv6 replacement is active, because otherwise
     // we will have inconsistencies for MAC based IPv6 addresses (EUI64 & MCast) or vice versa

     if value.IPv6DoReplace then
        value.EthernetDoOnlyDBBasedReplacement := true
     else
         value.EthernetDoOnlyDBBasedReplacement := false;

     result := value;
end;

(* ------------------------------------------- *)

function TFormTaskAnonymize.GetTaskDescription : string;

var value    : string;
    subvalue : string;
    help     : string;

begin
     // Payload

     if CheckboxGeneralActionPacketTruncateUnknownPayload.Checked then
        subvalue := '*Truncate Unknown Payload' + CRLF
     else
         subvalue := '';

     if CheckboxGeneralActionPacketTruncateAfterLayer.Checked then
        subvalue := subvalue + 'Truncate after Layer ' + IntToStr (ComboBoxGeneralPacketSlicingLayer.ItemIndex + 2)  + CRLF;

     if CheckboxGeneralActionPacketTruncateAfterOffset.Checked then
        subvalue := subvalue + 'Truncate after offset ' + EditGeneralPacketSlicingOffset.Text + CRLF;

     if subvalue <> '' then
        value := 'Payload Removal' + CRLF + subvalue;

     // Replacement DB

     if CheckBoxUseDiskBasedDatabaseFile.Checked then
        subvalue := '*Used Disk based database file'
     else
         subvalue := '';

     if CheckBoxKeepDatabaseFileAfterFinish.Checked then
        subvalue := subvalue + 'Keep database file after task finishes';

     if CheckBoxWipeDatabaseOnJobStart.Checked then
        subvalue := subvalue + 'Wipe database on job start';

     if CheckBoxForceDatabasePath.Checked then
        subvalue := subvalue + 'Force database path: "' + EditReplacementDBPath.Text + '"';

     if subvalue <> '' then
        value := value + '-Replacement Database' + CRLF;

     // PCAPng

     if RadioButtonPCAPngActionReplace.Checked then
        begin
             if CheckboxPCAPngActionSanitizeComments.Checked then
                begin
                     case ComboBoxPCAPngActionSanitizeCommentMethod.ItemIndex of
                      0 : help := 'Sanitize all ';
                      1 : help := 'Ask before sanitizing each ';
                     end;

                     case ComboBoxPCAPngActionSanitizeCommentScope.ItemIndex of
                      0 : subvalue := help + 'File and Packet Comment';
                      1 : subvalue := help + 'File Comment';
                      2 : subvalue := help + 'Packet Comment';
                     end;

                     if ComboBoxPCAPngActionSanitizeCommentMethod.ItemIndex = 1 then
                        subvalue := subvalue + 's';
                end;

             if CheckboxPCAPngActionSanitizeInterfaceBlocks.Checked then
                begin
                     // TODO: this needs to be filled with somethign useful

                end;


             value := value + '+PCAPng Sanitization' + CRLF + subvalue;
        end;

     result := value;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.WMStartVSTPayloadReplacementStringsEditing (var Message: TMessage);

// This message was posted by ourselves from the node change handler above to decouple that change event and our
// intention to start editing a node. This is necessary to avoid interferences between nodes editors potentially created
// for an old edit action and the new one we start here.

var Node: PVirtualNode;

begin
     Node := Pointer (Message.WParam);

     // Note: the test whether a node can really be edited is done in the OnEditing event.

     VSTPayloadReplacementStrings.EditNode (Node, 1);
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.CMDialogKey(var Msg: TCMDialogKey);

begin
     if (Msg.CharCode <> VK_TAB) or (not priv_CatchKeys) then
        inherited;
end;

(* ------------------------------------------- *)

procedure TFormTaskAnonymize.onResize(Sender: TObject);

begin
     LabelHintPayloadEditor.Left := GroupBoxGeneralSettingTruncate.Left + ((GroupBoxGeneralSettingTruncate.Width - LabelHintPayloadEditor.Width) DIV 2);
     LabelHintSSIDReplacementList.Left := VST802dot11SSIDReplacementList.Left + ((VST802dot11SSIDReplacementList.Width - LabelHintSSIDReplacementList.Width) DIV 2);
end;

(* ------------------------------------------- *)

end.

